-- ---------------------------------------------------------------------------
-- :   " "
-- :        " "
-- :      . .
-- :      15.04.2012
-- :    0.6
-- ---------------------------------------------------------------------------

-- . 
-- 1.    :
--    _fname = _full_name
--    _sname = _short_name

-- 2.    ,    "" 
--     (   ,   
--    ,   ..)  ,   
--    ,   "" ,  
--    .       
--    (       *_orig)    
--        -. 

-- 3.      
--                      DROP TABLE <table_name> CASCADE;
--      .   , , 
--           .

-- 4.      :    
--     .      ,  ,
--        .     
--       ( A,     
--     B,          B).
--     ,     (, Persons)
--           .


-- ---------------------------------------------------------------------------
--  
-- ---------------------------------------------------------------------------

-- ---------------------------------------------------------------------------
--  ""
-- ---------------------------------------------------------------------------
-- DROP TABLE Langs CASCADE;

CREATE TABLE Langs                    -- Languages
  ( lang_code int2,                   --  
    lang_fname text                   --   
      UNIQUE NOT NULL,
    lang_sname text                   --    
      UNIQUE NOT NULL,
    comment text,                     -- 
    --  
    who_chg text DEFAULT USER,        --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,      --   () 
    PRIMARY KEY ( lang_code )
  );

-- ---------------------------------------------------------------------------
--  " "
-- ---------------------------------------------------------------------------
-- DROP TABLE Acq_ways CASCADE;

CREATE TABLE Acq_ways             -- Acquisition_ways
  ( acq_way_code int2,            --   
    acq_way_fname text NOT NULL,  --    
    acq_way_sname text NOT NULL,  --     
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( acq_way_code )
  );
-- Internet
--  
-- 
--  

-- ---------------------------------------------------------------------------
--  "   , "
-- ---------------------------------------------------------------------------
-- DROP TABLE Activity_types CASCADE;

CREATE TABLE Activity_types
  ( act_type_code int2,             --   
    act_type_fname text             --    
      UNIQUE NOT NULL,
    act_type_sname text             --    
      UNIQUE NOT NULL,
    comment text,                   -- 
    --  
    who_chg text DEFAULT USER,      --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,    --   () 
    PRIMARY KEY ( act_type_code )
  );

-- ---------------------------------------------------------------------------
--  "  "
-- ---------------------------------------------------------------------------
-- DROP TABLE Conf_status_types CASCADE;

CREATE TABLE Conf_status_types        -- Conferences_status_types
  ( conf_status_code int2,            --   
    conf_status_fname text NOT NULL,  --   
                                      -- 
    conf_status_sname text NOT NULL,  --   
                                      -- 
    comment text,                     -- 
    --  
    who_chg text DEFAULT USER,        --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,      --   () 
    PRIMARY KEY ( conf_status_code )
  );

-- ---------------------------------------------------------------------------
--  " "
-- ---------------------------------------------------------------------------
-- DROP TABLE Conf_types CASCADE;

CREATE TABLE Conf_types              -- Conferences_types
  ( conf_type_code int2,             --   
    conf_type_fname text             --    
      UNIQUE NOT NULL,
    conf_type_sname text             --    
      UNIQUE NOT NULL,
    comment text,                    -- 
    --  
    who_chg text DEFAULT USER,       --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,     --   () 
    PRIMARY KEY ( conf_type_code )
  );

-- ---------------------------------------------------------------------------
--  ""
-- ---------------------------------------------------------------------------
-- DROP TABLE Countries CASCADE;

CREATE TABLE Countries
  ( country_code int2,                --  
    country_fname text NOT NULL,      --   
    country_sname text NOT NULL,      --    
    country_code_orig int2,           --  ,   
                                      -- (  ,
                                      --  ,   
                                      --  )
    lang_code int2                    --   (1 -  )
      NOT NULL DEFAULT 1,
    comment text,                     -- 
    --  
    who_chg text DEFAULT USER,        --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,      --   () 
    PRIMARY KEY ( country_code ),
    UNIQUE ( country_fname, lang_code ),
    UNIQUE ( country_sname, lang_code ),
    FOREIGN KEY ( lang_code )
      REFERENCES Langs ( lang_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( country_code_orig )
      REFERENCES Countries ( country_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  ""
-- .  ,    ,  
--              (   . .),    
--                 .   
--                ,      
--               ,    Countries   
--                .
-- ---------------------------------------------------------------------------
-- DROP TABLE Cities CASCADE;

CREATE TABLE Cities
  ( city_code int2,                --  
    country_code int2 NOT NULL,    --  
    city_region text,              --  (   
                                   --   --  
                                   --       
                                   --    )
    city_fname text NOT NULL,      --   
    city_sname text NOT NULL,      --    
    city_code_orig int2,           --  ,   
                                   -- (  ,
                                   --  ,   
                                   --  )
    --     ,     ,  
    --    country_code
    -- .       
    --               -.
    -- TODO           -  
    --                .
    lang_code int2                 --   (1 -  )
      NOT NULL DEFAULT 1,
    comment text,                  -- 
    --  
    who_chg text DEFAULT USER,     --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,   --   () 
    PRIMARY KEY ( city_code ),
    -- --------------------------------------------------------
    -- TODO      -  
    --      (       
    --        )
    UNIQUE ( city_fname, city_region, country_code, lang_code ),
    UNIQUE ( city_sname, city_region, country_code, lang_code ),
    -- ---------------------------------------------------------
    FOREIGN KEY ( country_code )
      REFERENCES Countries ( country_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( lang_code )
      REFERENCES Langs ( lang_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( city_code_orig )
      REFERENCES Cities ( city_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  ""
-- ---------------------------------------------------------------------------
-- DROP TABLE Currencies CASCADE;

CREATE TABLE Currencies
  ( currency_code int2,            --  
    currency_fname text            --   
      NOT NULL,
    currency_sname text            --   
      NOT NULL,
    country_code int2 NOT NULL,    --  
    currency_date date,            --    
    currency_code_orig int2,       --  ,   
                                   -- (  ,
                                   --  ,   
                                   --  )
    lang_code int2                 --  ,   
      NOT NULL DEFAULT 1,          --   (1 -  )
    comment text,                  -- 
    --  
    who_chg text DEFAULT USER,     --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,   --   () 
    PRIMARY KEY ( currency_code ),
    FOREIGN KEY ( country_code )
      REFERENCES Countries ( country_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( currency_code_orig )
      REFERENCES Currencies ( currency_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( lang_code )
      REFERENCES Langs ( lang_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  "     "
-- ---------------------------------------------------------------------------
-- DROP TABLE Dep_types CASCADE;

CREATE TABLE Dep_types              -- Objects_dependencies_types
  ( dep_type_code int2,             --   
    dep_type_fname text             --    
      NOT NULL UNIQUE,
    dep_type_sname text             --    
      NOT NULL UNIQUE,
    comment text,                   -- 
    --  
    who_chg text DEFAULT USER,      --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,    --   () 
    PRIMARY KEY ( dep_type_code )
  );
-- .       2 .
--             , "    -" 
--             "     - 
--             ".

-- ---------------------------------------------------------------------------
--  "    "
-- ---------------------------------------------------------------------------
-- DROP TABLE Det_char_types CASCADE;

CREATE TABLE Det_char_types         -- Detailed_characteristics_types
  ( det_char_code int2,             --   ()
    det_char_fname text             --   ()
      NOT NULL UNIQUE,              -- 
    det_char_sname text             --   ()
      NOT NULL UNIQUE,              -- 
    comment text,                   -- 
    --  
    who_chg text DEFAULT USER,      --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,    --   () 
    PRIMARY KEY ( det_char_code )
  );

-- ---------------------------------------------------------------------------
--  " "
-- ---------------------------------------------------------------------------
-- DROP TABLE Edition_types CASCADE;

CREATE TABLE Edition_types
  ( edition_code int2,            --   
    edition_name text             --   
      NOT NULL UNIQUE,
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( edition_code )
  );

-- ---------------------------------------------------------------------------
--  "    "
-- ---------------------------------------------------------------------------
-- DROP TABLE Feature_groups CASCADE;

CREATE TABLE Feature_groups
  ( feature_group_code int2,        --   
    feature_group_name text         --   
       NOT NULL UNIQUE,
    comment text,                   -- 
    --  
    who_chg text DEFAULT USER,      --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,    --   () 
    PRIMARY KEY ( feature_group_code )
  );

-- ---------------------------------------------------------------------------
--  "    "
-- ---------------------------------------------------------------------------
-- DROP TABLE Feature_types CASCADE;

CREATE TABLE Feature_types
  ( feature_code int2,              --  
    feature_group_code int2,        --   
    feature_name text               --  
       NOT NULL UNIQUE,
    comment text,                   -- 
    --  
    who_chg text DEFAULT USER,      --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,    --   () 
    PRIMARY KEY ( feature_code ),
    FOREIGN KEY ( feature_group_code )
      REFERENCES Feature_groups ( feature_group_code )
      ON DELETE CASCADE
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  "   "
-- ---------------------------------------------------------------------------
-- DROP TABLE Gen_mater_types CASCADE;

CREATE TABLE Gen_mater_types     -- General_material_designation_types
  ( gen_mat_code int2,           --    
    gen_mat_name text NOT NULL,  --    
    gen_mat_code_orig int2,      --    ,
                                 --   
                                 -- (    
                                 --  )
    lang_code int2               --   (1 -  )
      NOT NULL DEFAULT 1,
    comment text,                -- 
    --  
    who_chg text DEFAULT USER,   --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP, --   () 
    PRIMARY KEY ( gen_mat_code ),
    UNIQUE ( gen_mat_name, lang_code ),
    FOREIGN KEY ( lang_code )
      REFERENCES Langs ( lang_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( gen_mat_code_orig )
      REFERENCES Gen_mater_types ( gen_mat_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  "  "
-- ---------------------------------------------------------------------------
-- DROP TABLE Pack_types CASCADE;

CREATE TABLE Pack_types
  ( pack_code int2,                 --   
    pack_fname text                 --    
      UNIQUE NOT NULL,
    pack_sname text                 --     
      UNIQUE NOT NULL,
    comment text,                   -- 
    --  
    who_chg text DEFAULT USER,      --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,    --   () 
    PRIMARY KEY ( pack_code )
  );

-- ---------------------------------------------------------------------------
--  "  ,     "
-- ---------------------------------------------------------------------------
-- DROP TABLE Phys_form_types CASCADE;

CREATE TABLE Phys_form_types
  ( phys_form_code int2,             --   
    phys_form_fname text             --    
      UNIQUE NOT NULL,
    phys_form_sname text             --    
      UNIQUE NOT NULL,
    comment text,                    -- 
    --  
    who_chg text DEFAULT USER,       --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,     --   () 
    PRIMARY KEY ( phys_form_code )
  );

--   
-- 
--    (   )
--    ( )
--   (  )
--   ( )
--     
--  
--   CD-ROM

-- ---------------------------------------------------------------------------
--  "     "
-- ---------------------------------------------------------------------------
-- DROP TABLE Process_types CASCADE;

CREATE TABLE Process_types
  ( process_code int2,                --    
                                      -- (1 - ,
                                      --  2 -  ,
                                      --  3 -  ,
                                      --  4 -  )
    process_fname text NOT NULL,      --    
    process_sname text NOT NULL,      --     
    comment text,                     -- 
    --  
    who_chg text DEFAULT USER,        --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,      --   () 
    PRIMARY KEY ( process_code )
  );

-- ---------------------------------------------------------------------------
--  "   "
-- ---------------------------------------------------------------------------
-- DROP TABLE Recs_sources CASCADE;

CREATE TABLE Recs_sources        -- Records_sources
  ( source_code int2,            --    
    source_name text             --   
      NOT NULL UNIQUE,           -- 
    comment text,                -- 
    --  
    who_chg text DEFAULT USER,   --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP, --   () 
    PRIMARY KEY ( source_code )
  );
-- ,  -, - ...

-- ---------------------------------------------------------------------------
--  "  "
-- ---------------------------------------------------------------------------
-- DROP TABLE Ref_types CASCADE;

CREATE TABLE Ref_types              -- References_types
  ( ref_type_code int2,             --    
    ref_type_fname text             --    
      NOT NULL UNIQUE,              -- 
    ref_type_sname text             --    
      NOT NULL UNIQUE,              -- 
    comment text,                   -- 
    --  
    who_chg text DEFAULT USER,      --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,    --   () 
    PRIMARY KEY ( ref_type_code )
  );

--  
--  
--  
--   (     )
--   (     )
--  

-- ---------------------------------------------------------------------------
--  ""
-- ---------------------------------------------------------------------------
-- DROP TABLE Roles CASCADE;

CREATE TABLE Roles
  ( role_code int2,                --  
    role_fname text                --   
      NOT NULL UNIQUE,
    role_sname text                --    
      NOT NULL UNIQUE,
    role_code_orig int2,           --  ,   
                                   -- (  , 
                                   --   )
    lang_code int2                 --  ,    
      NOT NULL DEFAULT 1,          --  (1 -  )
    process_code int2              --     
      NOT NULL DEFAULT 1,          -- (1 - , ..   , 
                                   --    .
                                   -- )
    comment text,                  -- 
    --  
    who_chg text DEFAULT USER,     --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,   --   () 
    PRIMARY KEY ( role_code ),
    FOREIGN KEY ( role_code_orig )
      REFERENCES Roles ( role_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( lang_code )
      REFERENCES Langs ( lang_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( process_code )
      REFERENCES Process_types ( process_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  " "
-- ---------------------------------------------------------------------------
-- DROP TABLE Sci_branches CASCADE;

CREATE TABLE Sci_branches
  ( sci_code int2,                  --   
    sci_fname text                  --    
      UNIQUE NOT NULL,              -- (, "-")
    sci_sname text                  --     
      UNIQUE NOT NULL,              -- (, ".-.")
    comment text,                   -- 
    --  
    who_chg text DEFAULT USER,      --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,    --   () 
    PRIMARY KEY ( sci_code )
  );

-- ---------------------------------------------------------------------------
--  "  "
-- ---------------------------------------------------------------------------
-- DROP TABLE Sci_degrees CASCADE;

CREATE TABLE Sci_degrees          -- Scientific_degrees
  ( sci_deg_code int2,            --   
    sci_deg_fname text            --    
      UNIQUE NOT NULL,            -- (, "")
    sci_deg_sname text            --    
      UNIQUE NOT NULL,            -- (, ".")
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( sci_deg_code )
  );

-- ---------------------------------------------------------------------------
--  " "
-- ---------------------------------------------------------------------------
-- DROP TABLE Sci_specs CASCADE;

CREATE TABLE Sci_specs               -- Scientific_specialities
  ( sci_spec_code int2,              --   
    sci_spec_cipher text NOT NULL,   --   
    sci_spec_name text NOT NULL,     --   
    sci_spec_date date NOT NULL,     --    
    sci_spec_term date NOT NULL,     --    
    comment text,                    -- 
    --  
    who_chg text DEFAULT USER,       --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,     --   () 
    PRIMARY KEY ( sci_spec_code ),
    UNIQUE ( sci_spec_cipher, sci_spec_date )
  );

-- ---------------------------------------------------------------------------
--  "   "
-- . .   IRBIS.
-- ---------------------------------------------------------------------------
-- DROP TABLE Spec_mater_groups CASCADE;

CREATE TABLE Spec_mater_groups    -- Specific_material_designation_groups
  ( spec_mat_group_code int2,     --    
                                  -- 
    spec_mat_group_fname text     --   
      NOT NULL,
    spec_mat_group_sname text     --   
      NOT NULL,
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( spec_mat_group_code )
  );

-- , ,  ... (.   IRBIS).


-- ---------------------------------------------------------------------------
--  "  "
-- . .   IRBIS.
-- ---------------------------------------------------------------------------
-- DROP TABLE Spec_mater_types CASCADE;

CREATE TABLE Spec_mater_types     -- Specific_material_designation_types
  ( spec_mat_code int2,           --    
    spec_mat_group_code int2      --    
      NOT NULL,                   -- 
    spec_mat_fname text           --   
      NOT NULL,
    spec_mat_sname text           --   
      NOT NULL,
    spec_mat_code_orig int2,      --    ,
                                  --   
                                  -- (    
                                  --  )
    lang_code int2                --   (1 -  )
      NOT NULL DEFAULT 1,
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( spec_mat_code ),
    FOREIGN KEY ( spec_mat_group_code )
      REFERENCES Spec_mater_groups ( spec_mat_group_code )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( lang_code )
      REFERENCES Langs ( lang_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( spec_mat_code_orig )
      REFERENCES Spec_mater_types ( spec_mat_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  "   (ISBN, ISSN  .)"
-- ---------------------------------------------------------------------------
-- DROP TABLE Std_num_types CASCADE;

CREATE TABLE Std_num_types        -- Standard_numbers_types
  ( std_num_code int2,            --    
    std_num_name text             --    
      NOT NULL UNIQUE,            -- ("ISBN", "ISSN", ...)
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( std_num_code )
  );

-- ---------------------------------------------------------------------------
--  " "
-- ---------------------------------------------------------------------------
-- DROP TABLE Title_types CASCADE;

CREATE TABLE Title_types
  ( title_type_code int2,            --   
    title_type_fname text            --    
      UNIQUE NOT NULL,
    title_type_sname text            --     
      UNIQUE NOT NULL,
    comment text,                    -- 
    --  
    who_chg text DEFAULT USER,       --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,     --   () 
    PRIMARY KEY ( title_type_code )
  );



-- --------------------------------------------------------------------------
--  
-- --------------------------------------------------------------------------

-- ---------------------------------------------------------------------------
--  "    "
-- ---------------------------------------------------------------------------
-- DROP TABLE Bib_objs CASCADE;

CREATE TABLE Bib_objs            -- Bibliographic_objects
  ( obj_ID int4,                 --   
                                 --  
    flags text,                  --  
                                 -- (    )
    comment text,                -- 
    --  
    who_chg text DEFAULT USER,   --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP, --   () 
    PRIMARY KEY ( obj_ID )
  );

-- ---------------------------------------------------------------------------
--  "  ()"
-- ---------------------------------------------------------------------------
-- DROP TABLE Bib_recs CASCADE;

CREATE TABLE Bib_recs          -- Bibliographic_records
  ( obj_ID int4,               --   
                               --  
    bib_rec_num int2           --  .    
      NOT NULL DEFAULT 0       -- (    0)
      CHECK ( bib_rec_num >= 0 ),
    gen_mat_code int2          --    
      NOT NULL DEFAULT 1,      -- (1 - "")
                               -- .      
                               -- Bib_objs, ..   
                               --     
                               --     
                               -- (, -  
                               -- : ""  "Text"  ..)
    bib_rec_head text,         --   
    bib_rec_full text,         --   
    bib_rec_short text,        --   
    ord_unit_num text,         --    
                               --   
    source_code int2 NOT NULL, --    
    details_flag bool          --   ""   
      NOT NULL,
    lang_code int2             --  ,   
      NOT NULL DEFAULT 1,      --   (1 -  )
    process_code int2          --    . 
      NOT NULL DEFAULT 1,      -- (1 - , ..   , 
                               --    . )
    reason_add_rec text,       --  .  ( 
                               --  )
    flags text,                --  
                               -- (    )
    comment text,              -- 
    --  
    who_chg text DEFAULT USER,      --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,    --   () 
    --       ( ,  ,  )
    CHECK ( NOT ( bib_rec_full IS NULL and bib_rec_short IS NULL ) ),
    PRIMARY KEY ( obj_ID, bib_rec_num ),
    FOREIGN KEY ( obj_ID )
      REFERENCES Bib_objs ( obj_ID )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( gen_mat_code )
      REFERENCES Gen_mater_types ( gen_mat_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( source_code )
      REFERENCES Recs_sources ( source_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( lang_code )
      REFERENCES Langs ( lang_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( process_code )
      REFERENCES Process_types ( process_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  " "
-- ---------------------------------------------------------------------------
-- DROP TABLE Avail_terms;

CREATE TABLE Avail_terms          -- Availability_terms
  ( obj_ID int4 NOT NULL,         --   
                                  --  
    bib_rec_num int2              --  .    
      NOT NULL DEFAULT 0          -- (    0)
      CHECK ( bib_rec_num >= 0 ),
    avail_num int2                --    
      NOT NULL DEFAULT 1
      CHECK ( avail_num >= 1 ),
    avail_terms text NOT NULL,    --  
    er_flag bool                  --   
      NOT NULL DEFAULT 'no',
    protocol text,                --  (HTTP, FTP)
    URL text,                     -- URL ()  
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( obj_ID, bib_rec_num, avail_num ),
    FOREIGN KEY ( obj_ID, bib_rec_num )
      REFERENCES Bib_recs ( obj_ID, bib_rec_num )
      ON DELETE CASCADE
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  " ()   "
-- ---------------------------------------------------------------------------
-- DROP TABLE Contents;

CREATE TABLE Contents
  ( obj_ID int4,                  --   
                                  --  
    bib_rec_num int2              --  .    
      NOT NULL DEFAULT 0          -- (    0)
      CHECK ( bib_rec_num >= 0 ),
    order_num int2,               --     
                                  -- ()   ()
                                  -- .    
                                  --                ,
                                  --                
                                  --             unit_num   
                                  --              (, 
                                  --              1    10,
                                  --                2)
    unit_num text,                --  , , , ...
    authors text,                 -- , , , ...
    unit_title text NOT NULL,     -- , 
    class_codes text,             --   ,  ...
    spec_mat_code int2,           --    
                                  -- (..   : ,
                                  -- , ...)
    location text,                --     
                                  -- .  ( , ...)
    amount text,                  --  : , 24 (),
                                  -- 11 () (   )
                                  -- .   text  
                                  --              .
    duration text,                --   ( -
                                  --  )
    side numeric( 1 )             --   ( )
      CHECK ( side IS NULL or side = 1 or side = 2 ),
    analytic_obj_ID int4,         --   
                                  --  (   
                                  --   )
                                  -- .   ,   
                                  --               .
                                  --             .
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( obj_ID, bib_rec_num, order_num ),
    --       ,  unit_num  NULL
    -- (          
    --  obj_ID, bib_rec_num)
    UNIQUE ( obj_ID, bib_rec_num, unit_num ),
    FOREIGN KEY ( obj_ID, bib_rec_num )
      REFERENCES Bib_recs ( obj_ID, bib_rec_num )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( spec_mat_code )
      REFERENCES Spec_mater_types ( spec_mat_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( analytic_obj_ID )
      REFERENCES Bib_objs ( obj_ID )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  " "
-- ---------------------------------------------------------------------------
-- DROP TABLE Deposits;

CREATE TABLE Deposits
  ( obj_ID int4,                  --   
                                  --  
    bib_rec_num int2              --  .    
      NOT NULL DEFAULT 0          -- (    0)
      CHECK ( bib_rec_num >= 0 ),
    depo_date date NOT NULL,      --  
    depo_site text NOT NULL,      --   (  )
                                  -- (  
                                  --  )
    depo_code text NOT NULL,      -- 
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( obj_ID, bib_rec_num ),
    FOREIGN KEY ( obj_ID, bib_rec_num )
      REFERENCES Bib_recs ( obj_ID, bib_rec_num )
      ON DELETE CASCADE
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  "    "
-- ---------------------------------------------------------------------------
-- DROP TABLE Det_chars;

CREATE TABLE Det_chars            -- Detailed_characteristics
  ( obj_ID int4,                  --   
                                  --  
    det_char_code int2,           --   ()
    assessment_date date,         --   
    det_char_mark numeric( 2 )    --     10- 
      NOT NULL
      CHECK ( det_char_mark >= 1 and det_char_mark <= 10 ),
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( obj_ID, det_char_code, assessment_date ),
    FOREIGN KEY ( obj_ID )
      REFERENCES Bib_objs ( obj_ID )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( det_char_code )
      REFERENCES Det_char_types ( det_char_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  "   "
-- ---------------------------------------------------------------------------
-- DROP TABLE Diss;

CREATE TABLE Diss                 -- Dissertations
  ( obj_ID int4,                  --   
                                  --  
    bib_rec_num int2              --  .    
      NOT NULL DEFAULT 0          -- (    0)
      CHECK ( bib_rec_num >= 0 ),
    rec_num int2                  --     
      NOT NULL DEFAULT 1          -- ()
      CHECK ( rec_num = 1 or      -- .   
              rec_num = 2 ),      --               ,   
                                  --              .
    diss_abstr_flag numeric( 1 )  --  "/"
      NOT NULL DEFAULT 1          -- (1 - ; 2 - )
      CHECK ( diss_abstr_flag = 1 or diss_abstr_flag = 2 ),
    sci_deg_code int2,            --       
    sci_code int2,                --   
    sci_spec_code int2,           --   
    def_date date,                --  
    conf_date date,               --  
    diss_reg_num text,            --  . 
    -- .        
    --   ()
    -- 
    --  
    --  
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    --      ()   ,
    --     (     ) 
    --  
    CHECK ( ( rec_num = 1 and sci_deg_code IS NOT NULL and
              sci_code IS NOT NULL and sci_spec_code IS NOT NULL and
              def_date IS NOT NULL ) or
            ( rec_num = 2 and sci_deg_code IS NULL and sci_code IS NULL and
              sci_spec_code IS NOT NULL and def_date IS NULL and 
              conf_date IS NULL and diss_reg_num IS NULL )
          ),
    PRIMARY KEY ( obj_ID, bib_rec_num, rec_num ),
    FOREIGN KEY ( obj_ID, bib_rec_num )
      REFERENCES Bib_recs ( obj_ID, bib_rec_num )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( sci_deg_code )
      REFERENCES Sci_degrees ( sci_deg_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( sci_code )
      REFERENCES Sci_branches ( sci_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( sci_spec_code )
      REFERENCES Sci_specs ( sci_spec_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  "   "
-- ---------------------------------------------------------------------------
-- DROP TABLE Editions;

CREATE TABLE Editions
  ( obj_ID int4,                  --   
                                  --  
    edition_quant text            --   (  text, ..
      NOT NULL,                   --     
                                  --    ,   
                                  --   : 500-750);
                                  --       
                                  --  (    ), 
                                  --     comment
    edition_code int2 NOT NULL,   --   
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( obj_ID ), 
    FOREIGN KEY ( obj_ID )
      REFERENCES Bib_objs ( obj_ID )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( edition_code )
      REFERENCES Edition_types ( edition_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  "  "
-- ---------------------------------------------------------------------------
-- DROP TABLE Edition_stat;

CREATE TABLE Edition_stat         -- Edition_statement
  ( obj_ID int4 NOT NULL,         --   
                                  --  
    bib_rec_num int2              --  .    
      NOT NULL DEFAULT 0          -- (    0)
      CHECK ( bib_rec_num >= 0 ),
    ed_stat_type numeric( 1 )     --    
      NOT NULL DEFAULT 1             -- (1 -  ;
      CHECK ( ed_stat_type >= 1 and  --  2 -  ;
              ed_stat_type <= 3 ),   --  3 -  )
    ed_stat_num int2              --   
      NOT NULL DEFAULT 1          -- (    
      CHECK ( ed_stat_num >= 1 ), --   )
    ed_stat text NOT NULL,        --  
    lang_code int2 NOT NULL       --   
      DEFAULT 1,                  -- (1 -      )
    process_code int2             --    
      NOT NULL DEFAULT 1,         -- (1 - )
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( obj_ID, bib_rec_num, ed_stat_type, ed_stat_num ),
    FOREIGN KEY ( obj_ID, bib_rec_num )
      REFERENCES Bib_recs ( obj_ID, bib_rec_num )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( lang_code )
      REFERENCES Langs ( lang_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( process_code )
      REFERENCES Process_types ( process_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  "   "
-- ---------------------------------------------------------------------------
-- DROP TABLE Features;

CREATE TABLE Features
  ( obj_ID int4,                  --   
                                  --  
    feature_code int2,            --  
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( obj_ID, feature_code ),
    FOREIGN KEY ( obj_ID )
      REFERENCES Bib_objs ( obj_ID )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( feature_code )
      REFERENCES Feature_types ( feature_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- DROP INDEX Features_ind_1;
CREATE INDEX Features_ind_1 ON Features ( feature_code, obj_ID );

-- ---------------------------------------------------------------------------
--  "    "
-- ---------------------------------------------------------------------------
-- DROP TABLE Gen_chars;

CREATE TABLE Gen_chars            -- General_characteristics
  ( obj_ID int4,                  --   
                                  --  
    gen_char text NOT NULL,       --    
    useful_fragments text,        --    ,
                                  --   ( ,
                                  -- , ...)
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( obj_ID ),
    FOREIGN KEY ( obj_ID )
      REFERENCES Bib_objs ( obj_ID )
      ON DELETE CASCADE
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  " "
-- ---------------------------------------------------------------------------
-- DROP TABLE Keywords CASCADE;

CREATE TABLE Keywords
  ( keyword_code int4,            --   
    keyword_name text NOT NULL,   --   ()
    keyword_code_orig int4,       --   ,  
                                  --  (  ,
                                  -- , , 
                                  --   )
    lang_code int2                --   (1 -  )
      NOT NULL DEFAULT 1,
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( keyword_code ),
    UNIQUE( keyword_name, lang_code ),
    FOREIGN KEY ( lang_code )
      REFERENCES Langs ( lang_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( keyword_code_orig )
      REFERENCES Keywords ( keyword_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  "  "
-- .       
--                  . , "
--             "      ""   
--             " ".    
--             " "     ,
--                      .
-- ---------------------------------------------------------------------------
-- DROP TABLE Keywords_h;

CREATE TABLE Keywords_h            -- Keywords_hierarchies
  ( keyword_code int4,             --   
    keyword_code_parent int4,      --    
    include_all_flag bool          --    
      NOT NULL DEFAULT 'yes',      --      
                                   --  (   
                                   --   hier_depth)
    hier_depth int2                --  ,  
      NOT NULL DEFAULT 0           --     
      CHECK ( hier_depth >= 0 ),   --  ( ,  include_all_flag
                                   --  'no')
                                   -- .  include_all_flag 
                                   --             'no',  hier_depth = 0
                                   --               
                                   --               
                                   --                 .
    comment text,                  -- 
    --  
    who_chg text DEFAULT USER,     --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,   --   () 
    PRIMARY KEY ( keyword_code, keyword_code_parent ),
    FOREIGN KEY ( keyword_code )
      REFERENCES Keywords ( keyword_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    -- TODO      
    --                
    --       (    , ,
    --      ).       .
    FOREIGN KEY ( keyword_code_parent )
      REFERENCES Keywords ( keyword_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  ""
-- .       
--                 .
-- ---------------------------------------------------------------------------
-- DROP TABLE Notes;

CREATE TABLE Notes
  ( obj_ID int4 NOT NULL,         --   
                                  --  
    bib_rec_num int2              --  .    
      NOT NULL DEFAULT 0          -- (    0)
      CHECK ( bib_rec_num >= 0 ),
    note_num int2                 --   
      NOT NULL DEFAULT 1,
    note_text text NOT NULL,      --   (  . )
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( obj_ID, bib_rec_num, note_num ),
    FOREIGN KEY ( obj_ID, bib_rec_num )
      REFERENCES Bib_recs ( obj_ID, bib_rec_num )
      ON DELETE CASCADE
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  "-"
-- ---------------------------------------------------------------------------
-- DROP TABLE Obj_containers;

CREATE TABLE Obj_containers       -- Objects_containers
  ( obj_ID int4,                  --   
                                  --  
                                  -- ( )
    bib_rec_num int2              --  .    
      NOT NULL DEFAULT 0          -- (    0)
      CHECK ( bib_rec_num >= 0 ),
    part_num int2 NOT NULL        --   
      DEFAULT 1
      CHECK ( part_num >= 1 ),
    obj_ID_cont int4,             --   
                                  --  ,  
                                  --   
                                  -- (-)
    bib_rec_num_cont int2         --  .    
      NOT NULL DEFAULT 0          -- (    0)
      CHECK ( bib_rec_num_cont >= 0 ),
    part_place text,              --  ,   
                                  --   (   8 .
                                  --  )
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( obj_ID, bib_rec_num, obj_ID_cont, bib_rec_num_cont ),
    UNIQUE ( obj_ID, bib_rec_num, part_num ),
    FOREIGN KEY ( obj_ID, bib_rec_num )
      REFERENCES Bib_recs ( obj_ID, bib_rec_num )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( obj_ID_cont, bib_rec_num_cont )
      REFERENCES Bib_recs ( obj_ID, bib_rec_num )
      ON DELETE CASCADE
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  "   "
-- ---------------------------------------------------------------------------
-- DROP TABLE Obj_deps;

CREATE TABLE Obj_deps             -- Objects_dependencies
  ( base_obj_ID int4,             --   
                                  --  ,
                                  --  
    dep_obj_ID int4,              --   
                                  --  ,
                                  --  
    dep_type_code int2,           --   
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( base_obj_ID, dep_obj_ID, dep_type_code ),
    FOREIGN KEY ( base_obj_ID )
      REFERENCES Bib_objs ( obj_ID )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( dep_obj_ID )
      REFERENCES Bib_objs ( obj_ID )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( dep_type_code )
      REFERENCES Dep_types ( dep_type_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  "   () 
--  "
-- ---------------------------------------------------------------------------
-- DROP TABLE Obj_groups_descrs CASCADE;

CREATE TABLE Obj_groups_descrs
  ( tmp_group_code int2,            --    
    tmp_group_name text NOT NULL,   --   
    tmp_group_descr text NOT NULL,  --   
    tmp_group_date date NOT NULL,   --    
    comment text,                   -- 
    --  
    who_chg text DEFAULT USER,      --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,    --   () 
    PRIMARY KEY ( tmp_group_code ),
    UNIQUE ( tmp_group_name )
  );

-- ---------------------------------------------------------------------------
--  "   () 
--  "
-- ---------------------------------------------------------------------------
-- DROP TABLE Obj_groups;

CREATE TABLE Obj_groups
  ( tmp_group_code int2,          --    
    obj_ID int4,                  --   
                                  --  
    bib_rec_num int2              --  .    
      NOT NULL DEFAULT 0          -- (    0)
      CHECK ( bib_rec_num >= 0 ),
    tmp_group_inc_date date       --   
      NOT NULL,                   --   
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( tmp_group_code, obj_ID, bib_rec_num ),
    FOREIGN KEY ( tmp_group_code )
      REFERENCES Obj_groups_descrs ( tmp_group_code )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( obj_ID, bib_rec_num )
      REFERENCES Bib_recs ( obj_ID, bib_rec_num )
      ON DELETE CASCADE
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  " ,    "
-- ---------------------------------------------------------------------------
-- DROP TABLE Obj_keywords;

CREATE TABLE Obj_keywords
  ( obj_ID int4,                  --   
                                  --  
    keyword_code int4,            --   
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( obj_ID, keyword_code ),
    FOREIGN KEY ( obj_ID )
      REFERENCES Bib_objs ( obj_ID )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( keyword_code )
      REFERENCES Keywords ( keyword_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- DROP INDEX Obj_keywords_ind_1;
CREATE INDEX Obj_keywords_ind_1 ON Obj_keywords ( keyword_code, obj_ID );

-- ---------------------------------------------------------------------------
--  "    "
-- ---------------------------------------------------------------------------
-- DROP TABLE Obj_langs;

CREATE TABLE Obj_langs
  ( obj_ID int4,                  --   
                                  --  
    lang_code int2                --   (1 -  )
      NOT NULL DEFAULT 1,
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( obj_ID, lang_code ),
    FOREIGN KEY ( obj_ID )
      REFERENCES Bib_objs ( obj_ID )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( lang_code )
      REFERENCES Langs ( lang_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  ", ,  "
-- ---------------------------------------------------------------------------
-- DROP TABLE Orgs CASCADE;

CREATE TABLE Orgs               -- Organizations
  ( org_ID int4,                --   
    org_fname text NOT NULL,    --   
    org_sname text NOT NULL,    --   
    org_city_code int2          --   ()
      NOT NULL,
    org_addr text,              --  
    org_email text,             --   
    org_descr text,             --   , . 
    org_ID_orig int4,           --  ,   
                                -- (  , 
                                --   )
    org_ID_parent int4,         --   
                                -- .   
                                --     
                                --   " "  "
                                -- "    
                                -- ,     
                                -- : 
                                -- [.-  ] -
    org_tmp_flag bool NOT NULL  --    ()
      DEFAULT 'no',
    lang_code int2              --  ,    
      NOT NULL DEFAULT 1,       --  (1 -  )
    process_code int2           --     
      NOT NULL DEFAULT 1,       -- (1 - , ..   , 
                                --    . )
    comment text,               -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    --         ,
    --       (.. 
    -- ,      ..) -   
    --  ,      ,   
    --      "",   ;
    -- ,      ,
    --   NULL     org_ID_orig
    -- .   ,    
    --              ( org_ID_parent    NULL) 
    --               ,      
    --               .
    -- TODO        ,   -   
    --             " "      
    --                 .
    CHECK ( NOT ( org_ID_orig IS NOT NULL and org_ID_parent IS NOT NULL ) ),
    PRIMARY KEY ( org_ID ),
    FOREIGN KEY ( org_city_code )
      REFERENCES Cities ( city_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( lang_code )
      REFERENCES Langs ( lang_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( process_code )
      REFERENCES Process_types ( process_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    -- .   (,      
    -- )
    FOREIGN KEY ( org_ID_orig )
      REFERENCES Orgs ( org_ID )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    -- .   (,      
    -- )
    FOREIGN KEY ( org_ID_parent )
      REFERENCES Orgs ( org_ID )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  "  , "
-- ---------------------------------------------------------------------------
-- DROP TABLE Orgs_act;

CREATE TABLE Orgs_act             -- Orgs_activities
  ( org_ID int4,                  --   
    act_type_code int2,           --   
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( org_ID, act_type_code ),
    FOREIGN KEY ( org_ID )
      REFERENCES Orgs ( org_ID )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( act_type_code )
      REFERENCES Activity_types ( act_type_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  ", , , ,  ..."
-- .  -  .
-- ---------------------------------------------------------------------------
-- DROP TABLE Confs CASCADE;

CREATE TABLE Confs
  ( conf_code int4,                  --   
    conf_fname text NOT NULL,        --   () 
    conf_place text NOT NULL,        --   ( , ..
                                     --     
                                     -- )
    conf_date_beg date NOT NULL,     --    
    conf_date_end date NOT NULL,     --    
    conf_status_code int2 NOT NULL,  --    (,
                                     --  ...)
    conf_foreign_flag bool           --   
      NOT NULL DEFAULT 'no',         -- (..,   )
    conf_type_code int2 NOT NULL,    --    (,
                                     -- ,  ...)
    conf_num text,                   --   (  text
                                     --   )
    conf_code_orig int4,             --    (  ,
                                     -- )
    comment text,                    -- 
    --  
    who_chg text DEFAULT USER,       --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,     --   () 
    CHECK ( conf_date_beg <= conf_date_end ),
    PRIMARY KEY ( conf_code ),
    FOREIGN KEY ( conf_code )
      REFERENCES Orgs ( org_ID )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( conf_status_code )
      REFERENCES Conf_status_types ( conf_status_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( conf_type_code )
      REFERENCES Conf_types ( conf_type_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    --         
    FOREIGN KEY ( conf_code_orig )
      REFERENCES Confs ( conf_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  " , , , ,
--  ..."
-- .  , ,   .
-- TODO             .
-- ---------------------------------------------------------------------------
-- DROP TABLE Confs_maters;

CREATE TABLE Confs_maters         -- Conferences_materials
  ( conf_code int4,               --   
    obj_ID int4,                  --   
                                  --  
    bib_rec_num int2              --  .    
      NOT NULL DEFAULT 0          -- (    0)
      CHECK ( bib_rec_num >= 0 ),
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( obj_ID, bib_rec_num, conf_code ),
    FOREIGN KEY ( conf_code )
      REFERENCES Confs ( conf_code )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( obj_ID, bib_rec_num )
      REFERENCES Bib_recs ( obj_ID, bib_rec_num )
      ON DELETE CASCADE
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  ""
-- ---------------------------------------------------------------------------
-- DROP TABLE Persons CASCADE;

CREATE TABLE Persons
  ( pers_ID int4,               --   
    pers_name text NOT NULL,    --  , , 
                                -- .    
                                --                .
    pers_life_years text,       --  
    pers_add_info text,         --   (/,
                                -- /, ...  , ...)
    pers_ID_orig int4,          --  ,   
                                -- (  , 
                                --   )
    lang_code int2              --  ,    
      NOT NULL DEFAULT 1,       -- . . .  (1 -  )
    process_code int2           --     
      NOT NULL DEFAULT 1,       -- (1 - , ..   , 
                                --    . )
    pers_addr text,             -- 
    pers_email text,            --  
    comment text,               -- 
    --  
    who_chg text DEFAULT USER,   --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP, --   () 
    PRIMARY KEY ( pers_ID ),
    FOREIGN KEY ( lang_code )
      REFERENCES Langs ( lang_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( process_code )
      REFERENCES Process_types ( process_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( pers_ID_orig )
      REFERENCES Persons ( pers_ID )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- DROP INDEX Persons_ind_1;
CREATE INDEX Persons_ind_1 ON Persons ( pers_name );

-- ---------------------------------------------------------------------------
--  "   "
-- ---------------------------------------------------------------------------
-- DROP TABLE Prices;

CREATE TABLE Prices
  ( obj_ID int4 NOT NULL,          --   
                                   --  
    price numeric( 14,2 ),         -- :
                                   --  NULL -    ( );
                                   --  0 -  
                                   -- .     
                                   --                (
                                   --                ), 
                                   --                 
                                   --             comment.
    price_flag numeric( 1 )        --   :
      NOT NULL DEFAULT 1           --  0 - "" ;
      CHECK ( price_flag >= 0 and  --  1 -  ;
              price_flag <= 3 ),   --  2 - ". ." (" ");
                                   --  3 -  
    currency_code int2,            --  
    exchange_rate numeric( 14,2 ), --     
    price_note text,               --    
    comment text,                  -- 
    --  
    who_chg text DEFAULT USER,     --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,   --   () 
    PRIMARY KEY ( obj_ID ), 
    FOREIGN KEY ( obj_ID )
      REFERENCES Bib_objs ( obj_ID )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( currency_code )
      REFERENCES Currencies ( currency_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  " , , "
-- ---------------------------------------------------------------------------
-- DROP TABLE Pub_print_date;

CREATE TABLE Pub_print_date
  ( obj_ID int4 NOT NULL,         --   
                                  --  
    pub_date_begin text,          --   
                                  -- .      
                                  --             text, ..   
                                  --             [1988], 198?, 197-, ...
    dash_flag bool NOT NULL       --   ,   
      DEFAULT 'no',               --     
                                  -- (   ,   
                                  --  )
    pub_date_end text,            --   
    print_date text,              --  , 
    sine_anno_flag bool NOT NULL  --  "  (sine anno)"
      DEFAULT 'no',
    pub_print_date_sure_flag bool --    
      NOT NULL DEFAULT 'yes',     -- (    ,  
                                  --     - [])
                                  -- (   -   
                                  --  ,    
                                  --   'no',      
                                  --   )
                                  -- .    
                                  --               .
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    --     ,    ,   
    -- pub_date_begin   "?"
    CHECK ( NOT ( pub_date_begin IS NULL and pub_date_end IS NOT NULL ) ),
    CHECK ( ( sine_anno_flag = 'yes' and
              pub_date_begin IS NULL and dash_flag = 'no' and 
              pub_date_end IS NULL and print_date IS NULL
            ) or
            ( sine_anno_flag = 'no' and
              ( pub_date_begin IS NOT NULL or pub_date_end IS NOT NULL or
                print_date IS NOT NULL
              )
            )
          ),
    PRIMARY KEY ( obj_ID ),
    FOREIGN KEY ( obj_ID )
      REFERENCES Bib_objs ( obj_ID )
      ON DELETE CASCADE
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  " , "
-- ---------------------------------------------------------------------------
-- DROP TABLE Pub_print_place;

CREATE TABLE Pub_print_place
  ( obj_ID int4,                   --   
                                   --  
    bib_rec_num int2               --  .    
      NOT NULL DEFAULT 0           -- (    0)
      CHECK ( bib_rec_num >= 0 ),
    group_num int2                 --      
      DEFAULT 1
      CHECK ( group_num >= 1 ),
    place_num int2                 --      
      DEFAULT 1
      CHECK ( place_num >= 1 ),
    --    ,      ( ),
    --   
    city_country_flag numeric( 1 ) --  "/"
      DEFAULT 1                    -- (1 - ; 2 - )
      CHECK ( city_country_flag = 1 or city_country_flag = 2 or
              city_country_flag IS NULL ),
    city_code int2                 --   (  )
      NOT NULL DEFAULT 0,
    country_code int2              --   ( ,   
      NOT NULL DEFAULT 0,          --  )

    pub_print_flag numeric( 1 )    --  "/"
      NOT NULL DEFAULT 1           -- (1 - ; 2 - )
      CHECK ( pub_print_flag = 1 or pub_print_flag = 2 ),
    sine_loco_flag bool NOT NULL   --  "  (sine loco)"
      DEFAULT 'no',
    place_sure_flag bool NOT NULL  --     
      DEFAULT 'yes',               -- (    ,
                                   --   - [])
                                   -- .    
                                   --               .
    place_add_info text,           --     /
                                   --  (,  
                                   --     )
    comment text,                  -- 
    --  
    who_chg text DEFAULT USER,     --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,   --   () 
    --    ( ,  ) ,  
    -- sine_loco_flag   'no'      city_code 
    -- country_code     city_country_flag
    CHECK ( ( sine_loco_flag = 'yes' and city_country_flag IS NULL ) or
            ( sine_loco_flag = 'no' and 
              -- 
              ( ( city_country_flag = 1 and city_code <> 0 and
                                            country_code = 0
                ) or
              --  
                ( city_country_flag = 2 and city_code = 0 and
                                            country_code <> 0
                )
              )
            )
          ),
    PRIMARY KEY ( obj_ID, bib_rec_num, group_num, place_num ),
    -- UNIQUE ( obj_ID, bib_rec_num, group_num, place_num ),
    FOREIGN KEY ( obj_ID, bib_rec_num )
      REFERENCES Bib_recs ( obj_ID, bib_rec_num )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( city_code )
      REFERENCES Cities ( city_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( country_code )
      REFERENCES Countries ( country_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- DROP INDEX Pub_print_place_ind_1;
CREATE INDEX Pub_print_place_ind_1 ON Pub_print_place ( city_code, obj_ID );

-- ---------------------------------------------------------------------------
--  ", , "
-- ---------------------------------------------------------------------------
-- DROP TABLE Pub_printer;

CREATE TABLE Pub_printer          -- Publisher_printer
  ( obj_ID int4,                  --   
                                  --  
    bib_rec_num int2              --  .    
      NOT NULL DEFAULT 0          -- (    0)
      CHECK ( bib_rec_num >= 0 ),
    group_num int2                --     
      DEFAULT 1
      CHECK ( group_num >= 1 ),
    pub_num int2                  --  , 
      DEFAULT 1                   --   
      CHECK ( pub_num >= 1 ),
    pers_org_flag numeric( 1 )    --  "/"
      DEFAULT 2                   -- (1 - ; 2 - )
      CHECK ( pers_org_flag = 1 or pers_org_flag = 2 or 
              pers_org_flag IS NULL ),
    pub_org_ID int4               --  ,  ...
      NOT NULL DEFAULT 0,         -- ()
    pub_pers_ID int4              --  ,  ...
      NOT NULL DEFAULT 0,         -- ()
    pub_print_flag numeric( 1 )   --  "/"
      NOT NULL DEFAULT 1          --
      CHECK ( pub_print_flag = 1 or  -- 1 - ;
              pub_print_flag = 2 or  -- 2 - ;
              pub_print_flag = 3 ),  -- 3 - 
    pub_func text,                 --   ()
    sine_nomine_flag bool NOT NULL --  "  (sine nomine)"
      DEFAULT 'no',
    pub_print_sure_flag bool      --    
      NOT NULL DEFAULT 'yes',     -- (    ,
                                  --   - [])
                                  -- .   
                                  --               .
    pub_print_add_info text,      --     /
                                  --  (,  
                                  --     )
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    --   ( ,  ) ,  
    -- sine_nomine_flag   'no'      pub_org_ID
    --  pub_pers_ID     pers_org_flag
    CHECK ( ( sine_nomine_flag = 'yes' and pers_org_flag IS NULL ) or
            ( sine_nomine_flag = 'no' and 
              -- 
              ( ( pers_org_flag = 1 and pub_pers_ID <> 0 and
                                        pub_org_ID = 0
                ) or
              -- 
                ( pers_org_flag = 2 and pub_pers_ID = 0 and
                                        pub_org_ID <> 0
                )
              )
            )
          ),
    PRIMARY KEY ( obj_ID, bib_rec_num, group_num, pub_num ),
    -- UNIQUE ( obj_ID, bib_rec_num, group_num, pub_num ),
    FOREIGN KEY ( obj_ID, bib_rec_num )
      REFERENCES Bib_recs ( obj_ID, bib_rec_num )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( pub_pers_ID )
      REFERENCES Persons ( pers_ID )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( pub_org_ID )
      REFERENCES Orgs ( org_ID )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- DROP INDEX Pub_printer_ind_1;
CREATE INDEX Pub_printer_ind_1 ON Pub_printer ( pub_org_ID, obj_ID );

-- DROP INDEX Pub_printer_ind_2;
CREATE INDEX Pub_printer_ind_2 ON Pub_printer ( pub_pers_ID, obj_ID );

-- ---------------------------------------------------------------------------
--  "/"
-- ---------------------------------------------------------------------------
-- DROP TABLE Series CASCADE;

CREATE TABLE Series
  ( series_ID int2,               --   /
    series_ISSN text              -- ISSN,  /
      UNIQUE,
    subser_flag bool              --  
      NOT NULL DEFAULT 'no',
    series_ID_parent int2,        --    ()
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( series_ID ),
    FOREIGN KEY ( series_ID_parent )
      REFERENCES Series ( series_ID )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  " /"
-- ---------------------------------------------------------------------------
-- DROP TABLE Ser_descrs;

CREATE TABLE Ser_descrs          -- Series_descriptions
  ( series_ID int2,              --   /
    ser_descr_num int2           --   /
      NOT NULL DEFAULT 0         -- ( ,   bib_rec_num)
      CHECK ( ser_descr_num >= 0 ), -- (    0)
    ser_descr text NOT NULL,     --  /
    lang_code int2               --  ,   
      NOT NULL DEFAULT 1,        --  / (1 -  )
    process_code int2            --     /
      NOT NULL DEFAULT 1,        -- (1 - , ..   , 
                                 --    . )
    reason_add_descr text,       --  .  ( 
                                 --  )
    comment text,                -- 
    --  
    who_chg text DEFAULT USER,   --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP, --   () 
    PRIMARY KEY ( series_ID, ser_descr_num ),
    FOREIGN KEY ( series_ID )
      REFERENCES Series ( series_ID )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( lang_code )
      REFERENCES Langs ( lang_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( process_code )
      REFERENCES Process_types ( process_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  " /"
-- ---------------------------------------------------------------------------
-- DROP TABLE Ser_titles;

CREATE TABLE Ser_titles
  ( series_ID int2,                 --   /
    ser_descr_num int2              --   /
      NOT NULL DEFAULT 0            -- ( ,   bib_rec_num)
      CHECK ( ser_descr_num >= 0 ), -- (    0)
    ser_title_num int2              --  
      NOT NULL DEFAULT 0            -- (0 - ; 1, 2, ... - )
      CHECK ( ser_title_num >= 0 ),
    ser_title text NOT NULL,        --  /
    ser_title_info text,            -- ,   
                                    -- (  ":")
    lang_code int2                  --  ,    
      NOT NULL DEFAULT 1,           -- (1 -  )
    process_code int2               --    
      NOT NULL DEFAULT 1,           -- (1 - )
    comment text,                   -- 
    --  
    who_chg text DEFAULT USER,      --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,    --   () 
    PRIMARY KEY ( series_ID, ser_descr_num, ser_title_num ),
    FOREIGN KEY ( series_ID, ser_descr_num )
      REFERENCES Ser_descrs ( series_ID, ser_descr_num )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( lang_code )
      REFERENCES Langs ( lang_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( process_code )
      REFERENCES Process_types ( process_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  "   "
-- ---------------------------------------------------------------------------
-- DROP TABLE Obj_series;

CREATE TABLE Obj_series
  ( obj_ID int4,                    --   
                                    --  
    bib_rec_num int2                --  .   
      NOT NULL DEFAULT 0            --  (    0)
      CHECK ( bib_rec_num >= 0 ),
    series_ID int2,                 --   /
    ser_descr_num int2              --   /
      NOT NULL DEFAULT 0            -- ( ,   bib_rec_num)
      CHECK ( ser_descr_num >= 0 ), -- (    0)
    issue_num text,                 --    /
                                    -- (    , .. 
                                    --   )
    comment text,                   -- 
    --  
    who_chg text DEFAULT USER,      --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,    --   () 
    PRIMARY KEY ( obj_ID, bib_rec_num, series_ID, ser_descr_num ),
    FOREIGN KEY ( obj_ID, bib_rec_num )
      REFERENCES Bib_recs ( obj_ID, bib_rec_num )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( series_ID, ser_descr_num )
      REFERENCES Ser_descrs ( series_ID, ser_descr_num )
      ON DELETE CASCADE
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  "     
-- "
-- .       
--                  .
-- ---------------------------------------------------------------------------
-- DROP TABLE Refs_descrs;

CREATE TABLE Refs_descrs          -- Obj_references_descriptions
  ( obj_ID int4 NOT NULL,         --   
                                  --  
    bib_rec_num int2              --  .    
      NOT NULL DEFAULT 0          -- (    0)
      CHECK ( bib_rec_num >= 0 ),
    ref_num int2                  --   ( )
      NOT NULL DEFAULT 1          --     
      CHECK ( ref_num >= 1 ),     --  . 
    ref_type_code int2 NOT NULL,  --    
    ref_descr text NOT NULL,      --  ()  ,
                                  --    . 
                                  -- (   ,
                                  --        )
    ref_vol text,                 --     
                                  -- ,    
                                  -- .   
                                  --             ,   
                                  --               .
    ref_original_flag bool        --   
      NOT NULL DEFAULT 'yes',     -- (   ,
                                  --     'no')
    ref_complete_flag bool        --    
      NOT NULL DEFAULT 'no',      --    
                                  -- (    , ,
                                  --   ,   'no')
    lang_code int2                --  ,    
      NOT NULL DEFAULT 1,         --   (1 -  )
    process_code int2             --     
      NOT NULL DEFAULT 1,         --   (1 - ,
                                  -- ..   ,    
                                  -- .    
                                  -- )
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( obj_ID, bib_rec_num, ref_num ),
    FOREIGN KEY ( obj_ID, bib_rec_num )
      REFERENCES Bib_recs ( obj_ID, bib_rec_num )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( ref_type_code )
      REFERENCES Ref_types ( ref_type_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( lang_code )
      REFERENCES Langs ( lang_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( process_code )
      REFERENCES Process_types ( process_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  "    
-- "
-- ---------------------------------------------------------------------------
-- DROP TABLE Refs_contents;

CREATE TABLE Refs_contents        -- Obj_references_contents
  ( obj_ID int4 NOT NULL,         --   
                                  --  
    bib_rec_num int2              --  .    
      NOT NULL DEFAULT 0          -- (    0)
      CHECK ( bib_rec_num >= 0 ),
    ref_num int2                  --   ( )
      NOT NULL DEFAULT 1          --     
      CHECK ( ref_num >= 1 ),     --  . 
    ref_elem text NOT NULL,       --   
                                  -- (,   
                                  --  )
    ref_elem_descr text,          --    
                                  -- (,  ,  
                                  --   ,  
                                  --    )
    lang_code int2                --  ,    
      NOT NULL DEFAULT 1,         --   (1 -  )
                                  -- .    
                                  --              . , 
                                  --             ,   --
                                  --               .
    process_code int2             --     
      NOT NULL DEFAULT 1,         --   (1 - ,
                                  -- ..   ,    
                                  --   . )
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( obj_ID, bib_rec_num, ref_num, ref_elem ),
    FOREIGN KEY ( obj_ID, bib_rec_num, ref_num )
      REFERENCES Refs_descrs ( obj_ID, bib_rec_num, ref_num )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( lang_code )
      REFERENCES Langs ( lang_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( process_code )
      REFERENCES Process_types ( process_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  "  "
-- .   pers_org_flag    
--                   Persons   
--              Orgs (   -   1:1),  
--                 ,    
--             :     .
-- ---------------------------------------------------------------------------
-- DROP TABLE Resp_stat;

CREATE TABLE Resp_stat            -- Responsibility_statement
  ( obj_ID int4,                  --   
                                  --  
    bib_rec_num int2              --  .    
      NOT NULL DEFAULT 0          -- (    0)
      CHECK ( bib_rec_num >= 0 ),
    resp_type numeric( 1 )        --  
      NOT NULL DEFAULT 1          -- (1 -   ;
      CHECK ( resp_type >= 1 and  --  2 - .  ., 
              resp_type <= 5 ),   --        ;
                                  --  3 - .  ., 
                                  --       .    ;
                                  --  4 - ...  ;
                                  --  5 - ...  )
    resp_num_in_type int2         --      
      NOT NULL DEFAULT 1
      CHECK ( resp_num_in_type >= 1 ),
    resp_num int2                 --     
      NOT NULL DEFAULT 1          -- (    
      CHECK ( resp_num >= 1 ),    --      
                                  --  )
    role_code int2 NOT NULL,      --  
    pers_org_flag numeric( 1 )    --  "/"
      NOT NULL DEFAULT 1          -- (1 - ; 2 - )
      CHECK ( pers_org_flag = 1 or pers_org_flag = 2 ),
    resp_pers_ID int4             --    ()
      NOT NULL DEFAULT 0,
    resp_org_ID int4              --    ()
      NOT NULL DEFAULT 0,

    -- .   series_num     
    --             ,   ,      
    --               ,     
    --                 resp_num_in_type  ()
    --              100   ,  200 -    ..

    series_num int2               --  /  
      CHECK ( series_num IS NULL  --  
              or series_num >= 1 ),
    series_ID int2,               --   /
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    CHECK ( ( pers_org_flag = 1 and resp_pers_ID > 0 and resp_org_ID = 0 )
            or 
            ( pers_org_flag = 2 and resp_pers_ID = 0 and resp_org_ID > 0 )
          ),
    PRIMARY KEY ( obj_ID, bib_rec_num, resp_type, resp_num_in_type, resp_num ),
    FOREIGN KEY ( obj_ID, bib_rec_num )
      REFERENCES Bib_recs ( obj_ID, bib_rec_num )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( role_code )
      REFERENCES Roles ( role_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( resp_pers_ID )
      REFERENCES Persons ( pers_ID )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( resp_org_ID )
      REFERENCES Orgs ( org_ID )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( series_ID )
      REFERENCES Series ( series_ID )
      ON DELETE CASCADE
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  "  -  "
-- ---------------------------------------------------------------------------
-- DROP TABLE Spec_er;

CREATE TABLE Spec_er              -- Specific_electronic_resources
  ( obj_ID int4,                  --   
                                  --  
    bib_rec_num int2              --  .    
      NOT NULL DEFAULT 0          -- (    0)
      CHECK ( bib_rec_num >= 0 ),
    spec_er_num int2              --   
      DEFAULT 1                   -- .   .
      CHECK ( spec_er_num >= 1 ),
    spec_er_text text NOT NULL,   --   
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( obj_ID, bib_rec_num, spec_er_num ),
    FOREIGN KEY ( obj_ID, bib_rec_num )
      REFERENCES Bib_recs ( obj_ID, bib_rec_num )
      ON DELETE CASCADE
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  "  -  "
-- .   ,    ,   -
--             ,     NOT NULL.
-- ---------------------------------------------------------------------------
-- DROP TABLE Spec_maps;

CREATE TABLE Spec_maps
  ( obj_ID int4,                  --   
                                  --  
    bib_rec_num int2              --  .    
      NOT NULL DEFAULT 0          -- (    0)
      CHECK ( bib_rec_num >= 0 ),
    map_scale text,               -- 
    map_projection text,          --  
    map_coord text,               -- 
    map_equinox text,             --     
                                  -- (  )
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    --        
    CHECK ( map_scale IS NOT NULL or map_projection IS NOT NULL or
            map_coord IS NOT NULL or map_equinox IS NOT NULL ),
    PRIMARY KEY ( obj_ID, bib_rec_num ),
    FOREIGN KEY ( obj_ID, bib_rec_num )
      REFERENCES Bib_recs ( obj_ID, bib_rec_num )
      ON DELETE CASCADE
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  "    ; 
-- "
-- ---------------------------------------------------------------------------
-- DROP TABLE Spec_mater;

CREATE TABLE Spec_mater           -- Specific_material_designation
  ( obj_ID int4,                  --   
                                  --  
    bib_rec_num int2              --  .    
      NOT NULL DEFAULT 0          -- (    0)
      CHECK ( bib_rec_num >= 0 ),
    spec_mat_num int2             --     
      NOT NULL DEFAULT 1          --    . 
      CHECK ( spec_mat_num >= 1 ),-- (     
                                  --   
                                  --     )
    spec_mat_code int2,           --    
    total_extent numeric( 6 ),    --     
                                  -- (, "378" (  ..))
    orig_extent text NOT NULL,    --    ,   
                                  --   (, XXV ., 354 .,
                                  -- [10 .]) 
    phys_add_info text,           --     
    orig_dimensions text,         --  (    )
    size_sheet text,              --   ( ) (, 60x90)
    part_sheet text,              --   ( ) (, 1/16)
    accomp_flag bool NOT NULL     --   
      DEFAULT 'no',
    accomp_title text,            --   
    accomp_obj_ID int4,           --   
                                  --  ,  
                                  --   
                                  --  
    pack_code int2,               --   
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( obj_ID, bib_rec_num, spec_mat_num ),
    FOREIGN KEY ( obj_ID, bib_rec_num )
      REFERENCES Bib_recs ( obj_ID, bib_rec_num )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( spec_mat_code )
      REFERENCES Spec_mater_types ( spec_mat_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    --    ,   
    -- ,    Spec_mater  , 
    --        
    --  . 
    FOREIGN KEY ( accomp_obj_ID )
      REFERENCES Bib_objs ( obj_ID )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( pack_code )
      REFERENCES Pack_types ( pack_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  "  -  "
-- ---------------------------------------------------------------------------
-- DROP TABLE Spec_music;

CREATE TABLE Spec_music
  ( obj_ID int4,                  --   
                                  --  
    bib_rec_num int2              --  .    
      NOT NULL DEFAULT 0          -- (    0)
      CHECK ( bib_rec_num >= 0 ),
    music_info text NOT NULL,     -- ,  (), 
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( obj_ID, bib_rec_num ),
    FOREIGN KEY ( obj_ID, bib_rec_num )
      REFERENCES Bib_recs ( obj_ID, bib_rec_num )
      ON DELETE CASCADE
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  "  -  "
-- .   ,    ,   -
--             ,     NOT NULL.
-- ---------------------------------------------------------------------------
-- DROP TABLE Spec_patents;

CREATE TABLE Spec_patents
  ( obj_ID int4,                  --   
                                  --  
    bib_rec_num int2              --  .    
      NOT NULL DEFAULT 0          -- (    0)
      CHECK ( bib_rec_num >= 0 ),
    pat_request_reg_num text,     --    
                                  --  
    pat_request_date date,        --   () 
    pat_pub_date date,            --  
    pat_edition text,             --    ,  
                                  --     
    --    
    -- TODO    ?     NOT NULL.
    pat_request_date_conv date,   --   
    pat_request_num_conv text,    --  
    pat_country_code int2,        --    
    pat_class_index text,         --    
                                  -- 
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( obj_ID, bib_rec_num ),
    FOREIGN KEY ( obj_ID, bib_rec_num )
      REFERENCES Bib_recs ( obj_ID, bib_rec_num )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( pat_country_code )
      REFERENCES Countries ( country_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  "  -  "
-- ---------------------------------------------------------------------------
-- DROP TABLE Spec_serials;

CREATE TABLE Spec_serials
  ( obj_ID int4,                  --   
                                  --  
    bib_rec_num int2              --  .    
      NOT NULL DEFAULT 0          -- (    0)
      CHECK ( bib_rec_num >= 0 ),
    numer_area text NOT NULL,     --  
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( obj_ID, bib_rec_num ),
    FOREIGN KEY ( obj_ID, bib_rec_num )
      REFERENCES Bib_recs ( obj_ID, bib_rec_num )
      ON DELETE CASCADE
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  "  -   (  )"
-- ---------------------------------------------------------------------------
-- DROP TABLE Spec_stds;

CREATE TABLE Spec_stds            -- Spec_standards
  ( obj_ID int4,                  --   
                                  --  
    bib_rec_num int2              --  .    
      NOT NULL DEFAULT 0          -- (    0)
      CHECK ( bib_rec_num >= 0 ),
    std_prev text,                --    
    std_date text,                --  
    std_term text,                --  
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    --        
    CHECK ( std_prev IS NOT NULL or std_date IS NOT NULL or 
            std_term IS NOT NULL ),
    PRIMARY KEY ( obj_ID, bib_rec_num ),
    FOREIGN KEY ( obj_ID, bib_rec_num )
      REFERENCES Bib_recs ( obj_ID, bib_rec_num )
      ON DELETE CASCADE
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  "  (ISBN, ISSN  .),  
--  "
-- ---------------------------------------------------------------------------
-- DROP TABLE Std_nums;

CREATE TABLE Std_nums             -- Standard_numbers
  ( obj_ID int4,                  --   
                                  --  
    std_num_code int2 NOT NULL,   --    
    std_num_val text,             --   (ISBN, ISSN ...)
    std_num_note text,            --    
                                  -- 
    std_num_wrong bool            --    
      DEFAULT 'no',               -- (ISBN  ISSN)
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( obj_ID, std_num_val ),
    FOREIGN KEY ( obj_ID )
      REFERENCES Bib_objs ( obj_ID )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( std_num_code )
      REFERENCES Std_num_types ( std_num_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- DROP INDEX Std_nums_ind_1;
CREATE INDEX Std_nums_ind_1 ON Std_nums ( std_num_val );

-- ---------------------------------------------------------------------------
--  " ( )"
-- ---------------------------------------------------------------------------
-- DROP TABLE Stor_objs;

CREATE TABLE Stor_objs            -- Storage_objects
  ( obj_ID int4,                  --   
                                  --  
    stor_obj_num int2             --     
      DEFAULT 1                   --   . 
      CHECK ( stor_obj_num >= 1 ),-- (   
                                  -- , ,   
                                  --   ,    ,
                                  --       
                                  --   ..)
    --       
    pers_org_flag numeric( 1 )    --  "/"
      NOT NULL DEFAULT 1          -- (1 - ; 2 - )
      CHECK ( pers_org_flag = 1 or pers_org_flag = 2 ),
    owner_pers_ID int4            --   ()
      NOT NULL DEFAULT 0,
    owner_org_ID int4             --   ()
      NOT NULL DEFAULT 0,
    -- ----------------------------------------------------------
    phys_form_code int2 NOT NULL, --   ,  
                                  --   
    stor_obj_code text,           --  ()  
                                  -- (,   
                                  --  )
                                  -- (     )
    stor_place text,              --   (,   CD-ROM
                                  -- - (  )
    stor_obj_add_info text,       -- .      
                                  --    
                                  -- (,     ;
                                  --   (..   
                                  --  ))
    stor_obj_defects text,        --    (,
                                  -- ,  , 
                                  --   ,  
                                  --  ..)
    stor_obj_phys_cond numeric( 2 ) --    
      NOT NULL                    --    10- 
      CHECK ( stor_obj_phys_cond >= 1 and stor_obj_phys_cond <= 10 ),
    stor_obj_complete bool        --   
      NOT NULL DEFAULT 'yes',     -- ('no' - , , 
                                  --  .  
                                  --    stor_obj_defects)
    --   
    acq_date date,                --  
                                  -- (     
                                  -- ,     
                                  -- ,      - 
                                  --    ,  
                                  --  ,   NULL)
    acq_date_precise bool,        --    
                                  -- (    - 'yes',
                                  --  ,   , - 'no',
                                  --     - NULL)
    acq_date_note text,           --    
    acq_place_city int2,          --   (  )
    acq_place_country int2,       --   ( )
                                  -- (,    
                                  --    )
    acq_way_code int2,            --   
    stor_obj_price_curr           --  ()  
      numeric( 14,2 ),            --  (   
                                  --   )
    currency_code int2,           --  
    exchange_rate                 --     
      numeric( 14,5 ),            -- (..  , 
                                  --    1  
                                  --  )
    stor_obj_price                --    
      numeric( 14,2 ),            -- (    
                                  --  )
    stor_obj_price_note text,     --    
    acq_note text,                -- .   
    remove_stor_obj_flag bool     --    
      NOT NULL DEFAULT 'no',
    remove_stor_obj_note text,    -- .     
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    CHECK ( ( pers_org_flag = 1 and owner_pers_ID > 0 and owner_org_ID = 0 )
            or 
            ( pers_org_flag = 2 and owner_pers_ID = 0 and owner_org_ID > 0 )
          ),
    PRIMARY KEY ( obj_ID, stor_obj_num ),
    FOREIGN KEY ( obj_ID )
      REFERENCES Bib_objs ( obj_ID )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( owner_pers_ID )
      REFERENCES Persons ( pers_ID )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( owner_org_ID )
      REFERENCES Orgs ( org_ID )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( phys_form_code )
      REFERENCES Phys_form_types ( phys_form_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( acq_place_city )
      REFERENCES Cities ( city_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( acq_way_code )
      REFERENCES Acq_ways ( acq_way_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( currency_code )
      REFERENCES Currencies ( currency_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  ", /   "
-- ---------------------------------------------------------------------------
-- DROP TABLE Lend_borrow;

CREATE TABLE Lend_borrow
  ( obj_ID int4 NOT NULL,         --   
                                  --  
    stor_obj_num int2 NOT NULL,   --    
                                  --    . 
    --    (  )  
    -- 
    pers_org_flag numeric( 1 )    --  "/"
      NOT NULL DEFAULT 1          -- (1 - ; 2 - )
      CHECK ( pers_org_flag = 1 or pers_org_flag = 2 ),
    borr_lend_pers_ID int4        --   (  )
      NOT NULL DEFAULT 0,         -- ()
    borr_lend_org_ID int4         --   (  )
      NOT NULL DEFAULT 0,         -- ()
    -- ----------------------------------------------------------
    borr_lend_flag numeric( 1 )   --  "/" 
      NOT NULL DEFAULT 1,         -- (1 - , 2 - )
    borr_lend_date date           --  / 
      NOT NULL,
    return_date_supp date         --    - 
      NOT NULL,
    return_date_fact date,        --    - 
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    CHECK ( borr_lend_date <= return_date_supp ),
    CHECK ( return_date_fact IS NULL or return_date_fact >= borr_lend_date ),
    FOREIGN KEY ( obj_ID, stor_obj_num )
      REFERENCES Stor_objs ( obj_ID, stor_obj_num )
      ON DELETE CASCADE
      ON UPDATE CASCADE
  );

-- ---------------------------------------------------------------------------
--  "    "
-- ---------------------------------------------------------------------------
-- DROP TABLE Studying;

CREATE TABLE Studying
  ( obj_ID int4,                  --   
                                  --  
    study_begin date,             --   
    study_end date NOT NULL,      --   
    study_descr text,             --   
    study_result text,            --   
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    CHECK ( study_begin <= study_end ),
    PRIMARY KEY ( obj_ID, study_begin ),
    FOREIGN KEY ( obj_ID )
      REFERENCES Bib_objs ( obj_ID )
      ON DELETE CASCADE
      ON UPDATE CASCADE
  );

-- DROP INDEX Studying_ind_1;
CREATE INDEX Studying_ind_1 ON Studying ( study_begin );

-- ---------------------------------------------------------------------------
--  ""
-- ---------------------------------------------------------------------------
-- DROP TABLE Titles;

CREATE TABLE Titles
  ( obj_ID int4,                  --   
                                  --  
    bib_rec_num int2              --  .    
      NOT NULL DEFAULT 0          -- (    0)
      CHECK ( bib_rec_num >= 0 ),
    title_type_code int2          --    (1 - ,
      DEFAULT 1,                  -- 2 - , 3 - ,
                                  -- 4 -  (  ))
    title_num int2                --   ( 
      DEFAULT 1                   -- ,   
      CHECK ( title_num >= 1 ),   --  )
    obj_title text NOT NULL,      -- 
    lang_code int2 NOT NULL       --   
      DEFAULT 1,                  -- (1 -      )
    process_code int2             --    
      NOT NULL DEFAULT 1,         -- (1 - )
    private_title bool NOT NULL   --     ()
      DEFAULT 'no',    
    obj_title_info text,          -- ,   
                                  -- (  ":")
    comment text,                 -- 
    --  
    who_chg text DEFAULT USER,    --   () 
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,  --   () 
    PRIMARY KEY ( obj_ID, bib_rec_num, title_type_code, title_num ),
    FOREIGN KEY ( obj_ID, bib_rec_num )
      REFERENCES Bib_recs ( obj_ID, bib_rec_num )
      ON DELETE CASCADE
      ON UPDATE CASCADE,
    FOREIGN KEY ( title_type_code )
      REFERENCES Title_types ( title_type_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( lang_code )
      REFERENCES Langs ( lang_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE,
    FOREIGN KEY ( process_code )
      REFERENCES Process_types ( process_code )
      ON DELETE SET NULL
      ON UPDATE CASCADE
  );
