-- ---------------------------------------------------------------------------
-- Система:   "Электронный архив"
-- Модуль:    Структуры таблиц базы данных "Электронный архив":
--            Таблицы административной подсистемы
-- Автор:     Моргунов Е. П.
-- Дата:      15.04.2012
-- Версия:    0.6
-- ---------------------------------------------------------------------------

-- ---------------------------------------------------------------------------
-- Управление доступом к базе данных
-- ---------------------------------------------------------------------------

-- ---------------------------------------------------------------------------
-- Таблица "Пользователи"
-- ---------------------------------------------------------------------------
-- DROP TABLE Users;

CREATE TABLE Users
  ( user_name text,                  -- Имя пользователя
    user_description text,           -- Описание пользователя
    user_active bool DEFAULT 'no',   -- Флаг активизации пользователя
    -- служебная информация
    who_chg text DEFAULT USER,       -- Кем добавлена (изменена) запись
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,     -- Когда добавлена (изменена) запись
    PRIMARY KEY ( user_name )
  );

-- ---------------------------------------------------------------------------
-- Таблица "Права доступа"
-- ---------------------------------------------------------------------------
-- DROP TABLE Access;

CREATE TABLE Access
  ( user_name text,                  -- Имя пользователя
    module_name text DEFAULT 'ALL',  -- Условное наименование модуля
    proc_name text DEFAULT 'ALL',    -- Условное наименование процедуры
    oper_active bool DEFAULT 'no',   -- Флаг активизации данной операции
    -- служебная информация
    who_chg text DEFAULT USER,       -- Кем добавлена (изменена) запись
    when_chg timestamp 
      DEFAULT CURRENT_TIMESTAMP,     -- Когда добавлена (изменена) запись
    PRIMARY KEY ( user_name, module_name, proc_name ),
    FOREIGN KEY ( user_name )
      REFERENCES Users ( user_name )
      ON DELETE CASCADE
      ON UPDATE CASCADE
  );
