#!/bin/sh

# -----------------------------------------------------------------------------
# :   " "
# :      
#              
# :      . .
# :      15.04.2012
# :    0.6
# -----------------------------------------------------------------------------

#    
if [ -f ../../install.cfg ]; then
  . ../../install.cfg
else
  echo "   install.cfg"
  echo "      configure"
  exit 1
fi

#  
TARGET_DIR=$APACHE/e_arch

if [ -d $TARGET_DIR ]; then
  echo " $TARGET_DIR  "
  exit 1
fi

mkdir $TARGET_DIR

mkdir $TARGET_DIR/cfg
mkdir $TARGET_DIR/css
mkdir $TARGET_DIR/js
mkdir $TARGET_DIR/exp_imp

#  exp_imp.pl        
#   web-     daemon, 
#     "" 
chmod 777 $TARGET_DIR/exp_imp

DIR=`pwd`

#    (   ) 
#     (KOI8-R  UTF-8), 
#  
LOCALE=`echo $DIR | sed -E 's/^.+\///'`

#        ,     
# (     KOI8-R,      
#   KOI8-R)
PREFIX=../../prg/$LOCALE

#    (*.pl, *.pm, .htaccess)
cp $PREFIX/* $TARGET_DIR
cp $PREFIX/.htaccess $TARGET_DIR

#          
PREFIX=../../prg/cfg/$LOCALE
cp $PREFIX/* $TARGET_DIR/cfg

PREFIX=../../prg/css/$LOCALE
cp $PREFIX/* $TARGET_DIR/css

PREFIX=../../prg/js/$LOCALE
cp $PREFIX/* $TARGET_DIR/js

#   mk_links.sh
PREFIX=../../install/$LOCALE
cp $PREFIX/mk_links.sh $TARGET_DIR

#      langs.pl
DIR=`pwd`
cd $TARGET_DIR
./mk_links.sh

#   .htaccess    AuthUserFile
# (       "#";
#   "$"   "\",    
#    ,      "$" )
cmd="sed -E -e '\#^AuthUserFile#s#^.+\$#AuthUserFile $APACHE/bin/.htpasswd#'"
cat .htaccess | eval $cmd > .htaccess.tmp
mv .htaccess.tmp .htaccess

#   ./cfg/e_arch.cfg    DBNAME  CHARSET
# TODO.        ?
# TODO.      ?
cmd="sed -E -e '/^DBNAME/s/^.+\$/DBNAME             $DB_NAME/'"
cmd="$cmd  -e '/^CHARSET/s/^.+\$/CHARSET             $LOCALE/'"
cat ./cfg/e_arch.cfg | eval $cmd > ./cfg/e_arch.cfg.tmp
mv ./cfg/e_arch.cfg.tmp ./cfg/e_arch.cfg

#        Perl
# (  ,       /usr/bin/perl)

#    
for prg in `ls -1 *.pl`
do
  #       ( "\$"  
  #   "$"     )
  #        $PERL
  #   -w 
  # .       ,
  #                    ,  
  #               .    
  #                "#",    $PERL
  #                "/".   
  #               "\"   "#",  
  #               "" .
  cmd="sed -E -n -e '1s#^.+\$#\#!$PERL -w#p' -e '2,\$p' $prg"

  eval $cmd > tmp.pl
  mv tmp.pl $prg
done

#       (  - 
#       "")
chmod 755 *.pl

#     web- Apache
# (  bin/htpasswd)
cd $APACHE/bin

#     ,   (   
#   htpasswd)
if [ ! -f .htpasswd ]; then
  touch .htpasswd
fi

for user in admin debug admin_d debug_d
do
  grep "^$user:" .htpasswd > /dev/null

  #      
  if [ $? = 0 ]; then
    echo "   $user  web-  "
    continue
  fi

  echo "    $user  web-."
  echo " -- qwerty.    !"
  ./htpasswd -b .htpasswd $user qwerty
done

#    web- Apache -- httpd.conf

cd ../conf
cp httpd.conf httpd.conf.e_arch
echo "  httpd.conf    httpd.conf.e_arch"

#    
# (  ,   "a"  sed   
#     ,     
#   ;      ,   
# )
# .     eval,    
#              .
cat > httpd.append <<EOF
    # --- E_ARCH `date "+DATE: %Y-%m-%d% TIME: %H:%M:%S"` ---
    Alias /e_arch_js $APACHE/e_arch/js
    Alias /e_arch_css $APACHE/e_arch/css

    ScriptAlias /e_arch/ "$APACHE/e_arch/"
EOF

#       <IfModule alias_module>
cat httpd.conf | sed -e '/^<IfModule alias_module>/r httpd.append' > \
    httpd.conf.$$

mv httpd.conf.$$ httpd.conf

#     
cat > httpd.append <<EOF

# --- E_ARCH `date "+DATE: %Y-%m-%d% TIME: %H:%M:%S"` ---
<Directory "$APACHE/e_arch">
    AllowOverride All
    Options None
    Order allow,deny
    Allow from all
</Directory>

<Directory "$APACHE/e_arch/js">
    Options Indexes FollowSymLinks
    AllowOverride None
    Order allow,deny
    Allow from all
</Directory>

<Directory "$APACHE/e_arch/css">
    Options Indexes FollowSymLinks
    AllowOverride None
    Order allow,deny
    Allow from all
</Directory>
EOF

#       
cat httpd.append >> httpd.conf
rm httpd.append

echo "   httpd.conf   "
echo "   E_ARCH"

#    
cd $DIR
