#!/bin/sh

# -----------------------------------------------------------------------------
# :   " "
# :      
# :      . .
# :      15.04.2012
# :    0.6
# -----------------------------------------------------------------------------

# .       :
#             ./make_db.sh > create.txt 2>errors.txt &

#       
#set -x

#    
if [ -f ../../install.cfg ]; then
  . ../../install.cfg
else
  echo "   install.cfg"
  echo "      configure"
  exit 1
fi

#       
# TODO.      postgres.
#CONN_STR="dbname=$DB_NAME user=$DB_SUPERUSER password=..."
CONN_STR="dbname=$DB_NAME user=$DB_SUPERUSER"

DIR=`pwd`

#    (   ) 
#     (KOI8-R  UTF-8), 
#  
LOCALE=`echo $DIR | sed -E 's/^.+\///'`

#        ,     
# (     KOI8-R,      
#   KOI8-R)
PREFIX=../../db/$LOCALE/

# -----------------------------------------------------------------------------
echo "  "
DB_CREATE_CMD="CREATE DATABASE $DB_NAME"

#       ,  
[ "${DB_ENCODING:+set}" = "set" ] &&
  DB_CREATE_CMD="$DB_CREATE_CMD ENCODING = '$DB_ENCODING'"
[ "${DB_LC_COLLATE:+set}" = "set" ] &&
  DB_CREATE_CMD="$DB_CREATE_CMD LC_COLLATE = '$DB_LC_COLLATE'"
[ "${DB_LC_CTYPE:+set}" = "set" ] &&
  DB_CREATE_CMD="$DB_CREATE_CMD LC_CTYPE = '$DB_LC_CTYPE'"
         
#  ,     ,   
#  ,       , 
#      ,    
[ "${DB_ENCODING:+set}" = "set" ] &&
  DB_CREATE_CMD="$DB_CREATE_CMD TEMPLATE = template0"

# TODO.      postgres.
$PGSQL/bin/psql "user=$DB_SUPERUSER" -c "$DB_CREATE_CMD"
if [ $? != 0 ]; then
  echo "  $DB_NAME  "
  echo "         "
  exit 1
fi

# -----------------------------------------------------------------------------
echo "     \" \""
$PGSQL/bin/psql "${CONN_STR}" -f $PREFIX/e_arch.sql
$PGSQL/bin/psql "${CONN_STR}" -f $PREFIX/e_arch_admin.sql

# -----------------------------------------------------------------------------
echo " \"\"    \" \""
$PGSQL/bin/psql "${CONN_STR}" -f $PREFIX/e_arch_shad.sql
$PGSQL/bin/psql "${CONN_STR}" -f $PREFIX/e_arch_admin_shad.sql

# -----------------------------------------------------------------------------
echo "  /  "
$PGSQL/bin/psql "${CONN_STR}" -f $PREFIX/e_arch_exp_imp.sql
$PGSQL/bin/psql "${CONN_STR}" -f $PREFIX/e_arch_imp.sql

# -----------------------------------------------------------------------------
echo "        "
for user in admin admin_d debug debug_d
do
  $PGSQL/bin/psql "${CONN_STR}" -c "CREATE USER $user"
  if [ $? != 0 ]; then
    echo "   $user  "
  fi
done

# -----------------------------------------------------------------------------
echo "      "
$PGSQL/bin/psql "${CONN_STR}" -f $PREFIX/e_arch_grants.sql

# -----------------------------------------------------------------------------
echo "     "
$PGSQL/bin/psql "${CONN_STR}" -f $PREFIX/e_arch_rules.sql
$PGSQL/bin/psql "${CONN_STR}" -f $PREFIX/e_arch_admin_rules.sql

# -----------------------------------------------------------------------------
if [ "$INSERT_INITIAL_DATA" = "YES" ]; then
  echo "      "
  $PGSQL/bin/psql "${CONN_STR}" -f $PREFIX/e_arch_insert.sql
fi

# -----------------------------------------------------------------------------
echo "   \" \" "
# -----------------------------------------------------------------------------
