#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :   " "
# :     sql-
#                  
# :      . .
# :      15.04.2012
# :    0.6
# -----------------------------------------------------------------------------

#  
# ./mk_grants.pl user_name access_rights db_schema < e_arch.sql > grants.sql
# user_name -  
# access_rights -  (, 'ALL'  'SELECT, INSERT')
# db_schema -    (  -- public)
# e_arch.sql -     
# grants.sql -     

# .      .  GRANT
#                     .  
#                ,   .

use strict;

my $user = $ARGV[ 0 ];       #  
my $priv = $ARGV[ 1 ];       # 
my $db_schema = $ARGV[ 2 ];  #   

my $table;                   #   

if ( scalar @ARGV < 2 || scalar @ARGV > 3 )
{
  print " :\n" .
        "mk_grants.pl user_name access_rights [db_schema] < e_arch.sql > " .
        "grants.sql\n";
  exit( 0 );
}

$db_schema = 'public' if ( scalar @ARGV == 2 );

#       
print "--     " . $0 . "  " . localtime() . "\n\n\n";

print <<EOF;
-- ---------------------------------------------------------------------------
--       " "
-- ---------------------------------------------------------------------------

EOF

#  ,    
while ( <STDIN> )
{
  chomp;             #    
  next if $_ eq '';  #   

  #     
  if ( /^CREATE\s+TABLE\s+/ )
  {
    ( $table ) = $_ =~ /^CREATE\s+TABLE\s+(\w+)\s*/;

    print "GRANT $priv ON $db_schema.$table TO $user;\n";
  }
}
 
print "\n\n";

exit( 0 );
