#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :   " "
# :       
#             "" 
# :      . .
# :      15.04.2012
# :    0.6
# -----------------------------------------------------------------------------

#  
# ./mk_rules.pl < shadows.sql > rules.sql
# shadows.sql -     "" 
# rules.sql -    


use strict;

my $title;         #   ( )
my $table;         #  
my @struct = ();   #   
my $field_name;    #  

# , ,     DROP RULE
# (   ,     1)
my $drop = 0;

# , ,      
my $in_table = 0;

#       
print "--     " . $0 . "  " . localtime() . "\n\n\n";

print <<EOF;
-- ---------------------------------------------------------------------------
--      " "
-- ---------------------------------------------------------------------------

EOF

#  ,    "" 
while ( <STDIN> )
{
  chomp;             #    
  next if $_ eq '';  #   

  #  
  if ( /^-- / )
  {
    $title = $_;
  }
  #     ,   
  elsif ( /^\s*-- / )
  {
    $in_table = 0;     #     
    create_rules();    #  
  }
  elsif ( /^\s*--/ )
  {
    next;     # - 
  }
  #    
  elsif ( /^CREATE\s+TABLE\s+(.+)\s*/ )
  {
    ( $table ) = $_ =~ /^CREATE\s+TABLE\s+(.+)\s*/;
    $table =~ s/_2//;  #   "_2"
    $in_table = 1;     #  -    
    @struct = ();      #   
    next;
  }
  #   ,   ,      
  #    " "
  elsif ( /^\s+\(*\s+(.+)\s+/ && $in_table == 1 )
  {
    #         
    # .   "" (..   ) 
    #              ,        .
    ( $field_name ) = $_ =~ /^\s+\(*\s+(.+?)\s+/;
    push( @struct, $field_name );
  }
}

exit( 0 );

# ----------------------------------------------------------------------------
#     
# ----------------------------------------------------------------------------
sub create_rules
{
  my $f_name;    #  
  
  #      
  print "-- " . "-" x 77 . "\n";
  print "$title\n";
  print "-- " . "-" x 77 . "\n";

  print "--   \n";

  #    ,    
  print "DROP RULE ${table}_rule_1 ON ${table};\n\n" if ( $drop );

  print "CREATE RULE ${table}_rule_1 AS\n";
  print "  ON INSERT TO ${table}\n";
  print "  DO INSERT INTO ${table}_2 ( \n";

  #      
  foreach $f_name ( @struct )
  {
    print "            $f_name,\n";
  }
  #  ,      
  print "            db_operation )\n";

  print "     VALUES ( \n";

  #      
  foreach $f_name ( @struct )
  {
    print "            NEW.$f_name,\n";
  }
  #    ,      
  print "            'INSERT' );\n\n";

  # ----------------------------------------------------------------------
  print "--   \n";

  #    ,    
  print "DROP RULE ${table}_rule_1 ON ${table};\n\n" if ( $drop );
  
  print "CREATE RULE ${table}_rule_2 AS\n";
  print "  ON UPDATE TO ${table}\n";
  print "  DO INSERT INTO ${table}_2 ( \n";

  #      
  foreach $f_name ( @struct )
  {
    print "            $f_name,\n";
  }
  #  ,      
  print "            db_operation )\n";

  print "     VALUES ( \n";

  #      
  foreach $f_name ( @struct )
  {
    print "            NEW.$f_name,\n";
  }
  #    ,      
  print "            'UPDATE' );\n\n";

  # ----------------------------------------------------------------------
  print "--   \n";

  #    ,    
  print "DROP RULE ${table}_rule_1 ON ${table};\n\n" if ( $drop );

  print "CREATE RULE ${table}_rule_3 AS\n";
  print "  ON DELETE TO ${table}\n";
  print "  DO INSERT INTO ${table}_2 ( \n";

  #      
  foreach $f_name ( @struct )
  {
    print "            $f_name,\n";
  }
  #  ,      
  print "            db_operation )\n";

  print "     VALUES ( \n";

  #      
  foreach $f_name ( @struct )
  {
    print "            OLD.$f_name,\n";
  }
  #    ,      
  print "            'DELETE' );\n\n";

  return;
}
