#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :   " "
# :     
#            ""      
# :      . .
# :      15.04.2012
# :    0.6
# -----------------------------------------------------------------------------

#  
# ./mk_shad_tables.pl < source.sql > shadows.sql
# source.sql -      
# shadows.sql -     "" 

use strict;

my $title;         #   ( )
my $table;         #  
my @struct = ();   #    
my $field_name;    #  
my $field_type;    #   

#   
#         ,    -
# NOT NULL, DEFAULT... - 
my $current_field = ''; 

# , ,      
my $in_table = 0;

#       
print "--     " . $0 . "  " . localtime() . "\n\n\n";

print <<EOF;
-- ---------------------------------------------------------------------------
--     " "
-- ---------------------------------------------------------------------------

-- ---------------------------------------------------------------------------
-- "" 
-- ---------------------------------------------------------------------------

EOF

#  ,      
while ( <STDIN> )
{
  chomp;             #    
  next if $_ eq '';  #   

  #  
  if ( /^--\s*/ )
  {
    $title = $_;
    next;
  }
  
  #     ,   
  if ( /^\s*--\s*/ )
  {
    $in_table = 0;     #     
    create_struct();   #    
    next;
  }

  # - 
  # . ,      
  #             if ( /^--\s*/ )  if ( /^\s*--\s*/ )
  if ( /^\s*--/ )
  {
    next;
  }
  
  #      
  if ( /^CREATE\s+TABLE\s+\w+\s*/ )
  {
    #   
    ( $table ) = $_ =~ /^CREATE\s+TABLE\s+(\w+).*/;

    $in_table = 1;     #  -    
    @struct = ();      #   
    next;
  }

  #        
  if ( $in_table == 0 )
  {
    next;
  }

  #     
  
  s/^\s*\(//;          #   ,    
                       #  
  s/^\s*//;            #      
  s/--.*$//;           #     ,   
  s/\s*$//;            #       
                       #  
  $_ = $_ . ' ';       #   ,    
                       #     
  
  $current_field .= $_;     #    
  
  #        ( 
  #        )
  # .       .
  #                     numeric,
  #             : "numeric( 14,2 )".
  if ( $current_field =~ /,\s*$/ )
  {
    #     
    # (,    ,    
    #         )
    $current_field =~ s/,\s*$/ /;
    

    #         
    #   .
    # (\w+)  -     , ..  
    # \s+    - ()       
    # (\w+\(*\s*\d*,?\d*\s*\)*?) -   
    #   \w+  -   (       ,
    #             .   " ")
    #   \(*\s*\d*,?\d*\s*\)*? -      
    #           , : "numeric( 14,2 )" (,  
    #            ""     )
    # .  ,  \w  ,    "_".
    ( $field_name, $field_type ) = $current_field =~
                   /^\s*(\w+)\s+(\w+\(*\s*\d*,?\d*\s*\)*)\s+/;

    #       
    push( @struct, "$field_name $field_type" );
    $current_field = '';
  }
}
  
exit( 0 );

# ----------------------------------------------------------------------------
#    
# ----------------------------------------------------------------------------
sub create_struct
{
  my $field_descr;   #  
  my $bracket = 0;   #    
  
  print "-- " . "-" x 75 . "\n";
  print $title . "\n";
  print "-- " . "-" x 75 . "\n";

  #   ,    
  print "-- DROP TABLE ${table}_2;\n\n";

  print "CREATE TABLE ${table}_2\n";
  
  foreach $field_descr ( @struct )
  {
    if ( $bracket == 0 )   #   
    {
      print "  ( ";
      $bracket = 1;
    }
    else                   #       4 
    {
      print " " x 4;
    }

    print $field_descr . ",\n";
  }

  #   
  print <<EOF;
    who_chg text,
    when_chg timestamp,
    --  
    db_operation text,                            --   
    who_add text DEFAULT USER,                    --   
    when_add timestamp DEFAULT CURRENT_TIMESTAMP  --   
EOF

  print "  );\n\n";
  return;
}
