#!/bin/sh

# -----------------------------------------------------------------------------
# :   " "
# :     SQL-,
#                
# :      . .
# :      15.04.2012
# :    0.6
# -----------------------------------------------------------------------------

# .       :
#             ./prepare_sql.sh > create.txt 2>errors.txt &

#       
#set -x

DIR=`pwd`

#    (   ) 
#     (KOI8-R  UTF-8), 
#  
LOCALE=`echo $DIR | sed -E 's/^.+\///'`

#        ,     
# (     KOI8-R,      
#   KOI8-R)
PREFIX=../../db/$LOCALE

# -----------------------------------------------------------------------------
echo " SQL-,    \"\" "
echo " "
echo ""
./mk_shad_tables.pl < $PREFIX/e_arch.sql > $PREFIX/e_arch_shad.sql
./mk_shad_tables.pl < $PREFIX/e_arch_admin.sql > $PREFIX/e_arch_admin_shad.sql

# -----------------------------------------------------------------------------
echo " SQL-,   (RULES),  "
echo "  \"\"   "
echo ""
./mk_rules.pl < $PREFIX/e_arch_shad.sql > $PREFIX/e_arch_rules.sql
./mk_rules.pl < $PREFIX/e_arch_admin_shad.sql > $PREFIX/e_arch_admin_rules.sql

# -----------------------------------------------------------------------------
echo " SQL-,     "
echo "/  "
echo ""
cat > $PREFIX/e_arch_exp_imp.sql <<EOF
--     `basename $0`
-- `date`

-- ---------------------------------------------------------------------------
--    /   " "
-- ---------------------------------------------------------------------------

DROP SCHEMA IF EXISTS exp_imp CASCADE;
CREATE SCHEMA exp_imp;
SET SCHEMA 'exp_imp';
EOF

#      ,    
# ,   "--" ( SQL)
cat $PREFIX/e_arch.sql | sed -n '/^--/!p' >> $PREFIX/e_arch_exp_imp.sql

# -----------------------------------------------------------------------------
echo " SQL-,     "
echo "  "
echo ""
cat > $PREFIX/e_arch_imp.sql <<EOF
--     `basename $0`
-- `date`

-- ---------------------------------------------------------------------------
--       " "
-- ---------------------------------------------------------------------------

DROP SCHEMA IF EXISTS imp CASCADE;
CREATE SCHEMA imp;
SET SCHEMA 'imp';
EOF

#      ,    
# ,   "--" ( SQL)
cat $PREFIX/e_arch.sql | sed -n '/^--/!p' >> $PREFIX/e_arch_imp.sql

# -----------------------------------------------------------------------------
echo " ,     "
echo "    "
echo ""
cat > $PREFIX/e_arch_grants.sql<<EOF
--     `basename $0`
-- `date`

-- ---------------------------------------------------------------------------
--         " "
-- ---------------------------------------------------------------------------

GRANT USAGE ON SCHEMA exp_imp, imp TO admin, admin_d, debug, debug_d;

EOF

#      
./mk_grants.pl admin "select" < $PREFIX/e_arch_admin.sql >> \
  $PREFIX/e_arch_grants.sql
./mk_grants.pl debug "select" < $PREFIX/e_arch_admin.sql >> \
  $PREFIX/e_arch_grants.sql
./mk_grants.pl admin_d "all" < $PREFIX/e_arch_admin.sql >> \
  $PREFIX/e_arch_grants.sql
./mk_grants.pl debug_d "all" < $PREFIX/e_arch_admin.sql >> \
  $PREFIX/e_arch_grants.sql

#    admin  debug
for user in admin debug
do
  #     public
  ./mk_grants.pl $user "select, insert, update" public < \
    $PREFIX/e_arch.sql >> $PREFIX/e_arch_grants.sql

  #  /
  for schema in exp_imp imp
  do
    ./mk_grants.pl $user "all" $schema < \
      $PREFIX/e_arch.sql >> $PREFIX/e_arch_grants.sql
  done
done

#    admin_d  debug_d
for user in admin_d debug_d
do
  #   
  for schema in public exp_imp imp
  do
    ./mk_grants.pl $user "all" $schema < \
      $PREFIX/e_arch.sql >> $PREFIX/e_arch_grants.sql
  done
done

# -----------------------------------------------------------------------------
echo " SQL-,     "
echo "\" \" "
# -----------------------------------------------------------------------------
