#!/bin/sh

# -----------------------------------------------------------------------------
# Система:   "Электронный архив"
# Программа: вспомогательная программа для создания жестких ссылок
#            на модуль langs.pl
# Автор:     Моргунов Е. П.
# Дата:      15.04.2012
# Версия:    0.6
# -----------------------------------------------------------------------------

# выбираем строки с именами таблиц БД по ключевому слову 'TABLE'
# выводим второе поле в строке (имя таблицы) в нижнем регистре с добавлением
# расширения ".pl"
for filename in `grep TABLE ./cfg/tables34.cfg |
                 awk 'BEGIN { FS = " " } { print tolower( $2 ) ".pl" }'`
{
  echo $filename
  # если имя модуля -- не "langs.pl", то создадим жесткую ссылку на langs.pl
  # ПРИМЕЧАНИЕ. Параметр -f позволяет пересоздать ссылки, не удаляя их все
  #             предварительно. Пересоздание ссылок необходимо при внесении
  #             изменений в файл langs.pl.
  if [ "$filename" != "langs.pl" ] ; then
    ln -f langs.pl $filename
  fi
}

exit 0
