package E_ARCH;

# -----------------------------------------------------------------------------
# :  " "
# :     
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use warnings;

BEGIN
{
  use Exporter;
  our( $VERSION, @ISA, @EXPORT, @EXPORT_OK, %EXPORT_TAGS );

  $VERSION = 0.6;

  @ISA = qw( Exporter );

  # TODO. ,    &   .
  # .      , . . 
  #                 , ,
  #             process_referenced_tables(), process_dependent_tables(), 
  #             exec_cmd().
  @EXPORT = qw( &add_rec &can_work &change_case &close_bottom &close_top 
                &common_modes &create_assign_values_func &create_conn_str 
                &create_hot_help &create_selection_func &create_top_block
                &date_for_db &date_for_display &date_is_correct &del_rec
                &do_add &exec_connect_db &exec_select &exec_transaction
                &export_data &export_enabled &first_cap &first_letter
                &first_lower &get_available &get_bib_rec &get_next_key_value
                &get_ref_descr &get_ser_descr &get_user_name &have_access
                &http_html_headers &import_data &import_enabled
                &list_bib_recs_by_query &make_cmd &make_letters &open_bottom
                &open_top &popup_acq_ways_list &popup_activity_types_list
                &popup_cities_list &popup_conf_status_types_list
                &popup_conf_types_list &popup_countries_list 
                &popup_currencies_list &popup_det_char_types_list
                &popup_edition_types_list &popup_feature_groups_list
                &popup_gen_mater_types_list &popup_langs_list
                &popup_orgs_list &popup_pack_types_list
                &popup_phys_form_types_list &popup_process_types_list
                &popup_recs_sources_list &popup_ref_types_list
                &popup_roles_list &popup_spec_mater_groups_list
                &popup_spec_mater_types_list &popup_std_num_types_list
                &print_bib_record &print_debug_info &print_env &print_params
                &print_result &print_ser_descr &print_user_err_msgs
                &read_config &read_exp_config &reveal_rus_letter
                &screen_qts &update_rec &view_rec 
                $DEBUG %CFG %EXP_CFG $confirm_delete $confirm_export
                $confirm_import
              );

  %EXPORT_TAGS = ();

  #   ,     
  # 
  # @EXPORT_OK = qw( $Var1 %Hash1 &func3 );
}

# our @EXPORT_OK;

#    
our( $DEBUG, %CFG, %EXP_CFG, $confirm_delete, $confirm_export, 
     $confirm_import );

#   

#     
%CFG = read_config( "./cfg/e_arch.cfg" );

#    /  
%EXP_CFG = %{ read_exp_config( "./cfg/e_arch_exp.cfg" ) };

#     JavaScript    
#    
$confirm_delete = "return confirm( '" . ( $CFG{ CONFIRM_DELETE } ?
                                          $CFG{ CONFIRM_DELETE } :
                                          " ?"
                                        ) . "' );";
#     JavaScript    
#    
$confirm_export = "return confirm( '" . ( $CFG{ CONFIRM_EXPORT } ?
                                          $CFG{ CONFIRM_EXPORT } :
                                          " ?"
                                        ) . "' );";
#     JavaScript    
#    "/"    
$confirm_import = "return confirm( '" . ( $CFG{ CONFIRM_IMPORT } ?
                                          $CFG{ CONFIRM_IMPORT } :
                                          " ?"
                                        ) . "' );";
#  
$DEBUG = debug_is_enabled();

use Pg;                          #    PostgreSQL

# -   SQL-,    
my %SQL_commands = ();


# -----------------------------------------------------------------------------
#     
# -----------------------------------------------------------------------------
sub add_rec
{
  #   
  # (  :   =>  )
  my %prms = @_;

  # : CGI- (query);
  #                   
  #                ""   (create_top);
  #                 ,    
  #              (check_param);
  #                     
  #                (make_command);
  #                (user_msg);
  #                   
  #              (print_add_info)
  
  my $query = $prms{ query }; #  

  #      HTML-
  my $target_win = $query->param( 'target_win' );
  
  $target_win = "_self" unless $target_win;

  my( $conn, $result );       #    
  my $command;                #       

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => $target_win );

  open_top();                  #     
  &{ $prms{ create_top } }();  #      
                               # ""  
  close_top();                 #     

  open_bottom();               #     

  #     
  &{ $prms{ print_add_info } }() if defined( $prms{ print_add_info } );

  #      ,  
  if ( &{ $prms{ check_param } }() )
  {
    #  -   
    $command = &{ $prms{ make_command } }( 'APPEND' );

    # DEBUG 
    print_debug_info( $command ) if $DEBUG;  #   

    $conn = exec_connect_db();          #   
    $result = $conn->exec( $command );  #      

    #         
    if ( PGRES_COMMAND_OK ne $result->resultStatus )
    {
      #   
      print "<p class=\"error\">$CFG{ ERROR_INSERT }</p>\n";
      print STDERR $command . "\n";     #     
      die $conn->errorMessage;
    }
    else
    {
      #     ,  
      print "<p class=\"info\">";
      print( ( $prms{ user_msg } ne undef ) ? $prms{ user_msg } :
             "    " );
      print "</p>\n";
    }
  }

  close_bottom();      #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#       
#   
# -----------------------------------------------------------------------------
sub can_work
{
  # :  ,     , CGI-
  my $user      = shift;
  my $module    = shift;
  my $procedure = shift;
  my $query     = shift;

  if ( ! have_access( 'module' => $module,
                      'procedure' => $procedure,
                      'user' => $user ) )
  {
    #  HTTP-  HTML-
    http_html_headers( query => $query, target => "_self" );

    print "<p class=\"info\">";
    print "  <span style=\"font-weight:bold\">$user</span> " .
          "     </p>\n";

    print $query->end_html();
  
    return ( 0 );
  }
  #   -  
  return ( 1 );
}

# -----------------------------------------------------------------------------
#        
# -----------------------------------------------------------------------------
sub change_case
{
  # 
  my $original_str = shift;   #  
  my $operation = shift;      #  ('upper', 'UPPER', 'lower', 'LOWER')

  my $changed_str;            #  

  #   
  if ( lc( $operation ) ne 'lower' && lc( $operation ) ne 'upper' )
  {
    return $original_str;     #   
  }

  # ,      UNIX-   
  if ( $CFG{ CHARSET } ne "KOI8-R" && $CFG{ CHARSET } ne "UTF-8" )
  {
    return $original_str;     #   
  }

  #     " "  ( 
  # !)   UTF-8,    , 
  # "-"   Apache,    (   
  # "ru_RU.UTF-8",     "C")
  if ( $CFG{ CHARSET } eq "UTF-8" )
  {
    use Encode;    
    use utf8;   #  

    #      utf-8,      
    $original_str = decode( "UTF-8", ( $original_str ) ) 
      if ( ! utf8::is_utf8( $original_str ) );
    
    if ( lc( $operation ) eq 'lower' )
    {
      $changed_str = lc( $original_str );  #     
    }
    else                                   # if ( lc( $operation ) eq 'upper' )
    {
      $changed_str = uc( $original_str );  #     
    }

    return $changed_str;
  }

  #     KOI8-R

  #       
  #   

  #     
  #   POSIX
  use POSIX qw( locale_h );
    
  #     LC_CTYPE,  ""
  #  
  # (  ,     ,
  # "-"   web- Apache, , www  daemon --
  # .  httpd.conf)
  my $old_locale = setlocale( LC_CTYPE );

  if ( $old_locale ne "ru_RU.KOI8-R" )
  {
    #     ,   CHARSET
    # (KOI8-R  UTF-8)
    setlocale( LC_CTYPE, "ru_RU.KOI8-R" );
  }

  use locale;

  if ( lc( $operation ) eq 'lower' )
  {
    $changed_str = lc( $original_str );  #     
  }
  else                                   # if ( lc( $operation ) eq 'upper' )
  {
    $changed_str = uc( $original_str );  #     
  }
  no locale;

  #      ,  
  #    "" (      
  #    )
#  if ( setlocale( LC_CTYPE ) eq "C" || setlocale( LC_CTYPE ) eq "POSIX" ||
#       setlocale( LC_CTYPE ) eq "" )
  if ( setlocale( LC_CTYPE ) ne "ru_RU.KOI8-R" )
  {
    my %letters = ();
    my @rus_letters_big = split( /\s+/, $CFG{ STRING_LETTERS_RUS } );
    my @rus_letters_little = split( /\s+/, $CFG{ STRING_LETTERS_RUS_LITTLE } );
    my $new_letter;
    my $i;

    #   -    
    if ( lc( $operation ) eq 'lower' )
    {
      for( $i = 0; $i < scalar @rus_letters_big; $i++ )
      {
        #   --  
        $letters{ $rus_letters_big[ $i ] } = $rus_letters_little[ $i ];
      }
    }
    else
    {
      for( $i = 0; $i < scalar @rus_letters_little; $i++ )
      {
        #   --  
        $letters{ $rus_letters_little[ $i ] } = $rus_letters_big[ $i ];
      }
    }

    #    
    for ( $i = 0; $i < length( $changed_str ); $i++ )
    {
      #   -     ,   
      #      
      $new_letter = $letters{ substr( $changed_str, $i, 1 ) };
      substr( $changed_str, $i, 1 ) = $new_letter if ( $new_letter );
    }
  }

  #     LC_CTYPE
  setlocale( LC_CTYPE, $old_locale ) if ( $old_locale ne "ru_RU.KOI8-R" );

  return $changed_str;
}

# -----------------------------------------------------------------------------
#     
# -----------------------------------------------------------------------------
sub close_bottom
{
  #  HTML-,       
  print "$CFG{ CLOSE_BOTTOM }\n";

  return ( 0 );
}

# -----------------------------------------------------------------------------
#     
# -----------------------------------------------------------------------------
sub close_top
{
  #  HTML-,       
  print "$CFG{ CLOSE_TOP }\n";

  return ( 0 );
}

# -----------------------------------------------------------------------------
#   
# -----------------------------------------------------------------------------
sub common_modes
{
  #   
  # (  :   =>  )
  my %prms = @_;

  # : CGI- (query);
  #               (module);
  #             ,    (user);
  #            .   - ..   .
  #                 (make_form);
  #                - (make_command);
  #                  (check_param);
  #                     
  #                ""   (create_top);
  #                     (do_query);
  #                     (do_view);
  #                    (do_add);
  #                    (do_del);
  #                   (do_find);
  #                  (add_rec);
  #                 
  #                (update_rec);
  #                   
  #                 add_rec, update_rec (print_add_info);
  #            URL     (action)

  my $query = $prms{ query };    #  

  #      HTML-
  my $target_win = $query->param( 'target_win' );
  $target_win = "_self" unless $target_win;

  # ,          
  if ( ! can_work( $prms{ user }, $prms{ module }, 'main', $query ) )
  {
    exit( 0 );
  }

  #   --      ;
  #   --    "  " (,
  #       "");
  #   --     ;
  #   --        
  #   () / (   
  #  1,       'exp_imp')
  
  #        
  #        (,  
  #       ),  
  #       enable_select (. 
  # )
  if ( ( ! $query->path_info && ! $query->param ) ||
       $query->path_info =~ /^\/query$/ ||
       $query->path_info =~ /^\/select$/ ||
       ( ! $query->path_info && scalar $query->param() == 1 && 
         $query->param( 'exp_imp' )
       )
     )
  {
    #            
    # 
    &{ $prms{ do_query } }();
  }

  #           
  elsif ( $query->path_info =~ /^\/view$/ &&
          have_access( 'module' => $prms{ module }, 'procedure' => 'VIEW',
                       'user' => $prms{ user } )
        )
  {
    &{ $prms{ do_view } }();
  }

  #   (    )
  elsif ( $query->path_info =~ /^\/add$/ &&
          have_access( 'module' => $prms{ module }, 'procedure' => 'ADD',
                       'user' => $prms{ user } )
        )
  {
    &{ $prms{ do_add } }( query => $query,
                          create_top => $prms{ create_top },
                          make_form => $prms{ make_form },
                          action => $prms{ action },
                          target => $target_win,
                          submit_name => "submit_add",
                          submit_value => ""
                        );
  }

  #  
  elsif ( $query->path_info =~ /^\/delete$/ &&
          have_access( 'module' => $prms{ module }, 'procedure' => 'DELETE',
                       'user' => $prms{ user } )
        )
  {
    &{ $prms{ do_del } }();
  }

  #    
  elsif ( $query->path_info =~ /^\/find$/ )
  {
    &{ $prms{ do_find } }();
  }
  #  
  elsif ( $query->path_info =~ /^\/export$/ &&
          have_access( 'module' => $prms{ module }, 'procedure' => 'EXPORT',
                       'user' => $prms{ user } )
        ) 
  {
    &{ $prms{ do_export } }();
  }
  #  
  elsif ( $query->path_info =~ /^\/import$/ &&
          have_access( 'module' => $prms{ module }, 'procedure' => 'IMPORT',
                       'user' => $prms{ user } )
        ) 
  {
    &{ $prms{ do_import } }();
  }


  #    (   )
  if ( $query->param( 'submit_add' ) && 
       have_access( 'module' => $prms{ module }, 'procedure' => 'ADD',
                    'user' => $prms{ user } )
     )
  {
    &{ $prms{ add_rec } }( 'query' => $query, 
                           'create_top' => $prms{ create_top },
                           'check_param' => $prms{ check_param },
                           'make_command' => $prms{ make_command },
                           'print_add_info' => $prms{ print_add_info } );
  }

  #    (   )
  elsif ( $query->param( 'submit_update' ) &&
          have_access( 'module' => $prms{ module }, 'procedure' => 'UPDATE',
                       'user' => $prms{ user } )
        )
  {
    &{ $prms{ update_rec } }( 'query' => $query, 
                              'create_top' => $prms{ create_top },
                              'check_param' => $prms{ check_param },
                              'make_command' => $prms{ make_command },
                              'print_add_info' => $prms{ print_add_info } );
  }
  return ( 0 );
}

# -----------------------------------------------------------------------------
#           
#  
# -----------------------------------------------------------------------------
sub copy_data
{
  #   
  # (  :   =>  )
  my %prms = @_;

  # : CGI- (query);
  #                   
  #                ""   (create_top);
  #                  ,
  #                     
  #              (table_cmd_pairs);
  #                (source_schema);
  #                (target_schema)

  #      ,    .  
  #      public   exp_imp,
  #    --   exp_imp   imp.   
  #     .   
  #       .   
  #   :        .
  
  my $query = $prms{ query };                    #  
  my $source_schema = $prms{ source_schema };    #  
  my $target_schema = $prms{ target_schema };    #  

  #      HTML-
  my $target_win = $query->param( 'target_win' );

  my $conn;                  #    
  my $result;                #   SQL-
  my @row;                   #      
  my $table_cmd_pair;        #      
                             # (     )
  my $command;               #      
  my $exp_table;             # ,    
  my %rec;                   # -,    
                             #   
  my $table;                 #      
  my $i;
  my $cmd_type;              #  SQL- (INSERT  UPDATE)
  my $where;                 #     
  my @key_fields;            #     
  my $inserted_count = 0;    #  ,     

  $target_win = "_blank" unless $target_win;

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => $target_win );

  open_top();                  #     
  &{ $prms{ create_top } }();  #      
                               # ""  
  close_top();                 #     

  open_bottom();               #     

  # DEBUG 
  print_debug_info( " SQL-" ) if $DEBUG;

  #    "  --     ",
  #   
  foreach $table_cmd_pair ( @{ $prms{ table_cmd_pairs } } )
  {
    $exp_table = @{ $table_cmd_pair }[ 0 ];  #  
    $command = @{ $table_cmd_pair }[ 1 ];    #  

    #    
    # (  --  ,    , 
    #     ,    )
    $result = exec_select( $command, "  " );
  
    if ( $result )
    {
      #      
      while ( @row = $result->fetchrow )
      {
        my $fields = "";       #    (  )
        my $values = "";       #    (  )
        my $fname;             #  
        my $value;             #  

        %rec = ();             # "" -,  
                               #     

        #  -,     
        #  

        #     (. .   )
        for ( $i = 0; $i < scalar @row; $i++ )
        {
          #     
          $fname = $result->fname( $i );  #      
          $value = $row[ $i ];
        
          #  -,     
          #   ( --   -)
          $rec{ $fname } = $value;
        }

        # -------
        #        ,
        #     $exp_table ( )
        process_referenced_tables( $exp_table, \%rec, $source_schema,
                                   $target_schema );

        #        ,
        #     $exp_table (   
        # )
        process_dependent_tables( $exp_table, \%rec, $source_schema,
                                  $target_schema );
        # -------

        #          
        # INSERT INTO 
        foreach $fname ( keys %rec )
        {
          $value = $rec{ $fname };
        
          #        
          $fields .= $fname . ",";

          # TODO.    ""  
          #       .
          $value =~ s/\'/\'\'/g;

          #     (  
          # !!!)
          #    ,   null,   
          #     
          # .       , 
          #                    
          #                .
          $values .= $value ne '' ? "'$value'," : "null," ;
        }

        $fields =~ s/,$//;  #   
        $values =~ s/,$//;  #   

        #         
        $command = "INSERT INTO $target_schema.$exp_table ( $fields ) " .
                               "VALUES ( $values )";

        #    WHERE,   
        #       exp_imp  
        #   ,  INSERT      
        #  (  )
        
        #      
        @key_fields = @{ $EXP_CFG{ TABLES }{ $exp_table }{ KEY_FIELDS } };

        $where = "";

        #    
        for ( $i = 0; $i < scalar @key_fields; $i++ )
        {
          $where .= $key_fields[ $i ] . " = '" . $rec{ $key_fields[ $i ] } .
                    "' AND ";
        }

        $where =~ s/\s*AND\s*$//;  #   'AND'

        #      - -- 

        #  --  INSERT,  --  WHERE  
        #   
        $SQL_commands{ $exp_table }{ $command } = $where;

        # DEBUG 
        print_debug_info( $command ) if $DEBUG;  #   
      }
    }
    else
    {
      ;  # TODO.     ?
    }
  }
 
  # ---------------------------------------------------
  #  /     
  # ---------------------------------------------------

  $conn = exec_connect_db();           #   
  exec_transaction( $conn, "BEGIN" );  #     

  # DEBUG 
  print_debug_info( "  SQL-" ) if $DEBUG;

  #       ,    
  #  SQL-   (e_arch.sql),    
  #  
  foreach $table ( @{ $EXP_CFG{ TABLES_ORDER } } )
  {
    #       
    next if ( ! exists $SQL_commands{ $table } );
    
    #  
    #     : 'INSERT', 'UPDATE', . .  
    #        , 
    #     
    foreach $cmd_type ( ( 'INSERT', 'UPDATE' ) )
    {
      foreach $command ( keys %{ $SQL_commands{ $table } } )
      {
        #      ,    
        if ( $command =~ /^${cmd_type}/ )
        {
          #    ,  
          #  /  ;
          #       
          # ,    0
          $inserted_count += exec_cmd( $conn, $target_schema, $table, 
                                       $cmd_type, $command,
                                       $SQL_commands{ $table }{ $command } );
        }
      }
    }
  }
  exec_transaction( $conn, "END" );   #  

  #        /  
  if ( $inserted_count > 0 )
  {
    print "<p class=\"info\">";
    print( "     " . 
           ( ( $prms{ target_schema } eq "exp_imp" ) ? ": " :
                                                       ": " ) .
           "$inserted_count .</p>\n" );
  }
  else
  {
    print "<p class=\"info\">";
    print( "   " . 
           ( ( $prms{ target_schema } eq "exp_imp" ) ? "" :
                                                       "" ) .
           "</p>\n" );
  }
  
  close_bottom();      #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      JavaScript,  
#        ()  ,
#    
# -----------------------------------------------------------------------------
sub create_assign_values_func
{
  # 
  my $entity_id_fname = shift;   #  ,   
                                 #  (     )
                                 # (,  )
  my $entity_name_fname = shift; #  ,   
                                 #  (, . . . )
  my $add_info_fname = shift;    #  ,  
                                 #  (   )

  my $func_params = "entity_id, entity_name";

  if ( $add_info_fname ne undef )
  {
    $func_params .= ", add_info";
  }

  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript">
  <!--
  function assign_values( $func_params )
  {
    //       
    //    
    // ,    
    // . ,       ,
    //                 .
    if ( parent.opener.document.forms[ 0 ].$entity_id_fname.disabled == false )
    {
      parent.opener.document.forms[ 0 ].$entity_id_fname.value = entity_id;
      parent.opener.document.forms[ 0 ].$entity_name_fname.value = entity_name;
END_OF_SCRIPT
  ;

  if ( $add_info_fname )
  {
    #          
    print "parent.opener.document.forms[ 0 ].$add_info_fname.value = " .
          "add_info;";
  }

  print <<END_OF_SCRIPT;
      parent.opener.document.forms[ 0 ].$entity_id_fname.focus();
      parent.close();
    }
    else
    {
      window.alert( " .  " );
    }
  }
  //-->
  </script>
END_OF_SCRIPT
  ;
}

# -----------------------------------------------------------------------------
#        
# -----------------------------------------------------------------------------
sub create_conn_str
{
  # .       ,   
  #                .     
  #              - ""       ,
  #                     
  #               . ,   
  #                     
  #             ,     
  #               (,   ""  ..).

  my $conn_str = '';

  #      . ,    
  $conn_str = "dbname=" . $CFG{ DBNAME } . " user=" . get_user_name();

  return ( $conn_str );
}

# -----------------------------------------------------------------------------
#       JavaScript,  
#   HTML-
# -----------------------------------------------------------------------------
sub create_enable_elements_func
{
  #        HTML-
  # web-     submit
  # .   (   disabled 
  #              true)   web-  .
  #                     
  #              ,     
  #             :   ,  
  #              ,     .
  
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript">
  <!--
  //     HTML-,   
  // disabled (        ,
  //     )
  function enable_elements()
  {
    var i;
    //    
    for ( i = 0; i < document.forms[ 0 ].elements.length; i++ )
    {
      //     ...
      if ( document.forms[ 0 ].elements[ i ].disabled == true )
      {
        // ...    
        document.forms[ 0 ].elements[ i ].disabled = false;
      }
    }
  }
  //-->
  </script>
END_OF_SCRIPT
  ;
}

# -----------------------------------------------------------------------------
#   ( )     
#    
# -----------------------------------------------------------------------------
sub create_hot_help
{
  # 

  #   ( HTML-),     () -- 
  #  , , document.forms[ 0 ].bib_rec_full
  # .   ,    
  #                     
  #             .
  my $field_name = shift;

  #    ,   
  # ""  (, BIB_RECS_BIB_REC_FULL)
  #   ,  ,    
  #  
  my $prefix = shift;  

  #  ,     :   
  #   ,      
  my $operation = shift;

  #  JavaScript-,      
  # (  )
  my $additional_code = shift;
  
  #          
  # HTML-
  $operation = "INSERT" if ( $operation eq undef );

  #      JavaScript-
  $additional_code = '' if ( $additional_code eq undef );
  
  #        %hot_help_info,
  #   

  # { 1 }->[ [ 'LINK', ' ' ],
  #          [
  #            [ 1, ' 1' ], [ 2, ' 2' ], ...
  #          ]
  #        ]
  # { 2 }->[ [ 'BTN', '  ' ],
  #          [
  #            [ 1, ' 1' ], [ 2, ' 2' ], ...
  #          ]
  #        ]
  # ....

  #      [ 'LINK', ' ' ] 
  #    ..._HELP_(LINK|BTN)_TITLE,    
  # [ [ 1, ' 1' ], [ 2, ' 2' ], ... ]   
  #  ..._HELP_VALUE (   
  #        ,
  # . .   ,      
  #   )
  #  -    "" 
  # () (  ,      . )

  my %hot_help_info = ();
  my $key;
  
  #   (       HTML-)
  # (       JavaScript)
  my( $short_field_name ) = $field_name =~ /.+\.(.+)$/;
  
  #  ,     CGI::escapeHTML
  my $esc_val;      # escaped_value
  
  #   -  , 
  #  . ,       
  foreach $key ( keys %CFG )
  {
    #       ,   
    #   . ,   
    if ( $key =~ /^${prefix}_HELP_(LINK|BTN)_TITLE(\d+)$/ )
    {
      #    ,    $2,    , ...
      if ( ! exists $hot_help_info{ $2 } )
      {
        # ...         
        # (.   )
        $hot_help_info{ $2 } = [ [ $1, $CFG{ $key } ], [] ];
      }
      #        (     
      #  ..._HELP_VALUE), ...
      else 
      {
        # ...      0 (.   )
        ${ $hot_help_info{ $2 } }[ 0 ] = [ $1, $CFG{ $key } ];
      }
    }
    #    ,     
    #  , ...
    elsif ( $key =~ /^${prefix}_HELP_VALUE(\d+)_(\d+)$/ )
    {
      # ...       ,
      #    ,       $CFG{ $key },
      #       ,    $2
      #   ( ,      , 
      #      . )
      if ( ! exists $hot_help_info{ $1 } )
      {
        $hot_help_info{ $1 } = [ [], [] ];
        push( @{ $hot_help_info{ $1 }[ 1 ] }, [ $2, $CFG{ $key } ] );
      }
      # ...     , ...
      else
      {
        # ...        $CFG{ $key } 
        #   
        push( @{ $hot_help_info{ $1 }[ 1 ] }, [ $2, $CFG{ $key } ] );
      }
    }
  }

  #     , . .   
  
  #        
  # , . .  1, 2, 3  . .
  #     ,   
  foreach $key ( sort { $a <=> $b } keys %hot_help_info )
  {
    #    ""    ,   
    #  "" ,     

    my @tmp;
    my @sorted;
  
    #  ,    "" 
    # (. .  ..._HELP_VALUE)
    @tmp = @{ $hot_help_info{ $key }[ 1 ] };

    #       , 
    #      0  
    # ([ [ 1, ' 1' ], [ 2, ' 2' ], ... ])
    @sorted = sort { $$a[ 0 ] <=> $$b[ 0 ] } @tmp;

    #        
    $hot_help_info{ $key }[ 1 ] = [ @sorted ];

    # DEBUG
    #  print $key, $hot_help_info{ $key }[ 0 ][ 0 ],
    #              $hot_help_info{ $key }[ 0 ][ 1 ], "\n";
    #  foreach ( @{ $hot_help_info{ $key }[ 1 ] } )
    #  {
    #    print $_->[ 0 ], $_->[ 1 ], "\n";
    #  }

    #       (   
    #  ,  1), ...
    if ( scalar @{ $hot_help_info{ $key }[ 1 ] } == 1 )
    {
      #     "" ,  
      #     ,     
      # (.    obj_groups_descrs.pl)
      #     , . . , 
      #   escapeHTML(), 
      $esc_val = $hot_help_info{ $key }[ 1 ][ 0 ][ 1 ];
      $esc_val =~ s/\'/\\\'/g;
      $esc_val = CGI::escapeHTML( $esc_val );

      #   HTML-
      if ( $hot_help_info{ $key }[ 0 ][ 0 ] eq 'LINK' )
      {
        # ...   HTML-
        if ( $operation eq "INSERT" )     #     
        {
          print qq{ <a href="javascript:void( 0 )" class="hot_help_link" 
                    onclick=
                    "insert_str_into_field( $field_name, '$esc_val' )">} .
                    $hot_help_info{ $key }[ 0 ][ 1 ] . "</a>\n";
        }
        elsif ( $operation eq "REPLACE" )  #    
        {
          #  NAME    ,  
          #      .   ,
          # . .  ,     ,
          #  JavaScript,   .  
          #     . ,  
          #  " "   "  "
          #         ,
          #       (. . ,   
          #  )     , 
          #         .
          #  $additional_code     
          #   JavaScript:
          #         "var str; if (this.value) str = this.value;
          #                   else str = this.name;
          #         document.forms[ 0 ].pers_name.value = str; "
          #       VALUE,   
          # (   <input type = "button">)
          print "<a href=\"javascript:void( 0 )\" 
                    name=\"$hot_help_info{ $key }[ 0 ][ 1 ]\" 
                    class=\"hot_help_link\" 
                    onclick=
                    \"if ( $field_name.disabled == false )
                    { $field_name.value = '$esc_val'; 
                      $additional_code;
                      $field_name.focus();
                    }
                    else
                    { 
                      window.alert( ' .  ' );
                    }  
                    \">" . $hot_help_info{ $key }[ 0 ][ 1 ] . "</a>\n";
        }
      }
      #   HTML-
      # .     qq{} 
      #              ""  joe    
      #               .
      elsif ( $hot_help_info{ $key }[ 0 ][ 0 ] eq 'BTN' )
      {
        # ...   HTML-
        if ( $operation eq "INSERT" )     #     
        {
          print qq{ <input type="button" } .
                qq{ class="hot_help_btn" } .
                qq{ value="} . 
                  CGI::escapeHTML( $hot_help_info{ $key }[ 0 ][ 1 ] ) .
                qq{"} .
                qq{ onclick="insert_str_into_field( $field_name, 
                                                    '$esc_val' )" />} . "\n";
        }
        elsif ( $operation eq "REPLACE" )  #    
        {
          print qq{ <input type="button" } .
                qq{ class="hot_help_btn" } .
                qq{ value="} . 
                  CGI::escapeHTML( $hot_help_info{ $key }[ 0 ][ 1 ] ) .
                qq{"} .
                qq{ onclick=
                    "if ( $field_name.disabled == false )
                    \{ $field_name.value = '$esc_val'; 
                       $additional_code;
                       $field_name.focus();
                    \}
                     else
                    \{
                      window.alert( ' .  ' );
                    \}
                    "/>} . "\n";
        }
      }      
    }
    #        (  
    #   ,  1), ...
    elsif ( scalar @{ $hot_help_info{ $key }[ 1 ] } > 1 )
    {
      # ...   JavaScript-    ,  
      #    "" ,   
      #    JavaScript
      
      #       (  )
      #       "" ,   
      #        $key, . .
      # open_hot_help_window1(), open_hot_help_window2()  . .

      #   ""       
      #   HTML-,     $key   
      #   ,         ,
      #       
      
      #     HTML-    
      # insert_text.js,    
      # insert_str_into_field(),     
      #   HTML-
      
      # .  "+" --     JavaScript.
      #                   
      #                ( -- 80 ).

      # help_win.document.write( "<TITLE>$hot_help_info{ $key }[ 0 ][ 1 ]" +
      #                          "</TITLE>" );
      #     "" ,  
      #     ,   
      # 
      $esc_val = CGI::escapeHTML( $hot_help_info{ $key }[ 0 ][ 1 ] );
      
      print <<END_OF_SCRIPT;
      <script language="JavaScript" type="text/javascript">
      <!--
      function open_hot_help_window_${short_field_name}_${key}()
      {
        var help_win = window.open( "", "help_window",
                                    "$CFG{ HOT_HELP_WINDOW_PARAMS }" );
        help_win.document.open();
        help_win.document.write( "<html>" );
        help_win.document.write( "<head>" );
        help_win.document.write( "<link rel=\\\"stylesheet\\\" " +
                                 "type=\\\"text/css\\\" " +
                                 "href=\\\"/$CFG{ HOME_WEB_CSS_DIR }" +
                                 "/$CFG{ CSS }\\\" />" );
        help_win.document.write( "<title>$esc_val</title>" );
        help_win.document.write( "</head>" );
        help_win.document.write( "<body class=\\\"hot_help_body\\\">" );
        help_win.document.write( "<script language=\\\"JavaScript\\\" " +
                                 "type=\\\"text/javascript\\\" " +
                                 "src=\\\"/$CFG{ HOME_WEB_JS_DIR }" + 
                                 "/insert_text.js\\\">" +
                                 "</script>" );
END_OF_SCRIPT
      ;

      #    ,   ""
      # ,  HTML-,      
      foreach ( @{ $hot_help_info{ $key }[ 1 ] } )
      {
        #     "" ,  
        #     ,     
        # (.    obj_groups_descrs.pl)
        #     , . . , 
        #   escapeHTML(), 
        $esc_val = $_->[ 1 ];
        # TODO.    , . .     
        #       .    !
        # $esc_val =~ s/\'/\\\'/g;
        # $esc_val =~ s/\"/\\\"/g;
        $esc_val = CGI::escapeHTML( $esc_val );

        #   $field_name     ,
        #    ,     "opener.";
        #       "" ,
        #    self.close();
        # .    "\"  , 
        #                Perl    JavaScript,
        #             ,   ,    HTML.
        #               .
        # TODO.   ,      
        #        "'" ( ),  
        #          .
        my $command = "<a href=\\\"javascript:void( 0 )\\\" " .
                      "class=\\\"hot_help_link_list\\\" onclick=" .
                      "\\\"insert_str_into_field( opener.$field_name, " .
                                                 "'$esc_val' ); " .
                      "self.close()\\\">" .
                      "$esc_val</a><br />";

        print qq{ help_win.document.write( "$command" ); } . "\n";
      }

      print <<END_OF_SCRIPT;
        help_win.document.write( "</body>" );
        help_win.document.write( "</html>" );
        help_win.document.close();
      }
      //-->
      </script>
END_OF_SCRIPT
      ;

      #      HTML-, ...
      if ( $hot_help_info{ $key }[ 0 ][ 0 ] eq 'LINK' )
      {
        # ...   HTML-
        print "<a href=\"javascript:void( 0 )\" " .
              "class=\"hot_help_link\" onclick=" .
              "\"open_hot_help_window_${short_field_name}_${key}()\">" .
              $hot_help_info{ $key }[ 0 ][ 1 ] . "</a>\n";
      }
      #       , ...
      elsif ( $hot_help_info{ $key }[ 0 ][ 0 ] eq 'BTN' )
      {
        # ...   HTML-
        print "<input type=\"button\" " .
              qq{ class="hot_help_btn" } .
              " value=\"" . 
                CGI::escapeHTML( $hot_help_info{ $key }[ 0 ][ 1 ] ) .
              "\"" .
              " onclick=
              \"open_hot_help_window_${short_field_name}_${key}()\"/>" . "\n";
      }
    }
    #         (  
    #   ,  0),     
    # (  ..._TITLE,        ..._VALUE
    #  . )
    else       # scalar @{ $hot_help_info{ $key }[ 1 ] } == 0
    {
      #      HTML-, ...
      if ( $hot_help_info{ $key }[ 0 ][ 0 ] eq 'LINK' )
      {
        # ...   HTML-
        print "<a href=\"javascript:void( 0 )\" " .
              "class=\"hot_help_link\" onclick=" .
              "\"javascript:alert('  ')\">" .
              $hot_help_info{ $key }[ 0 ][ 1 ] . "</a>\n";
      }
      #       , ...
      elsif ( $hot_help_info{ $key }[ 0 ][ 0 ] eq 'BTN' )
      {
        # ...   HTML-
        print "<input type=\"button\" " .
              "class=\"hot_help_btn\" " .
              "value=\"$hot_help_info{ $key }[ 0 ][ 1 ]\" " .
              "onclick = \"javascript:alert('  ')\"/>" .
              "\n";
      }
    }
  }

  #     , ,      
  # HTML-  ,   HTML-  
  #  <br />,    ()     
  # 
  # .        ?
  if ( scalar keys %hot_help_info >= 1 )
  {
    print "<br />\n";
  }
  
  return;
}

# -----------------------------------------------------------------------------
#        " "
# -----------------------------------------------------------------------------
sub create_main_page_link
{
  #  {}   qq   '',    Joe
  #         Perl
  print qq'<a id="main_link" href="/$CFG{ HOME_WEB_DIR }/e_arch.pl" 
             target="_top"> : $CFG{ TITLE }</a>\n';
}

# -----------------------------------------------------------------------------
#      JavaScript,  
#    -   -
# -----------------------------------------------------------------------------
sub create_selection_func
{
  #   
  # (  :   =>  )
  my %prms = @_;

  # :
  #     JavaScript (func_name);
  #    (module_name);
  #    (caller_name);
  #    ( JavaScript) (window_name);
  #     (window_params);
  #     "/"  (exp_imp)

  #     
  my $func_name = $prms{ func_name };
  my $module_name = $prms{ module_name };
  my $caller_name = $prms{ caller_name };
  my $window_name = $prms{ window_name };
  my $window_params = $prms{ window_params };
  my $exp_imp = $prms{ exp_imp };
  
  if ( $window_params eq undef )
  {
    $window_params = $CFG{ SELECTION_WINDOW_PARAMS };
  }
  
  #   enable_select=1
  #   exp_imp=$exp_imp
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript">
  <!--
  function ${func_name}()
  {
    window.open( '/$CFG{ HOME_WEB_DIR }/$module_name/select' +
                 '?enable_select=1&caller_name=$caller_name' +
                 '&exp_imp=$exp_imp',
                 '$window_name',
                 '$window_params' );
  }
  //-->
  </script>
END_OF_SCRIPT
  ;
}

# -----------------------------------------------------------------------------
#        ""  
# -----------------------------------------------------------------------------
sub create_top_block
{
  #   
  # (  :   =>  )
  my %prms = @_;

  # : CGI- (query);
  #               (module);
  #              (module_title);
  #             ,    (user);
  #                  
  #               ,   
  #             (make_letters);
  #               ,  
  #               (num_last_recs);
  #                 (full_top)
  #            (  -- 'yes',    
  #             ,    'no')

  my $query = $prms{ query };    #  
  my $script_name;               #   ( ),  
                                 #   
  my $add_params = '';           #  

  $script_name = $query->script_name;  #  

  #   -- 'yes', . .  
  $prms{ full_top } = 'yes' if ! $prms{ full_top };

  #          
  #  ,      
  # TODO.    .
  if ( ! $query->param( 'enable_select' ) || $CFG{ DBDESCR_DISPLAY_IS_ON } )
  {
    print "<table id=\"main_link_table\">\n";
    print "<tr>\n";
    print "<td id=\"td_main_link\">\n";

    #         
    #  ,        
    if ( ! $query->param( 'enable_select' ) )
    {
      create_main_page_link();
    }
    print "</td>\n";

    print "<td id=\"td_dbdescr\">\n";
    #    ,    . 
    print "$CFG{ DBDESCR }\n" if ( $CFG{ DBDESCR_DISPLAY_IS_ON } );

    #      "/",    
    #     --   
    if ( $query->param( 'exp_imp' ) )
    {
      print "&nbsp;" . "()\n" if export_enabled();
      print "&nbsp;" . "()\n" if import_enabled();
    }
    print "</td>\n";

    print "</tr>\n";
    print "</table>\n";
  }
  
  #   
  print "<h2 class=\"module_title\">$prms{ module_title }</h2>\n";

  #          
  if ( $prms{ full_top } eq 'no' )
  {
    return ( 0 );
  }
  
  #         
  #  enable_select  caller_name (  )
  if ( $query->param( 'enable_select' ) )
  {
    $add_params = "enable_select=1&caller_name=" .
                  $query->param( 'caller_name' );
  }

  if ( $query->param( 'exp_imp' ) )
  {
    #    $add_params  
    $add_params .= "&" if ( $add_params );
    $add_params .= "exp_imp=1";
  }
  
  #     EXPORT (exp_imp.pl)
  if ( $prms{ module } eq 'EXPORT' )
  {
    if ( have_access( 'module' => $prms{ module }, 'procedure' => 'START',
                      'user' => $prms{ user } ) )
    {
      print qq{ <a class="command_link" href="$script_name/export?start=1} .
            ( ( $add_params ) ? "?$add_params" : '' ) . "\"" .
            qq{ target="_self"> </a>\n };
    }

    #     ,   
    if ( export_enabled() )
    {
      print qq{ <a class="command_link"} .
            qq{ href="/$CFG\{ HOME_WEB_DIR \}/e_arch.pl?exp_imp=1} .
            ( ( $add_params ) ? "?$add_params" : '' ) . "\"" .
            qq{ target="_self"> </a>\n };
    }

    #       ,   
    #  
    if ( export_enabled() &&
         have_access( 'module' => $prms{ module }, 'procedure' => 'EXPORT_ALL',
                      'user' => $prms{ user } ) )
    {
      print qq{ <a class="command_link" } .
            qq{href="$script_name/export?export_all=1} .
            ( ( $add_params ) ? "?$add_params" : '' ) . "\"" .
            qq{ target="_self">   </a>\n };
    }

    #   ,     
    if ( export_enabled() &&
         have_access( 'module' => $prms{ module }, 'procedure' => 'FINISH',
                      'user' => $prms{ user } ) )
    {
      print qq{ <a class="command_link" href="$script_name/export?finish=1} .
            ( ( $add_params ) ? "?$add_params" : '' ) . "\"" .
            qq{ target="_self"> </a>\n };
    }
    return ( 0 );  
  }

  #     IMPORT (exp_imp.pl)
  if ( $prms{ module } eq 'IMPORT' )
  {
    if ( have_access( 'module' => $prms{ module }, 'procedure' => 'START',
                      'user' => $prms{ user } ) )
    {
      print qq{ <a class="command_link" href="$script_name/import?start=1} .
            ( ( $add_params ) ? "?$add_params" : '' ) . "\"" .
            qq{ target="_self"> </a>\n };
    }

    #     ,   
    if ( import_enabled() )
    {
      print qq{ <a class="command_link"} .
            qq{ href="/$CFG\{ HOME_WEB_DIR \}/e_arch.pl?exp_imp=1} .
            ( ( $add_params ) ? "?$add_params" : '' ) . "\"" .
            qq{ target="_self"> </a>\n };
    }

    #   ,     
    if ( import_enabled() &&
         have_access( 'module' => $prms{ module }, 'procedure' => 'FINISH',
                      'user' => $prms{ user } ) )
    {
      print qq{ <a class="command_link" href="$script_name/import?finish=1} .
            ( ( $add_params ) ? "?$add_params" : '' ) . "\"" .
            qq{ target="_self"> </a>\n };
    }
    return ( 0 );  
  }

  #    ,  /

  if ( $prms{ make_letters } eq 'yes' )
  {
    #         ,
    #    
    #       "&", . .   
    # make_letters()    ,   
    #  "?"
    make_letters( $script_name, 
                  ( $add_params ) ? "&" . $add_params : '',
                  $prms{ num_last_recs }
                );
  }
  else
  {
    #         (,  )
    print qq{ <a class="command_link" href="$script_name/query} .
          ( ( $add_params ) ? "?$add_params" : '' ) . "\"" .
          qq{ target="_self"></a>\n };
  }

  #       ,     
  # "  ",      
  # . ,  ""   "  "
  #                ,   .
  #           "/"
  if ( ! ( $query->param( 'enable_select' ) &&
           $query->param( 'caller_name') eq $prms{ module }
         ) &&
       ! $query->param( 'exp_imp' )
     )
  {
    if ( have_access( 'module' => $prms{ module }, 'procedure' => 'ADD', 
                      'user' => $prms{ user } ) )
    {
      print qq{ <a class="command_link" href="$script_name/add} .
            ( ( $add_params ) ? "?$add_params" : '' ) . "\"" .
            qq{ target="_self"> </a>\n };
    }
  }  

  print qq{ <a class="command_link" href="$script_name/find} .
        ( ( $add_params ) ? "?$add_params" : '' ) . "\"" .
        qq{ target="_self"></a>\n };

  return ( 0 );
}

# -----------------------------------------------------------------------------
#     --       PostgreSQL
# -----------------------------------------------------------------------------
sub date_for_db
{
  my $date_in = shift; #  -     ("")
  my $epoch = shift;   #  - "" 
                       # (,     )

  my $date_out;        #    
  my( $day, $mon, $year );

  #        , ...
  if ( $date_in =~ /^(\d\d\d\d)-(\d\d)-(\d\d)$/ )
  {
    return ( $date_in );  # ...       
  }
  #     , ...
  elsif ( $date_in eq undef )
  {
    return ( $date_in );  # ...       
  }

  #      - ,   
  # (,      ".-/",    
  #      )
  ( $day, $mon, $year ) = $date_in =~
                          /^(\d{1,2})[\.\/-](\d{1,2})[\.\/-]((\d\d){1,2})$/;

  #      ,  ""
  if ( $year =~ /^\d\d$/ )
  {
    #    , ...
    if ( $epoch eq undef )
    {
      $epoch = 20  # ...      1920 
    }
    else
    {
      #       (    
      #  ,    , , 20  1920)
      ( $epoch ) = $epoch =~ /(\d\d)$/; 
    }
    $year = ( $year < $epoch ) ? $year + 2000 : $year + 1900;
  }
  
  #       ,  
  $date_out = sprintf( "%4d-%02d-%02d", $year, $mon, $day );

  return ( $date_out );
}

# -----------------------------------------------------------------------------
#     --     
# -----------------------------------------------------------------------------
sub date_for_display
{
  my $date_in = shift; #  -     ("--")

  my $date_out;        #    
  my( $day, $mon, $year );

  # TODO
  #       ,   
  #  .   --    .

  #   ,    
  if ( $date_in eq undef || $date_in eq '' )
  {
    return ( '' );
  }

  #      - ,   
  ( $year, $mon, $day ) = $date_in =~ /^(\d\d\d\d)-(\d\d)-(\d\d)$/;
  
  #       ,  
  $date_out = sprintf( "%02d-%02d-%4d", $day, $mon, $year );

  return ( $date_out );
}

# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub date_is_correct
{
  # .       --().

  my $date = shift;    #  -     ("")
  my $epoch = shift;   #  - "" 
                       # (,     )

  my( $day, $month, $year );

  #     , ...
  if ( $date eq undef )
  {
    return ( 0 );  #   
  }

  #    , ...
  # (,      ".-/",    
  #      )
  if ( $date !~ /^(\d{1,2})[\.\/-](\d{1,2})[\.\/-]((\d\d){1,2})$/ )
  {
    return ( 0 );  #   
  }

  #      - ,   
  ( $day, $month, $year ) = $date =~
                            /^(\d{1,2})[\.\/-](\d{1,2})[\.\/-]((\d\d){1,2})$/;

  #      ,  ""
  if ( $year =~ /^\d\d$/ )
  {
    #    , ...
    if ( $epoch eq undef )
    {
      $epoch = 20  # ...      1920 
    }
    else
    {
      #       (    
      #  ,    , , 20  1920)
      ( $epoch ) = $epoch =~ /(\d\d)$/; 
    }
    $year = ( $year < $epoch ) ? $year + 2000 : $year + 1900;
  }
  
  #      
  if ( $month < 1 || $month > 12 )
  {
    return ( 0 );  #   
  }

  #    (    grep)
  $month = sprintf( "%02d", $month );
  
  if ( $day == 0 )
  {
    return ( 0 );  #   
  }
  else
  {
    if ( grep( /^$month$/, ( '01', '03', '05', '07', '08', '10', '12' ) ) > 0 )
    {
      if ( $day > 31 )
      {
        return ( 0 );  #   
      }
    }
    elsif ( grep( /^$month$/, ( '04', '06', '09', '11' ) ) > 0 )
    {
      if ( $day > 30 )
      {
        return ( 0 );  #   
      }
    }
    elsif ( $month eq '02' )
    {
      #   
      # TODO       .   ,
      #            -  400.
      if ( $year % 4 == 0 && $day > 29 )
      {
        return ( 0 );  #   
      }
      elsif ( $year % 4 != 0 && $day > 28 )
      {
        return ( 0 );  #   
      }
    }
  }

  return ( 1 );        #   
}

# -----------------------------------------------------------------------------
#     ,    
#   
# -----------------------------------------------------------------------------
sub debug_is_enabled
{
  #        ()
  #   :
  # -  DEBUG_IS_ON  .    1 ();
  # -  () ,    , 
  #      ,   DEBUG_USERS
  #    . 

  my $user = get_user_name();  #  
  my @debug_users;             #  "" 
  my $debug = 0;               #     

  if ( $CFG{ DEBUG_IS_ON } )
  {
    $debug = 1;         #   !
  }
  else
  {
    if ( $CFG{ DEBUG_USERS } )
    {
      $CFG{ DEBUG_USERS } =~ s/\s*$//;  #     

      #    (,    ) 
      #  
      $CFG{ DEBUG_USERS } =~ s/,/ /g;   #    

      #      
      @debug_users = split( /\s+/, $CFG{ DEBUG_USERS } );

      #      "" 
      $debug = grep( /^$user$/, @debug_users ) ? 1 : 0;
    }
  }

  return ( $debug );
}

# -----------------------------------------------------------------------------
#     
# -----------------------------------------------------------------------------
sub del_rec
{
  #   
  # (  :   =>  )
  my %prms = @_;

  # : CGI- (query);
  #                    
  #                ""   (create_top);
  #                (target);
  #                   
  #              (print_add_info)
  #                   (command)

  my $query = $prms{ query };
  my $conn;                       #    
  my $result;                     #   SQL-

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => $prms{ target } );

  open_top();          #     
  &{ $prms{ create_top } }();  #      
                       # ""  
  close_top();         #     

  open_bottom();       #     

  #     
  &{ $prms{ print_add_info } }() if defined( $prms{ print_add_info } );

  $conn = exec_connect_db();   #   

  # DEBUG 
  print_debug_info( $prms{ command } ) if $DEBUG;  #   

  #     
  $result = $conn->exec( $prms{ command } );

  #         
  if ( PGRES_COMMAND_OK ne $result->resultStatus )
  {
    #   
    print "<p class=\"error\">$CFG{ ERROR_DELETE }</p>\n";
    print STDERR $prms{ command } . "\n";     #     
    die $conn->errorMessage;
  }

  #     
  if ( $result->cmdTuples == 1 )
  {
    print "<p class=\"info\">";
    print "    </p>\n";
  }
  elsif ( $result->cmdTuples == 0 )
  {
    print "<p class=\"info\">";
    print "     </p>\n";
  }
  else          # ( $result->cmdTuples > 1 )
  {
    print "<p class=\"error\">";
    print "    " . $result->cmdTuples .
          " .  !   </p>\n";
  }

  close_bottom();      #     
  print $query->end_html();  
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_add
{
  #   
  # (  :   =>  )
  my %prms = @_;

  # : CGI- (query);
  #                     
  #              ""   (create_top);
  #                 (make_form);
  #            URL     (action);
  #                (target);
  #              submit (submit_name);
  #               submit (submit_value)

  # .      ,  
  #             submit_name  submit_value   
  #               .

  my $query = $prms{ query };

  my $i;

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => $prms{ target } );

  open_top();          #     
  &{ $prms{ create_top } }();  #      
                       # ""  
  close_top();         #     

  open_bottom();       #     

  #        URL-,  
  #  ,    URL    ,
  #    , ..   PATH_INFO = 'add' 
  #   ,     ,  
  # PATH_INFO    ,    
  print $query->start_form( -action => $prms{ action },
                            -target => $prms{ target }
                          ), "\n";

  #       JavaScript,  
  #   HTML- (  ) --   
  #     web-
  create_enable_elements_func();

  #     
  &{ $prms{ make_form } }();

  #  submit     make_form()   

  #     ,    
  # .   $prms{ submit_name }  $prms{ submit_value }
  #                 .  
  #                : ,    .
  if ( ref( $prms{ submit_name } ) eq 'ARRAY' )
  {
    for( $i = 0; $i < scalar @{ $prms{ submit_name } }; $i++ )
    {
      print $query->submit( -name => ${ $prms{ submit_name } }[ $i ],
                            -value => ${ $prms{ submit_value } }[ $i ],
                            -class => 'submit',
                            -onclick => "enable_elements()"
                          ), "&nbsp;\n";
    }
  }
  else                #   
  {
    print $query->submit( -name => $prms{ submit_name },
                          -value => $prms{ submit_value },
                          -class => 'submit',
                          -onclick => "enable_elements()" ), "\n";
  }

  print $query->end_form();

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#   SQL- /   
# ( "/"  "")
# -----------------------------------------------------------------------------
sub exec_cmd
{
  #  
  my $conn = shift;             #    
  my $target_schema = shift;    #    
  my $table = shift;            #  
  my $cmd_type = shift;         #  SQL- (INSERT  UPDATE)
  my $command = shift;          #  SQL-
  my $where = shift;            #  WHERE,    
                                #     
                                # "/"

  my $result;                   #   SQL-

  #         
  #     :     ,
  #   0,    -- 1

  #   WHERE    ,  
  #    (      
  # $command,         
  #       )
  if ( $where )
  {
    #  
    $result = 
      $conn->exec( "SELECT 'x' FROM $target_schema.$table WHERE $where" );

    #        
    if ( PGRES_TUPLES_OK ne $result->resultStatus )
    {
      #   
      print "<p class=\"error\">$CFG{ ERROR_SELECT }</p>\n";
      print STDERR $command . "\n";           #     
      die $conn->errorMessage;
    }

    #      :      "/"
    # TODO. :         ?
    # TODO.  ,      , 
    #           ?    
    #         --    .   ,
    #              
    #       , , . ?
    return 0 if ( $result->ntuples > 0 );
  }
  
  # DEBUG 
  print_debug_info( $command ) if $DEBUG;  #   

  #   /    ( "/")
  $result = $conn->exec( $command );

  #     /   
  if ( PGRES_COMMAND_OK ne $result->resultStatus )
  {
    #   
    print "<p class=\"error\">" .
          ( ( $cmd_type eq 'INSERT' ) ? $CFG{ ERROR_INSERT } :
                                        $CFG{ ERROR_UPDATE } ) . "</p>\n";
    print STDERR $command . "\n";             #     
    die $conn->errorMessage;
  }
  # .     .
  #  else
  #  {
  #    print "<p class=\"info\">";
  #    print( "      ( " .
  #           "\"    \")</p>\n" );
  #  }
  
  #    ,  (UPDATE) -- 
  return ( $cmd_type eq 'INSERT' ) ? 1 : 0;
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub exec_connect_db
{
  #  --    
  my $conn_str = shift;
  
  my $conn;        #    

  #    ,       
  $conn_str = create_conn_str() if ( $conn_str eq undef );
  
  $conn = Pg::connectdb( $conn_str );
  
  die $CFG{ ERROR_CONNECT } . $conn->errorMessage
    unless PGRES_CONNECTION_OK eq $conn->status;

  return $conn;
}

# -----------------------------------------------------------------------------
#     
# -----------------------------------------------------------------------------
sub exec_select
{
  # 
  my $command = shift;   #  SQL-
  my $msg     = shift;   #  ,    
  my $conn    = shift;   #    

  my $result;            #   

  #       ,    
  $msg = ",   ,    "
    if ( $msg eq undef );

  # DEBUG 
  print_debug_info( $command ) if $DEBUG;  #   

  if ( ! $conn )
  {
    $conn = exec_connect_db();
  }
  #  
  $result = $conn->exec( $command );

  #        
  if ( PGRES_TUPLES_OK ne $result->resultStatus )
  {
    #   
    print "<p class=\"error\">$CFG{ ERROR_SELECT }</p>\n";
    print STDERR $command . "\n";           #     
    die $conn->errorMessage;
  }

  if ( $result->ntuples == 0 )              #     
  {
    #         (,  
    # get_available()),       
    #  " ",      
    print "<p class=\"info\">$msg</p>\n" if ( $msg !~ /^\s+$/ );

    return ( undef );
  }

  return ( $result );
}  

# -----------------------------------------------------------------------------
#  SQL-  
# -----------------------------------------------------------------------------
sub exec_transaction
{
  # 
  my $conn = shift;          #    
  my $oper = shift;          #  (BEGIN, END, ROLLBACK)

  my $result;                #   SQL-
  
  if ( $oper ne "BEGIN" && $oper ne "END" && $oper ne "ROLLBACK" )
  {
    #   
    print "<p class=\"error\">  : $oper</p>\n";
    #     
    print STDERR "  : $oper\n";
    die;
  }

  $result = $conn->exec( $oper );

  #        
  die $CFG{ 'ERROR_' . $oper } . $conn->errorMessage
    unless PGRES_COMMAND_OK eq $result->resultStatus;

  return;
}

# -----------------------------------------------------------------------------
#     
# -----------------------------------------------------------------------------
sub export_data
{
  #   
  # (  :   =>  )
  my %prms = @_;

  # : CGI- (query);
  #                   
  #                ""   (create_top);
  #                  ,
  #                     
  #              (table_cmd_pairs)

  #       
  $prms{ source_schema } = 'public';
  $prms{ target_schema } = 'exp_imp';

  #          ,    
  # (       )
  copy_data( %prms );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#      " "
# -----------------------------------------------------------------------------
sub export_enabled
{
  #   export ,   import  
  # ( stat()    ;   ,
  #     )
  if ( scalar stat( "./exp_imp/export" ) > 0 && 
       scalar stat( "./exp_imp/import" ) == 0
     )
  {
    return ( 1 );    #  ""
  }

  return ( 0 );      #   ""
}

# -----------------------------------------------------------------------------
#       
# -----------------------------------------------------------------------------
sub first_cap
{
  # .   -    first_letter(), 
  #                ,   .

  return first_letter( 'to_upper', shift );
}

# -----------------------------------------------------------------------------
#         
# -----------------------------------------------------------------------------
sub first_letter
{
  # .      Perl - ucfirst(),
  #             lcfirst(),   ,   ,   
  #                   
  #             (LC_CTYPE  ..),      .
  #             ,  Perl'   use locale.  ,
  #                    - 
  #              .

  # : 
  #   - to_lower  to_upper;
  # ,         
  my $mode = shift;
  my $string = shift;

  # -
  # .  ""  ""    -   .
  my $lower_abc = "abcdefghijklmnopqrstuvwxyz" .
                  "ţ";
  my $upper_abc = "ABCDEFGHIJKLMNOPQRSTUVWXYZ" .
                  "";

  my $first = substr( $string, 0, 1 );  #     

  #        - 
  # ()   () 
  my $index;

  #         - ,  
  if ( length( $string ) == 0 || $string eq undef )
  {
    return undef;
  }

  #      -

  #    , ...
  if ( $mode eq 'to_upper' )
  {
    # ...    
    $index = index( $lower_abc, $first );
  }
  #    - ...
  elsif ( $mode eq 'to_lower' )
  {
    # ...  
    $index = index( $upper_abc, $first );
  }
  
  #      - ,   
  #    
  if ( $index < 0 )
  {
    return ( $string );
  }

  #   ,       ""
  # -

  #    , ...
  if ( $mode eq 'to_upper' )
  {
    $first = substr( $upper_abc, $index, 1 );
  }
  #    - ...
  elsif ( $mode eq 'to_lower' )
  {
    $first = substr( $lower_abc, $index, 1 );
  }

  #     
  # .    substr()   
  #              lvalue (..  ,   
  #              ,    ). .  
  #               substr().
  substr( $string, 0, 1 ) = $first;

  return ( $string );
}

# -----------------------------------------------------------------------------
#       
# -----------------------------------------------------------------------------
sub first_lower
{
  # .   -    first_letter(), 
  #                ,   .

  return first_letter( 'to_lower', shift );
}

# -----------------------------------------------------------------------------
#    ,     
# . ,       , 
#  . 
# -----------------------------------------------------------------------------
sub get_available
{
  #  
  my $obj_id = shift;       #   
                            #  
  my $db_schema = shift;    #   -- exp_imp  public
                            # ( exp_imp,     ,
                            #      ;
                            #  public,   --   "")
  
  my $result;               #    
  my $command;              #      
  my @row;                  #      

  my @phys_forms = ();      #     
  my $owner_pers_id;        #    

  $owner_pers_id = $CFG{ BIB_RECS_OWNER_PERS_ID };
  
  if ( $owner_pers_id eq undef )  #  .    
  {
    #  1,   ,    ,
    # . . ,     
    #   1
    $owner_pers_id = 1;
  }

  #      . ,   - 
  #   
  $command = "SELECT pft.phys_form_sname, count( pft.phys_form_sname ) " .
             "FROM ${db_schema}stor_objs so, " .
                  "${db_schema}phys_form_types pft " .
             "WHERE so.obj_id = '$obj_id' AND " .
                   "so.owner_pers_id = $owner_pers_id AND " .
                   "so.phys_form_code = pft.phys_form_code " .
             "GROUP BY pft.phys_form_sname";

  #    
  #           
  #   ,   -- " "
  $result = exec_select( $command, " " );
  
  if ( $result )
  {
    #      
    while ( @row = $result->fetchrow )
    {
      #     .   
      if ( $row[ 1 ] > 1 )
      {
        #       . ,   -
        #    
        push( @phys_forms, "$row[ 0 ] ($row[ 1 ])" );
      }
      else
      {
        #     
        push( @phys_forms, $row[ 0 ] );
      }
    }
  }
  return ( @phys_forms );
}  

# -----------------------------------------------------------------------------
#  .    
# -----------------------------------------------------------------------------
sub get_bib_rec
{
  #  
  my $obj_id = shift;       #    . 
  my $bib_rec_num = shift;  #  .    
  my $db_schema = shift;    #   -- exp_imp  public
                            # ( exp_imp,     ,
                            #      ;
                            #  public,   --   "")
  
  my $result;               #    
  my $command;              #      
  my @row;                  #      
  my $bib_rec;              # . 
  
  $command = "SELECT CASE WHEN bib_rec_full IS NOT NULL " .
                         "THEN bib_rec_full " .
                         "ELSE bib_rec_short " .
                    "END AS bib_rec " .
             "FROM ${db_schema}bib_recs " .
             "WHERE obj_id = $obj_id AND " .
                   "bib_rec_num = $bib_rec_num";

  #    
  $result = exec_select( $command );
  
  if ( $result )
  {
    #      
    @row = $result->fetchrow;
    $bib_rec = $row[ $result->fnumber( 'bib_rec' ) ];

    #    ,      
    # ,   &mdash;
    # . TODO   list_bib_recs_by_query()  E_ARCH.pm.
    $bib_rec =~ s/--/&mdash;/g;

    return ( $bib_rec );
  }
  return "";
}

# -----------------------------------------------------------------------------
#       
# -----------------------------------------------------------------------------
sub get_next_key_value
{
  # 
  my $table = shift;              #   
  my $key_name = shift;           #      
  my $where_clause = shift;       #  WHERE (   ,
                                  #      -- 
                                  # , ,   Stor_objs)

  my $key_value;                  #   

  my( $conn, $result );           #    
  my @row;                        #      
  my $command;                    #      

  #        $table
  $command = "SELECT max( $key_name ) FROM $table";
  $command .= " WHERE " . $where_clause if ( $where_clause );

  # TODO.     exec_select().

  # DEBUG 
  print_debug_info( $command ) if $DEBUG;  #   

  $conn = exec_connect_db();            #   
  $result = $conn->exec( $command );    #  

  #        
  if ( PGRES_TUPLES_OK ne $result->resultStatus )
  {
    #   
    print "<p class=\"error\">$CFG{ ERROR_SELECT }</p>\n";
    print STDERR $command . "\n";             #     
    die $conn->errorMessage;
  }

  if ( $result->ntuples == 0 )
  {
    print "<p class=\"error\">";
    print "      $table " .
          " </p>\n";
    die;
  }
  else
  {
    #     
    @row = $result->fetchrow();

    #          1
    $key_value = $row[ 0 ] + 1;
  }
  return ( $key_value );  #      
}

# -----------------------------------------------------------------------------
#       
# -----------------------------------------------------------------------------
sub get_ref_descr
{
  #  
  my $obj_id = shift;       #    . 
  my $bib_rec_num = shift;  #  .    
  my $ref_num = shift;      #      
  my $db_schema = shift;    #   -- exp_imp  public
                            # ( exp_imp,     ,
                            #      ;
                            #  public,   --   "")
  
  my $result;               #    
  my $command;              #      
  my @row;                  #      
  my $ref_descr;            #   
  
  $command = "SELECT ref_descr " .
             "FROM ${db_schema}Refs_descrs " .
             "WHERE obj_id = $obj_id AND " .
                   "bib_rec_num = $bib_rec_num AND " .
                   "ref_num = $ref_num";

  #    
  $result = exec_select( $command );
  
  if ( $result )
  {
    #      
    @row = $result->fetchrow;
    $ref_descr = $row[ $result->fnumber( 'ref_descr' ) ];

    #    ,      
    # ,   &mdash;
    $ref_descr =~ s/--/&mdash;/g;

    return ( $ref_descr );
  }
  return "";
}

# -----------------------------------------------------------------------------
#   /   
# -----------------------------------------------------------------------------
sub get_ser_descr
{
  #  
  my $series_id = shift;     #   /
  my $ser_descr_num = shift; #   /
  my $db_schema = shift;     #   -- exp_imp  public
                             # ( exp_imp,     ,
                             #      ;
                             #  public,   --   "")
  
  my $result;                #    
  my $command;               #      
  my @row;                   #      
  my $ser_descr;             #  /
  
  $command = "SELECT ser_descr " .
             "FROM ${db_schema}Ser_descrs " .
             "WHERE series_id = $series_id AND " .
                   "ser_descr_num = $ser_descr_num";

  #    
  $result = exec_select( $command );
  
  if ( $result )
  {
    #      
    @row = $result->fetchrow;
    $ser_descr = $row[ $result->fnumber( 'ser_descr' ) ];

    #    ,      
    # ,   &mdash;
    $ser_descr =~ s/--/&mdash;/g;

    return ( $ser_descr );
  }
  return "";
}

# -----------------------------------------------------------------------------
#   ,   " "
# -----------------------------------------------------------------------------
sub get_user_name
{
  #        -  %ENV,
  #     
  my $user_name = $ENV{ REMOTE_USER };

  return ( $user_name );
}

# -----------------------------------------------------------------------------
#        
#  
# -----------------------------------------------------------------------------
sub have_access
{
  #  -        :
  # user, module, procedure (  );
  #  ,   , :
  # USER => 'admin', MODULE => 'students', PROCEDURE => 'add'

  my %params;
  my @tmp = @_;  #      
  my $i;

  my( $conn, $result );         #    
  my @row;                      #      
  my $command;                  #      

  my %access = ();              #       

  #      
  # .      
  #             .
  for ( $i = 0; $i < scalar @tmp; $i++ )
  {
    $tmp[ $i ] = uc( $tmp[ $i ] );
  }

  # .     -   - 
  #               .
  %params = ( @tmp ); 

  $conn = exec_connect_db();    #   

  #      ""   
  $command = "SELECT * FROM users " .
             "WHERE upper( user_name ) = '$params{ USER }'";
  # DEBUG 
  #    ,     web-
  #    http- (   ,
  # ..         - 
  # )
  # .        
  #             ,     ,  
  #              .
  # print_debug_info( $command ) if $DEBUG;  #   

  $result = $conn->exec( $command );

  #        
  if ( PGRES_TUPLES_OK ne $result->resultStatus )
  {
    #   
    # print "<p class=\"error\">$CFG{ ERROR_SELECT }</p>\n";
    print STDERR $command . "\n";               #     
    die $conn->errorMessage;
  }

  #     ,   0 -   
  # .   ,    . 
  #               :      .
  if ( $result->ntuples == 0 )
  {
    return ( 0 );
  }

  @row = $result->fetchrow();  #    

  #     
  if ( $row[ $result->fnumber( 'user_active' ) ] eq 'f' )
  {
    return ( 0 );              #  
  }

  #         "",
  #         " "
  $command = "SELECT upper( module_name ) as module_name, " .
                    "upper( proc_name ) as proc_name, oper_active " .
             "FROM access " .
             "WHERE upper( user_name ) = '$params{ USER }' " .
             "ORDER BY 1, 2";
  # DEBUG 
  # (.    )
  # print_debug_info( $command ) if $DEBUG;  #   

  $result = $conn->exec( $command );

  #        
  if ( PGRES_TUPLES_OK ne $result->resultStatus )
  {
    #   
    # print "<p class=\"error\">$CFG{ ERROR_SELECT }</p>\n";
    print STDERR $command . "\n";             #     
    die $conn->errorMessage;
  }

  #     ,   0 -   
  if ( $result->ntuples == 0 )
  {
    return ( 0 );   #   
  }

  #    ...
  while ( @row = $result->fetchrow() )
  {
    # ...   :
    # _ => _ => _
    $access{ $row[ $result->fnumber( 'module_name' ) ] }
           { $row[ $result->fnumber( 'proc_name' ) ] } = 
           $row[ $result->fnumber( 'oper_active' ) ];
  }

  # .       :
  #                  , .. 
  #                  ,  
  #              ,       'ALL'
  #             ,    ,    
  #                  .

  #         
  #   
  if ( exists $access{ $params{ MODULE } }{ $params{ PROCEDURE } } )
  {
    #  
    if ( $access{ $params{ MODULE } }{ $params{ PROCEDURE } } eq 't' )
    {
      return ( 1 );     #  
    }
    #  
    else
    {
      return ( 0 );     #   
    }
  }

  #         
  #    'ALL' (   -  )
  # .        
  #               .    ,  
  #              , ,    .
  if ( exists $access{ ALL }{ $params{ PROCEDURE } } )
  {
    #  
    if ( $access{ ALL }{ $params{ PROCEDURE } } eq 't' )
    {
      return ( 1 );     #  
    }
    #  
    else
    {
      return ( 0 );     #   
    }
  }

  #        
  #  'ALL'   (    
  #  )
  if ( exists $access{ $params{ MODULE } }{ ALL } )
  {
    #  
    if ( $access{ $params{ MODULE } }{ ALL } eq 't' )
    {
      return ( 1 );     #  
    }
    #  
    else
    {
      return ( 0 );     #   
    }
  }

  #         
  # 'ALL'    'ALL' (     )
  if ( exists $access{ ALL }{ ALL } )
  {
    #  
    if ( $access{ ALL }{ ALL } eq 't' )
    {
      return ( 1 );     #  
    }
    #  
    else
    {
      return ( 0 );     #   
    }
  }

  # -----------------------------------------------------------------------
  #   :      
  #      Access.   
  #  
  # -----------------------------------------------------------------------
#  #         
#  $command = "SELECT 'x' " .
#             "FROM access " .
#             "WHERE upper( user_name ) = '$params{ USER }' and " .
#                   "upper( module_name ) = '$params{ MODULE }' and " .
#                   "upper( proc_name ) = '$params{ PROCEDURE }'";
#
#  # DEBUG
#  # print STDERR "$command<BR>\n";
#
#  $result = $conn->exec( $command );
#  die $conn->errorMessage unless PGRES_TUPLES_OK eq $result->resultStatus;
#
#  #    ,   "" -  
#  # .   ,    . 
#  #               :      .
#  if ( $result->ntuples == 1 )
#  {
#    return ( 1 );
#  }
#  
#  #      , ,      
#  # 
#  # .        'ALL', 
#  #                  .
#  $command = "SELECT 'x' " .
#             "FROM access " .
#             "WHERE upper( user_name ) = '$params{ USER }' and " .
#                   "upper( module_name ) = '$params{ MODULE }' and " .
#                   "upper( proc_name ) = 'ALL'";
#
#  # DEBUG
#  # print STDERR "$command<BR>\n";
#
#  $result = $conn->exec( $command );
#  die $conn->errorMessage unless PGRES_TUPLES_OK eq $result->resultStatus;
#
#  #    ,   "" -  
#  # .   ,    . 
#  #               :      .
#  if ( $result->ntuples == 1 )
#  {
#    return ( 1 );
#  }
#  
#  #      , ,      
#  # 
#  $command = "SELECT 'x' " .
#             "FROM access " .
#             "WHERE upper( user_name ) = '$params{ USER }' and " .
#                   "upper( module_name ) = 'ALL' and " .
#                   "upper( proc_name ) = 'ALL'";
#
#  # DEBUG
#  # print STDERR "$command<BR>\n";
#
#  $result = $conn->exec( $command );
#  die $conn->errorMessage unless PGRES_TUPLES_OK eq $result->resultStatus;
#
#  #    ,   "" -  
#  # .   ,    . 
#  #               :      .
#  if ( $result->ntuples == 1 )
#  {
#    return ( 1 );
#  }
# -------------------------------------------------------------------------

  #   
  return ( 0 );
}

# -----------------------------------------------------------------------------
#   HTTP  HTML
# -----------------------------------------------------------------------------
sub http_html_headers
{
  #  - 
  #  -   CGI-     
  # (  - query)

  #      
  #     ,   
  #   
  my %prms = ( target => "_self",
               charset => lc( $CFG{ CHARSET } ),
               Content_Language => "ru_RU",
               title => $CFG{ TITLE },
               author => $CFG{ AUTHOR_EMAIL },
               type => "text/html",
               @_
             );

  # TODO.  target, ,  , . .    
  #       header (.   CGI).   , . .
  #          .
  print $prms{ query }->header( -type => $prms{ type },
                                -target => $prms{ target },
                                -charset => $prms{ charset }
                              );
  #   META  
  print $prms{ query }->start_html( 
          -title => $prms{ title },
          -author => $prms{ author },
          -style => { 'src' => "/$CFG{ HOME_WEB_CSS_DIR }/$CFG{ CSS }" },
          -lang => "$prms{ Content_Language }",
          -head => "<meta http-equiv='Content-Type' content='$prms{ type };" .
                   "charset=$prms{ charset }' />",
          -class => "body"
        );
  return;
}

# -----------------------------------------------------------------------------
#     
# -----------------------------------------------------------------------------
sub import_data
{
  #   
  # (  :   =>  )
  my %prms = @_;

  # : CGI- (query);
  #                   
  #                ""   (create_top);
  #                  ,
  #                     
  #              (table_cmd_pairs)

  #       
  $prms{ source_schema } = 'exp_imp';
  $prms{ target_schema } = 'imp';

  #          ,    
  # (       )
  copy_data( %prms );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#      " "
# -----------------------------------------------------------------------------
sub import_enabled
{
  #   import ,   export  
  # ( stat()    ;   ,
  #     )
  if ( scalar stat( "./exp_imp/import" ) > 0 && 
       scalar stat( "./exp_imp/export" ) == 0
     )
  {
    return ( 1 );    #  ""
  }

  return ( 0 );      #   ""
}

# -----------------------------------------------------------------------------
#  .   ,   
# -----------------------------------------------------------------------------
sub list_bib_recs_by_query
{
  # 
  my $query = shift;              # CGI-
  my $command = shift;            #      
  my $headline = shift;           #  

  my( $result, $i );              #    
  my @row;                        #      

  my @avail_objs;                 #  . ,   
                                  #    . ,
                                  #   , 
                                  # ,   . 

  my $can_view = 0;      #        
  my $can_delete = 0;    #   HTML-   

  my $can_export = 0;    #      ...
  my $can_import = 0;    # ... 

  my $alt_row = 1;       #  ,     
                         #   
  my $href;              #   HTML-

  #   ( /)
  my $db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

  print "$headline\n";                 #   

  $result = exec_select( $command );   #    
  
  if ( $result )
  {
    #          'BIB_RECS',
    #      ,     
    # (  , ,   persons.pl;  
    #   bib_recs.pl   )
    $can_view = have_access( 'module' => 'BIB_RECS', 'procedure' => 'VIEW', 
                             'user' => get_user_name() );
    $can_delete = have_access( 'module' => 'BIB_RECS', 'procedure' => 'DELETE',
                               'user' => get_user_name() );

    #     "/",     
    if ( $query->param( 'exp_imp' ) )
    {
      $can_import = import_enabled() && 
                    have_access( 'module' => 'BIB_RECS',
                                 'procedure' => 'IMPORT',
                                 'user' => get_user_name() );
    }
    else      #    public --   
    {
      $can_export = export_enabled() && 
                    have_access( 'module' => 'BIB_RECS',
                                 'procedure' => 'EXPORT',
                                 'user' => get_user_name() );
    }

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th> /</th>\n";
    print "<th>    . </th>\n";
    print "<th> </th>\n";
    print "<th></th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete || $can_export ||
                                   $can_import );
    print "</tr>\n";

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #   , .   . 
      #   . , . 
      $i++;                      #  
      print "<td class=\"center\">$i</td>\n";
      print "<td class=\"center\">" .
            $row[ $result->fnumber( 'obj_id' ) ] . " (".
            $row[ $result->fnumber( 'bib_rec_num' ) ] . ")",
            "</td>\n";

      #    ,      
      # ,   &mdash;
      # TODO.        
      #           .  ,   
      #        --       -- 
      #              ,   -
      #       -.
      my $bib_rec = $row[ $result->fnumber( 'bib_rec' ) ];
      $bib_rec =~ s/--/&mdash;/g;
      print "<td>$bib_rec</td>\n";

      #      , 
      #    . 
      print "<td>\n";
      @avail_objs = get_available( $row[ $result->fnumber( 'obj_id' ) ],
                                   $db_schema );
      #     (, . ,   
      #  )   
      foreach ( @avail_objs )
      {
        print $_ . "<br />\n";
      }
      print "</td>\n";

      #   HTML-
      $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
              "obj_id=" . $row[ $result->fnumber( 'obj_id' ) ] .
              "&bib_rec_num=" . $row[ $result->fnumber( 'bib_rec_num' ) ];

      #      HTML- (  )
      print "<td>" if ( $can_view || $can_delete || $can_export ||
                        $can_import );
      print qq{<a class="command_link" } .
            qq{href="/$CFG\{ HOME_WEB_DIR \}/bib_recs.pl/view?$href} .
            qq{&target_win=_self"} .
            qq{ target="_blank"></a>} . "\n" if $can_view;

      #   
      print qq{<a class="command_link" } .
            qq{href="/$CFG\{ HOME_WEB_DIR \}/bib_recs.pl/delete?$href} .
            qq{&target_win=_self"} .
            qq{ onclick="$confirm_delete"} .
            qq{ target="_self"></a>} . "\n" if $can_delete;

      #   
      print qq{<a class="command_link" } .
            qq{href="/$CFG\{ HOME_WEB_DIR \}/bib_recs.pl/export?$href} .
            qq{&target_win=_self"} .
            qq{ onclick="$confirm_export"} .
            qq{ target="_blank"></a>} . "\n" if $can_export;

      #   
      print qq{<a class="command_link" } .
            qq{href="/$CFG\{ HOME_WEB_DIR \}/bib_recs.pl/import?$href} .
            qq{&target_win=_self"} .
            qq{ onclick="$confirm_import"} .
            qq{ target="_blank"></a>} . "\n" if $can_import;

      print "</td>" if ( $can_view || $can_delete || $can_export ||
                         $can_import );
      print "</tr>\n";
    }
    print "</table>\n";
  }

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_cmd
{
  #   
  # (  :   =>  )
  my %prms = @_;

  # : CGI- (query);
  #              -   ? (operation);
  #                (table);
  #              ,     ,
  #                   (key).
  #                ,        
  #                 Web-,    
  #                   Web-.   
  #                 : '/', '\', ':', '='. 
  #                  : "field1=abcd, field2, field3:xyz";
  #                    (f_names);
  #                   , 
  #                (f_special);
  #                   (func_special);
  #             ,   (user)

  my $query = $prms{ query }; #   -  

  my $command;           #   
  my $fields = "";       #  -  
  my $values = "";       #  -   
  my $fname_value = "";  #   -     
  my $tmp;               #     
  my $fname;             #     
                         # (  f_names)
  my $key_value;         #   
  my @keys_tmp;          #     
  my @keys;              # ""    
  my $db_schema;         #   ( /)
  
  #  $prms{ key }   
  #     ,   ,    
  #     
  $prms{ key } =~ s/\s//g;
  @keys_tmp = split( /,/, $prms{ key } );

  #         
  foreach ( @keys_tmp )
  {
    #          Web-
    if ( /[\/:=\\]/ )       #    -
    {
      #      (,  -
      #     )     
      #        (
      #  )
      push( @keys, [ split( /[\/:=\\]/ ) ] );
    }
    #           Web-,  
    # 
    else
    {
      push( @keys, [ $_, $_ ] );  #     
    }
  }

  #      $prms{ table }  
  # -        
  foreach $fname ( @{ $prms{ f_names } } )  # ..    
  {
    #     
    # .   f_special     ,
    #                     
    #               .
    if ( grep( /^$fname$/, @{ $prms{ f_special } } ) > 0 )
    {
      #    :     
      $tmp = &{ $prms{ func_special } }( $fname, $prms{ operation } );
    }
    #          
    else
    {
      #    $prms{ table }    - 
      $tmp = $query->param( $fname );
    }

    #     
    $tmp =~ s/^\s*//;        #  ...
    $tmp =~ s/\s*$//;        # ...   

    #    9.1,      
    #    (.    PostgreSQL
    # standard_conforming_strings),    (")  (\)
    #  ,   (')  
    # TODO.    ""   .
    $tmp =~ s/\'/\'\'/g;

    #    -     :
    #  - -  ,  - -  
    if ( $prms{ operation } eq 'APPEND' )
    {    
      #        
      $fields .= $fname . ",";

      #     (   !!!)
      #    ,   null,   
      #     
      # .       ,   
      #                   
      #             .
      $values .= $tmp ne '' ? "'$tmp'," : "null," ;
    }
    elsif ( $prms{ operation } eq 'UPDATE' )
    {
      #   "_ + "      
      # .    . .
      $fname_value .= $tmp ne '' ? "$fname = '$tmp'," : "$fname = null,";
    }
  }

  if ( $prms{ operation } eq 'APPEND' )
  {
    #     
    # $fields =~ s/,$//;  #   
    # $values =~ s/,$//;  #   

    #   ,    , 
    #    ,     
    $fields .= 'who_chg'; 
    $values .= "'$prms{ user }'";

    #     
    $command = "INSERT INTO $prms{ table } ( $fields ) VALUES ( $values )";
  }
  elsif ( $prms{ operation } eq 'UPDATE' )
  {
    #     
    # $fname_value =~ s/,$//;  #   

    #     ,  
    #    ,      
    $fname_value .= "who_chg = '$prms{ user }', when_chg = CURRENT_TIMESTAMP";

    #    /   ,   
    #   ;      SQL-  
    #  ,    
    $db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";
  
    #   
    $command = "UPDATE ${db_schema}$prms{ table } SET $fname_value " .
               "WHERE ";

    #    
    foreach ( @keys )
    {
      #          Web-
      $key_value = $query->param( $$_[ 1 ] );

      #  
      $command .= " $$_[ 0 ] = '$key_value' AND ";
    }

    #   :    
    #   - (      
    #   'AND')
    $command =~ s/AND\s*$//;
  }
  return ( $command );
}

# -----------------------------------------------------------------------------
#         
# -----------------------------------------------------------------------------
sub make_letters
{
  # 
  my $script_name = shift;   #  
  my $add_params = shift;    # ,   ,
                             #     
                             # (,     
                             # )
  my $num_last_recs = shift; #   ,   ,
                             #     
                             #   
  
  my @letters;               #   
  my $letter;                #  
  my $letter_num = 1;        #    

  #       (   
  #        )
  if ( $add_params )
  {
    $add_params =~ s/^\?//;  #   "?"    
    $add_params = "&" . $add_params if ( $add_params !~ /^&/ );
  }
  else
  {
    $add_params = '';
  }

  #   .       ,
  #    
  # .         
  #              (, /^\d+$/).   
  #                 .
  # TODO.       , 
  #          ,   .
  #       .
  if ( $num_last_recs )
  {
    #   
    #   PATH_INFO  query
    print qq{ <a class="command_link" href="$script_name/query} .
          qq{?num_last_recs=$num_last_recs$add_params" } .
          qq{ target="_self"> </a>\n };

    #      
    print "&nbsp;&nbsp;&nbsp;&nbsp;\n";
  }
  
  #  "" -   
  # (- -- )
  @letters = split( /\s+/, $CFG{ STRING_LETTERS_RUS } );
  
  #       
  #   CGI::escape()
  foreach $letter ( @letters )
  {
    print qq{ <a class="command_link" href="$script_name/query} .
          qq{?letter=} . ( $CFG{ HIDE_RUS_LETTERS } ? "_" . $letter_num :
                           CGI::escape( $letter ) ) .
          qq{$add_params" } .
          qq{ target="_self">$letter</a>\n};

    $letter_num++;
  }
  print "<br />\n";
  
  #  "" -     
  @letters = split( /\s+/, $CFG{ STRING_LETTERS_LAT } );
  
  #       
  #       CGI::escape()
  foreach $letter ( @letters )
  {
    print qq{ <a class="command_link" href="$script_name/query} .
          qq{?letter=} . CGI::escape( $letter ) . qq{$add_params" } .
          qq{ target="_self">$letter</a>\n};
  }
  print "&nbsp;&nbsp;&nbsp;&nbsp;\n";   #   
  
  #       
  @letters = split( /\s+/, $CFG{ STRING_SYMBOLS } );

  #      
  #   CGI::escape()
  foreach $letter ( @letters )
  {
    # TODO     .
    # $letter =~ s/\"/\\\"/;    # ""   
    # $letter =~ s/\'/\\\'/;
    # $letter = CGI::escape( $letter );
    print qq{ <a class="command_link" href="$script_name/query} .
          qq{?letter=} . CGI::escape( $letter ) . qq{$add_params" } .
          qq{ target="_self">$letter</a>\n};
  }
  print "<br />\n";

  return ( 0 );
}

# -----------------------------------------------------------------------------
#     
# -----------------------------------------------------------------------------
sub open_bottom
{
  #  HTML-,       
  print "$CFG{ OPEN_BOTTOM }\n";

  return ( 0 );
}

# -----------------------------------------------------------------------------
#     
# -----------------------------------------------------------------------------
sub open_top
{
  #  HTML-,       
  print "$CFG{ OPEN_TOP }\n";

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  ,      values  labels
#   popup menu    
#    
# -----------------------------------------------------------------------------
sub make_list_for_popup
{
  # .      ,  
  #              ,    (popup menu).
  #                   
  #             values  labels,       
  #               values.     
  #               .

  #  
  my $command = shift;   #      

  #    "" (values)    
  #  ,   ,    , 
  #  labels.     popup menu

  my @values = ();    #  ( ) -  values
  my @labels = ();    # -  () -  labels

  my $result;         #    
  my @row;            #      

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    #     ,     
    # popup_menu
    while ( @row = $result->fetchrow )
    {
      # .  ,    @row,   :
      #              -   ,  - 
      #             -.     
      #              .

      # ,       
      # (  values  popup_menu)
      push( @values, $row[ 0 ] );  #    

      # -   -       
      # ,   -
      # (   labels  popup_menu)
      push( @labels, $row[ 0 ], $row[ 1 ] );
    }
  }

  return ( \@values, \@labels );    #     
}

# -----------------------------------------------------------------------------
#  ,      values  labels
#   popup menu      
# -----------------------------------------------------------------------------
sub popup_acq_ways_list
{
  # 
  my $db_schema = shift;    #   -- exp_imp  public
                            # ( exp_imp,     ,
                            #      ;
                            #  public,   --   "")

  my $command;              #      

  #      
  $command = "SELECT acq_way_code, acq_way_sname " .
             "FROM ${db_schema}acq_ways " .
             "ORDER BY acq_way_sname";

  return ( make_list_for_popup( $command ) );  #  
}

# -----------------------------------------------------------------------------
#  ,      values  labels
#   popup menu       
# -----------------------------------------------------------------------------
sub popup_activity_types_list
{
  # 
  my $db_schema = shift;    #  

  my $command;              #      

  #       
  $command = "SELECT act_type_code, act_type_fname " .
             "FROM ${db_schema}activity_types " .
             "ORDER BY act_type_fname";

  return ( make_list_for_popup( $command ) );  #  
}

# -----------------------------------------------------------------------------
#  ,      values  labels
#   popup menu     
# -----------------------------------------------------------------------------
sub popup_cities_list
{
  # 
  my $db_schema = shift;    #  

  my $command;              #      

  #      (    
  #  )
  $command = "SELECT c.city_code, " .
                    "c.city_fname || " .
                      "' (' || cc.country_sname || ')' AS city " .
             "FROM ${db_schema}cities c, ${db_schema}countries cc " .
             "WHERE c.country_code = cc.country_code " .
             "ORDER BY city";

  return ( make_list_for_popup( $command ) );  #  
}

# -----------------------------------------------------------------------------
#  ,      values  labels
#   popup menu       
# -----------------------------------------------------------------------------
sub popup_conf_status_types_list
{
  # 
  my $db_schema = shift;    #  

  my $command;              #      

  #       
  $command = "SELECT conf_status_code, conf_status_sname " .
             "FROM ${db_schema}conf_status_types " .
             "ORDER BY conf_status_sname";

  return ( make_list_for_popup( $command ) );  #  
}

# -----------------------------------------------------------------------------
#  ,      values  labels
#   popup menu      
# -----------------------------------------------------------------------------
sub popup_conf_types_list
{
  # 
  my $db_schema = shift;    #  

  my $command;              #      

  #      
  $command = "SELECT conf_type_code, conf_type_sname " .
             "FROM ${db_schema}conf_types " .
             "ORDER BY conf_type_sname";

  return ( make_list_for_popup( $command ) );  #  
}

# -----------------------------------------------------------------------------
#  ,      values  labels
#   popup menu     
# -----------------------------------------------------------------------------
sub popup_countries_list
{
  # 
  my $db_schema = shift;    #  

  my $command;              #      

  #     
  $command = "SELECT country_code, country_sname " .
             "FROM ${db_schema}countries " .
             "ORDER BY country_sname";

  return ( make_list_for_popup( $command ) );  #  
}

# -----------------------------------------------------------------------------
#  ,      values  labels
#   popup menu     
# -----------------------------------------------------------------------------
sub popup_currencies_list
{
  # 
  my $db_schema = shift;    #  

  my $command;              #      

  #     
  $command = "SELECT currency_code, currency_fname " .
             "FROM ${db_schema}currencies " .
             "ORDER BY currency_fname";

  return ( make_list_for_popup( $command ) );  #  
}

# -----------------------------------------------------------------------------
#  ,      values  labels
#   popup menu       
# -----------------------------------------------------------------------------
sub popup_det_char_types_list
{
  # 
  my $db_schema = shift;    #  

  my $command;              #      

  #      
  $command = "SELECT det_char_code, det_char_sname " .
             "FROM ${db_schema}det_char_types " .
             "ORDER BY det_char_sname";

  return ( make_list_for_popup( $command ) );  #  
}

# -----------------------------------------------------------------------------
#  ,      values  labels
#   popup menu      
# -----------------------------------------------------------------------------
sub popup_edition_types_list
{
  # 
  my $db_schema = shift;    #  

  my $command;              #      

  #      
  $command = "SELECT edition_code, edition_name " .
             "FROM ${db_schema}edition_types " .
             "ORDER BY edition_code";

  return ( make_list_for_popup( $command ) );  #  
}

# -----------------------------------------------------------------------------
#  ,      values  labels
#   popup menu     
#    
# -----------------------------------------------------------------------------
sub popup_feature_groups_list
{
  # 
  my $db_schema = shift;    #  

  my $command;              #      

  #      
  $command = "SELECT feature_group_code, feature_group_name " .
             "FROM ${db_schema}feature_groups " .
             "ORDER BY feature_group_name";

  return ( make_list_for_popup( $command ) );  #  
}

# -----------------------------------------------------------------------------
#  ,      values  labels
#   popup menu      
#  
# -----------------------------------------------------------------------------
sub popup_gen_mater_types_list
{
  # 
  my $db_schema = shift;    #  

  my $command;              #      

  #        
  $command = "SELECT gen_mat_code, gen_mat_name " .
             "FROM ${db_schema}gen_mater_types " .
             "ORDER BY gen_mat_name";

  return ( make_list_for_popup( $command ) );  #  
}

# -----------------------------------------------------------------------------
#  ,      values  labels
#   popup menu     
# -----------------------------------------------------------------------------
sub popup_langs_list
{
  # 
  my $db_schema = shift;    #  

  my $command;              #      

  #     
  $command = "SELECT lang_code, lang_fname " .
             "FROM ${db_schema}langs " .
             "ORDER BY lang_fname";

  return ( make_list_for_popup( $command ) );  #  
}

# -----------------------------------------------------------------------------
#  ,      values  labels
#   popup menu     
# -----------------------------------------------------------------------------
sub popup_orgs_list
{
  # 
  my $db_schema = shift;    #  

  my $command;              #      

  #     
  $command = "SELECT org_id, org_sname " .
             "FROM ${db_schema}orgs " .
             "ORDER BY org_sname";

  return ( make_list_for_popup( $command ) );  #  
}

# -----------------------------------------------------------------------------
#  ,      values  labels
#   popup menu      
# -----------------------------------------------------------------------------
sub popup_pack_types_list
{
  # 
  my $db_schema = shift;    #  

  my $command;              #      

  #      
  $command = "SELECT pack_code, pack_fname " .
             "FROM ${db_schema}pack_types " .
             "ORDER BY pack_fname";

  return ( make_list_for_popup( $command ) );  #  
}

# -----------------------------------------------------------------------------
#  ,      values  labels
#   popup menu       
# -----------------------------------------------------------------------------
sub popup_phys_form_types_list
{
  # 
  my $db_schema = shift;    #  

  my $command;              #      

  #       
  $command = "SELECT phys_form_code, phys_form_fname " .
             "FROM ${db_schema}phys_form_types " .
             "ORDER BY phys_form_fname";

  return ( make_list_for_popup( $command ) );  #  
}

# -----------------------------------------------------------------------------
#  ,      values  labels
#   popup menu       
# -----------------------------------------------------------------------------
sub popup_process_types_list
{
  # 
  my $db_schema = shift;    #  

  my $command;              #      

  #       
  $command = "SELECT process_code, process_fname " .
             "FROM ${db_schema}process_types " .
             "ORDER BY process_fname";

  return ( make_list_for_popup( $command ) );  #  
}

# -----------------------------------------------------------------------------
#  ,      values  labels
#   popup menu     
#   
# -----------------------------------------------------------------------------
sub popup_recs_sources_list
{
  # 
  my $db_schema = shift;    #  

  my $command;              #      

  #        
  $command = "SELECT source_code, source_name " .
             "FROM ${db_schema}recs_sources " .
             "ORDER BY source_name";

  return ( make_list_for_popup( $command ) );  #  
}

# -----------------------------------------------------------------------------
#  ,      values  labels
#   popup menu       
# -----------------------------------------------------------------------------
sub popup_ref_types_list
{
  # 
  my $db_schema = shift;    #  

  my $command;              #      

  #       
  $command = "SELECT ref_type_code, ref_type_sname " .
             "FROM ${db_schema}ref_types " .
             "ORDER BY ref_type_sname";

  return ( make_list_for_popup( $command ) );  #  
}

# -----------------------------------------------------------------------------
#  ,      values  labels
#   popup menu     
# -----------------------------------------------------------------------------
sub popup_roles_list
{
  # 
  my $db_schema = shift;    #  

  my $command;              #      

  #      
  $command = "SELECT role_code, role_sname " .
             "FROM ${db_schema}roles " .
             "ORDER BY role_sname";

  return ( make_list_for_popup( $command ) );  #  
}

# -----------------------------------------------------------------------------
#  ,      values  labels
#   popup menu     
#   
# -----------------------------------------------------------------------------
sub popup_spec_mater_groups_list
{
  # 
  my $db_schema = shift;    #  

  my $command;              #      

  #        
  $command = "SELECT spec_mat_group_code, spec_mat_group_fname " .
             "FROM ${db_schema}spec_mater_groups " .
             "ORDER BY spec_mat_group_fname";

  return ( make_list_for_popup( $command ) );  #  
}

# -----------------------------------------------------------------------------
#  ,      values  labels
#   popup menu     
#   
# -----------------------------------------------------------------------------
sub popup_spec_mater_types_list
{
  # 
  my $db_schema = shift;    #  

  my $command;              #      

  #        
  $command = "SELECT t.spec_mat_code, t.spec_mat_sname || ' (' || " .
                    "g.spec_mat_group_sname || ')' " .
             "FROM ${db_schema}spec_mater_types t, " .
                  "${db_schema}spec_mater_groups g " .
             "WHERE t.spec_mat_group_code = g.spec_mat_group_code " .
             "ORDER BY g.spec_mat_group_sname, t.spec_mat_sname";

  return ( make_list_for_popup( $command ) );  #  
}

# -----------------------------------------------------------------------------
#  ,      values  labels
#   popup menu      (ISBN, ISSN
#  .)  
# -----------------------------------------------------------------------------
sub popup_std_num_types_list
{
  # 
  my $db_schema = shift;    #  

  my $command;              #      

  #       
  $command = "SELECT std_num_code, std_num_name " .
             "FROM ${db_schema}std_num_types " .
             "ORDER BY std_num_name";

  return ( make_list_for_popup( $command ) );  #  
}

# -----------------------------------------------------------------------------
#  .     , 
#   . 
# -----------------------------------------------------------------------------
sub print_bib_record
{
  # 
  my $query = shift;          # CGI-
  my $headline = shift;       #  ,  
                              # . 
  my $calling_module = shift; #  ,    
    
  #      --    
  #       
  # (      "_self")
  my $href = "exp_imp=" . $query->param( 'exp_imp' ) .
             "&obj_id=" . $query->param( 'obj_id' ) .
             "&bib_rec_num=" . $query->param( 'bib_rec_num' ) .
             "&bib_rec=" . CGI::escape( $query->param( 'bib_rec' ) ) .
             "&target_win=_self";

  my $script_name = $query->script_name;

  my $bib_rec;           # . 
  my $ref_descr;         #   
  
  #   "    
  # "   
  if ( $calling_module eq "REFS_CONTENTS" )
  {
    $href .= "&ref_num=" . $query->param( 'ref_num' )
      if ( $query->param( 'ref_num' ) );

    $href .= "&ref_descr=" . CGI::escape( $query->param( 'ref_descr' ) )
      if ( $query->param( 'ref_descr' ) );
  }
  
  #     .    .
  #    
  print "<p class=\"bib_rec\">";
  print "   : " . 
        $query->param( 'obj_id' ) . "\n";
  print "&nbsp;&nbsp;\n";

  # TODO.    ,   . ,
  #            , -  .
  #               , 
  #          print      "".
  print "     : " .
        $query->param( 'bib_rec_num' ) . "</p>\n";

  #        HTML-
  if ( $CFG{ HIDE_RUS_LETTERS } )
  {
    #   'bib_rec_num'  ,    0
    # (. TODO )
    $bib_rec = get_bib_rec( $query->param( 'obj_id' ), 
                            $query->param( 'bib_rec_num' ) ?
                              $query->param( 'bib_rec_num' ) : 0,
                            $query->param( 'exp_imp' ) ? "exp_imp." : "" );
  }
  else
  {
    $bib_rec = $query->param( 'bib_rec' );
  }

  #  . 
  print "<p class=\"bib_rec\">$bib_rec</p>\n";
  
  #   
  print "<h2 class=\"module_title\">$headline</h2>\n";

  #   "    
  # "    
  if ( $calling_module eq "REFS_CONTENTS" )
  {
    #        HTML-
    if ( $CFG{ HIDE_RUS_LETTERS } )
    {
      $ref_descr = get_ref_descr( $query->param( 'obj_id' ), 
                                  $query->param( 'bib_rec_num' ),
                                  $query->param( 'ref_num' ),
                                  $query->param( 'exp_imp' ) ? "exp_imp." :
                                  "" );
    }
    else
    {
      $ref_descr = $query->param( 'ref_descr' );
    }
    print "<p class=\"bib_rec\">$ref_descr</p>\n";
  }

  #       
  #       ,      
  # ". ",     , 
  #   .  (, " ");
  #          
  # ". "   ,  ,    
  #       
  print qq{<a class="command_link" href="$script_name/query?$href"} .
        qq{ target="_self"></a>\n};

  #   "    
  # "     
  if ( $calling_module eq "REFS_CONTENTS" )
  {
    print qq{<a class="command_link" href="$script_name/find?$href" } .
          qq{ target="_self"></a>\n};
  }

  return ( 0 );
}

# -----------------------------------------------------------------------------
#     
# -----------------------------------------------------------------------------
sub print_debug_info
{
  my $msg = shift;    #  --   (,   )
  
  print "<p class=\"debug_info\">\n";
  
  if ( ref( $msg ) eq 'ARRAY' )
  {
    foreach ( @{ $msg } )
    {
      print $_;
    }
  }
  else
  {
    print $msg;
  }
  
  print "</p>\n";
  
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      ()
# -----------------------------------------------------------------------------
sub print_env
{
  my( $var, $val );

  foreach $var ( sort( keys( %ENV ) ) ) 
  {
    $val = $ENV{ $var };
    print "${ var }=\"${ val }\"<br />\n";
  }
}

# -----------------------------------------------------------------------------
#     
# -----------------------------------------------------------------------------
sub print_params
{
  my $query = shift;    #  - CGI-

  foreach ( $query->param )
  {
    print $_, " ", $query->param( $_ ), "<br />\n";
  }
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub print_result
{
  #  -  $result,      
  my $result = shift;

  my( $i, $j );

  foreach ( $i = 0; $i < $result->ntuples; $i++ )
  {
    foreach ( $j = 0; $j < $result->nfields; $j++ )
    {
      print $result->getvalue( $i, $j ) . " ";
    }
    print "<br />\n";
  }
}

# -----------------------------------------------------------------------------
#   /    , 
#     /
# -----------------------------------------------------------------------------
sub print_ser_descr
{
  # 
  my $query = shift;     # CGI-
  my $headline = shift;  #  ,  
                         #  /
 
  #      --    
  #       
  # (      "_self")
  my $href = "exp_imp=" . $query->param( 'exp_imp' ) .
             "&series_id=" . $query->param( 'series_id' ) .
             "&ser_descr_num=" . $query->param( 'ser_descr_num' ) .
             "&ser_descr=" . CGI::escape( $query->param( 'ser_descr' ) ) .
             "&target_win=_self";

  my $script_name = $query->script_name;
  my $ser_descr;         #  /

  #    /   
  #   /
  print "<p class=\"bib_rec\">";
  print " /: " . $query->param( 'series_id' ) . "\n";
  print "&nbsp;&nbsp;\n";
  print "  /: " .
        $query->param( 'ser_descr_num' ) . "</p>\n";

  #        HTML-
  if ( $CFG{ HIDE_RUS_LETTERS } )
  {
    $ser_descr = get_ser_descr( $query->param( 'series_id' ), 
                                $query->param( 'ser_descr_num' ),
                                $query->param( 'exp_imp' ) ? "exp_imp." : "" );
  }
  else
  {
    $ser_descr = $query->param( 'ser_descr' );
  }

  #   /
  print "<p class=\"bib_rec\">$ser_descr</p>\n";
  
  #   
  print "<h2 class=\"module_title\">$headline</h2>\n";

  #       
  #       ,      
  # " /",     ,
  #     / (, 
  # " /");
  #          
  # " /"     
  # , ,      
  print qq{<a class="command_link" href="$script_name/query?$href"} .
        qq{ target="_self"></a>\n};

  return ( 0 );
}

# -----------------------------------------------------------------------------
#     
# -----------------------------------------------------------------------------
sub print_user_err_msgs
{
  #  -      
  my $arr_msgs_ref = shift;
  
  foreach ( @{ $arr_msgs_ref } )
  {
    print "<p class=\"user_error\">$_</p>\n";
  }

  return;
}

# -----------------------------------------------------------------------------
#      ,  
#   
# -----------------------------------------------------------------------------
sub process_dependent_tables
{
  # :
  my $table = shift;          #    (  
                              #   )
  my $record_ref = shift;     #   -,   
                              #     $table
  my $source_schema = shift;  #    
  my $target_schema = shift;  #    

  my @f_key_fields;        #     
                           #  
  my @ref_fields;          #     
  my $dep_table;           #  
  my @key_fields;          #   
  my $command;             #        
  my $result;              #    
  my @row;                 #      
  my $f_key_name;          #    --  -
  my %rec = ();            # -,    
                           #     
  my $i;
  my $where;               #     

  # DEBUG
  # print "  process_dependent_tables   " .
  #       "$table<br />\n";

  #    $table   ,     
  # . ,         
  #             .        ,
  #               .    ,   
  #               ,    
  #             (   ,  ).  ?
  if ( ! exists $EXP_CFG{ TABLES }{ $table }{ DEPENDENT_TABLES } )
  {
    # DEBUG
    # print "   process_dependent_tables " .
    #       "  $table --   <br />\n";

    return;
  }

  #      $table
  foreach $dep_table ( @{ $EXP_CFG{ TABLES }{ $table }{ DEPENDENT_TABLES } } )
  {
    #       --   
    next if $EXP_CFG{ TABLES }{ $dep_table }{ TABLE_EXPORT } eq 'disabled';

    #          
    #     ,    :
    #     ,    
    # $table      ,     
    #          
    #    

    #      $dep_table
    #      1  2   
    foreach $f_key_name ( sort keys %{ $EXP_CFG{ TABLES }{ $dep_table }
                                               { FOREIGN_KEYS } } )
    {
      #      - ( , 
      #    -,      
      # )
      if ( $table eq $EXP_CFG{ TABLES }{ $dep_table }{ FOREIGN_KEYS }
                             { $f_key_name }{ REF_TABLE } )
      {
        @f_key_fields = @{ $EXP_CFG{ TABLES }{ $dep_table }{ FOREIGN_KEYS }
                                   { $f_key_name }{ F_KEY_FIELDS }
                         };

        @ref_fields = @{ $EXP_CFG{ TABLES }{ $dep_table }{ FOREIGN_KEYS }
                                 { $f_key_name }{ REF_FIELDS }
                       };
        # !        
        #        (,      Obj_containers),
        #         ,      
        #         ,     . 
        #        .       
        #           last,    .
        last;      #       
      }
    }
    
    #   -     
    #  $dep_table
    $command = "SELECT * FROM $source_schema.$dep_table WHERE ";

    #        
    for ( $i = 0; $i < scalar @f_key_fields; $i++ )
    {
      #  ,        
      #    ,      
      # .       @ref_fields  
      #             @f_key_fields   .
      $command .= " " . $f_key_fields[ $i ] . " = '" .
                  $$record_ref{ $ref_fields[ $i ] } . "' AND ";
    }

    #  :       
    # - (          
    #  'AND')
    $command =~ s/\s*AND\s*$//;

    #    
    # (  --  ,    , 
    #     ,    )
    $result = exec_select( $command, "  " );
  
    if ( $result )
    {
      #      
      while ( @row = $result->fetchrow )
      {
        my $fields = "";       #    (  )
        my $values = "";       #    (  )
        my $fname;             #  
        my $value;             #  

        %rec = ();

        #     (. .   )
        for ( $i = 0; $i < scalar @row; $i++ )
        {
          #     
          #          
          #    -
          $fname = $result->fname( $i );
          $value = $row[ $i ];
        
          #  -,     
          #  
          $rec{ $fname } = $value;

          #        
          $fields .= $fname . ",";

          # TODO.    ""  
          #       .
          $value =~ s/\'/\'\'/g;

          #     (  
          # !!!)
          #    ,   null,   
          #     
          # .       , 
          #                    
          #                .
          $values .= $value ne '' ? "'$value'," : "null," ;
        }

        $fields =~ s/,$//;  #   
        $values =~ s/,$//;  #   

        #         
        $command = "INSERT INTO $target_schema.$dep_table ( $fields ) " .
                               "VALUES ( $values )";

        #    WHERE,   
        #       exp_imp  
        #   ,  INSERT      
        #  (  )
        # TODO. ,       
        #         .     
        #            ?
        # .    , ,   
        #        .    .   
        #             Bib_recs.   
        #         ,   . ,
        #           Bib_recs   obj_id + bib_rec_num, 
        #          --   Bib_objs   obj_id.
        #            ( ) ,
        #             , , 
        #          Bib_objs,      
        #        .   ,   
        #        ,      .
        
        #      
        @key_fields = @{ $EXP_CFG{ TABLES }{ $dep_table }{ KEY_FIELDS } };

        $where = "";

        #    
        for ( $i = 0; $i < scalar @key_fields; $i++ )
        {
          $where .= $key_fields[ $i ] . " = '" . $rec{ $key_fields[ $i ] } .
                    "' AND ";
        }

        $where =~ s/\s*AND\s*$//;  #   'AND'

        #      - -- 

        #  --  INSERT,  --  WHERE  
        #   
        $SQL_commands{ $dep_table }{ $command } = $where;

        # DEBUG 
        print_debug_info( $command ) if $DEBUG;  #   

        #        ,
        #     $dep_table ( )
        process_referenced_tables( $dep_table, \%rec, $source_schema,
                                   $target_schema );

        #        ,
        #      $dep_table (  
        #   )
        process_dependent_tables( $dep_table, \%rec, $source_schema,
                                  $target_schema );
      }
    }
    else
    {
      ;  # TODO.     ?
    }
  }
  # DEBUG
  # print "   process_dependent_tables " .
  #       "  $table<br />\n";

  return;
}

# -----------------------------------------------------------------------------
#      ,  
#   
# -----------------------------------------------------------------------------
sub process_referenced_tables
{
  # :
  my $table = shift;          #   
  my $record_ref = shift;     #   -,   
                              #     $table
  my $source_schema = shift;  #    
  my $target_schema = shift;  #    

  my @f_key_fields;        #    
  my @ref_fields;          #     
  my $ref_table;           #  
  my @key_fields;          #   
  my $command;             #        
  my $result;              #    
  my @row;                 #      
  my $f_key_name;          #    --  -
  my %rec = ();            # -,    
                           #     
  my $i;
  my $where;               #     

  # DEBUG
  # print "  process_referenced_tables " .
  #       "  $table<br />\n";

  #    $table   ,     
  if ( ! exists $EXP_CFG{ TABLES }{ $table }{ FOREIGN_KEYS } )
  {
    # DEBUG
    # print "   process_referenced_tables " .
    #       "  $table --   <br />\n";

    return;
  }

  #      $table
  foreach $f_key_name ( keys %{ $EXP_CFG{ TABLES }{ $table }
                                        { FOREIGN_KEYS } } )
  {
    #   ,      ,
    #   ,     
    next if grep( /^$f_key_name$/, 
                  @{ $EXP_CFG{ TABLES }{ $table }{ FOREIGN_KEYS_EXCLUDE } } )
            > 0;

    %rec = ();

    #      - ( , 
    #    -,      
    # )
    $ref_table = $EXP_CFG{ TABLES }{ $table }{ FOREIGN_KEYS }
                         { $f_key_name }{ REF_TABLE };

    @f_key_fields = @{ $EXP_CFG{ TABLES }{ $table }{ FOREIGN_KEYS }
                               { $f_key_name }{ F_KEY_FIELDS }
                     };
    @ref_fields = @{ $EXP_CFG{ TABLES }{ $table }{ FOREIGN_KEYS }
                             { $f_key_name }{ REF_FIELDS }
                   };

    #       NULL (undef),   
    #         
    # (        , ,
    #   Gen_mater_types  gen_mat_code_orig   
    # gen_mat_code)
    # .  ,      
    #              NULL (undef),      
    #               .   " " 
    #                ,     
    #              (NULL).
    next if ( $$record_ref{ $f_key_fields[ 0 ] } eq undef );
    
    #   -     
    #  $ref_table
    $command = "SELECT * FROM $source_schema.$ref_table WHERE ";

    #      
    for ( $i = 0; $i < scalar @ref_fields; $i++ )
    {
      #  ,        
      #    ,      
      # .       @ref_fields  
      #             @f_key_fields   .
      $command .= " " . $ref_fields[ $i ] . " = '" .
                  $$record_ref{ $f_key_fields[ $i ] } . "' AND ";
    }

    #  :       
    # - (          
    #  'AND')
    $command =~ s/\s*AND\s*$//;

    #    
    # (  --  ,    , 
    #     ,    )
    $result = exec_select( $command, "  " );
  
    if ( $result )
    {
      #      
      # ! ,        
      #          (,  Orgs).
      if ( $table eq $ref_table )
      {
        #    UPDATE,     
        # /      
        #   ,     public
        # !      /.
        $command = "UPDATE $target_schema.$table SET ";

        #       
        for ( $i = 0; $i < scalar @f_key_fields; $i++ )
        {
          #   "_ + "      
          $command .= $f_key_fields[ $i ] . " = '" .
                      $$record_ref{ $f_key_fields[ $i ] } . "', ";

          # ""      $table,
          #        UPDATE
          # .   , . .    
          #                 ,  
          #             ,      . 
          #             ,   Persons   :
          #                  pers_id  10,
          #                pers_id_orig  11, .. 
          #             ""     "", ,
          #              ,  .  INSERT  
          #                pers_id  pers_id_orig
          #               ,      
          #              INSERT  pers_id = 11.  
          #             INSERT  ,    
          #              , ,   
          #                   INSERT
          #                 UPDATE, 
          #               .
          $$record_ref{ $f_key_fields[ $i ] } = undef;
        }
        
        $command =~ s/,\s*$//;  #   

        @key_fields = @{ $EXP_CFG{ TABLES }{ $table }{ KEY_FIELDS } };

        #   
        $command .= " WHERE ";
        
        #       
        # (    ,     
        #     $record_ref)
        for ( $i = 0; $i < scalar @key_fields; $i++ )
        {
          $command .= $key_fields[ $i ] . " = '" .
                      $$record_ref{ $key_fields[ $i ] } . "' AND ";
        }

        $command =~ s/\s*AND\s*$//;

        #     -,    
        #       ,  -- undef;
        #   -    
        #     :   
        #  ,   Perl   ,   
        #  
        $SQL_commands{ $table }{ $command } = undef;

        # DEBUG 
        print_debug_info( $command ) if $DEBUG;  #   
      }

      #     
      # .     ?
      @row = $result->fetchrow;

      my $fields = "";       #    (  )
      my $values = "";       #    (  )

      my $fname;
      my $value;

      #  -,     
      #  ,    $ref_table
      for ( $i = 0; $i < scalar @row; $i++ )
      {
        $rec{ $result->fname( $i ) } = $row[ $i ];  #   --  
      }

      #        ,  
      #     $ref_table
      # !  "INSERT INTO exp_imp.$ref_table ..." 
      #            process_referenced_tables().
      #          ,       
      #        (undef)   ,    
      #         .   INSERT     
      #         .
      process_referenced_tables( $ref_table, \%rec, $source_schema,
                                 $target_schema );

      #        ,
      #      $ref_table (  
      #   )
      process_dependent_tables( $ref_table, \%rec, $source_schema,
                                $target_schema );
      
      #          
      # INSERT INTO 
      foreach $fname ( keys %rec )
      {
        #     
        #          
        #    -
        # $fname = $result->fname( $i );
        $value = $rec{ $fname };
        
        #        
        $fields .= $fname . ",";

        # TODO.    ""  
        #       .
        $value =~ s/\'/\'\'/g;

        #     (   !!!)
        #    ,   null,   
        #     
        # .       , 
        #                    
        #                .
        $values .= $value ne '' ? "'$value'," : "null," ;
      }

      $fields =~ s/,$//;  #   
      $values =~ s/,$//;  #   

      #           
      $command = "INSERT INTO $target_schema.$ref_table ( $fields ) " .
                             "VALUES ( $values )";

      #    WHERE,   
      #       exp_imp  
      #   ,  INSERT      
      #  (  )
        
      #      
      @key_fields = @{ $EXP_CFG{ TABLES }{ $ref_table }{ KEY_FIELDS } };

      $where = "";

      #    
      for ( $i = 0; $i < scalar @key_fields; $i++ )
      {
        $where .= $key_fields[ $i ] . " = '" . $rec{ $key_fields[ $i ] } .
                  "' AND ";
      }

      $where =~ s/\s*AND\s*$//;

      #  --  INSERT,  --  WHERE  
      #   
      $SQL_commands{ $ref_table }{ $command } = $where;

      # DEBUG 
      print_debug_info( $command ) if $DEBUG;  #   
    }
    else
    {
      ;  #     ?
    }
  }
  
  # DEBUG
  # print "   process_referenced_tables " .
  #       "  $table<br />\n";

  return;
}

# -----------------------------------------------------------------------------
#   
# -----------------------------------------------------------------------------
sub read_config
{
  #  -    
  my $config_file = shift;

  #         
  my @configuration = ();

  #    
  my( $param_name, $param_value );

  #    ()   ""  ;
  #       HTML- (  
  #      ""  )
  my $hot_help_index;

  #    , ,    
  # ,   ""   ( );
  #      ""   (
  #    ,      ,  
  #    ,    
  #     ""     
  #   HTML-)
  my $help_value_index;

  #     ( ,   
  #  ,        )
  my $module_field = "";          #  
  my $current_module_field = "";  #     . 
    
  #   ...
  open( CONFIG, "< $config_file" ) or 
      die "    $config_file. : $!\n";

  # ...    
  while( <CONFIG> )
  {
    chomp;          #    

    #     ,     
    #  
    next if /^\s*$/;

    #     "#"   
    next if /^#/;

    #         
    # ,      
    # (   -  , 
    #   "\",   ),   ,  
    #       (,   
    #    ),       
    if ( /^(\S+)\s*$/ )
    {
      $param_name = $1;
      $param_value = '';
    }
    else
    {
      #  ,   ,  
      # TODO.     -  ?
      #               
      #           HTML-,   
      #             ,
      #        .
      s/\s*$//;
      
      #     :   -   ,
      #       ;    - 
      #   ,        
      ( $param_name, $param_value ) = $_ =~ /^(\S+)\s+(.+)$/;
    }

    #      ,   ()
    #        HTML-,  ,
    #         ,   
    # (    )
    if ( $param_name =~ /HELP_(LINK|BTN)_TITLE$/ )
    {
      #      --     
      ( $current_module_field ) = $param_name =~ 
                                  /^(.+)_HELP_(LINK|BTN)_TITLE$/;
      #       
      if ( $current_module_field eq $module_field )
      {
        $hot_help_index++;      #   "" 
      }
      else                      #  -- 
      {
        #     
        $module_field = $current_module_field;

        $hot_help_index = 1;    #    --  
                                # "" 
      }
      #     ...HELP_(LINK|BTN)_TITLE,  
      #    ...HELP_VALUE  ,  
      #    ""     
      # "" 
      $help_value_index = 1;

      #      ,  
      #   
      $param_name .= $hot_help_index;
    }
    #      ,   ()
    #        HTML-
    elsif ( $param_name =~ /HELP_VALUE$/ )
    {
      #       "" , 
      #    ,     
      $param_name .= $hot_help_index . "_" . $help_value_index;
      $help_value_index++;
    }

    #       ,   
    #  
    push( @configuration, $param_name, $param_value );
  }
  # TODO        ""
  #      . ,   _TITLE,    
  #           _VALUE , ,  _VALUE,
  #           _TITLE.
  
  close( CONFIG );

  return ( @configuration );
}

# -----------------------------------------------------------------------------
#    /
# -----------------------------------------------------------------------------
sub read_exp_config
{
  #  -    
  my $config_file = shift;

  #     
  my( $param_name, $param_value );

  my %config;     # -  /
  my $line = 0;   #    . 
  
  #    .  (   )
  # my @keywords = ( 'TABLE', 'KEY_FIELDS', 'CHECK_FIELDS', 'FIELDS',
  #                  'FOREIGN_KEY', 'TABLE_EXPORT', 'FOREIGN_KEYS_EXCLUDE',
  #                  'DEPENDENT_TABLES' );

  #  .  (       
  # . ,       ,     
  # ""     "\")
  my $param;
  
  #  ,      
  my $inside_multiline = 0;

  my $table;              #  
  my $ref_table;          #   
  my $f_key_name;         #    (   )
  my @tables_order = ();  #      
                          #    (   
                          #    
                          #     ""  )
  my @bib_rec_areas = (); #  ,   
                          # . 
  my $error = 0;          #      
      
  #   ...
  open( CONFIG, "< $config_file" ) or 
      die "    $config_file. : $!\n";

  # ...    
  while( <CONFIG> )
  {
    $line++;        #    . 
    chomp;          #    

    #     ,     
    #  
    next if /^\s*$/;

    #     "#"   
    next if /^#/;

    s/\s*$//;   #  ,   ,  
    s/^\s*//;   #       
        
    #   ""
    if ( $_ =~ /\\$/ )
    {
      s/\\$//;   #   "\"
      
      #         
      if ( $inside_multiline )
      {
        $param .= ' ' . $_; #     
      }
      else   #        
      {
        $param = $_;        #    
        $inside_multiline = 1;
      }  
 
      #   " ",     (" ")
      next;
    }
    else
    #  "" (    
    #    )
    {
      if ( $inside_multiline ) #    
      {
        $param .= ' ' . $_;    #     
        $inside_multiline = 0;
      }
      else                     #    
      {
        $param = $_;           #  
      }  
    }

    #     :   -   ,
    #       ;    - 
    #   ,        
    ( $param_name, $param_value ) = $param =~ /^(\S+)\s+(.+)$/;

    if ( $param_name eq 'TABLE' )          #  
    {
      $table = $param_value;
      push( @tables_order, $table );
    }
    elsif ( $param_name eq 'TABLE_NAME' )  #  
    {
      $config{ TABLES }{ $table }{ TABLE_NAME } = $param_value;
    }
    elsif ( $param_name eq 'KEY_FIELDS' )  #   ( )
    {
      #     "," (,  )
      #         -
      #      $table   
      $config{ TABLES }{ $table }{ KEY_FIELDS } =
             [ split( /\s*,\s*/, $param_value ) ];
    }
    #        
    elsif ( $param_name eq 'CHECK_FIELDS' )
    {
      $config{ TABLES }{ $table }{ CHECK_FIELDS } =
             [ split( /\s*,\s*/, $param_value ) ];
    }
    elsif ( $param_name eq 'FIELDS' )      #    
    {
      $config{ TABLES }{ $table }{ FIELDS } =
             [ split( /\s*,\s*/, $param_value ) ];
    }
    elsif ( $param_name eq 'FOREIGN_KEY' ) #  
    {
      #     :    ,
      #   ,      ( 
      #    $1, $2  $3)
      # .        --  1
      #              2,       ,
      #                .
      # !!!     (  "\")
      #             REFERENCES   ,
      #          : FOREIGN_KEY spec_mat_group_code  REFERENCES ...
      #             /^(.+?)\s+...  
      #           "?",         
      #           .      
      #          ,      
      #            ,      
      #            export_process_referenced_tables()  
      #           , -   
      #           undef (NULL).
      $param_value =~ /^(.+?)\s+REFERENCES\s+(\S+)\s+\(\s*(.+)\s+\)$/;
      
      #    (    1  2  )
      # .       
      #                .    
      #                    , 
      #               1  2.
      # (      --   )
      $f_key_name = $2;

      # !   .  -- FOREIGN_KEY, 
      #   - -- FOREIGN_KEYS
      $config{ TABLES }{ $table }{ FOREIGN_KEYS }{ $f_key_name }
             { F_KEY_FIELDS } = [ split( /\s*,\s*/, $1 ) ];

      $config{ TABLES }{ $table }{ FOREIGN_KEYS }{ $f_key_name }
             { REF_FIELDS } = [ split( /\s*,\s*/, $3 ) ];

      $ref_table = $2;
      $ref_table =~ s/\d$//;  #       --  

      $config{ TABLES }{ $table }{ FOREIGN_KEYS }{ $f_key_name }
             { REF_TABLE } = $ref_table;
    }
    #  ,     
    elsif ( $param_name eq 'FOREIGN_KEYS_EXCLUDE' )
    {
      $config{ TABLES }{ $table }{ FOREIGN_KEYS_EXCLUDE } =
             [ split( /\s*,\s*/, $param_value ) ];
    }
    #  ,    
    elsif ( $param_name eq 'DEPENDENT_TABLES' )
    {
      $config{ TABLES }{ $table }{ DEPENDENT_TABLES } =
             [ split( /\s*,\s*/, $param_value ) ];
    }
    #  ,      
    elsif ( $param_name eq 'ADJUSTABLE_FIELDS' )
    {
      $config{ TABLES }{ $table }{ ADJUSTABLE_FIELDS } =
             [ split( /\s*,\s*/, $param_value ) ];
    }
    #    
    elsif ( $param_name eq 'TABLE_EXPORT' )
    {
      if ( $param_value eq 'disabled' )
      {
        $config{ TABLES }{ $table }{ TABLE_EXPORT } = 'disabled';
      }
      else
      {
        $error = 1;

        #      
        print STDERR " $line,  $param_name: " .
                     "  '$param_value'\n";
      }
    }
    elsif ( $param_name eq 'TABLE_IMPORT' )
    {
      if ( $param_value eq 'disabled' )
      {
        $config{ TABLES }{ $table }{ TABLE_IMPORT } = 'disabled';
      }
      else
      {
        $error = 1;

        #      
        print STDERR " $line,  $param_name: " .
                     "  '$param_value'\n";
      }
    }
    elsif ( $param_name eq 'IMPORT_MODE' )
    {
      $config{ TABLES }{ $table }{ IMPORT_MODE } = $param_value;
    }
    elsif ( $param_name eq 'ADJUSTABLE_FIELDS_INCREASE' )
    {
      $config{ PARAMS }{ ADJUSTABLE_FIELDS_INCREASE } = $param_value;
    }
    else   #   
    {
      $error = 1;
      #      
      print STDERR " $line:   " .
                   " $param_name\n";
    }
  }

  close( CONFIG );

  #     (,   .  )
  $config{ TABLES_ORDER } = [ @tables_order ];

  if ( $error )
  {
    #      
    # TODO.        __LINE__  __FILE__ ?
    print STDERR "Line " . __LINE__ . " at " . __FILE__ . ": " .
          "     $config_file\n";
    die "Line " . __LINE__ . " at " . __FILE__ . ": " .
        "     $config_file\n";
  }
  
  return ( \%config );
}

# -----------------------------------------------------------------------------
#       
# -----------------------------------------------------------------------------
sub reveal_rus_letter
{
  # 
  my $letter = shift;       #  

  my @letters;              #   
  my $letter_num;           #    

  #    -- "_",    ,  
  if ( $letter =~ /^_/ )
  {
    #   ,    
    #   (    )
    ( $letter_num ) = $letter =~ /^_(\d+)/;
    
    #  "" -   
    # (- -- )
    @letters = split( /\s+/, $CFG{ STRING_LETTERS_RUS } );

    $letter = $letters[ $letter_num - 1 ];  #   --  1
  }

  if ( $CFG{ CHARSET } eq "UTF-8" )
  {
    use Encode;

    #      utf-8 (   
    #   ,   $letter --  ,   )
    $letter = decode( "UTF-8", $letter );
  }  

  return $letter;
}

# -----------------------------------------------------------------------------
#          
# -----------------------------------------------------------------------------
sub screen_qts
{
  # :    

  my $tmp;

  foreach $tmp ( @_ )
  {
    $$tmp =~ s/^\s*//;      #   ...
    $$tmp =~ s/\s*$//;      # ...   
    $$tmp =~ s/\'/\'\'/g;   # .    make_cmd
  }

  return;
}

# -----------------------------------------------------------------------------
#     
# -----------------------------------------------------------------------------
sub update_rec
{
  #   
  # (  :   =>  )
  my %prms = @_;

  # : CGI- (query);
  #                   
  #                ""   (create_top);
  #                 ,    
  #              (check_param);
  #                     
  #                (make_command);
  #                   
  #              (print_add_info)

  my $query = $prms{ query }; #  

  #      HTML-
  my $target_win = $query->param( 'target_win' );
  $target_win = "_self" unless $target_win;

  my( $conn, $result );     #    
  my $command;              #     

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => $target_win );

  open_top();                  #     
  &{ $prms{ create_top } }();  #      
                               # ""  
  close_top();                 #     

  open_bottom();               #     

  #     
  &{ $prms{ print_add_info } }() if defined( $prms{ print_add_info } );

  #      ,  
  # .    .
  if ( &{ $prms{ check_param } }() )
  {
    #  -   
    $command = &{ $prms{ make_command } }( 'UPDATE' );

    # DEBUG 
    print_debug_info( $command ) if $DEBUG;  #   

    $conn = exec_connect_db();         #   
    $result = $conn->exec( $command ); #      

    #         
    if ( PGRES_COMMAND_OK ne $result->resultStatus )
    {
      #   
      print "<p class=\"error\">$CFG{ ERROR_UPDATE }</p>\n";
      print STDERR $command . "\n";             #     
      die $conn->errorMessage;
    }

    #     
    if ( $result->cmdTuples == 1 )
    {
      print "<p class=\"info\">";
      print "    </p>\n";
    }
    elsif ( $result->cmdTuples == 0 )
    {
      print "<p class=\"info\">";
      print "     </p>\n";
    }
    else          # ( $result->cmdTuples > 1 )
    {
      print "<p class=\"error\">";
      print "    " . $result->cmdTuples .
            " .  !   </p>\n";
    }
  }  

  close_bottom();      #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub view_rec
{
  #   
  # (  :   =>  )
  my %prms = @_;

  # : CGI- (query);
  #                     
  #              ""   (create_top);
  #                 (make_form);
  #            URL     (action);
  #                (target);
  #              submit (submit_name);
  #               submit (submit_value);
  #                   (command);
  #                     (error);
  #            ,     
  #              (: 1  0) (can_update)

  # .      ,  
  #             submit_name  submit_value   
  #               .

  my $query = $prms{ query };

  my( $conn, $result );           #    
  my @row;                        #      
  my $i;

  #     ,     
  #     
  $prms{ can_update } = 0 if ( ! exists $prms{ can_update } );

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => $prms{ target } );

  open_top();          #     
  &{ $prms{ create_top } }();  #      
                       # ""  
  close_top();         #     

  open_bottom();       #     

  # DEBUG 
  print_debug_info( $prms{ command } ) if $DEBUG;  #   

  $conn = exec_connect_db();                   #   
  $result = $conn->exec( $prms{ command } );   #    

  #        
  if ( PGRES_TUPLES_OK ne $result->resultStatus )
  {
    #   
    print "<p class=\"error\">$CFG{ ERROR_SELECT }</p>\n";
    print STDERR $prms{ command } . "\n";     #     
    die $conn->errorMessage;
  }

  #    
  if ( $result->ntuples == 0 )
  {
    print "<p class=\"info\">";
    print ",   , " .
          "   </p>\n";
  }
  elsif ( $result->ntuples > 1 )
  {
    print "<p class=\"error\">";
    print $prms{ error } . "</p>\n";  #    
  }
  else
  {
    @row = $result->fetchrow;  #    

    # . .    do_add().
    #        
    #  ,         .
    #     action,    
    #  .
    print $query->start_form( -action => $prms{ action },
                              -target => $prms{ target }
                            ), "\n";
    #       JavaScript,  
    #   HTML- (  ) --   
    #     web-
    create_enable_elements_func();

    #   
    &{ $prms{ make_form } }( \@row, $result );

    #  submit     make_form()   
    # 

    #   submit      ,  
    # $prms{ can_update }       
    if ( $prms{ can_update } )
    {
      #     ,    
      # .   $prms{ submit_name }  $prms{ submit_value }
      #                 .  
      #                : ,  
      #              .
      if ( ref( $prms{ submit_name } ) eq 'ARRAY' )
      {
        for( $i = 0; $i < scalar @{ $prms{ submit_name } }; $i++ )
        {
          print $query->submit( -name => ${ $prms{ submit_name } }[ $i ],
                                -value => ${ $prms{ submit_value } }[ $i ],
                                -class => 'submit',
                                -onclick => "enable_elements()"
                              ), "&nbsp;\n";
        }
      }
      else                #   
      {
        print $query->submit( -name => $prms{ submit_name },
                              -value => $prms{ submit_value },
                              -class => 'submit',
                              -onclick => "enable_elements()"
                            ), "\n";
      }
    }
    print $query->end_form();
  }

  close_bottom();         #     
  print $query->end_html();
  return ( 0 );
}

END {   };

1;
