#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :   " "
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'AVAIL_TERMS';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Avail_terms
my @f_names =
   ( 'obj_id',           #   
                         #  
     'bib_rec_num',      #  .    
                         # (    0)
     'avail_num',        #    
     'avail_terms',      #  
     'er_flag',          #   
     'protocol',         #  (HTTP, FTP)
     'url',              # URL ()  
     'comment'           # 
   );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              print_add_info => \&print_add_info,
              action => $script_name
            );

exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  if ( $query->param( 'avail_num' ) !~ /^\d+$/ )
  {
    push( @error_messages, "      " .
          " " );
  }

  if ( $query->param( 'avail_terms' ) eq '' )
  {
    push( @error_messages, "   " );
  }

  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }
  
  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => '  ()',
                    user => $user,
                    full_top => 'no'
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $avail_num;          #    
  my $target_win;         #      HTML-

  my $command;            #      

  $obj_id      = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );
  $avail_num   = $query->param( 'avail_num' );
  $target_win  = $query->param( 'target_win' );

  #         
  $command = "DELETE FROM ${db_schema}avail_terms " .
             "WHERE obj_id = '$obj_id' AND " .
                   "bib_rec_num = '$bib_rec_num' AND " .
                   "avail_num = '$avail_num'";

  #   
  del_rec( query => $query,
           target => $target_win,
           create_top => \&create_top,
           print_add_info => \&print_add_info,
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#        
# -----------------------------------------------------------------------------
sub do_query
{
  # .        
  #              bib_recs.pl.

  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $bib_rec;            # . 
  my $target_win;         #      HTML-

  my( $result, $i );      #    
  my @row;                #      
  my $command;            #      
  my $href;               #   HTML-

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #  ,        
  my $alt_row = 1;

  $obj_id      = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );
  $bib_rec     = $query->param( 'bib_rec' );
  $target_win  = $query->param( 'target_win' );

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => $target_win );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  print_add_info(); #     

  #  ,    
  $bib_rec = CGI::escape( $bib_rec );

  #   HTML-
  $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
          "obj_id=$obj_id" .
          "&bib_rec_num=$bib_rec_num" .
          "&bib_rec=$bib_rec" .
          "&target_win=$target_win";

  #         
  $command = "SELECT * " .
             "FROM ${db_schema}avail_terms " .
             "WHERE obj_id = $obj_id AND " .
                   "bib_rec_num = $bib_rec_num " .
             "ORDER BY avail_num";

  #    
  $result = exec_select( $command );
  
  if ( $result )
  {
    $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                             'user' => $user );
    $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                               'user' => $user );

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th>   </th>\n";
    print "<th> </th>\n";
    print "<th> </th>\n";
    print "<th>URL ()  </th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete );
    print "</tr>\n";

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #      ,  .
      #   URL
      # (  &nbsp;   URL   :
      #    'url'  null,    
      # -)
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( 'avail_num' ) ]</td>\n";
      print "<td>$row[ $result->fnumber( 'avail_terms' ) ]</td>\n";
      print "<td  class=\"center\">",
            ( $row[ $result->fnumber( 'er_flag' ) ] eq 't' ? '' : '' ),
            "</td>\n";
      print "<td>$row[ $result->fnumber( 'url' ) ]&nbsp;</td>\n";

      #         
      print "<td>" if ( $can_view || $can_delete );
      print qq{<a class="command_link" href="$script_name/view?$href} .
            "&avail_num=" . $row[ $result->fnumber( 'avail_num' ) ]  . "\"" .
            qq{ target="$target_win"></a>} if $can_view;
      print "\n" if $can_view;

      #      
      print qq{<a class="command_link" href="$script_name/delete?$href} .
            "&avail_num=" . $row[ $result->fnumber( 'avail_num' ) ]  . "\"" .
            qq{ onclick="$confirm_delete"} .
            qq{ target="$target_win"></a>} if $can_delete;
      print "</td>\n" if ( $can_view || $can_delete );

      print "</tr>\n";
    }
    print "</table>\n";
  }

  #        
  #          "/"
  if ( ! $query->param( 'exp_imp' ) &&
       have_access( 'module' => $module, 'procedure' => 'ADD', 
                    'user' => $user ) )
  {
    print "<br />\n";
    print qq{<a class="command_link" href="$script_name/add?$href"} .
          qq{ target="$target_win"> </a>};
  }

  close_bottom();   #     

  print $query->end_html();

  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $avail_num;          #    
  my $target_win;         #      HTML-

  my $command;            #      

  $obj_id      = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );
  $avail_num   = $query->param( 'avail_num' );
  $target_win  = $query->param( 'target_win' );

  #      
  $command = "SELECT * " .
             "FROM ${db_schema}avail_terms " .
             "WHERE obj_id = '$obj_id' AND " .
                   "bib_rec_num = '$bib_rec_num' AND " .
                   "avail_num = '$avail_num'";

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => $target_win,
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "        : " .
                     "   .  - " .
                     $obj_id . ", " .
                     " .     - " .
                     $bib_rec_num . ", " .
                     "    - $avail_num",
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "avail_terms",
                       key => "obj_id, bib_rec_num, " .
                              "avail_num:avail_num_begin",
                       f_names => \@f_names,
                       f_special => [ 'er_flag' ],
                       func_special => \&non_std_fields,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  #  -   ,     ;
  #              
  
  #   ,     
  my $ref_row = $_[ 0 ];

  #  
  my $res = $_[ 1 ];

  my $i;
  my %fields = ();  # -      

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #        
    $fields{ 'obj_id' }      = $query->param( 'obj_id' );
    $fields{ 'bib_rec_num' } = $query->param( 'bib_rec_num' );

    #   

    #    
    if ( $CFG{ AVAIL_TERMS_AVAIL_NUM } )  #    . 
    {
      $fields{ 'avail_num' } = $CFG{ AVAIL_TERMS_AVAIL_NUM };
    }
    else
    {
      #      avail_num  
      # ,   1      
      #    .    . 
      # (   obj_id  bib_rec_num   Avail_terms)
      $fields{ 'avail_num' } = 
        get_next_key_value( 'avail_terms', 'avail_num',
                            'obj_id = ' . $query->param( 'obj_id' ) . ' AND ' .
                            'bib_rec_num = ' . $query->param( 'bib_rec_num' )
                          );
    }

    #  
    $fields{ 'avail_terms' } = $CFG{ AVAIL_TERMS_AVAIL_TERMS };

    #   
    $fields{ 'er_flag' }     = $CFG{ AVAIL_TERMS_ER_FLAG };

    #  (HTTP, FTP)
    $fields{ 'protocol' }    = $CFG{ AVAIL_TERMS_PROTOCOL };

    # URL ()  
    $fields{ 'url' }         = $CFG{ AVAIL_TERMS_URL };

    # 
    $fields{ 'comment' }     = $CFG{ AVAIL_TERMS_COMMENT };
  } 
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  #    "  
  #  "  " .   
  # "   ,     ,
  #     , ..    
  #  UPDATE   ,      INSERT
  # (     ,    
  #   ,      )
  print $query->hidden( -name => 'obj_id' ), "\n";
  print $query->hidden( -name => 'bib_rec_num' ), "\n";

  #     "   "
  # .      'begin'  ,
  #                   ,  
  #               (.  make_cmd   E_ARCH.pm).
  #             ..       ,   
  #              (, ,   ).
  print $query->hidden( -name => 'avail_num_begin',
                        -default => $fields{ 'avail_num' }
                      ), "\n";

  #      .  
  #  ,     add_rec()  update_rec()
  print $query->hidden( -name => 'bib_rec' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print_add_info();          #     

  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th>   </th>\n";
  print "<td>",
        $query->textfield( -name => 'avail_num',
                           -default => $fields{ 'avail_num' },
                           -size => $CFG{ AVAIL_TERMS_AVAIL_NUM_SIZE },
                           -maxlength => 
                             $CFG{ AVAIL_TERMS_AVAIL_NUM_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].avail_terms",
                   "AVAIL_TERMS_AVAIL_TERMS" ) if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'avail_terms',
                          -default => $fields{ 'avail_terms' },
                          -rows => $CFG{ AVAIL_TERMS_AVAIL_TERMS_ROWS },
                          -columns => $CFG{ AVAIL_TERMS_AVAIL_TERMS_COLS }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>",
        $query->checkbox( -name => 'er_flag',
                          -checked => 
                             $fields{ 'er_flag' } eq 't' ? '1' : '0',
                          -value => 'yes',
                          -label => ''
                        ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> (HTTP, FTP)</th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].protocol",
                   "AVAIL_TERMS_PROTOCOL" ) if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'protocol',
                           -default => $fields{ 'protocol' },
                           -size => $CFG{ AVAIL_TERMS_PROTOCOL_SIZE },
                           -maxlength => 
                             $CFG{ AVAIL_TERMS_PROTOCOL_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>URL ()  </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].url",
                   "AVAIL_TERMS_URL" ) if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'url',
                          -default => $fields{ 'url' },
                          -rows => $CFG{ AVAIL_TERMS_URL_ROWS },
                          -columns => $CFG{ AVAIL_TERMS_URL_COLS }
                         ),
        "</td>\n";
  print "</tr>\n";

  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment",
                   "AVAIL_TERMS_COMMENT" ) if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ AVAIL_TERMS_COMMENT_ROWS },
                          -columns => $CFG{ AVAIL_TERMS_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
    
  return ( 0 );
}

# -----------------------------------------------------------------------------
#   ,    
#  -      
# -----------------------------------------------------------------------------
sub non_std_fields
{
  # :
  my $fname = shift;  #  
                      #   -   ( 
                      #  ).      
  my $value;

  #      - 'er_flag',
  #   bool,       
  $value = $query->param( $fname ) ? 'yes' : 'no';

  return ( $value );  
}

# -----------------------------------------------------------------------------
#          
# -----------------------------------------------------------------------------
sub print_add_info
{
  #  .    
  print_bib_record( $query, " " );
  
  return ( 0 );
}
