#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :   "  ()"
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'BIB_RECS';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Bib_recs
my @f_names =
   ( 'obj_id',         #   
                       #  
     'bib_rec_num',    #  .    
                       # (    0)
     'gen_mat_code',   #     (1 - "")
     'bib_rec_head',   #   
     'bib_rec_full',   #   
     'bib_rec_short',  #   
     'ord_unit_num',   #    
                       #   
     'source_code',    #    
     'details_flag',   #   ""   
     'lang_code',      #  ,   
                       #   (1 -  )
     'process_code',   #    . 
                       # (1 - , ..   , 
                       #    . )
     'reason_add_rec', #  .  ( 
                       #  )
     'flags',          #   (    )
     'comment'         # 
   );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

# ,          
if ( ! can_work( $user, $module, 'main', $query ) )
{
  exit( 0 );
}

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#   --      ;
#   --    "  " (,
#    ,     . );
#   --     ;
#   --        
#   () / (     1,
#       'exp_imp')
if ( ( ! $query->path_info && ! $query->param ) ||
     $query->path_info =~ /^\/query$/ ||
     $query->path_info =~ /^\/select$/ ||
     ( ! $query->path_info && scalar $query->param() == 1 && 
       $query->param( 'exp_imp' )
     )
   )
{
  do_query();
}

#         
#       
elsif ( $query->path_info =~ /^\/view$/ &&
        have_access( 'module' => $module, 'procedure' => 'VIEW',
                     'user' => $user )
      )
{
  do_view();
}

#   (    )
elsif ( $query->path_info =~ /^\/add$/ &&
        have_access( 'module' => $module, 'procedure' => 'ADD',
                     'user' => $user )
      )
{
  do_add( query => $query,
          create_top => \&create_top_full,
          make_form => \&make_form,
          action => $script_name,
          target => "_self",
          submit_name => "submit_add",
          submit_value => ""
        );
}

#  
elsif ( $query->path_info =~ /^\/delete$/ &&
        have_access( 'module' => $module, 'procedure' => 'DELETE',
                     'user' => $user )
      )
{
  do_del();
}

#    
elsif ( $query->path_info =~ /^\/find$/ )
{
  do_find();
}

#   .  , ""   
elsif ( $query->path_info =~ /^\/list_contained_objs$/ )
{
  do_list_contained_objs();
}

#  
elsif ( $query->path_info =~ /^\/export$/ &&
        have_access( 'module' => $module, 'procedure' => 'EXPORT',
                     'user' => $user )
      ) 
{
  do_export();
}

#  
elsif ( $query->path_info =~ /^\/import$/ &&
        have_access( 'module' => $module, 'procedure' => 'IMPORT',
                     'user' => $user )
      ) 
{
  do_import();
}

#    (   )
#   , ..     
#   Bib_recs,      Bib_objs
if ( $query->param( 'submit_add' ) &&
     have_access( 'module' => $module, 'procedure' => 'ADD', 'user' => $user )
   )
{
  add_rec_non_std( $query, \&create_top_full, \&check_param, \&make_command );
}

#    (   )
elsif ( $query->param( 'submit_update' ) &&
        have_access( 'module' => $module, 'procedure' => 'UPDATE',
                     'user' => $user )
      )
{
  update_rec( 'query' => $query, 
              'create_top' => \&create_top_short,
              'check_param' => \&check_param,
              'make_command' => \&make_command );
}

exit( 0 );


# -----------------------------------------------------------------------------
#    - %CFG   
# ""   ,    Persons
# -----------------------------------------------------------------------------
sub add_conf_params_for_pers
{
  #     - %CFG  ,  
  #        e_arch.cfg

  #  -  ,     
  #  
  my $field_name = shift;

  my( $result, $i );              #    
  my @row;                        #      
  my $command;                    #      

  my $param_name;                 #     %CFG
  my $param_value;                #   
  
  #         
  # ,    Persons
  if ( ! $CFG{ PERSONS_NUM_LAST_RECS } )
  {
    return ( 0 );
  }  

  #    

  #     
  # .        
  #                ,   ,  
  #              .  -   ,
  #                ""   pers_id,
  #                   .
  $command = "SELECT pers_name " .
             "FROM ${db_schema}persons " .
             "WHERE pers_id >= ( SELECT max( pers_id ) " .
                                "FROM ${db_schema}persons ) - " .
                   "$CFG{ PERSONS_NUM_LAST_RECS } + 1 " .
             "ORDER BY pers_name";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    #      "" 
    #   $field_name

    my $max_index = -1;
    
    foreach ( keys %CFG )
    {
      #    -  ""    $field_name
      if ( /^${field_name}_HELP_(LINK|BTN)_TITLE(\d+)$/ )
      {
        $max_index = $2 if ( $2 > $max_index );
      }
    }

    $max_index++;         #      
    
    #      ""    HTML-
    $param_name = $field_name . '_HELP_LINK_TITLE' . $max_index;

    #  HTML-       
    # TODO.       . .
    $CFG{ $param_name } = '';

    $i = 1;

    #      
    while ( @row = $result->fetchrow )
    {
      #          %CFG
      $param_name = $field_name . '_HELP_VALUE' . $max_index . '_' . $i;

      #       
      if ( $field_name eq "BIB_RECS_BIB_REC_HEAD" )
      {
        #     Persons  
        $param_value = $row[ $result->fnumber( 'pers_name' ) ];

        #       ,  ,
        # . .   .   
        $param_value .= '.' if ( $param_value !~ /\.$/ )
      }
      elsif ( $field_name eq "BIB_RECS_BIB_REC_FULL" )
      {
        # , ,  ( ),  ,  
        #  ( ), (),     ,
        #    ( ),  ( )
        if ( $row[ $result->fnumber( 'pers_name' ) ] =~
             /^(\S+),\s*(\S)\S*\s+(\S)\S*\s*$/ )
        {
          #     :   
          $param_value = $2 . '. ' . $3 . '. ' . $1;
        }
        #   ,    
        elsif ( $row[ $result->fnumber( 'pers_name' ) ] =~
                /^(\S+),\s*(\S)\S*\s*$/ )
        {
          #     :    
          # (  --  ,   ,  )
          $param_value = $2 . '. ' .  $1;
        }
        #    :  - ,  
        #      ( , 
        #      )
        elsif ( $row[ $result->fnumber( 'pers_name' ) ] =~
                /^(\S+),\s*(.+)\s*$/ )
        {
          $param_value = $2 . ' ' . $1;
        }
        else    #        
        {
          # TODO.     von, van der  . .
          
          #     Persons  
          $param_value = $row[ $result->fnumber( 'pers_name' ) ];
        }
      }

      $CFG{ $param_name } = $param_value;
      $i++;
    }
  }
  return ( 0 );
}

# -----------------------------------------------------------------------------
#     
# .        
#               Bib_recs,      Bib_objs
# -----------------------------------------------------------------------------
sub add_rec_non_std
{
  my $query = shift;        #  - CGI- 

  #  -        
  #   ""  
  my $create_top = shift;

  my $check_param = shift;  #  -     
                            # ,    
  my $make_command = shift; #  -     
                            #      

  my( $conn, $result );     #    
  my $command;              #       

  #    . 
  # (      make_form())
  my $obj_id = $query->param( 'obj_id' );

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();          #     
  &{ $create_top }();  #       "" 
                       #  
  close_top();         #     

  open_bottom();       #     

  #      ,  
  if ( &{ $check_param }() )
  {
    $conn = exec_connect_db();          #   
    exec_transaction( $conn, "BEGIN" ); #     

    #   - ...
    $command = "INSERT INTO Bib_objs ( obj_id, flags, comment, who_chg ) " .
               "VALUES ( $obj_id, null, null, '$user' )"; 
    # DEBUG 
    print_debug_info( $command ) if $DEBUG;  #   

    # ...      Bib_objs
    $result = $conn->exec( $command );

    #         
    if ( PGRES_COMMAND_OK ne $result->resultStatus )
    {
      #   
      print "<p class=\"error\">$CFG{ ERROR_INSERT }</p>\n";
      print STDERR $command . "\n";           #     
      die $conn->errorMessage;
    }
    else
    {
      print "<p class=\"info\">";
      print( "     ( \"  " .
             "  \")</p>\n" );
    }

    #        Bib_recs

    #  -   
    $command = &{ $make_command }( 'APPEND' );

    # DEBUG 
    print_debug_info( $command ) if $DEBUG;  #   

    #      
    $result = $conn->exec( $command );

    #         
    if ( PGRES_COMMAND_OK ne $result->resultStatus )
    {
      #   
      print "<p class=\"error\">$CFG{ ERROR_INSERT }</p>\n";
      print STDERR $command . "\n";           #     
      die $conn->errorMessage;
    }
    else
    {
      print "<p class=\"info\">";
      print( "     ( \" " .
             " ()\")</p>\n" );
    }
    exec_transaction( $conn, "END" );     #  
  }

  close_bottom();      #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  #     (   )
  if ( $query->param( 'obj_id' ) !~ /^\d+$/ )
  {
    push( @error_messages, "     " .
          "   " );
  }

  #     (   )
  if ( $query->param( 'bib_rec_num' ) !~ /^\d+$/ )
  {
    push( @error_messages, "     .  " .
          "    " );
  }

  if ( $query->param( 'gen_mat_code' ) eq '' )
  {
    push( @error_messages, "     " );
  }

  if ( $query->param( 'source_code' ) eq '' )
  {
    push( @error_messages, "     " .
          "" );
  }

  if ( $query->param( 'lang_code' ) eq '' )
  {
    push( @error_messages, "   " );
  }

  if ( $query->param( 'process_code' ) eq '' )
  {
    push( @error_messages, "      " .
          "" );
  }

  if ( $query->param( 'bib_rec_full' ) eq '' &&
       $query->param( 'bib_rec_short' ) eq '' )
  {
    push( @error_messages, "     : " .
          " ,  ,  " );
  }

  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }
  
  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""   --   
# -----------------------------------------------------------------------------
sub create_top_full
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => '  ()',
                    user => $user,
                    make_letters => 'yes',
                    num_last_recs => $CFG{ BIB_RECS_NUM_LAST_RECS },
                    full_top => 'yes'
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#    ,     
# ""   --   
# -----------------------------------------------------------------------------
sub create_top_short
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => '  ()',
                    user => $user,
                    full_top => 'no'
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my( $conn, $result );      #    
  my @row;                   #      
  my $obj_id;                #    . 
  my $bib_rec_num;           #  .    
  my $command;               #      

  $obj_id      = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();          #     
  create_top_full();   #      
                       # ""  
  close_top();         #     

  open_bottom();       #     

  $conn = exec_connect_db();           #   
  exec_transaction( $conn, "BEGIN" );  #     

  #         
  #   Bib_recs (   ,    
  # Bib_recs,   )
  $command = "DELETE FROM ${db_schema}bib_recs " .
             "WHERE obj_id = '$obj_id' AND " .
                   "bib_rec_num = '$bib_rec_num'";
  # DEBUG 
  print_debug_info( $command ) if $DEBUG;  #   

  $result = $conn->exec( $command );   #     

  #         
  if ( PGRES_COMMAND_OK ne $result->resultStatus )
  {
    #   
    print "<p class=\"error\">$CFG{ ERROR_DELETE }</p>\n";
    print STDERR $command . "\n";           #     
    die $conn->errorMessage;
  }

  #     
  if ( $result->cmdTuples == 1 )
  {
    print "<p class=\"info\">";
    print "     </p>\n";
  }
  elsif ( $result->cmdTuples == 0 )
  {
    #      0,   
    #  .    ,    
    #  ""    ,   
    #  web-    . 
    # (. .  ),     
    print "<p class=\"info\">";
    print "      </p>\n";

    exec_transaction( $conn, "END" );      #  
    print $query->end_html();
    return ( 0 );    
  }
  #   --    
  else          # ( $result->cmdTuples > 1 )
  {
    print "<p class=\"error\">";
    print "      " . $result->cmdTuples .
          " .  !   </p>\n";

    exec_transaction( $conn, "ROLLBACK" );      #  
    print $query->end_html();
    return ( 0 );
  }

  # ---------------------------------------------------------------------
  # !    .    , 
  #                Bib_objs.
  # ---------------------------------------------------------------------  

  #   ,    .    ,
  #    ,       
  #   Bib_objs
  $command = "DELETE FROM ${db_schema}bib_objs o " .
             "WHERE o.obj_id = '$obj_id' AND " .
                   "NOT EXISTS ( SELECT * FROM ${db_schema}bib_recs r " .
                                "WHERE r.obj_id = '$obj_id' )";
  # DEBUG 
  print_debug_info( $command ) if $DEBUG;  #   

  $result = $conn->exec( $command );    #     

  #         
  if ( PGRES_COMMAND_OK ne $result->resultStatus )
  {
    #   
    print "<p class=\"error\">$CFG{ ERROR_DELETE }</p>\n";
    print STDERR $command . "\n";           #     
    die $conn->errorMessage;
  }

  #     
  if ( $result->cmdTuples == 1 )
  {
    print "<p class=\"info\">";
    print "      </p>\n";
  }
  elsif ( $result->cmdTuples == 0 )
  {
    print "<p class=\"info\">";
    print "        " .
          " </p>\n";
  }
  else
  {
    ;   # ,        
  }

  exec_transaction( $conn, "END" );      #  
  close_bottom();      #     
  print $query->end_html();
  return ( 0 );    
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_export
{
  # !!!     ( )
  #          .    . 
  # TODO. ,     ,   
  #          ( ) .      
  #           .
  
  my $obj_id;                #    . 
  my $bib_rec_num;           #  .    
  my $command;               #      
  my @table_cmd_pairs = ();  #     ,
                             #       
                             # TODO.    ?  .

  $obj_id = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );

  #  -         
  # (      ,    
  #  )
  $command = "SELECT * FROM Bib_recs ". 
             "WHERE obj_id = $obj_id AND " .
                   "bib_rec_num = $bib_rec_num";

  push( @table_cmd_pairs, [ 'Bib_recs', $command ] );

  #    
  export_data( query => $query,
               create_top => \&create_top_full,
               table_cmd_pairs => \@table_cmd_pairs
             );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_find
{
  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();        #     
  create_top_full(); #    
  close_top();       #     
  
  open_bottom();     #     
  
  print "<p class=\"info\">     </p>\n";

  close_bottom();    #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_import
{
  # !!!     ( )
  #          .    . 

  # TODO. ,     ,   
  #        ( ) .        
  #        .
  
  my $obj_id;                #    . 
  my $bib_rec_num;           #  .    
  my $command;               #      
  my @table_cmd_pairs = ();  #     ,
                             #       

  $obj_id = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );

  #  -         
  # (      ,    
  #  )
  $command = "SELECT * FROM exp_imp.Bib_recs " .
             "WHERE obj_id = $obj_id AND " .
                   "bib_rec_num = $bib_rec_num";

  push( @table_cmd_pairs, [ 'Bib_recs', $command ] );

  #    
  import_data( query => $query,
               create_top => \&create_top_full,
               table_cmd_pairs => \@table_cmd_pairs
             );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#    .   , ""   
# -----------------------------------------------------------------------------
sub do_list_contained_objs
{
  my @row;                    #      
  my $command;                #      
  my $obj_id;                 #    . 
  my $bib_rec_num;            #  .    
  my $bib_rec;                # . 
  my $target_win;             #      HTML-
  my $headline;               #   . 
  
  $obj_id      = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );
  $bib_rec     = $query->param( 'bib_rec' );
  $target_win  = $query->param( 'target_win' );

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => $target_win );

  open_top();         #     
  create_top_short(); #    
  close_top();        #     

  open_bottom();      #     

  #     .    .
  #       
  print "<p class=\"bib_rec\">";
  print "  . : $obj_id\n";
  print "&nbsp;&nbsp;\n";
  print " .    : $bib_rec_num</p>\n";

  #        HTML-
  $bib_rec = get_bib_rec( $obj_id, $bib_rec_num, $db_schema )
    if ( $CFG{ HIDE_RUS_LETTERS } );

  #   . 
  print "<p class=\"bib_rec\">$bib_rec</p>\n";

  #   
  $headline = "<h2 class=\"module_title\">, \"\" " .
              "  </h2>\n";

  #     ,     obj_id_cont
  #  bib_rec_num_cont   Obj_containers    obj_id
  #  bib_rec_num,    
  # .   PostgreSQL,  
  #                  -  ( ,
  #                     
  #             'bib_rec_full'  'bib_rec_short').
  $command = "SELECT b.obj_id, b.bib_rec_num, " .
                    "CASE WHEN b.bib_rec_short IS NOT NULL " .
                         "THEN b.bib_rec_short " .
                         "ELSE b.bib_rec_full " .
                    "END AS bib_rec " .
             "FROM ${db_schema}obj_containers o, ${db_schema}bib_recs b " .
             "WHERE o.obj_id_cont = '$obj_id' AND " .
                   "o.bib_rec_num_cont = '$bib_rec_num' AND " .
                   "o.obj_id = b.obj_id AND " .
                   "o.bib_rec_num = b.bib_rec_num " .
             "ORDER BY bib_rec";

  #  .   ,   
  list_bib_recs_by_query( $query, $command, $headline );

  close_bottom();     #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      (),  
#    
# -----------------------------------------------------------------------------
sub do_query
{
  my( $result, $i );              #    
  my @row;                        #      
  my $command;                    #      
  my $letter;                     #   . 
  my $letter_lower;               #   --   
  my @avail_objs;                 #  . ,   
                                  #    . ,
                                  #   , 
                                  # ,   . 

  #   ,   ,   
  #     
  my $num_last_recs;

  #  WHERE   
  my $where;

  #    . : bib_rec_short  bib_rec_full
  # .    bib_rec_short   ?... , 
  #                 :    
  #              ...
  my $bib_rec_fname = "CASE WHEN bib_rec_short IS NOT NULL " .
                           "THEN bib_rec_short " .
                           "ELSE bib_rec_full " .
                      "END ";

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #      / 
  my $can_export = 0;
  my $can_import = 0;
  
  #  ,        
  my $alt_row = 1;

  my $href;    #   HTML-
  
  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();        #     
  create_top_full(); #    
  close_top();       #     

  open_bottom();     #     

  $letter        = $query->param( 'letter' );
  $num_last_recs = $query->param( 'num_last_recs' );

  #    ,      - 
  #      
  # .    undef,      '' 
  #               -   CGI.pm.
  if ( ( $letter eq undef || $letter eq '' ) &&
       ( $num_last_recs eq undef || $num_last_recs eq '' )
     )
  {
    close_bottom();   #     

    print $query->end_html();
    return ( 0 );
  }

  #         ,
  #   
  if ( $num_last_recs )
  {
    # .        
    #                ,   ,  
    #              .  -   ,
    #                ""   obj_id,
    #                   .
    # .       ,    
    #             bib_rec_num,     
    #             .       - 
    #                 (. .    
    #               ),    :
    #             - ,      ,  
    #              ,    obj_id   
    #                ,  
    #             $num_last_recs,       ,
    #                $num_last_recs;
    #             -      ,   
    #             $num_last_recs,    obj_id  
    #                ,  
    #             $num_last_recs
    $where = "WHERE obj_id >= ( SELECT max( obj_id ) " .
                               "FROM ${db_schema}bib_recs ) - " .
                    "$num_last_recs + 1 ";
  }
  #       
  elsif ( $letter )
  {
    # !    .     .
    
    #     KDE 4.4.5 ,   Konqueror
    #    html-,   GET,
    #   UTF-8 ( ).      
    #    .     ,
    #  html-      KOI8-R.
    # .   (  , , IE8, Chrome)
    #              .
    # TODO.      (, , html-
    #          UTF-8,    -   
    #       CP1251).
    # DEBUG
    # print "letter " . $letter . "<br />\n";
    #{
    #  use Encode qw( from_to );
    #  #    $letter    ( ,  
    #  # ),  ,   UTF-8
    #  from_to( $letter, "utf-8", "koi8-r" ) if ( length( $letter ) > 1 );
    #}

    #        
    $letter = reveal_rus_letter( $letter );

    #      , 
    # ,   
    $letter_lower = change_case( $letter, 'lower' );

    #   ,      'bib_rec_full' 
    # 'bib_rec_short'      ,  
    #      (     )
    #    --  ,    
    $where = "WHERE $bib_rec_fname ~ '^($letter|\"$letter|" .
                                       "$letter_lower|\"$letter_lower)' ";
  }

  # .   PostgreSQL,  
  #                  -  ( ,
  #                     
  #             'bib_rec_full'  'bib_rec_short').
  #              ,    CASE 
  #               ( WHERE  ORDER BY):   
  #             bib_rec   (,  - ?).
  $command = "SELECT obj_id, bib_rec_num, $bib_rec_fname AS bib_rec " .
             "FROM ${db_schema}bib_recs " .
             $where .
  #      -- ,    ,  
  #  ,    ;
  #        ,   
  #      (,     
  #    --  )
             "ORDER BY CASE WHEN $bib_rec_fname ~ '^\"' " .
                           "THEN lower( substr( $bib_rec_fname, 2, 200 ) ) " .
                           "ELSE lower( substr( $bib_rec_fname, 1, 200 ) ) " .
                      "END";
  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    #    ,    ,   
    if ( $num_last_recs )
    {
      print "<h3>,      (" . 
            $num_last_recs . " .)</h3>\n";
    }
    $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                             'user' => $user );
    $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                               'user' => $user );

    #     "/",     
    if ( $query->param( 'exp_imp' ) )
    {
      $can_import = import_enabled() && 
                    have_access( 'module' => $module, 'procedure' => 'IMPORT',
                                 'user' => $user );
    }
    #    public --   ,
    #   -- 
    else
    {
      $can_export = export_enabled() && 
                    have_access( 'module' => $module, 'procedure' => 'EXPORT',
                                 'user' => $user );
    }

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th>ID</th>\n";
    print "<th> . </th>\n";
    print "<th> </th>\n";
    print "<th></th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete || $can_export ||
                                   $can_import );
    print "</tr>\n";

    #          
    #    .  ...
    if ( $query->param( 'enable_select' ) )
    {
      # ...    JavaScript    
      #     Bib_recs     ...
      if ( $query->param( 'caller_name' ) eq 'OBJ_CONTAINERS' )
      {
        # ...  obj_id_cont, bib_rec_num_cont  bib_rec_cont
        #   OBJ_CONTAINERS
        create_assign_values_func( 'obj_id_cont', 'bib_rec_num_cont',
                                   'bib_rec_cont' );
      }
    }

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #   ,  .    
      # (   ,     -
      # .   SELECT)
      print "<td class=\"center\">$row[ $result->fnumber( 'obj_id' ) ]</td>\n";
      print "<td class=\"center\">" .
            $row[ $result->fnumber( 'bib_rec_num' ) ] . "</td>\n";

      #    ,      
      # ,   &mdash;
      # . TODO   list_bib_recs_by_query()  E_ARCH.pm.
      my $bib_rec_for_display = $row[ $result->fnumber( 'bib_rec' ) ];
      $bib_rec_for_display =~ s/--/&mdash;/g;

      #         
      #     . ,   
      # bib_rec    
      if ( $query->param( 'enable_select' ) )
      {
        #     "" 
        # (.    obj_groups_descrs.pl)
        #     , . . , 
        #   escapeHTML(), 
        my $bib_rec = $row[ $result->fnumber( 'bib_rec' ) ];
        $bib_rec =~ s/\'/\\\'/g;
        $bib_rec = CGI::escapeHTML( $bib_rec );

        print "<td>",
              qq{ <a class="command_link" href="javascript:void( 0 )" onclick=
                  "assign_values( $row[ $result->fnumber( 'obj_id' ) ],
                                  $row[ $result->fnumber( 'bib_rec_num' ) ],
                                  '$bib_rec' )">
                  $bib_rec_for_display</a> },
              "</td>\n";
      }
      else
      {
        print "<td>$bib_rec_for_display</td>\n";
      }

      #      , 
      #    . 
      print "<td>\n";
      @avail_objs = get_available( $row[ $result->fnumber( 'obj_id' ) ],
                                   $db_schema );

      #     (, . ,   
      #  )   
      foreach ( @avail_objs )
      {
        print $_ . "<br />\n";
      }
      print "</td>\n";

      #   HTML-
      $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
              "obj_id=" . $row[ $result->fnumber( 'obj_id' ) ] .
              "&bib_rec_num=" . $row[ $result->fnumber( 'bib_rec_num' ) ];

      #     
      print "<td>" if ( $can_view || $can_delete || $can_export ||
                        $can_import );
      print qq{ <a class="command_link" href="$script_name/view?$href"} .
            qq{ target="_blank"></a> } . "\n"  if $can_view;

      #   
      print qq{ <a class="command_link" href="$script_name/delete?$href"} .
            qq{ onclick="$confirm_delete"} .
            qq{ target="_self"></A> } . "\n" if $can_delete;

      #   
      print qq{ <a class="command_link" href="$script_name/export?$href"} .
            qq{ onclick="$confirm_export"} .
            qq{ target="_blank"></A> } . "\n" if $can_export;

      #   
      print qq{ <a class="command_link" href="$script_name/import?$href"} .
            qq{ onclick="$confirm_import"} .
            qq{ target="_blank"></A> } . "\n" if $can_import;

      print "</td>" if ( $can_view || $can_delete || $can_export ||
                         $can_import );
      print "</tr>\n";
    }
    print "</table>\n";
  }

  close_bottom();    #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $obj_id;                #    . 
  my $bib_rec_num;           #  .    
  my $target_win;            #      HTML-
  my $command;               #      

  $obj_id      = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );
  $target_win  = $query->param( 'target_win' );

  $target_win  = "_self" unless $target_win;

  #     ()" 
  $command = "SELECT * " .
             "FROM ${db_schema}bib_recs " .
             "WHERE obj_id = '$obj_id' AND " .
                   "bib_rec_num = '$bib_rec_num'"; 

  #   
  view_rec( query => $query,
            create_top => \&create_top_short,
            make_form => \&make_form,
            action => $script_name,
            target => $target_win,
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "        " .
                     "  " . $obj_id .
                     "   .  " . $bib_rec_num,
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#     ""   . 
#   
# -----------------------------------------------------------------------------
sub get_details
{
  #  
  my $table = shift;        #   ,    
  my $obj_id = shift;       #    . 
  my $bib_rec_num = shift;  #  .    

  #          . 
  #    . 
  # .        
  #              .  , ""   .
  #             ,  .    ""
  #             .     ().
  my $field_for_obj_id = shift;
  my $field_for_bib_rec_num = shift;

  my $result;               #     ( ) 
  my $command;              #      
  my @row;                  #      
  my $mark;                 # ,    ""

  #     ,    
  $field_for_obj_id = 'obj_id' unless $field_for_obj_id;
  $field_for_bib_rec_num = 'bib_rec_num' unless $field_for_bib_rec_num;
 
  $command = "SELECT count( * ) FROM ${db_schema}$table " .
             "WHERE $field_for_obj_id = '$obj_id'";

  #     bib_rec_num  , 
  #      undef
  if ( $bib_rec_num ne undef )
  {
    $command .= " AND $field_for_bib_rec_num = '$bib_rec_num'";
  }

  $result = exec_select( $command );    #    

  #     
  # ( count()    ,   , 
  #  ,  0)
  @row = $result->fetchrow();
  
  if ( $row[ 0 ] == 0 )  # ""  
  {
    #      ( ""  
    #    )
    $mark = '&nbsp;&nbsp;';
  }
  else
  {
    #   .    ,   
    if ( $CFG{ BIB_RECS_DETAILS_MARK } ne undef )
    {
      $mark = $CFG{ BIB_RECS_DETAILS_MARK };
    }
    #    ,  ...
    else
    {
      # ...    ""    
      $mark = $row[ 0 ];
    }
  }

  return ( $mark );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "bib_recs",
                       key => "obj_id, bib_rec_num",
                       f_names => \@f_names,
                       f_special => [ 'details_flag' ],
                       func_special => \&non_std_fields,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();      # -      

  #      (    
  #   )
  my( $ref_values_maters, $ref_labels_maters ) = 
    popup_gen_mater_types_list( $db_schema );

  #      (    
  #   )
  my( $ref_values_sources, $ref_labels_sources ) = 
    popup_recs_sources_list( $db_schema );

  #      (    
  # ,    . )
  my( $ref_values_langs, $ref_labels_langs ) = popup_langs_list( $db_schema );

  #      (    
  #    . )
  my( $ref_values_procs, $ref_labels_procs ) = 
    popup_process_types_list( $db_schema );

  #   HTML-      ""
  # . 
  my $href;

  #   ,    "" 
  #     ("", "  "  . .)
  my $details_mark;

  #   ,      HTML-,
  #  ""  ("", " 
  # "  .)
  # .       CGI- target_win
  #              - ,     . ,
  #                . ,   -
  #              (,  .   - ,
  #                   -- 
  #             .  Persons.pl),      
  #             (_blank).    ,  
  #              ("", "  "  .)
  #                     ,  
  #               ,       
  #               (),  
  #               . ,     
  #             HTML-   . ,   
  #               ", ".    
  #              HTML-     
  #              .      ,   
  #             ,      ,    
  #              HTML-.
  my $target_win = $query->param( 'target_win' );
  $target_win = "_self" unless $target_win;

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #         ,
    #   1        
    # .  ,      
    #               bib_objs? ,   ,  
    #             obj_id      ,
    #                   ... !
    $fields{ 'obj_id' } = get_next_key_value( 'bib_recs', 'obj_id' );

    #   " .    "
    #      0
    # TODO       -  
    #      .    .     'bib_rec_num'
    #          1 ,   
    #          .
    $fields{ 'bib_rec_num' } = 0;

    #    
    $fields{ 'gen_mat_code' }   = $CFG{ BIB_RECS_GEN_MAT_CODE };

    #   
    $fields{ 'bib_rec_head' }   = $CFG{ BIB_RECS_BIB_REC_HEAD };
    
    #   
    $fields{ 'bib_rec_full' }   = $CFG{ BIB_RECS_BIB_REC_FULL };

    #   
    $fields{ 'bib_rec_short' }  = $CFG{ BIB_RECS_BIB_REC_SHORT };

    #       
    $fields{ 'ord_unit_num' }   = $CFG{ BIB_RECS_ORD_UNIT_NUM };

    #    
    $fields{ 'source_code' }    = $CFG{ BIB_RECS_SOURCE_CODE };

    #   ""   
    $fields{ 'details_flag' }   = $CFG{ BIB_RECS_DETAILS_FLAG };

    #  
    $fields{ 'lang_code' }      = $CFG{ BIB_RECS_LANG_CODE };

    #    . 
    $fields{ 'process_code' }   = $CFG{ BIB_RECS_PROCESS_CODE };

    #  .  (   )
    $fields{ 'reason_add_rec' } = $CFG{ BIB_RECS_REASON_ADD_REC };

    #  
    $fields{ 'flags' }          = $CFG{ BIB_RECS_FLAGS };

    # 
    $fields{ 'comment' }        = $CFG{ BIB_RECS_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  #    "  
  #  "  " .   
  # "     
  # get_next_key_value(),     ,
  #     , ..    
  #  UPDATE   
  print $query->hidden( -name => 'obj_id',
                        -default => $fields{ 'obj_id' }
                      ), "\n";
  print $query->hidden( -name => 'bib_rec_num',
                        -default => $fields{ 'bib_rec_num' }
                      ), "\n";
  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";
  
  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th>   " .
            " </th>\n";
  print "<td>", $fields{ 'obj_id' }, "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> a    </th>\n";
  print "<td>", $fields{ 'bib_rec_num' }, "</td>\n";
  print "</tr>\n";
  
  #        labels  
  # ,    popup_gen_mater_types_list() 
  #  ,   -   
  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>",
        $query->popup_menu( -name => 'gen_mat_code',
                            -default => $fields{ 'gen_mat_code' },
                            -values => $ref_values_maters,
                            -labels => { @{ $ref_labels_maters } }
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>";

  #    - %CFG   
  # ""   ,    Persons
  add_conf_params_for_pers( "BIB_RECS_BIB_REC_HEAD" ) 
    if $CFG{ HOT_HELP_IS_ON };

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].bib_rec_head",
                   "BIB_RECS_BIB_REC_HEAD" ) if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'bib_rec_head',
                          -default => $fields{ 'bib_rec_head' },
                          -rows => $CFG{ BIB_RECS_BIB_REC_HEAD_ROWS },
                          -columns => $CFG{ BIB_RECS_BIB_REC_HEAD_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>";

  #    - %CFG   
  # ""   ,    Persons
  add_conf_params_for_pers( "BIB_RECS_BIB_REC_FULL" ) 
    if $CFG{ HOT_HELP_IS_ON };
  
  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].bib_rec_full",
                   "BIB_RECS_BIB_REC_FULL" ) if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'bib_rec_full',
                          -default => $fields{ 'bib_rec_full' },
                          -rows => $CFG{ BIB_RECS_BIB_REC_FULL_ROWS },
                          -columns => $CFG{ BIB_RECS_BIB_REC_FULL_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].bib_rec_short",
                   "BIB_RECS_BIB_REC_SHORT" ) if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'bib_rec_short',
                          -default => $fields{ 'bib_rec_short' },
                          -rows => $CFG{ BIB_RECS_BIB_REC_SHORT_ROWS },
                          -columns => $CFG{ BIB_RECS_BIB_REC_SHORT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>      </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].ord_unit_num",
                   "BIB_RECS_ORD_UNIT_NUM" ) if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'ord_unit_num',
                           -default => $fields{ 'ord_unit_num' },
                           -size => $CFG{ BIB_RECS_ORD_UNIT_NUM_SIZE },
                           -maxlength => 
                             $CFG{ BIB_RECS_ORD_UNIT_NUM_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";
  
  #        labels  
  # ,    popup_recs_sources_list() 
  #  ,   -   
  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>",
        $query->popup_menu( -name => 'source_code',
                            -default => $fields{ 'source_code' },
                            -values => $ref_values_sources,
                            -labels => { @{ $ref_labels_sources } }
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  \"\"   </th>\n";
  print "<td>",
        $query->checkbox( -name => 'details_flag',
                          -checked => 
                             $fields{ 'details_flag' } eq 't' ? '1' : '0',
                          -value => 'yes',
                          -label => ''
                        ),
        "</td>\n";
  print "</tr>\n";
  
  #        labels  
  # ,    popup_langs_list()   ,
  #   -   
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>",
        $query->popup_menu( -name => 'lang_code',
                            -default => $fields{ 'lang_code' },
                            -values => $ref_values_langs,
                            -labels => { @{ $ref_labels_langs } }
                          ),
        "</td>\n";
  print "</tr>\n";

  #        labels  
  # ,    popup_process_types_list() 
  #  ,   -   
  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>",
        $query->popup_menu( -name => 'process_code',
                            -default => $fields{ 'process_code' },
                            -values => $ref_values_procs,
                            -labels => { @{ $ref_labels_procs } }
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>   " .
            "(   )</th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].reason_add_rec",
                   "BIB_RECS_REASON_ADD_REC" ) if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'reason_add_rec',
                           -default => $fields{ 'reason_add_rec' },
                           -size => $CFG{ BIB_RECS_REASON_ADD_REC_SIZE },
                           -maxlength => 
                             $CFG{ BIB_RECS_REASON_ADD_REC_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].flags", "BIB_RECS_FLAGS" ) 
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'flags',
                           -default => $fields{ 'flags' },
                           -size => $CFG{ BIB_RECS_FLAGS_SIZE },
                           -maxlength => $CFG{ BIB_RECS_FLAGS_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment", "BIB_RECS_COMMENT" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ BIB_RECS_COMMENT_ROWS },
                          -columns => $CFG{ BIB_RECS_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";

  #    -       
  #  , ,     /
  #         ,   
  # Bib_recs
  if ( $ref_row ne undef )
  {
    #    ,      
    # ,   &mdash;
    # . TODO   list_bib_recs_by_query()  E_ARCH.pm.
    my $bib_rec_for_display = ( ( $fields{ 'bib_rec_full' } ne undef ) ?
                                  $fields{ 'bib_rec_full' } :
                                  $fields{ 'bib_rec_short' } );
    $bib_rec_for_display =~ s/--/&mdash;/g;

    #   HTML-      ""
    # .  (       , 
    #   .  -      "")
    # .  .    ,  
    #              -    .
    $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
            "obj_id=$fields{ 'obj_id' }" .
            "&bib_rec_num=$fields{ 'bib_rec_num' }" .
            "&bib_rec=" . CGI::escape( $bib_rec_for_display );

    #      .     
    #     URL, ..    ,  
    #   bib_rec    (   )
    # CGI.pm     name=value   ,
    #     (   - bib_rec - 
    # , , ).      
    #   escapeHTML/unescapeHTML.    
    #   ,      ,
    #    escapeHTML/unescapeHTML.   
    #  CGI.pm,  unescapeHTML    2.46 CGI.pm   .
    #    2.70 CGI.pm    . ? 
    # .        2.46
    #              CGI.pm.
    # $href = "obj_id=$fields{ 'obj_id' }" .
    #         "&bib_rec=" . ( ( $fields{ 'bib_rec_short' } ne undef ) ?
    #                           $fields{ 'bib_rec_short' } :
    #                           $fields{ 'bib_rec_full' } ) .
    #         "&bib_rec_num=$fields{ 'bib_rec_num' }";

    #      .     .
    #   .   ,    "%20",
    #    ,      HTML:
    #  .   , , 
    # (      $href)
    # .      , .. ,
    #        , "&"      name=value,
    #                Bib_rec.
    # $href =~ s/[ ]+/%20/g;
    # $href = CGI::escapeHTML( $href );
    # $href = CGI::escape( $href );
    # $href = uri_escape( $href );      #   URI::Escape

    print "<table class=\"details_links\">\n";
    print "<tr>\n";

    print "<td>\n";

    print "<h4 class=\"bib_descr_area\">" .
          "     </h4>\n";

    # 
    $details_mark = get_details( 'titles', $fields{ 'obj_id' },
                                 $fields{ 'bib_rec_num' } );

    print "<span id=\"details_mark\">$details_mark" . "&nbsp;</span>" .
          qq{<a class="command_link" } .
          qq{href="/$CFG{ HOME_WEB_DIR }/titles.pl/query?$href} .
          qq{&target_win=$target_win"} .
          qq{ target="$target_win"></a>},
          "<br />\n";

    #   
    $details_mark = get_details( 'resp_stat', $fields{ 'obj_id' },
                                 $fields{ 'bib_rec_num' } );

    print "<span id=\"details_mark\">$details_mark" . "&nbsp;</span>" .
          qq{<a class="command_link" } .
          qq{href="/$CFG{ HOME_WEB_DIR }/resp_stat.pl/query?$href} .
          qq{&target_win=$target_win"} .
          qq{ target="$target_win">  </a>},
          "<br />\n";

    print "<h4 class=\"bib_descr_area\"> </h4>\n";

    #   
    $details_mark = get_details( 'edition_stat', $fields{ 'obj_id' },
                                 $fields{ 'bib_rec_num' } );

    print "<span id=\"details_mark\">$details_mark" . "&nbsp;</span>" .
          qq{<a class="command_link" } .
          qq{href="/$CFG{ HOME_WEB_DIR }/edition_stat.pl/query?$href} .
          qq{&target_win=$target_win"} .
          qq{ target="$target_win">  </a>},
          "<br />\n";

    print "<h4 class=\"bib_descr_area\">  </h4>\n";

    #  
    
    # .  -  
    $details_mark = get_details( 'spec_er', $fields{ 'obj_id' },
                                 $fields{ 'bib_rec_num' } );

    print "<span id=\"details_mark\">$details_mark" . "&nbsp;</span>" .
          qq{<a class="command_link" } .
          qq{href="/$CFG{ HOME_WEB_DIR }/spec_er.pl/query?$href} .
          qq{&target_win=$target_win"} .
          qq{ target="$target_win"> </a>},
          "<br />\n";

    # .  -  
    $details_mark = get_details( 'spec_serials', $fields{ 'obj_id' },
                                 $fields{ 'bib_rec_num' } );

    print "<span id=\"details_mark\">$details_mark" . "&nbsp;</span>" .
          qq{<a class="command_link" } .
          qq{href="/$CFG{ HOME_WEB_DIR }/spec_serials.pl/query?$href} .
          qq{&target_win=$target_win"} .
          qq{ target="$target_win"> </a>},
          "<br />\n";

    # .  -  
    $details_mark = get_details( 'spec_stds', $fields{ 'obj_id' },
                                 $fields{ 'bib_rec_num' } );

    print "<span id=\"details_mark\">$details_mark" . "&nbsp;</span>" .
          qq{<a class="command_link" } .
          qq{href="/$CFG{ HOME_WEB_DIR }/spec_stds.pl/query?$href} .
          qq{&target_win=$target_win"} .
          qq{ target="$target_win">  (  )</a>},
          "<br />\n";

    print "<h4 class=\"bib_descr_area\">  </h4>\n";

    #  
    $details_mark = get_details( 'pub_print_place', $fields{ 'obj_id' },
                                 $fields{ 'bib_rec_num' } );

    print "<span id=\"details_mark\">$details_mark" . "&nbsp;</span>" .
          qq{<a class="command_link" } .
          qq{href="/$CFG{ HOME_WEB_DIR }/pub_print_place.pl/query?$href} .
          qq{&target_win=$target_win"} .
          qq{ target="$target_win"> , </a>},
          "<br />\n";

    # /
    $details_mark = get_details( 'pub_printer', $fields{ 'obj_id' },
                                 $fields{ 'bib_rec_num' } );

    print "<span id=\"details_mark\">$details_mark" . "&nbsp;</span>" .
          qq{<a class="command_link" } .
          qq{href="/$CFG{ HOME_WEB_DIR }/pub_printer.pl/query?$href} .
          qq{&target_win=$target_win"} .
          qq{ target="$target_win">, , } .
          "</a>",
          "<br />\n";

    #  
    $details_mark = get_details( 'pub_print_date', $fields{ 'obj_id' },
                                 undef );

    print "<span id=\"details_mark\">$details_mark" . "&nbsp;</span>" .
          qq{<a class="command_link" } .
          qq{href="/$CFG{ HOME_WEB_DIR }/pub_print_date.pl/query?$href} .
          qq{&target_win=$target_win"} .
          qq{ target="$target_win"> , , </a>},
          "<br />\n";

    print "<h4 class=\"bib_descr_area\">" .
          "  </h4>\n";

    #   
    $details_mark = get_details( 'spec_mater', $fields{ 'obj_id' },
                                 $fields{ 'bib_rec_num' } );

    print "<span id=\"details_mark\">$details_mark" . "&nbsp;</span>" .
          qq{<a class="command_link" } .
          qq{href="/$CFG{ HOME_WEB_DIR }/spec_mater.pl/query?$href} .
          qq{&target_win=$target_win"} .
          qq{ target="$target_win">   } .
                                  " ;  </a>",
          "<br />\n";

    print "<h4 class=\"bib_descr_area\"> </h4>\n";

    # /
    $details_mark = get_details( 'obj_series', $fields{ 'obj_id' },
                                 $fields{ 'bib_rec_num' } );

    print "<span id=\"details_mark\">$details_mark" . "&nbsp;</span>" .
          qq{<a class="command_link" } .
          qq{href="/$CFG{ HOME_WEB_DIR }/obj_series.pl/query?$href} .
          qq{&target_win=$target_win"} .
          qq{ target="$target_win"></a>},
          "<br />\n";

    print "<h4 class=\"bib_descr_area\"> </h4>\n";

    # 
    $details_mark = get_details( 'notes', $fields{ 'obj_id' },
                                 $fields{ 'bib_rec_num' } );

    print "<span id=\"details_mark\">$details_mark" . "&nbsp;</span>" .
          qq{<a class="command_link" } .
          qq{href="/$CFG{ HOME_WEB_DIR }/notes.pl/query?$href} .
          qq{&target_win=$target_win"} .
          qq{ target="$target_win"></a>},
          "<br />\n";

    # 
    $details_mark = get_details( 'editions', $fields{ 'obj_id' }, undef );

    print "<span id=\"details_mark\">$details_mark" . "&nbsp;</span>" .
          qq{<a class="command_link" } .
          qq{href="/$CFG{ HOME_WEB_DIR }/editions.pl/query?$href} .
          qq{&target_win=$target_win"} .
          qq{ target="$target_win"></a>},
          "<br />\n";

    print "<h4 class=\"bib_descr_area\">" .
          "     </h4>\n";

    #  
    $details_mark = get_details( 'std_nums', $fields{ 'obj_id' }, undef );

    print "<span id=\"details_mark\">$details_mark" . "&nbsp;</span>" .
          qq{<a class="command_link" } .
          qq{href="/$CFG{ HOME_WEB_DIR }/std_nums.pl/query?$href} .
          qq{&target_win=$target_win"} .
          qq{ target="$target_win">  (ISBN, ISSN, ...)</a>},
          "<br />\n";

    #  
    $details_mark = get_details( 'avail_terms', $fields{ 'obj_id' },
                                 $fields{ 'bib_rec_num' } );

    print "<span id=\"details_mark\">$details_mark" . "&nbsp;</span>" .
          qq{<a class="command_link" } .
          qq{href="/$CFG{ HOME_WEB_DIR }/avail_terms.pl/query?$href} .
          qq{&target_win=$target_win"} .
          qq{ target="$target_win"> </a>},
          "<br />\n";

    # 
    $details_mark = get_details( 'prices', $fields{ 'obj_id' }, undef );

    print "<span id=\"details_mark\">$details_mark" . "&nbsp;</span>" .
          qq{<a class="command_link" } .
          qq{href="/$CFG{ HOME_WEB_DIR }/prices.pl/query?$href} .
          qq{&target_win=$target_win"} .
          qq{ target="$target_win"></a>},
          "<br />\n";

    print "</td>\n";

    print "<td>\n";

    print "<h4 class=\"bib_descr_area\">" .
          "  </h4>\n";

    # -
    $details_mark = get_details( 'obj_containers', $fields{ 'obj_id' },
                                 $fields{ 'bib_rec_num' } );

    print "<span id=\"details_mark\">$details_mark" . "&nbsp;</span>" .
          qq{<a class="command_link" } .
          qq{href="/$CFG{ HOME_WEB_DIR }/obj_containers.pl/query?$href} .
          qq{&target_win=$target_win"} .
          qq{ target="$target_win">-</a>},
          "<br />\n";

    #  .  , ""   
    $details_mark = get_details( 'obj_containers', $fields{ 'obj_id' },
                                 $fields{ 'bib_rec_num' },
                                 'obj_id_cont', 'bib_rec_num_cont' );

    print "<span id=\"details_mark\">$details_mark" . "&nbsp;</span>" .
          qq{<a class="command_link" } .
          qq{href="$script_name/list_contained_objs?$href} .
          qq{&target_win=$target_win"} .
          qq{ target="$target_win">, ""  </a>},
          "<br />\n";

    #  
    $details_mark = get_details( 'obj_langs', $fields{ 'obj_id' }, undef );

    print "<span id=\"details_mark\">$details_mark" . "&nbsp;</span>" .
          qq{<a class="command_link" } .
          qq{href="/$CFG{ HOME_WEB_DIR }/obj_langs.pl/query?$href} .
          qq{&target_win=$target_win"} .
          qq{ target="$target_win"> </a>},
          "<br />\n";

    #  
    $details_mark = get_details( 'features', $fields{ 'obj_id' }, undef );

    print "<span id=\"details_mark\">$details_mark" . "&nbsp;</span>" .
          qq{<a class="command_link" } .
          qq{href="/$CFG{ HOME_WEB_DIR }/features.pl/query?$href} .
          qq{&target_win=$target_win"} .
          qq{ target="$target_win"> </a>},
          "<br />\n";

    print "<br />\n";

    print "<h4 class=\"bib_descr_area\"></h4>\n";

    #  
    $details_mark = get_details( 'studying', $fields{ 'obj_id' }, undef );

    print "<span id=\"details_mark\">$details_mark" . "&nbsp;</span>" .
          qq{<a class="command_link" } .
          qq{href="/$CFG{ HOME_WEB_DIR }/studying.pl/query?$href} .
          qq{&target_win=$target_win"} .
          qq{ target="$target_win"> </a>},
          "<br />\n";

    #   
    $details_mark = get_details( 'gen_chars', $fields{ 'obj_id' }, undef );

    print "<span id=\"details_mark\">$details_mark" . "&nbsp;</span>" .
          qq{<a class="command_link" } .
          qq{href="/$CFG{ HOME_WEB_DIR }/gen_chars.pl/query?$href} .
          qq{&target_win=$target_win"} .
          qq{ target="$target_win"> </a>},
          "<br />\n";

    #   
    $details_mark = get_details( 'det_chars', $fields{ 'obj_id' }, undef );

    print "<span id=\"details_mark\">$details_mark" . "&nbsp;</span>" .
          qq{<a class="command_link" } .
          qq{href="/$CFG{ HOME_WEB_DIR }/det_chars.pl/query?$href} .
          qq{&target_win=$target_win"} .
          qq{ target="$target_win"> </a>},
          "<br />\n";

    #  
    $details_mark = get_details( 'obj_keywords', $fields{ 'obj_id' }, undef );

    print "<span id=\"details_mark\">$details_mark" . "&nbsp;</span>" .
          qq{<a class="command_link" } .
          qq{href="/$CFG{ HOME_WEB_DIR }/obj_keywords.pl/query?$href} .
          qq{&target_win=$target_win"} .
          qq{ target="$target_win"> </a>},
          "<br />\n";

    #  ()
    $details_mark = get_details( 'contents', $fields{ 'obj_id' },
                                 $fields{ 'bib_rec_num' } );

    print "<span id=\"details_mark\">$details_mark" . "&nbsp;</span>" .
          qq{<a class="command_link" } .
          qq{href="/$CFG{ HOME_WEB_DIR }/contents.pl/query?$href} .
          qq{&target_win=$target_win"} .
          qq{ target="$target_win"> ()</a>},
          "<br />\n";

    #  
    $details_mark = get_details( 'refs_descrs', $fields{ 'obj_id' },
                                 $fields{ 'bib_rec_num' } );

    print "<span id=\"details_mark\">$details_mark" . "&nbsp;</span>" .
          qq{<a class="command_link" } .
          qq{href="/$CFG{ HOME_WEB_DIR }/refs_descrs.pl/query?$href} .
          qq{&target_win=$target_win"} .
          qq{ target="$target_win"> </a>},
          "<br />\n";

    print "<br />\n";

    #  
    $details_mark = get_details( 'obj_groups', $fields{ 'obj_id' },
                                 $fields{ 'bib_rec_num' } );

    print "<span id=\"details_mark\">$details_mark" . "&nbsp;</span>" .
          qq{<a class="command_link" } .
          qq{href="/$CFG{ HOME_WEB_DIR }/obj_groups.pl/query?$href} .
          qq{&target_win=$target_win"} .
          qq{ target="$target_win">   </a>},
          "<br />\n";

    print "<br />\n";

    print "<h4 class=\"bib_descr_area\"></h4>\n";

    #  
    $details_mark = get_details( 'stor_objs', $fields{ 'obj_id' }, undef );

    print "<span id=\"details_mark\">$details_mark" . "&nbsp;</span>" .
          qq{<a class="command_link" } .
          qq{href="/$CFG{ HOME_WEB_DIR }/stor_objs.pl/query?$href} .
          qq{&target_win=$target_win"} .
          qq{ target="$target_win"> ( )</a>},
          "<br />\n";

    print "</td>\n";
    print "</tr>\n";

    print "</table>\n";
  }

  return ( 0 );
}

# -----------------------------------------------------------------------------
#   ,    
#  -      
# -----------------------------------------------------------------------------
sub non_std_fields
{
  # :
  my $fname = shift;  #  
                      #   -   ( 
                      #  ).      
  my $value;
  
  #   ""   
  if ( $fname eq 'details_flag' )
  {
    #     bool,    
    #   
    $value = $query->param( $fname ) ? 'yes' : 'no';
  }

  return ( $value );  
}
