#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :    ""
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'CITIES';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Cities
my @f_names =
   ( 
     'city_code',         #  
     'country_code',      #  
     'city_region',       # 
     'city_fname',        #   
     'city_sname',        #    
     'city_code_orig',    #  ,   
                          # (  , , 
                          #   )
     'lang_code',         #   (1 -  )
     'comment'            # 
   );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              do_find => \&do_find,
              do_export => \&do_export,
              do_import => \&do_import,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              action => $script_name
            );

exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        
  
  if ( $query->param( 'city_code' ) eq '' )
  {
    push( @error_messages, "   " );
  }

  if ( $query->param( 'country_code' ) eq '' )
  {
    push( @error_messages, "   " );
  }

  if ( $query->param( 'city_fname' ) eq '' )
  {
    push( @error_messages, "    " );
  }

  if ( $query->param( 'city_sname' ) eq '' )
  {
    push( @error_messages, "    " );
  }

  if ( $query->param( 'lang_code' ) eq '' )
  {
    push( @error_messages, "   " );
  }

  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }
  
  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => '',
                    user => $user
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $city_code;             #  
  my $command;               #      

  $city_code = $query->param( 'city_code' );
  
  #         
  $command = "DELETE FROM ${db_schema}cities " .
             "WHERE city_code = '$city_code'";

  #   
  del_rec( query => $query,
           create_top => \&create_top,
           target => "_self",
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_export
{
  my $city_code;             #  
  my $command;               #      
  my @table_cmd_pairs = ();  #     ,
                             #       

  $city_code = $query->param( 'city_code' );

  #  -       
  #    (      , 
  #     )
  $command = "SELECT * FROM Cities WHERE city_code = $city_code";
  push( @table_cmd_pairs, [ 'Cities', $command ] );

  #    
  export_data( query => $query,
               create_top => \&create_top,
               table_cmd_pairs => \@table_cmd_pairs
             );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_find
{
  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();       #     
  create_top();     #    
  close_top();      #     
  
  open_bottom();    #     
  
  print "<p class=\"info\">     </p>\n";

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_import
{
  my $city_code;             #  
  my $command;               #      
  my @table_cmd_pairs = ();  #     ,
                             #       

  $city_code = $query->param( 'city_code' );

  #  -       
  #    (      , 
  #     )
  $command = "SELECT * FROM exp_imp.Cities WHERE city_code = $city_code";
  push( @table_cmd_pairs, [ 'Cities', $command ] );

  #    
  import_data( query => $query,
               create_top => \&create_top,
               table_cmd_pairs => \@table_cmd_pairs
             );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub do_query
{
  my( $result, $i );              #    
  my @row;                        #      
  my $command;                    #      

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #      / 
  my $can_export = 0;
  my $can_import = 0;

  #        
  #   ( --      
  #   )
  my $add_params = '';

  #  ,        
  my $alt_row = 1;

  my $href;    #   HTML-

  #         
  #  enable_select  caller_name (  )
  if ( $query->param( 'enable_select' ) )
  {
    $add_params = "&enable_select=1&caller_name=" .
                  $query->param( 'caller_name' );
  }

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  #      (     
  #   ,     )
  $command = "SELECT c1.*, c2.city_fname AS city_fname_orig, " .
                    "cc.country_sname, l.lang_sname " .
             "FROM ( ${db_schema}cities c1 LEFT JOIN ${db_schema}cities c2 " .
                  "ON c1.city_code_orig = c2.city_code ), " .
                  "${db_schema}countries cc, ${db_schema}langs l " .
             "WHERE c1.lang_code = l.lang_code and " .
                   "c1.country_code = cc.country_code " .
             "ORDER BY c1.city_fname";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    #       ,     
    # "  ",       
    # (      ,
    #     )
    if ( $query->param( 'enable_select' ) &&
         $query->param( 'caller_name') eq $module )
    {
      $can_view = 0;
      $can_delete = 0;
    }
    else
    {
      $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                               'user' => $user );
      $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                                 'user' => $user );
    }

    #     "/",     
    if ( $query->param( 'exp_imp' ) )
    {
      $can_import = import_enabled() && 
                    have_access( 'module' => $module, 'procedure' => 'IMPORT',
                                 'user' => $user );
    }
    #    public --   ,
    #   -- 
    else
    {
      $can_export = export_enabled() && 
                    have_access( 'module' => $module, 'procedure' => 'EXPORT',
                                 'user' => $user );
    }
 
    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th> </th>\n";
    print "<th> </th>\n";
    print "<th> &mdash;   (  )</th>\n";
    print "<th></th>\n";
    print "<th></th>\n";
    print "<th></th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete || $can_export ||
                                   $can_import );
    print "</tr>\n";

    #          
    #     ( ) ...
    if ( $query->param( 'enable_select' ) )
    {
      # ...    JavaScript    
      #     Cities     ...
      if ( $query->param( 'caller_name' ) eq 'PUB_PRINT_PLACE' )
      {
        # ...  city_code, city_sname  country_sname_city
        #   PUB_PRINT_PLACE
        create_assign_values_func( 'city_code', 'city_sname',
                                   'country_sname_city' );
      }
      elsif ( $query->param( 'caller_name' ) eq 'STOR_OBJS' )
      {
        # ...  acq_place_city, city_sname  country_sname_city
        #   STOR_OBJS
        create_assign_values_func( 'acq_place_city', 'city_sname',
                                   'country_sname_city' );
      }
      elsif ( $query->param( 'caller_name' ) eq 'CITIES' )
      {
        # ...  city_code_orig, city_sname_orig  country_sname_orig
        #   CITIES
        create_assign_values_func( 'city_code_orig', 'city_sname_orig',
                                   'country_sname_orig' );
      }
      elsif ( $query->param( 'caller_name' ) eq 'ORGS' )
      {
        # ...  org_city_code, org_city_sname  org_country_sname_city
        #   CITIES
        create_assign_values_func( 'org_city_code', 'org_city_sname',
                                   'org_country_sname_city' );
      }
    }

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #   ,  ,     --
      #  , , , ,    
      # 
      # (  &nbsp;   ,   ,
      #     ,   :  
      #  'city_code_orig'  'city_region'  null,   
      #  -)
      print "<td class=\"center\">" .
            $row[ $result->fnumber( 'city_code' ) ] . "</td>\n";

      #         
      #      ( ),  
      #  city_fname    
      if ( $query->param( 'enable_select' ) )
      {
        print "<td>",
              qq{ <a class="command_link" href="javascript:void( 0 )" onclick=
                  "assign_values( $row[ $result->fnumber( 'city_code' ) ],
                                  '$row[ $result->fnumber( 'city_sname' ) ]',
                                  '$row[ $result->fnumber( 'country_sname' ) ]'
                                )">
                   $row[ $result->fnumber( 'city_fname' ) ]</a> },
              "</td>\n";
      }
      else
      {
        print "<td>$row[ $result->fnumber( 'city_fname' ) ]</td>\n";
      }

      #   ,   , ,  
      #    "&nbsp;"
      print "<td>",
            ( $row[ $result->fnumber( 'city_code_orig' ) ] ne undef ) ?
              "(" . $row[ $result->fnumber( 'city_code_orig' ) ] . ") " .
              $row[ $result->fnumber( 'city_fname_orig' ) ] :
            "&nbsp;",
            "</td>\n";

      print "<td>$row[ $result->fnumber( 'country_sname' ) ]</td>\n";
      print "<td>$row[ $result->fnumber( 'city_region' ) ]&nbsp;</td>\n";
      print "<td>$row[ $result->fnumber( 'lang_sname' ) ]</td>\n";

      #   HTML-
      $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
              "city_code=" . $row[ $result->fnumber( 'city_code' ) ] .
              $add_params;

      #      
      print "<td>" if ( $can_view || $can_delete || $can_export ||
                        $can_import );
      print qq{ <a class="command_link" href="$script_name/view?$href"} .
            qq{ target="_self"></a> } . "\n" if $can_view;

      #    
      print qq{ <a class="command_link" href="$script_name/delete?$href"} .
            qq{ onclick="$confirm_delete" } .
            qq{ target="_self"></a> } . "\n" if $can_delete;

      #   
      print qq{ <a class="command_link" href="$script_name/export?$href"} .
            qq{ onclick="$confirm_export"} .
            qq{ target="_blank"></A> } . "\n" if $can_export;

      #   
      print qq{ <a class="command_link" href="$script_name/import?$href"} .
            qq{ onclick="$confirm_import"} .
            qq{ target="_blank"></A> } . "\n" if $can_import;

      print "</td>" if ( $can_view || $can_delete || $can_export ||
                         $can_import );
      print "</tr>\n";
    }
    print "</table>\n";
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $city_code;                  #  
  my $command;                    #      

  $city_code = $query->param( 'city_code' );

  #     
  #     ,   ,
  #     
  $command = "SELECT c1.*, c2.city_sname AS city_sname_orig, " .
                    "c3.country_sname AS country_sname_orig " .
             "FROM ( ${db_schema}cities c1 LEFT JOIN ${db_schema}cities c2 " .
                  "ON c1.city_code_orig = c2.city_code ) " .
                  "LEFT JOIN ${db_schema}countries c3 " .
                  "ON c2.country_code = c3.country_code " .
             "WHERE c1.city_code = '$city_code'"; 

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => "_self",
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "         " .
                     " " . $city_code,
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "cities",
                       key => "city_code",
                       f_names => \@f_names,
                       f_special => undef,
                       func_special => undef,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();      # -      

  #      (    
  # ,    )
  my( $ref_values_countries, $ref_labels_countries ) =
    popup_countries_list( $db_schema );

  #      (    
  # ,     )
  my( $ref_values_langs, $ref_labels_langs ) = popup_langs_list( $db_schema );

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #         ,
    #   1        
    $fields{ 'city_code' } = get_next_key_value( 'cities', 'city_code' );

    #   

    #  
    $fields{ 'country_code' }   = $CFG{ CITIES_COUNTRY_CODE };

    # 
    $fields{ 'city_region' }    = $CFG{ CITIES_CITY_REGION };

    #   
    $fields{ 'city_fname' }     = $CFG{ CITIES_CITY_FNAME };

    #    
    $fields{ 'city_sname' }     = $CFG{ CITIES_CITY_SNAME };

    #  ,   
    # (  , ,    )
    $fields{ 'city_code_orig' } = $CFG{ CITIES_CITY_CODE_ORIG };

    #   (1 -  )
    $fields{ 'lang_code' }      = $CFG{ CITIES_LANG_CODE };

    # 
    $fields{ 'comment' }        = $CFG{ CITIES_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  #    " "  
  #    get_next_key_value(),    
  # ,     , ..  
  #    UPDATE   
  print $query->hidden( -name => 'city_code',
                        -default => $fields{ 'city_code' }
                      ), "\n";

  #       ,     
  #           ,
  #        ,   
  #  ,     
  # .   ,     ,
  #                    
  #                   .   
  #                    
  #             "",       HTML-, ""
  #                ,      
  #             .        ,   
  #                     
  #             HTML-   ,     
  #             .        ,
  #               ,      
  #             ,    , 
  #               ""  ,  .
  print $query->hidden( -name => 'enable_select' ), "\n";
  print $query->hidden( -name => 'caller_name' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>", $fields{ 'city_code' }, "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>",
        $query->textfield( -name => 'city_fname',
                           -default => $fields{ 'city_fname' },
                           -size => $CFG{ CITIES_CITY_FNAME_SIZE },
                           -maxlength => $CFG{ CITIES_CITY_FNAME_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>",
        $query->textfield( -name => 'city_sname',
                           -default => $fields{ 'city_sname' },
                           -size => $CFG{ CITIES_CITY_SNAME_SIZE },
                           -maxlength => $CFG{ CITIES_CITY_SNAME_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  #        labels  
  # ,    popup_countris_list()   ,
  #   -   
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>",
        $query->popup_menu( -name => 'country_code',
                            -default => $fields{ 'country_code' },
                            -values => $ref_values_countries,
                            -labels => { @{ $ref_labels_countries } }
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].city_region",
                   "CITIES_CITY_REGION" ) if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'city_region',
                           -default => $fields{ 'city_region' },
                           -size => $CFG{ CITIES_CITY_REGION_SIZE },
                           -maxlength => $CFG{ CITIES_CITY_REGION_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> &mdash;   (, , )</th>\n";

  #      JavaScript,  
  # - cities.pl
  create_selection_func( func_name => 'select_orig_city',
                         module_name => 'cities.pl',
                         caller_name => $module,
                         window_name => 'orig_cities',
                         exp_imp => $query->param( 'exp_imp' ) );

  #        , 
  #   (  )
  print "<td>",
        $query->textfield( -name => 'city_code_orig',
                           -default => $fields{ 'city_code_orig' },
                           -size => $CFG{ CITIES_CITY_CODE_ORIG_SIZE },
                           -maxlength => 
                             $CFG{ CITIES_CITY_CODE_ORIG_MAXLENGTH }
                         ),
        "&nbsp;&nbsp;",
        $query->textfield( -name => 'city_sname_orig',
                           -default => $fields{ 'city_sname_orig' },
                           -size => $CFG{ CITIES_CITY_SNAME_ORIG_SIZE },
                           -maxlength => 
                             $CFG{ CITIES_CITY_SNAME_ORIG_MAXLENGTH },
                           -readonly => 'readonly'
                         ),
        "&nbsp;&nbsp;",
        $query->textfield( -name => 'country_sname_orig',
                           -default => $fields{ 'country_sname_orig' },
                           -size => $CFG{ CITIES_COUNTRY_SNAME_ORIG_SIZE },
                           -maxlength => 
                             $CFG{ CITIES_COUNTRY_SNAME_ORIG_MAXLENGTH },
                           -readonly => 'readonly'
                         ),
        "&nbsp;&nbsp;",
        qq{ <a class="command_link" href="javascript:void( 0 )" onclick=} .
        qq{"select_orig_city()">} . "</a>",
        "</td>\n";
  print "</tr>\n";
  
  #        labels  
  # ,    popup_langs_list()   ,
  #   -   
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>",
        $query->popup_menu( -name => 'lang_code',
                            -default => $fields{ 'lang_code' },
                            -values => $ref_values_langs,
                            -labels => { @{ $ref_labels_langs } }
                          ),
        "</td>\n";
  print "</tr>\n";
  
  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment", "CITIES_COMMENT" )
    if $CFG{ HOT_HELP_IS_ON };
  
  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ CITIES_COMMENT_ROWS },
                          -columns => $CFG{ CITIES_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
    
  return ( 0 );
}
