#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :   ", , , ,  ..."
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'CONFS';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Confs
my @f_names =
   ( 'conf_code',         #   
     'conf_fname',        #   () 
     'conf_place',        #   ( , .. 
                          #     )
     'conf_date_beg',     #    
     'conf_date_end',     #    
     'conf_status_code',  #    (,
                          #  ...)
     'conf_foreign_flag', #   
                          # (..   )
     'conf_type_code',    #    (,
                          # ,  ...)
     'conf_num',          #  
     'conf_code_orig',    #    (  ,
                          # )
     'comment'            # 
   );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              do_find => \&do_find,
              do_export => \&do_export,
              do_import => \&do_import,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              action => $script_name
            );

exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  #     -    
  if ( $query->param( 'conf_code' ) !~ /^\d+$/ )
  {
    push( @error_messages, "      " .
          "" );
  }

  if ( $query->param( 'conf_fname' ) eq '' )
  {
    push( @error_messages, "    " );
  }

  if ( $query->param( 'conf_place' ) eq '' )
  {
    push( @error_messages, "    " );
  }

  #    
  if ( ! date_is_correct( $query->param( 'conf_date_beg' ) ) )
  {
    push( @error_messages, "       " .
          "" );
  }

  #    
  if ( ! date_is_correct( $query->param( 'conf_date_end' ) ) )
  {
    push( @error_messages, "       " .
          "" );
  }

  if ( $query->param( 'conf_status_code' ) eq '' )
  {
    push( @error_messages, "    " );
  }

  if ( $query->param( 'conf_type_code' ) eq '' )
  {
    push( @error_messages, "    " );
  }

  #    ,   
  if ( $query->param( 'conf_code_orig' ) !~ /^\d*$/ )
  {
    push( @error_messages, "   --  " );
  }

  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }
  
  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => ', , , ' .
                                    ',  ...',
                    user => $user,
                    make_letters => 'yes',
                    num_last_recs => $CFG{ CONFS_NUM_LAST_RECS },
                    full_top => 'yes'
                  );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $conf_code;             #  
  my $command;               #      

  $conf_code = $query->param( 'conf_code' );
  
  #         
  $command = "DELETE FROM ${db_schema}confs " .
             "WHERE conf_code = '$conf_code'";

  #   
  del_rec( query => $query,
           create_top => \&create_top,
           target => "_self",
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_export
{
  my $conf_code;             #   
  my $command;               #      
  my @table_cmd_pairs = ();  #     ,
                             #       

  $conf_code = $query->param( 'conf_code' );

  #  -       
  #    (      , 
  #     )
  $command = "SELECT * FROM Confs WHERE conf_code = $conf_code";
  push( @table_cmd_pairs, [ 'Confs', $command ] );

  #    
  export_data( query => $query,
               create_top => \&create_top,
               table_cmd_pairs => \@table_cmd_pairs
             );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_find
{
  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();       #     
  create_top();     #    
  close_top();      #     
  
  open_bottom();    #     
  
  print "<p class=\"info\">     </p>\n";

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_import
{
  my $conf_code;             #   
  my $command;               #      
  my @table_cmd_pairs = ();  #     ,
                             #       

  $conf_code = $query->param( 'conf_code' );

  #  -       
  #    (      , 
  #     )
  $command = "SELECT * FROM exp_imp.Confs WHERE conf_code = $conf_code";
  push( @table_cmd_pairs, [ 'Confs', $command ] );

  #    
  import_data( query => $query,
               create_top => \&create_top,
               table_cmd_pairs => \@table_cmd_pairs
             );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#    ,   
#   
# -----------------------------------------------------------------------------
sub do_query
{
  my( $result, $i );              #    
  my @row;                        #      
  my $command;                    #      
  my $letter;                     #    
  my $letter_lower;               #   --   

  #   ,   ,   
  #     
  my $num_last_recs;

  #  WHERE   
  my $where;

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #      / 
  my $can_export = 0;
  my $can_import = 0;

  #        
  #   ( --      
  #   )
  my $add_params = '';

  #  ,        
  my $alt_row = 1;

  my $href;    #   HTML-

  #         
  #  enable_select  caller_name (  )
  if ( $query->param( 'enable_select' ) )
  {
    $add_params = "&enable_select=1&caller_name=" .
                  $query->param( 'caller_name' );
  }

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  $letter        = $query->param( 'letter' );
  $num_last_recs = $query->param( 'num_last_recs' );

  #    ,      - 
  #      
  # .    undef,      '' 
  #               -   CGI.pm.
  if ( ( $letter eq undef || $letter eq '' ) &&
       ( $num_last_recs eq undef || $num_last_recs eq '' )
     )
  {
    close_bottom();   #     
    print $query->end_html();
    return ( 0 );
  }

  #         ,
  #   
  if ( $num_last_recs )
  {
    # .        
    #                ,   ,  
    #              .  -   ,
    #                ""   conf_code,
    #                   .
    $where = "WHERE c1.conf_code >= " .
                   "( SELECT max( conf_code ) FROM ${db_schema}confs ) - " .
                   "$num_last_recs + 1 ";
  }
  #       
  elsif ( $letter )
  {
    #        
    $letter = reveal_rus_letter( $letter );

    #      , 
    # ,   
    $letter_lower = change_case( $letter, 'lower' );

    #    --  ,    
    $where = "WHERE c1.conf_fname ~ '^($letter|\"$letter|" .
                                      "$letter_lower|\"$letter_lower)' ";
  }

  #     ,   
  #  $where (. .        
  #   ),      , 
  #  
  $command = "SELECT c1.*, c2.conf_fname AS conf_fname_orig " .
             "FROM ( ${db_schema}confs c1 LEFT JOIN ${db_schema}confs c2 " .
                  "ON c1.conf_code_orig = c2.conf_code ) " .
             $where .
             "ORDER BY c1.conf_date_beg";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    #    ,    ,   
    if ( $num_last_recs )
    {
      print "<h3>,      (" . 
            $num_last_recs . " .)</h3>\n";
    }

    #       ,     
    # "  ",       
    # (      ,
    #     )
    if ( $query->param( 'enable_select' ) &&
         $query->param( 'caller_name') eq $module )
    {
      $can_view = 0;
      $can_delete = 0;
    }
    else
    {
      $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                               'user' => $user );
      $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                                 'user' => $user );
    }

    #     "/",     
    if ( $query->param( 'exp_imp' ) )
    {
      $can_import = import_enabled() && 
                    have_access( 'module' => $module, 'procedure' => 'IMPORT',
                                 'user' => $user );
    }
    #    public --   ,
    #   -- 
    else
    {
      $can_export = export_enabled() && 
                    have_access( 'module' => $module, 'procedure' => 'EXPORT',
                                 'user' => $user );
    }

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th> </th>\n";
    print "<th> </th>\n";
    print "<th> &mdash;   (  )</th>\n";
    print "<th> </th>\n";
    print "<th> </th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete || $can_export ||
                                   $can_import );
    print "</tr>\n";

    #          
    #    --   ...
    if ( $query->param( 'enable_select' ) )
    {
      # ...    JavaScript    
      #     Confs     ...
      if ( $query->param( 'caller_name' ) eq 'CONFS' )
      {
        # ...  conf_code_orig  conf_fname_orig   CONFS
        create_assign_values_func( 'conf_code_orig', 'conf_fname_orig' );
      }
    }

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #   ,  ,   
      #  --  ,    
      # (  &nbsp;   ,   ,
      #   :    'conf_code_orig'
      #  null,     -)
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( 'conf_code' ) ]</td>\n";

      #         
      #      --  ,
      #    conf_fname    

      #     "" 
      # (.    obj_groups_descrs.pl)
      #     , . . , 
      #   escapeHTML(), 
      my $conf_fname = $row[ $result->fnumber( 'conf_fname' ) ];
      $conf_fname =~ s/\'/\\\'/g;
      $conf_fname = CGI::escapeHTML( $conf_fname );

      if ( $query->param( 'enable_select' ) )
      {
        print "<td>",
              qq{ <a class="command_link" href="javascript:void( 0 )" onclick=
                  "assign_values( $row[ $result->fnumber( 'conf_code' ) ],
                                  '$conf_fname' )">
                   $row[ $result->fnumber( 'conf_fname' ) ]</a> },
              "</td>\n";
      }
      else
      {
        print "<td>$row[ $result->fnumber( 'conf_fname' ) ]</td>\n";
      }

      print "<td>",
            ( $row[ $result->fnumber( 'conf_code_orig' ) ] ne undef ) ?
              "(" . $row[ $result->fnumber( 'conf_code_orig' ) ] . ") " .
              $row[ $result->fnumber( 'conf_fname_orig' ) ] :
            "&nbsp;",
            "</td>\n";
      print "<td>" .
            date_for_display( $row[ $result->fnumber( 'conf_date_beg' ) ] ) .
            "</td>\n";
      print "<td>" .
            date_for_display( $row[ $result->fnumber( 'conf_date_end' ) ] ) .
            "</td>\n";

      #   HTML-
      $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
              "city_code=" . $row[ $result->fnumber( 'city_code' ) ] .
              $add_params;

      #      
      print "<td>" if ( $can_view || $can_delete || $can_export ||
                        $can_import );
      print qq{ <a class="command_link" href="$script_name/view?$href"} .
            qq{ target="_self"></a> } . "\n" if $can_view;

      #    
      print qq{ <a class="command_link" href="$script_name/delete?$href"} .
            qq{ onclick="$confirm_delete" } .
            qq{ target="_self"></a> } . "\n" if $can_delete;

      #   
      print qq{ <a class="command_link" href="$script_name/export?$href"} .
            qq{ onclick="$confirm_export"} .
            qq{ target="_blank"></A> } . "\n" if $can_export;

      #   
      print qq{ <a class="command_link" href="$script_name/import?$href"} .
            qq{ onclick="$confirm_import"} .
            qq{ target="_blank"></A> } . "\n" if $can_import;

      print "</td>" if ( $can_view || $can_delete || $can_export ||
                         $can_import );
      print "</tr>\n";
    }
    print "</table>\n";
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $conf_code;             #  
  my $command;               #      

  $conf_code = $query->param( 'conf_code' );

  #     
  $command = "SELECT c1.*, c2.conf_fname AS conf_fname_orig " .
             "FROM ( ${db_schema}confs c1 LEFT JOIN ${db_schema}confs c2 " .
                  "ON c1.conf_code_orig = c2.conf_code ) " .
             "WHERE c1.conf_code = '$conf_code'"; 

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => "_self",
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "         " .
                     " " . $conf_code,
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "confs",
                       key => "conf_code:conf_code_begin",
                       f_names => \@f_names,
                       f_special => [ 'conf_date_beg', 'conf_date_end',
                                      'conf_foreign_flag' ],
                       func_special => \&non_std_fields,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  #      (    
  #   )
  my( $ref_values_stats, $ref_labels_stats ) =
    popup_conf_status_types_list( $db_schema );

  #      (    
  #  )
  my( $ref_values_types, $ref_labels_types ) =
    popup_conf_types_list( $db_schema );

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #   

    #   () 
    $fields{ 'conf_fname' }        = $CFG{ CONFS_CONF_FNAME };

    #   (     )
    $fields{ 'conf_place' }        = $CFG{ CONFS_CONF_PLACE };

    #    
    $fields{ 'conf_date_beg' }     = $CFG{ CONFS_CONF_DATE_BEG };

    #    
    $fields{ 'conf_date_end' }     = $CFG{ CONFS_CONF_DATE_END };

    #    (,  ...)
    $fields{ 'conf_status_code' }  = $CFG{ CONFS_CONF_STATUS_CODE };

    #   , . .   )
    $fields{ 'conf_foreign_flag' } = $CFG{ CONFS_CONF_FOREIGN_FLAG };

    #    (, ,  ...)
    $fields{ 'conf_type_code' }    = $CFG{ CONFS_CONF_TYPE_CODE };

    #  
    $fields{ 'conf_num' }          = $CFG{ CONFS_CONF_NUM };

    #    (  , )
    $fields{ 'conf_code_orig' }    = $CFG{ CONFS_CONF_CODE_ORIG };

    # 
    $fields{ 'comment' }           = $CFG{ CONFS_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  #     "  "
  # .      'begin'  ,
  #                   ,  
  #               (.  make_cmd   E_ARCH.pm.
  #             ..       ,   
  #              (, ,   ).
  print $query->hidden( -name => 'conf_code_begin',
                        -default => $fields{ 'conf_code' }
                      ), "\n";

  #       ,     
  #           ,
  #        ,   
  #  ,     
  # . .    cities.pl.
  print $query->hidden( -name => 'enable_select' ), "\n";
  print $query->hidden( -name => 'caller_name' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th> </th>\n";

  #      JavaScript,  
  #  orgs.pl   -  
  create_selection_func( func_name => 'select_org',
                         module_name => 'orgs.pl',
                         caller_name => $module,
                         window_name => 'orgs',
                         exp_imp => $query->param( 'exp_imp' ) );
  print "<td>",
        $query->textfield( -name => 'conf_code',
                           -default => $fields{ 'conf_code' },
                           -size => $CFG{ CONFS_CONF_CODE_SIZE },
                           -maxlength => $CFG{ CONFS_CONF_CODE_MAXLENGTH }
                         ),
        "&nbsp;&nbsp;",
        qq{ <a class="command_link" href="javascript:void( 0 )"} .
        qq{ onclick="select_org()"></a>},
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>";
  
  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].conf_fname", "CONFS_CONF_FNAME" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'conf_fname',
                          -default => $fields{ 'conf_fname' },
                          -rows => $CFG{ CONFS_CONF_FNAME_ROWS },
                          -columns => $CFG{ CONFS_CONF_FNAME_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].conf_place", "CONFS_CONF_PLACE" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'conf_place',
                           -default => $fields{ 'conf_place' },
                           -size => $CFG{ CONFS_CONF_PLACE_SIZE },
                           -maxlength => $CFG{ CONFS_CONF_PLACE_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].conf_date_beg", "CONFS_CONF_DATE_BEG",
                   'REPLACE' ) if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'conf_date_beg',
                           -default =>
                              date_for_display( $fields{ 'conf_date_beg' } ),
                           -size => $CFG{ CONFS_CONF_DATE_BEG_SIZE },
                           -maxlength => $CFG{ CONFS_CONF_DATE_BEG_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>";
  
  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].conf_date_end", "CONFS_CONF_DATE_END",
                   'REPLACE' ) if $CFG{ HOT_HELP_IS_ON };
  
  print $query->textfield( -name => 'conf_date_end',
                           -default =>
                              date_for_display( $fields{ 'conf_date_end' } ),
                           -size => $CFG{ CONFS_CONF_DATE_END_SIZE },
                           -maxlength => $CFG{ CONFS_CONF_DATE_END_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  #        labels  
  # ,    popup_conf_status_types_list() 
  #  ,   -   
  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>",
        $query->popup_menu( -name => 'conf_status_code',
                            -default => $fields{ 'conf_status_code' },
                            -values => $ref_values_stats,
                            -labels => { @{ $ref_labels_stats } }
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>",
        $query->checkbox( -name => 'conf_foreign_flag',
                          -checked => 
                             $fields{ 'conf_foreign_flag' } eq 't' ? '1' : '0',
                          -value => 'yes',
                          -label => ''
                        ),
        "</td>\n";
  print "</tr>\n";

  #        labels  
  # ,    popup_conf_types_list()   ,
  #   -   
  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>",
        $query->popup_menu( -name => 'conf_type_code',
                            -default => $fields{ 'conf_type_code' },
                            -values => $ref_values_types,
                            -labels => { @{ $ref_labels_types } }
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].conf_num", "CONFS_CONF_NUM" )
    if $CFG{ HOT_HELP_IS_ON };
  
  print $query->textfield( -name => 'conf_num',
                           -default => $fields{ 'conf_num' },
                           -size => $CFG{ CONFS_CONF_NUM_SIZE },
                           -maxlength => $CFG{ CONFS_CONF_NUM_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> &mdash;   ()</th>\n";

  #      JavaScript,  
  #  orgs.pl   -  
  create_selection_func( func_name => 'select_conf',
                         module_name => 'confs.pl',
                         caller_name => $module,
                         window_name => 'confs',
                         exp_imp => $query->param( 'exp_imp' ) );
  print "<td>",
        $query->textfield( -name => 'conf_code_orig',
                           -default => $fields{ 'conf_code_orig' },
                           -size => $CFG{ CONFS_CONF_CODE_ORIG_SIZE },
                           -maxlength => $CFG{ CONFS_CONF_CODE_ORIG_MAXLENGTH }
                         ),
        "&nbsp;&nbsp;",
        qq{ <a class="command_link" href="javascript:void( 0 )"} .
        qq{ onclick="select_conf()"></a>},
        "</td>\n";
  print "</tr>\n";

  #     --  
  # (  )
  print "<tr>\n";
  print "<th> &mdash;   ()</th>\n";
  print "<td>", 
        $query->textarea( -name => 'conf_fname_orig',
                          -default => $fields{ 'conf_fname_orig' },
                          -rows => $CFG{ CONFS_CONF_FNAME_ORIG_ROWS },
                          -columns => $CFG{ CONFS_CONF_FNAME_ORIG_COLS },
                          -readonly => 'readonly'
                        ),
        "</td>\n";
  print "</tr>\n";

  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";
  
  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment", "CONFS_COMMENT" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ CONFS_COMMENT_ROWS },
                          -columns => $CFG{ CONFS_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
  return ( 0 );
}

# -----------------------------------------------------------------------------
#   ,    
#  -      
# -----------------------------------------------------------------------------
sub non_std_fields
{
  # :
  my $fname = shift;  #  
                      #   -   ( 
                      #  ).      
  my $value;
  
  #   
  if ( $fname eq 'conf_date_beg' || $fname eq 'conf_date_end' )
  {
    $value = date_for_db( $query->param( $fname ) );
  }
  elsif ( $fname eq 'conf_foreign_flag' )
  {
    #     bool,    
    #   
    $value = $query->param( $fname ) ? 'yes' : 'no';
  }

  return ( $value );  
}
