#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :   " ()   "
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'CONTENTS';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Contents
my @f_names =
   ( 'obj_id',            #   
                          #  
     'bib_rec_num',       #  .    
                          # (    0)
     'order_num',         #     
                          # ()   ()
     'unit_num',          #  , , , ...
     'authors',           # , , , ...
     'unit_title',        # , 
     'class_codes',       #   ,  ...
     'spec_mat_code',     #    
                          # (..   : , , ...)
     'location',          #     
                          # .  ( , ...)
     'amount',            #  : , 24 (),
                          # 11 () (   )
     'duration',          #   ( -  )
     'side',              #   ( )
     'analytic_obj_id',   #   
                          #  (   
                          #   )
     'comment'            # 
   );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              print_add_info => \&print_add_info,
              action => $script_name
            );

exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  if ( $query->param( 'order_num' ) !~ /^\d+$/ )
  {
    push( @error_messages, "      " .
          "    ()" );
  }

  if ( $query->param( 'unit_title' ) eq '' )
  {
    push( @error_messages, "  , " );
  }

  if ( $query->param( 'spec_mat_code' ) !~ /^\d+$/ )
  {
    push( @error_messages, "      " .
          " " );
  }

  if ( ! ( $query->param( 'side' ) eq '' ||
           $query->param( 'side' ) eq '1' ||
           $query->param( 'side' ) eq '2'
         )
     )
  {
    push( @error_messages, "   ( )" );
  }

  #     
  if ( $query->param( 'analytic_obj_id' ) !~ /^\d*$/ )
  {
    push( @error_messages, "    " .
          ".  (      " .
          ")" );
  }

  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }
  
  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => '  ()',
                    user => $user,
                    full_top => 'no'
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $order_num;          #      ()
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id      = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );
  $order_num   = $query->param( 'order_num' );
  $target_win  = $query->param( 'target_win' );

  #         
  $command = "DELETE FROM ${db_schema}contents " .
             "WHERE obj_id = '$obj_id' AND " .
                   "bib_rec_num = '$bib_rec_num' AND " .
                   "order_num = '$order_num'";

  #   
  del_rec( query => $query,
           target => $target_win,
           create_top => \&create_top,
           print_add_info => \&print_add_info,
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#      ()  
# -----------------------------------------------------------------------------
sub do_query
{
  # .        
  #              bib_recs.pl.

  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $bib_rec;            # . 
  my $target_win;         #      HTML-
  my( $result, $i );      #    
  my @row;                #      
  my $command;            #      
  my $href;               #   HTML-

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #  ,        
  my $alt_row = 1;

  $obj_id      = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );
  $bib_rec     = $query->param( 'bib_rec' );
  $target_win  = $query->param( 'target_win' );

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => $target_win );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  print_add_info(); #     

  #  ,    
  $bib_rec = CGI::escape( $bib_rec );

  #   HTML-
  $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
          "obj_id=$obj_id" .
          "&bib_rec_num=$bib_rec_num" .
          "&bib_rec=$bib_rec" .
          "&target_win=$target_win";

  #      ()  
  $command = "SELECT * " .
             "FROM ${db_schema}contents " .
             "WHERE obj_id = '$obj_id' AND " .
                   "bib_rec_num = '$bib_rec_num' " .
             "ORDER BY order_num";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                             'user' => $user );
    $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                               'user' => $user );

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th>    </th>\n";
    print "<th> , , </th>\n";
    print "<th>, , , ...</th>\n";
    print "<th>, </th>\n";
    print "<th>, ...</th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete );
    print "</tr>\n";

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #      ,   (,
      # ),  (  ..),  (),
      #  ( )
      # (  &nbsp;   "  ()", ", ...",
      # "  ..."   :  
      #    null,    
      # -)
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( 'order_num' ) ]</td>\n";
      print "<td>$row[ $result->fnumber( 'unit_num' ) ]&nbsp;</td>\n";
      print "<td>$row[ $result->fnumber( 'authors' ) ]&nbsp;</td>\n";
      print "<td>$row[ $result->fnumber( 'unit_title' ) ]</td>\n";
      print "<td>$row[ $result->fnumber( 'location' ) ]&nbsp;</td>\n";

      #        
      print "<td>" if ( $can_view || $can_delete );
      print qq{<a class="command_link" href="$script_name/view?$href} .
            "&order_num=" . $row[ $result->fnumber( 'order_num' ) ] . "\"" .
            qq{ target="$target_win"></a>} if $can_view;
      print "\n" if $can_view;

      #     
      print qq{<a class="command_link" href="$script_name/delete?$href} .
            "&order_num=" . $row[ $result->fnumber( 'order_num' ) ] . "\"" .
            qq{ onclick="$confirm_delete"} .
            qq{ target="$target_win"></a>} if $can_delete;
      print "</td>\n" if ( $can_view || $can_delete );

      print "</tr>\n";
    }
    print "</table>\n";
  }

  #       
  #          "/"
  if ( ! $query->param( 'exp_imp' ) &&
       have_access( 'module' => $module, 'procedure' => 'ADD', 
                    'user' => $user ) )
  {
    print "<br />\n";
    print qq{<a class="command_link" href="$script_name/add?$href"} .
          qq{ target="$target_win"> </a>};
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $order_num;          #      ()
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id      = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );
  $order_num   = $query->param( 'order_num' );
  $target_win  = $query->param( 'target_win' );

  #      ()  
  $command = "SELECT * " .
             "FROM ${db_schema}contents " .
             "WHERE obj_id = '$obj_id' AND " .
                   "bib_rec_num = '$bib_rec_num' AND " .
                   "order_num = '$order_num'";

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => $target_win,
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "        : " .
                     "   .  - " .
                     $obj_id . ", " .
                     " .     - " .
                     $bib_rec_num . ", " .
                     "     - $order_num",
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "contents",
                       key => "obj_id, bib_rec_num, " .
                              "order_num:order_num_begin",
                       f_names => \@f_names,
                       f_special => undef,
                       func_special => undef,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  #      (    
  #  . . )
  my( $ref_values, $ref_labels ) = popup_spec_mater_types_list( $db_schema );

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
    # "  ( )"   , 
    #       null
    $fields{ 'side' } = '' if $fields{ 'side' } eq undef;
  }
  else                      #      
  {
    #        
    $fields{ 'obj_id' }      = $query->param( 'obj_id' );
    $fields{ 'bib_rec_num' } = $query->param( 'bib_rec_num' );

    #   

    #      ()   ()
    if ( $CFG{ CONTENTS_ORDER_NUM } )  #    . 
    {
      $fields{ 'order_num' } = $CFG{ CONTENTS_ORDER_NUM };
    }
    else
    {
      #      order_num  
      # ,   1      
      #    .    . 
      # (   obj_id  bib_rec_num   Contents)
      $fields{ 'order_num' } = 
        get_next_key_value( 'contents', 'order_num',
                            'obj_id = ' . $query->param( 'obj_id' ) . ' AND ' .
                            'bib_rec_num = ' . $query->param( 'bib_rec_num' )
                          );
    }

    #  , , , ...
    $fields{ 'unit_num' }        = $CFG{ CONTENTS_UNIT_NUM };

    # , , , ...
    $fields{ 'authors' }         = $CFG{ CONTENTS_AUTHORS };

    # , 
    $fields{ 'unit_title' }      = $CFG{ CONTENTS_UNIT_TITLE };

    #   ,  ...
    $fields{ 'class_codes' }     = $CFG{ CONTENTS_CLASS_CODES };

    #    
    # (..   : , , ...)
    $fields{ 'spec_mat_code' }   = $CFG{ CONTENTS_SPEC_MAT_CODE };

    #      . 
    # ( , ...)
    $fields{ 'location' }        = $CFG{ CONTENTS_LOCATION };

    #  : , 24 (), 11 () ( 
    #  )
    $fields{ 'amount' }          = $CFG{ CONTENTS_AMOUNT };

    #   ( -  )
    $fields{ 'duration' }        = $CFG{ CONTENTS_DURATION };
    
    #   ( )
    $fields{ 'side' }            = $CFG{ CONTENTS_SIDE };
    
    #     (  
    #    )
    $fields{ 'analytic_obj_id' } = $CFG{ CONTENTS_ANALYTIC_OBJ_ID };

    # 
    $fields{ 'comment' }         = $CFG{ CONTENTS_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  #    "  
  #  "  " .   
  # "   ,     ,
  #     , ..    
  #  UPDATE   ,      INSERT
  # (     ,    
  #   ,      )
  print $query->hidden( -name => 'obj_id' ), "\n";
  print $query->hidden( -name => 'bib_rec_num' ), "\n";

  #     "    "
  # .      'begin'  ,
  #                   ,  
  #               (.  make_cmd   E_ARCH.pm).
  #             ..       ,   
  #              (, ,   ).
  print $query->hidden( -name => 'order_num_begin',
                        -default => $fields{ 'order_num' }
                      ), "\n";

  #      .  
  #  ,     add_rec()  update_rec()
  print $query->hidden( -name => 'bib_rec' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print_add_info();           #     

  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th>    </th>\n";
  print "<td>",
        $query->textfield( -name => 'order_num',
                           -default => $fields{ 'order_num' },
                           -size => $CFG{ CONTENTS_ORDER_NUM_SIZE },
                           -maxlength => $CFG{ CONTENTS_ORDER_NUM_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> , , , ...</th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].unit_num", "CONTENTS_UNIT_NUM" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'unit_num',
                           -default => $fields{ 'unit_num' },
                           -size => $CFG{ CONTENTS_UNIT_NUM_SIZE },
                           -maxlength => $CFG{ CONTENTS_UNIT_NUM_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>, , , ...</th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].authors", "CONTENTS_AUTHORS" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'authors',
                          -default => $fields{ 'authors' },
                          -rows => $CFG{ CONTENTS_AUTHORS_ROWS },
                          -columns => $CFG{ CONTENTS_AUTHORS_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>, </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].unit_title", "CONTENTS_UNIT_TITLE" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'unit_title',
                          -default => $fields{ 'unit_title' },
                          -rows => $CFG{ CONTENTS_UNIT_TITLE_ROWS },
                          -columns => $CFG{ CONTENTS_UNIT_TITLE_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  ,  ...</th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].class_codes", "CONTENTS_CLASS_CODES" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'class_codes',
                           -default => $fields{ 'class_codes' },
                           -size => $CFG{ CONTENTS_CLASS_CODES_SIZE },
                           -maxlength => $CFG{ CONTENTS_CLASS_CODES_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  #        labels  
  # ,    popup_spec_mater_types_list() 
  #  ,   -   
  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>",
        $query->popup_menu( -name => 'spec_mat_code',
                            -default => $fields{ 'spec_mat_code' },
                            -values => $ref_values,
                            -labels => { @{ $ref_labels } }
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>      " .
            " ( , ...)</th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].location", "CONTENTS_LOCATION" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'location',
                           -default => $fields{ 'location' },
                           -size => $CFG{ CONTENTS_LOCATION_SIZE },
                           -maxlength => $CFG{ CONTENTS_LOCATION_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  (   )<br />" .
            ", 24 (), 11 () </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].amount", "CONTENTS_AMOUNT" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'amount',
                           -default => $fields{ 'amount' },
                           -size => $CFG{ CONTENTS_AMOUNT_SIZE },
                           -maxlength => $CFG{ CONTENTS_AMOUNT_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  ( -  )</th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].duration", "CONTENTS_DURATION" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'duration',
                           -default => $fields{ 'duration' },
                           -size => $CFG{ CONTENTS_DURATION_SIZE },
                           -maxlength => $CFG{ CONTENTS_DURATION_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  ( )</th>\n";
  print "<td>",
        $query->popup_menu( -name => 'side',
                            -default => $fields{ 'side' },
                            -values => [ '1', '2', '' ],
                            -labels => { '1' => ' 1',
                                         '2' => ' 2',
                                         ''  => '-' }
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>     " .
            "(      )" .
            "</th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].analytic_obj_id",
                   "CONTENTS_ANALYTIC_OBJ_ID", "REPLACE" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'analytic_obj_id',
                           -default => $fields{ 'analytic_obj_id' },
                           -size => $CFG{ CONTENTS_ANALYTIC_OBJ_ID_SIZE },
                           -maxlength => 
                             $CFG{ CONTENTS_ANALYTIC_OBJ_ID_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment", "CONTENTS_COMMENT" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ CONTENTS_COMMENT_ROWS },
                          -columns => $CFG{ CONTENTS_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
  return ( 0 );
}

# -----------------------------------------------------------------------------
#          
# -----------------------------------------------------------------------------
sub print_add_info
{
  #  .    
  print_bib_record( $query, " ()" );
  
  return ( 0 );
}
