#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :    ""
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'CURRENCIES';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Currencies
my @f_names =
   ( 'currency_code',      #  
     'currency_fname',     #   
     'currency_sname',     #   
     'country_code',       #  
     'currency_date',      #    
     'currency_code_orig', #  ,   
                           # (  , ,
                           #    )
     'lang_code',          #   (1 -  )
     'comment'             # 
   );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              do_find => \&do_find,
              do_export => \&do_export,
              do_import => \&do_import,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              action => $script_name
            );

exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  if ( $query->param( 'currency_code' ) eq '' )
  {
    push( @error_messages, "   " );
  }

  if ( $query->param( 'currency_fname' ) eq '' )
  {
    push( @error_messages, "    " );
  }

  if ( $query->param( 'currency_sname' ) eq '' )
  {
    push( @error_messages, "    " );
  }

  if ( $query->param( 'country_code' ) eq '' )
  {
    push( @error_messages, "   " );
  }

  #   
  if ( $query->param( 'currency_date' ) ne '' &&
       ! date_is_correct( $query->param( 'currency_date' ) ) )
  {
    push( @error_messages, "    " );
  }

  #    ,   
  if ( $query->param( 'currency_code_orig' ) !~ /^\d*$/ )
  {
    push( @error_messages, "  ,   " );
  }

  if ( $query->param( 'lang_code' ) eq '' )
  {
    push( @error_messages, "   " );
  }

  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }
  
  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => '',
                    user => $user
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $currency_code;         #  
  my $command;               #      

  $currency_code = $query->param( 'currency_code' );
  
  #         
  $command = "DELETE FROM ${db_schema}currencies " .
             "WHERE currency_code = '$currency_code'";

  #   
  del_rec( query => $query,
           create_top => \&create_top,
           target => "_self",
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_export
{
  my $currency_code;         #  
  my $command;               #      
  my @table_cmd_pairs = ();  #     ,
                             #       

  $currency_code = $query->param( 'currency_code' );

  #  -       
  #    (      , 
  #     )
  $command = "SELECT * FROM Currencies WHERE currency_code = $currency_code";
  push( @table_cmd_pairs, [ 'Currencies', $command ] );

  #    
  export_data( query => $query,
               create_top => \&create_top,
               table_cmd_pairs => \@table_cmd_pairs
             );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_find
{
  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();       #     
  create_top();     #    
  close_top();      #     
  
  open_bottom();    #     
  
  print "<p class=\"info\">     </p>\n";

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_import
{
  my $currency_code;         #  
  my $command;               #      
  my @table_cmd_pairs = ();  #     ,
                             #       

  $currency_code = $query->param( 'currency_code' );

  #  -       
  #    (      , 
  #     )
  $command = "SELECT * FROM exp_imp.Currencies " .
             "WHERE currency_code = $currency_code";
  push( @table_cmd_pairs, [ 'Currencies', $command ] );

  #    
  import_data( query => $query,
               create_top => \&create_top,
               table_cmd_pairs => \@table_cmd_pairs
             );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub do_query
{
  my( $result, $i );              #    
  my @row;                        #      
  my $command;                    #      

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #      / 
  my $can_export = 0;
  my $can_import = 0;

  #        
  #   ( --      
  #   )
  my $add_params = '';

  #  ,        
  my $alt_row = 1;

  my $href;    #   HTML-

  #         
  #  enable_select  caller_name (  )
  if ( $query->param( 'enable_select' ) )
  {
    $add_params = "&enable_select=1&caller_name=" .
                  $query->param( 'caller_name' );
  }

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  #      (     
  #   ,     )
  $command = "SELECT c1.*, c2.currency_fname AS currency_fname_orig, " .
                    "cc.country_sname, l.lang_sname " .
             "FROM ( ${db_schema}currencies c1 " .
                    "LEFT JOIN ${db_schema}currencies c2 " .
                    "ON c1.currency_code_orig = c2.currency_code ), " .
                    "${db_schema}countries cc, ${db_schema}langs l " .
             "WHERE c1.lang_code = l.lang_code and " .
                   "c1.country_code = cc.country_code " .
             "ORDER BY c1.currency_fname";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    #       ,     
    # "  ",       
    # (      ,
    #     )
    if ( $query->param( 'enable_select' ) &&
         $query->param( 'caller_name') eq $module )
    {
      $can_view = 0;
      $can_delete = 0;
    }
    else
    {
      $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                               'user' => $user );
      $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                                 'user' => $user );
    }

    #     "/",     
    if ( $query->param( 'exp_imp' ) )
    {
      $can_import = import_enabled() && 
                    have_access( 'module' => $module, 'procedure' => 'IMPORT',
                                 'user' => $user );
    }
    #    public --   ,
    #   -- 
    else
    {
      $can_export = export_enabled() && 
                    have_access( 'module' => $module, 'procedure' => 'EXPORT',
                                 'user' => $user );
    }

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th> </th>\n";
    print "<th> </th>\n";
    print "<th> &mdash;   (  )</th>\n";
    print "<th></th>\n";
    print "<th></th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete || $can_export ||
                                   $can_import );
    print "</tr>\n";

    #          
    #     ...
    if ( $query->param( 'enable_select' ) )
    {
      # ...    JavaScript    
      #     Currencies     ...
      if ( $query->param( 'caller_name' ) eq 'CURRENCIES' )
      {
        # ...  currency_code_orig  currency_fname_orig   
        # CURRENCIES
        create_assign_values_func( 'currency_code_orig', 
                                   'currency_fname_orig' );
      }
    }

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #   ,  ,     --
      #  , , ,     
      # (  &nbsp;   ,   ,
      #   :    'currency_code_orig'
      #  null,     -)
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( 'currency_code' ) ]</td>\n";

      #         
      #     ,   
      # currency_fname    
      if ( $query->param( 'enable_select' ) )
      {
        print "<td>",
              qq{ <a class="command_link" href="javascript:void( 0 )" onclick=
                  "assign_values( $row[ $result->fnumber( 'currency_code' ) ],
                                  '$row[ $result->fnumber( 'currency_fname' )
                                       ]'
                                )">
                   $row[ $result->fnumber( 'currency_fname' ) ]</a> },
              "</td>\n";
      }
      else
      {
        print "<td>$row[ $result->fnumber( 'currency_fname' ) ]</td>\n";
      }

      #  ,   , ,  
      #    "&nbsp;"
      print "<td>",
            ( $row[ $result->fnumber( 'currency_code_orig' ) ] ne undef ) ?
              "(" . $row[ $result->fnumber( 'currency_code_orig' ) ] . ") " .
              $row[ $result->fnumber( 'currency_fname_orig' ) ] :
            "&nbsp;",
            "</td>\n";

      print "<td>$row[ $result->fnumber( 'country_sname' ) ]</td>\n";
      print "<td>$row[ $result->fnumber( 'lang_sname' ) ]</td>\n";

      #   HTML-
      $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
              "currency_code=" . $row[ $result->fnumber( 'currency_code' ) ] .
              $add_params;

      #      
      print "<td>" if ( $can_view || $can_delete || $can_export ||
                        $can_import );
      print qq{ <a class="command_link" href="$script_name/view?$href"} .
            qq{ target="_self"></a> } . "\n" if $can_view;

      #    
      print qq{ <a class="command_link" href="$script_name/delete?$href"} .
            qq{ onclick="$confirm_delete" } .
            qq{ target="_self"></a> } . "\n" if $can_delete;

      #   
      print qq{ <a class="command_link" href="$script_name/export?$href"} .
            qq{ onclick="$confirm_export"} .
            qq{ target="_blank"></A> } . "\n" if $can_export;

      #   
      print qq{ <a class="command_link" href="$script_name/import?$href"} .
            qq{ onclick="$confirm_import"} .
            qq{ target="_blank"></A> } . "\n" if $can_import;

      print "</td>" if ( $can_view || $can_delete || $can_export ||
                         $can_import );
      print "</tr>\n";
    }
    print "</table>\n";
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $currency_code;         #  
  my $command;               #      

  $currency_code = $query->param( 'currency_code' );

  #     
  #    ,   
  $command = "SELECT c1.*, c2.currency_fname AS currency_fname_orig " .
             "FROM ${db_schema}currencies c1 " .
                  "LEFT JOIN ${db_schema}currencies c2 " .
                  "ON c1.currency_code_orig = c2.currency_code " .
             "WHERE c1.currency_code = '$currency_code'"; 

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => "_self",
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "         " .
                     " " . $currency_code,
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "currencies",
                       key => "currency_code",
                       f_names => \@f_names,
                       f_special => [ 'currency_date' ],
                       func_special => \&non_std_fields,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  #      (    
  # ,  )
  my( $ref_values_countries, $ref_labels_countries ) =
    popup_countries_list( $db_schema );

  #      (    
  # ,     )
  my( $ref_values_langs, $ref_labels_langs ) = popup_langs_list( $db_schema );

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #         ,
    #   1        
    $fields{ 'currency_code' } = get_next_key_value( 'currencies',
                                                     'currency_code' );
    #   

    #   
    $fields{ 'currency_fname' }     = $CFG{ CURRENCIES_CURRENCY_FNAME };

    #   
    $fields{ 'currency_sname' }     = $CFG{ CURRENCIES_CURRENCY_SNAME };
    
    #  
    $fields{ 'country_code' }       = $CFG{ CURRENCIES_COUNTRY_CODE };
    
    #    
    $fields{ 'currency_date' }      = $CFG{ CURRENCIES_CURRENCY_DATE };
    
    #  ,   
    # (  , ,    )
    $fields{ 'currency_code_orig' } = $CFG{ CURRENCIES_CURRENCY_CODE_ORIG };

    #   (1 -  )
    $fields{ 'lang_code' }          = $CFG{ CURRENCIES_LANG_CODE };
    
    # 
    $fields{ 'comment' }            = $CFG{ CURRENCIES_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  #    " "  
  #    get_next_key_value(),    
  # ,     , ..  
  #    UPDATE   
  print $query->hidden( -name => 'currency_code',
                        -default => $fields{ 'currency_code' }
                      ), "\n";

  #       ,     
  #           ,
  #        ,   
  #  ,     
  print $query->hidden( -name => 'enable_select' ), "\n";
  print $query->hidden( -name => 'caller_name' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>", $fields{ 'currency_code' }, "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>",
        $query->textfield( -name => 'currency_fname',
                           -default => $fields{ 'currency_fname' },
                           -size => $CFG{ CURRENCIES_CURRENCY_FNAME_SIZE },
                           -maxlength =>
                             $CFG{ CURRENCIES_CURRENCY_FNAME_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>",
        $query->textfield( -name => 'currency_sname',
                           -default => $fields{ 'currency_sname' },
                           -size => $CFG{ CURRENCIES_CURRENCY_SNAME_SIZE },
                           -maxlength =>
                             $CFG{ CURRENCIES_CURRENCY_SNAME_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  #        labels  
  # ,    popup_countris_list()   ,
  #   -   
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>",
        $query->popup_menu( -name => 'country_code',
                            -default => $fields{ 'country_code' },
                            -values => $ref_values_countries,
                            -labels => { @{ $ref_labels_countries } }
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>",
        $query->textfield( -name => 'currency_date',
                           -default =>
                              date_for_display( $fields{ 'currency_date' } ),
                           -size => $CFG{ CURRENCIES_CURRENCY_DATE_SIZE },
                           -maxlength =>
                             $CFG{ CURRENCIES_CURRENCY_DATE_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> &mdash;   (  )</th>\n";

  #      JavaScript,  
  # - currencies.pl
  create_selection_func( func_name => 'select_orig_currency',
                         module_name => 'currencies.pl',
                         caller_name => $module,
                         window_name => 'orig_currencies',
                         exp_imp => $query->param( 'exp_imp' ) );

  #    ,   
  # (  )
  print "<td>",
        $query->textfield( -name => 'currency_code_orig',
                           -default => $fields{ 'currency_code_orig' },
                           -size => $CFG{ CURRENCIES_CURRENCY_CODE_ORIG_SIZE },
                           -maxlength =>
                             $CFG{ CURRENCIES_CURRENCY_CODE_ORIG_MAXLENGTH }
                         ),
        "&nbsp;&nbsp;",
        $query->textfield( -name => 'currency_fname_orig',
                           -default => $fields{ 'currency_fname_orig' },
                           -size =>
                             $CFG{ CURRENCIES_CURRENCY_FNAME_ORIG_SIZE },
                           -maxlength =>
                             $CFG{ CURRENCIES_CURRENCY_FNAME_ORIG_MAXLENGTH },
                           -readonly => 'readonly'
                         ),
        "&nbsp;&nbsp;",
        qq{ <a class="command_link" href="javascript:void( 0 )" onclick=
            "select_orig_currency()">} . "</a>",
        "</td>\n";
  print "</tr>\n";
  
  #        labels  
  # ,    popup_langs_list()   ,
  #   -   
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>",
        $query->popup_menu( -name => 'lang_code',
                            -default => $fields{ 'lang_code' },
                            -values => $ref_values_langs,
                            -labels => { @{ $ref_labels_langs } }
                          ),
        "</td>\n";
  print "</tr>\n";
  
  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment",
                   "CURRENCIES_COMMENT" ) if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ CURRENCIES_COMMENT_ROWS },
                          -columns => $CFG{ CURRENCIES_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
  return ( 0 );
}

# -----------------------------------------------------------------------------
#   ,    
#  -      
# -----------------------------------------------------------------------------
sub non_std_fields
{
  # :
  my $fname = shift;  #  
                      #   -   ( 
                      #  ).      

  my $value;
  
  #   
  if ( $fname eq 'currency_date' )
  {
    $value = date_for_db( $query->param( $fname ) );
  }

  return ( $value );  
}
