#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :   "    "
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'DET_CHARS';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Det_chars
my @f_names =
   ( 'obj_id',           #   
                         #  
     'det_char_code',    #   ()
     'assessment_date',  #   
     'det_char_mark',    #     10- 
     'comment'           # 
   );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              print_add_info => \&print_add_info,
              action => $script_name
            );

exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  if ( $query->param( 'det_char_code' ) eq '' )
  {
    push( @error_messages, "    ()" );
  }

  #    
  if ( ! date_is_correct( $query->param( 'assessment_date' ) ) )
  {
    push( @error_messages, "   " );
  }

  if ( ! ( $query->param( 'det_char_mark' ) =~ /^\d{1,2}$/ &&
           $query->param( 'det_char_mark' ) >= 1 &&
           $query->param( 'det_char_mark' ) <= 10
         )  
     )
  {
    push( @error_messages, "      " .
          "  10- " );
  }

  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }
  
  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => '  ()',
                    user => $user,
                    full_top => 'no'
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $obj_id;             #    . 
  my $det_char_code;      #   ()
  my $assessment_date;    #   
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id          = $query->param( 'obj_id' );
  $det_char_code   = $query->param( 'det_char_code' );
  $assessment_date = $query->param( 'assessment_date' );
  $target_win      = $query->param( 'target_win' );

  #         
  $command = "DELETE FROM ${db_schema}det_chars " .
             "WHERE obj_id = '$obj_id' AND " .
                   "det_char_code = '$det_char_code' AND " .
                   "assessment_date = '$assessment_date'";

  #   
  del_rec( query => $query,
           target => $target_win,
           create_top => \&create_top,
           print_add_info => \&print_add_info,
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#        
# -----------------------------------------------------------------------------
sub do_query
{
  # .        
  #              bib_recs.pl.

  my $obj_id;             #    . 
  my $bib_rec;            # . 
  my $target_win;         #      HTML-
  my( $result, $i );      #    
  my @row;                #      
  my $command;            #      
  my $href;               #   HTML-

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #  ,        
  my $alt_row = 1;

  $obj_id     = $query->param( 'obj_id' );
  $bib_rec    = $query->param( 'bib_rec' );
  $target_win = $query->param( 'target_win' );

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => $target_win );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  print_add_info(); #     

  #  ,    
  $bib_rec = CGI::escape( $bib_rec );

  #   HTML-
  $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
          "obj_id=$obj_id" .
          "&bib_rec=$bib_rec" .
          "&target_win=$target_win";

  #         
  # (    )
  $command = "SELECT dc.*, dt.det_char_sname " .
             "FROM ${db_schema}det_chars dc, ${db_schema}det_char_types dt " .
             "WHERE dc.obj_id = '$obj_id' AND " .
                   "dc.det_char_code = dt.det_char_code " .
             "ORDER BY dt.det_char_sname, dc.assessment_date";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                             'user' => $user );
    $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                               'user' => $user );

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th> ()</th>\n";
    print "<th>  </th>\n";
    print "<th>    10- </th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete );
    print "</tr>\n";

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #     (),  
      #  
      print "<td>$row[ $result->fnumber( 'det_char_sname' ) ]</td>\n";
      print "<td class=\"center\">",
            date_for_display( $row[ $result->fnumber( 'assessment_date' ) ] ),
            "</td>\n";
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( 'det_char_mark' ) ]</td>\n";

      #         
      print "<td>" if ( $can_view || $can_delete );
      print qq{<a class="command_link" href="$script_name/view?$href} .
            "&det_char_code=" . $row[ $result->fnumber( 'det_char_code' ) ] .
            "&assessment_date=" .
            $row[ $result->fnumber( 'assessment_date' ) ] . "\"" .
            qq{ target="$target_win"></a>} if $can_view;
      print "\n" if $can_view;

      #      
      print qq{<a class="command_link" href="$script_name/delete?$href} .
            "&det_char_code=" . $row[ $result->fnumber( 'det_char_code' ) ] .
            "&assessment_date=" .
            $row[ $result->fnumber( 'assessment_date' ) ] . "\"" .
            qq{ onclick="$confirm_delete"} .
            qq{ target="$target_win"></a>} if $can_delete;
      print "</td>\n" if ( $can_view || $can_delete );

      print "</tr>\n";
    }
    print "</table>\n";
  }

  #        
  #          "/"
  if ( ! $query->param( 'exp_imp' ) &&
       have_access( 'module' => $module, 'procedure' => 'ADD', 
                    'user' => $user ) )
  {
    print "<br />\n";
    print qq{<a class="command_link" href="$script_name/add?$href"} .
          qq{ target="$target_win"> </a>};
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $obj_id;             #    . 
  my $det_char_code;      #   ()
  my $assessment_date;    #   
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id          = $query->param( 'obj_id' );
  $det_char_code   = $query->param( 'det_char_code' );
  $assessment_date = $query->param( 'assessment_date' );
  $target_win      = $query->param( 'target_win' );

  #      
  $command = "SELECT * " .
             "FROM ${db_schema}det_chars " .
             "WHERE obj_id = '$obj_id' AND " .
                   "det_char_code = '$det_char_code' AND " .
                   "assessment_date = '$assessment_date'";

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => $target_win,
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "        : " .
                     "   .  - " .
                     $obj_id . ", " .
                     "  () - $det_char_code, " .
                     "   - $assessment_date",
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "det_chars",
                       key => "obj_id, det_char_code:det_char_code_begin, " .
                              "assessment_date:assessment_date_begin",
                       f_names => \@f_names,
                       f_special => [ 'assessment_date' ],
                       func_special => \&non_std_fields,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  #      (    
  #   )
  my( $ref_values, $ref_labels ) = popup_det_char_types_list( $db_schema );

  my( $day, $mon, $year );  #    

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #       
    $fields{ 'obj_id' } = $query->param( 'obj_id' );

    #   
    ( $day, $mon, $year ) = ( localtime() )[ 3..5 ];

    $fields{ 'assessment_date' } =
      sprintf( "%04d-%02d-%02d", $year + 1900, $mon + 1, $day );

    #   

    # 
    $fields{ 'comment' } = $CFG{ DET_CHARS_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  #    "  
  #  "   ,   
  #  ,     , ..   
  #   UPDATE   ,    
  #  INSERT (     ,   
  #    ,      )
  print $query->hidden( -name => 'obj_id' ), "\n";

  #     "  ()"  "
  #  "
  # .      'begin'  ,
  #                   ,  
  #               (.  make_cmd   E_ARCH.pm).
  #             ..       ,   
  #              (, ,   ).
  print $query->hidden( -name => 'det_char_code_begin',
                        -default => $fields{ 'det_char_code' }
                      ), "\n";
  print $query->hidden( -name => 'assessment_date_begin',
                        -default => $fields{ 'assessment_date' }
                      ), "\n";

  #      .  
  #  ,     add_rec()  update_rec()
  print $query->hidden( -name => 'bib_rec' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print_add_info();            #     

  print "<table class=\"form\">\n";

  #        labels  
  # ,    popup_det_char_types_list() 
  #  ,   -   
  print "<tr>\n";
  print "<th> ()</th>\n";
  print "<td>",
        $query->popup_menu( -name => 'det_char_code',
                            -default => $fields{ 'det_char_code' },
                            -values => $ref_values,
                            -labels => { @{ $ref_labels } }
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  </th>\n";
  #   override, ..      
  #       ,   
  # ( assessment_date     do_query() 
  #    PATH_INFO  'view')
  # .    override,       
  #                    
  #             --. ,   -- ,  
  #               --  ,  .
  print "<td>",
        $query->textfield( -name => 'assessment_date',
                           -default =>
                              date_for_display( $fields{ 'assessment_date' } ),
                           -override => 1,
                           -size => $CFG{ DET_CHARS_ASSESSMENT_DATE_SIZE },
                           -maxlength =>
                             $CFG{ DET_CHARS_ASSESSMENT_DATE_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>    10- </th>\n";
  print "<td>",
        $query->popup_menu( -name => 'det_char_mark',
                            -default => $fields{ 'det_char_mark' },
                            -values => [ '1', '2', '3', '4', '5',
                                         '6', '7', '8', '9', '10' ]
                          ),
        "</td>\n";
  print "</tr>\n";

  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment", "DET_CHARS_COMMENT" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ DET_CHARS_COMMENT_ROWS },
                          -columns => $CFG{ DET_CHARS_COMMENT_COLS } 
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
  return ( 0 );
}

# -----------------------------------------------------------------------------
#   ,    
#  -      
# -----------------------------------------------------------------------------
sub non_std_fields
{
  # :
  my $fname = shift;  #  
                      #   -   ( 
                      #  ).      
  my $value;
  
  #   
  # .   , ..   
  #                  'assessment_date'.
  if ( $fname eq 'assessment_date' )
  {
    $value = date_for_db( $query->param( $fname ) );
  }

  return ( $value );  
}

# -----------------------------------------------------------------------------
#          
# -----------------------------------------------------------------------------
sub print_add_info
{
  #  .    
  print_bib_record( $query, "   " .
                    " " );
  
  return ( 0 );
}
