#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :     
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

my $exp_imp;                     #     /

$query = CGI->new;

#  ,         HTML-
# .     "  ",   
#                exp_imp.
$exp_imp = $query->param( 'exp_imp' ) ? "?exp_imp=1" : "";

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

#  HTTP-  HTML-
http_html_headers( query => $query, target => "_top" );

#      (    
#  / )
if ( ! $query->param( 'exp_imp' ) )
{
  #   
  print qq{<h1 class="program_title"> </h1>\n};
  print qq{<p id="version"> 0.6</p>\n};
  print qq{<p id="author">:   </p>\n};
  print qq{<p id="author"><a class="mail_link" } .
        qq{href="mailto:$CFG\{ AUTHOR_EMAIL \}">} .
        "$CFG{ AUTHOR_EMAIL }</a></p>\n";
  print "</p>\n";
}
else
{
  #   
  my $module_title;
  
  $module_title = " " if export_enabled();
  $module_title = " " if import_enabled();

  #   
  create_top_block( query => $query,
                    module_title => $module_title,
                    user => $user,
                    full_top => 'no'
                  );
}

#       ,   
#       / 
make_links();

print $query->end_html();

exit( 0 );


# ----------------------------------------------------------------------------
#   
# ----------------------------------------------------------------------------
sub make_links
{
  print "<table class=\"main_screen\">\n";

  print "<tr>\n";
  print "<th> </th>\n";
  print "<th> </th>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<td>\n";

  print <<END_OF_FRAGMENT;
  <ul>
    <li><a href="bib_recs.pl$exp_imp" class="module_link">
          ()</a></li>
    <br /><br />
    <li><a href="series.pl$exp_imp" class="module_link">
        /</a></li>
    <li><a href="ser_descrs.pl$exp_imp" class="module_link">
         /</a></li>
    <br /><br />
    <li><a href="obj_groups_descrs.pl$exp_imp" class="module_link">
           </a></li>
END_OF_FRAGMENT
;

  #    --       
  # (  /      )
  if ( ! $query->param( 'exp_imp' ) )
  {
    print <<END_OF_FRAGMENT;
      <br /><br />
      <li><a href="exp_imp.pl/export" class="module_link">
           </a></li>
      <li><a href="exp_imp.pl/import" class="module_link">
           </a></li>
END_OF_FRAGMENT
;
  }
  print "</ul>\n";
  print "</td>\n";

  print "<td>\n";
  print <<END_OF_FRAGMENT;
  <ul>
    <li><a href="persons.pl$exp_imp" class="module_link">
        </a></li>
    <li><a href="keywords.pl$exp_imp" class="module_link">
         </a></li>
    <li><a href="orgs.pl$exp_imp" class="module_link">
        , ,  </a></li>
    <li><a href="confs.pl$exp_imp" class="module_link">
        , , , ,  ...</a></li>
    <li><a href="orgs_act.pl$exp_imp" class="module_link">
          , </a></li>
  </ul>
END_OF_FRAGMENT
;

  print "<ul>\n";
  #        
  #  
  make_refs_list();

  print "</ul>\n";
  print "</td>\n";

  print "</tr>\n";
  print "</table>\n";

  return;
}

# ----------------------------------------------------------------------------
#       
# ----------------------------------------------------------------------------
sub make_refs_list
{
  my $html_ref;             #   <a href>
  my @links = ();           #    
  my @links_sorted;         #    
  my $link;                 #      HTML-

  #   -,  
  #   tables34.cfg
  my @other_modules = 
     ( [ 'countries.pl', '' ],
       [ 'cities.pl', '' ],
       [ 'currencies.pl', '' ],
       [ 'feature_types.pl', '   ' .
                             ' ' ],
       [ 'gen_mater_types.pl', '   ' ],
       [ 'roles.pl', '' ],
       [ 'sci_specs.pl', ' ' ],
       [ 'spec_mater_types.pl', '  ' ]
     );

  #      -
  if ( ! open( TABLES, "< ./cfg/tables34.cfg" ) )
  {
    #     
    print STDERR "    tables34.cfg: $!\n"; 

    #   
    die "    tables34.cfg: $!\n";
  }

  while ( <TABLES> )
  {
    chomp;                  #    
    next if $_ =~ /^\s*$/;  #   (   ) 
    next if $_ =~ /^\s*#/;  # - 

    s/^\s*//;               #    ...
    s/\s*$//;               # ...  

    #        (  )
    if ( /^TABLE\s+(.+)$/ )
    {
      #    HTML- ...
      # ,         $exp_imp
      # (        /)
      $html_ref = qq{  <li><a href="} . lc( $1 ) .
                  qq{.pl$exp_imp" class="module_link">};
    }
    elsif ( /^TITLE\s+(.+)$/ )
    {
      # ...    
      # (    )
      $html_ref .= $1 . "</a></li>";

      #       ( 
      #    - -- -  
      #     )
      push( @links, [ $1, $html_ref ] );
    }
    else     #    .    
    {
      next;
    }
  }

  #      -
  if ( ! close( TABLES ) )
  {
    #     
    print STDERR "    tables34.cfg: $!\n"; 

    #   
    die "    tables34.cfg: $!";
  }

  #     HTML-  -,
  #     tables34.cfg
  foreach $link ( @other_modules )
  {
    #  HTML-
    # ,         $exp_imp
    $html_ref = qq{  <li><a href="$$link[ 0 ]$exp_imp" class="module_link">} .
                $$link[ 1 ] . "</a></li>";

    push( @links, [ $$link[ 1 ], $html_ref ] );
  }

  {
    #     
    #   POSIX
    use POSIX qw( locale_h );
    
    #     LC_COLLATE,  
    #   
    # (  ,     ,
    # "-"   web- Apache, , www  daemon --
    # .  httpd.conf)
    my $old_locale = setlocale( LC_COLLATE );

    #     ,   CHARSET
    setlocale( LC_COLLATE, "ru_RU." . $CFG{ CHARSET } );

    use locale;

    #     HTML-
    # (  --  )
    @links_sorted = sort { $$a[ 0 ] cmp $$b[ 0 ] } @links;

    foreach $link ( @links_sorted )
    {
      print $$link[ 1 ] . "\n";    #      
    }
               
    no locale;

    #     LC_COLLATE
    setlocale( LC_COLLATE, $old_locale );
  }

  return ( 0 );
}
