#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :   "   "
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'EDITIONS';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Editions
my @f_names =
   ( 'obj_id',           #   
                         #  
     'edition_quant',    #  
     'edition_code',     #   
     'comment'           # 
   );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              print_add_info => \&print_add_info,
              action => $script_name
            );

exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  if ( $query->param( 'edition_quant' ) eq '' )
  {
    push( @error_messages, "   " );
  }

  #    (  )
  if ( $query->param( 'edition_code' ) !~ /^\d+$/ )
  {
    push( @error_messages, "      " );
  }

  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }
  
  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => '  ()',
                    user => $user,
                    full_top => 'no'
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $obj_id;             #    . 
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id = $query->param( 'obj_id' );
  $target_win = $query->param( 'target_win' );

  #         
  $command = "DELETE FROM ${db_schema}editions " .
             "WHERE obj_id = '$obj_id'";

  #   
  del_rec( query => $query,
           target => $target_win,
           create_top => \&create_top,
           print_add_info => \&print_add_info,
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#       
# .       (. 
#               Editions),    
#                .
# -----------------------------------------------------------------------------
sub do_query
{
  # .        
  #              bib_recs.pl.

  my $obj_id;             #    . 
  my $bib_rec;            # . 
  my $target_win;         #      HTML-
  my( $result, $i );      #    
  my @row;                #      
  my $command;            #      
  my $href;               #   HTML-

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #  ,        
  my $alt_row = 1;

  $obj_id     = $query->param( 'obj_id' );
  $bib_rec    = $query->param( 'bib_rec' );
  $target_win = $query->param( 'target_win' );

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => $target_win );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  print_add_info(); #     

  #  ,    
  $bib_rec = CGI::escape( $bib_rec );

  #   HTML-
  $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
          "obj_id=$obj_id" .
          "&bib_rec=$bib_rec" .
          "&target_win=$target_win";

  #        
  # (     )
  # (       - . . Editions)
  $command = "SELECT e.*, et.edition_name " .
             "FROM ${db_schema}editions e, ${db_schema}edition_types et " .
             "WHERE e.obj_id = $obj_id AND " .
                   "e.edition_code = et.edition_code";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                             'user' => $user );
    $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                               'user' => $user );

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th> </th>\n";
    print "<th> </th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete );
    print "</tr>\n";

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #     
      print "<td>$row[ $result->fnumber( 'edition_name' ) ]</td>\n";
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( 'edition_quant' ) ]</td>\n";

      #        
      print "<td>" if ( $can_view || $can_delete );
      print qq{<a class="command_link" href="$script_name/view?$href"} .
            qq{ target="$target_win"></a>} if $can_view;
      print "\n" if $can_view;

      #     
      print qq{<a class="command_link" href="$script_name/delete?$href"} .
            qq{ onclick="$confirm_delete"} .
            qq{ target="$target_win"></a>} if $can_delete;
      print "</td>\n" if ( $can_view || $can_delete );

      print "</tr>\n";
    }
    print "</table>\n";
  }
  else     #    ,     (. PRIMARY KEY)
  {
    #       
    #          "/"
    if ( ! $query->param( 'exp_imp' ) &&
         have_access( 'module' => $module, 'procedure' => 'ADD', 
                      'user' => $user ) )
    {
      print "<br />\n";
      print qq{<a class="command_link" href="$script_name/add?$href"} .
            qq{ target="$target_win"> </a>};
    }
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $obj_id;             #    . 
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id     = $query->param( 'obj_id' );
  $target_win = $query->param( 'target_win' );

  #     
  $command = "SELECT * " .
             "FROM ${db_schema}editions " .
             "WHERE obj_id = $obj_id";

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => $target_win,
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "        : " .
                     "   .  - " .
                     $obj_id,
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "editions",
                       key => "obj_id",
                       f_names => \@f_names,
                       f_special => undef,
                       func_special => undef,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  #      (    
  #  )
  my( $ref_values, $ref_labels ) = popup_edition_types_list( $db_schema );

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #       
    $fields{ 'obj_id' } = $query->param( 'obj_id' );

    #   

    #   
    $fields{ 'edition_code' }  = $CFG{ EDITIONS_EDITION_CODE };

    #  
    #      "" ,  
    if ( $CFG{ EDITIONS_EDITION_QUANT } =~ /^\d+$/ )
    {
      $fields{ 'edition_quant' } = $CFG{ EDITIONS_EDITION_QUANT };
    }
    else           #    --    . 
    {
      #   ""  . :      . -- 2000 . --
      # ( ,      , 
      #   \s*)
      ( $fields{ 'edition_quant' } ) = $query->param( 'bib_rec' ) =~
        /\.\s*--\s*(\d+)\s*\.\s*--/;
    }

    # 
    $fields{ 'comment' }         = $CFG{ EDITIONS_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  #    "  
  #  "   ,   
  #  ,     , ..   
  #   UPDATE   ,    
  #  INSERT (     ,   
  #    ,      )
  print $query->hidden( -name => 'obj_id' ), "\n";

  #      .  
  #  ,     add_rec()  update_rec()
  print $query->hidden( -name => 'bib_rec' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print_add_info();             #     

  print "<table class=\"form\">\n";

  #        labels  
  # ,    popup_edition_types_list() 
  #  ,   -   
  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>",
        $query->popup_menu( -name => 'edition_code',
                            -default => $fields{ 'edition_code' },
                            -values => $ref_values,
                            -labels => { @{ $ref_labels } }
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> <br />" .
        "(        ; " .
        "       : " .
        "500&mdash;750)<br />" .
        "        " .
        "(    ),      " .
        "\"\"</th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].edition_quant",
                   "EDITIONS_EDITION_QUANT" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'edition_quant',
                           -default => $fields{ 'edition_quant' },
                           -size => $CFG{ EDITIONS_EDITION_QUANT_SIZE },
                           -maxlength => 
                             $CFG{ EDITIONS_EDITION_QUANT_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment", "EDITIONS_COMMENT" )
    if $CFG{ HOT_HELP_IS_ON };
  
  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ EDITIONS_COMMENT_ROWS },
                          -columns => $CFG{ EDITIONS_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
  return ( 0 );
}

# -----------------------------------------------------------------------------
#          
# -----------------------------------------------------------------------------
sub print_add_info
{
  #  .    
  print_bib_record( $query, "   " );
  
  return ( 0 );
}
