#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :   "/"
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module;

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#        path_info
# (    path_info   )
$module = ( $query->path_info =~ /^\/export$/ ) ? 'EXPORT' : 'IMPORT';

# ,          
if ( ! can_work( $user, $module, 'main', $query ) )
{
  exit( 0 );
}

#      /
if ( ( $query->path_info =~ /^\/export$/ || $query->path_info =~ /^\/import$/ )
     && ! $query->param )
{
  create_main_form();
}

#  
elsif ( $query->path_info =~ /^\/export$/ && $query->param( 'start' ) &&
        have_access( 'module' => $module, 'procedure' => 'START',
                     'user' => $user )
   )
{
  do_start_export();
}

#    
elsif ( $query->path_info =~ /^\/export$/ && $query->param( 'export_all' ) &&
        have_access( 'module' => $module, 'procedure' => 'EXPORT_ALL',
                     'user' => $user )
   )
{
  do_export_db();
}

#  
elsif ( $query->path_info =~ /^\/export$/ && $query->param( 'finish' ) &&
        have_access( 'module' => $module, 'procedure' => 'FINISH',
                     'user' => $user )
      )
{
  do_finish_export();
}

#  
elsif ( $query->path_info =~ /^\/import$/ && $query->param( 'start' ) &&
        have_access( 'module' => $module, 'procedure' => 'START',
                     'user' => $user )
      )
{
  do_start_import();
}

#  
elsif ( $query->path_info =~ /^\/import$/ && $query->param( 'finish' ) &&
        have_access( 'module' => $module, 'procedure' => 'FINISH',
                     'user' => $user )
      )
{
  do_finish_import();
}

exit( 0 );


# -----------------------------------------------------------------------------
#        "/"
#   ""    /   
# -----------------------------------------------------------------------------
sub check_before_import
{
  # 
  my $conn = shift;          #    

  my $result;                #    
  my $command;               #  SQL-
  my @row;                   #      
  my $series_issn_null;      #     series_issn

  #      Series    
  #  series_issn (  CHECK_FIELDS)
  # .         
  #              -  . ,  
  #                 /
  #              ,      .   
  #                    series_issn
  #                .      ,
  #                  .  
  #              --   ISSN  .  
  #                 -ISSN   
  #             Series  .
  $command = "SELECT * FROM exp_imp.Series";

  #    
  # (  --  ,    , 
  #     ,    )
  $result = exec_select( $command, "  ", $conn );
  
  #  
  if ( $result )
  {
    #      
    while ( @row = $result->fetchrow )
    {
      if ( $row[ $result->fnumber( 'series_issn' ) ] eq undef )
      {
        $series_issn_null = 1;
      }
    }

    if ( $series_issn_null )     #      ISSN
    {
      print "<p class=\"info\">";
      print( "  \"" . $EXP_CFG{ TABLES }{ 'Series' }{ TABLE_NAME } .
             "\"       ISSN. " .
             "      " .
             ".          " .
             ",          " .
             ".      " .
             "  ISSN  </p>\n" );
    }
  }
  return ( 0 );
}

# -----------------------------------------------------------------------------
#         "/"   
# ""
# -----------------------------------------------------------------------------
sub clear_tables
{
  # 
  my $conn = shift;              #    

  my $result;                    #    
  my $table;                     #      
  my $deleted_count_exp_imp = 0; #    ( exp_imp)
  my $deleted_count_imp = 0;     #    ( imp)
  my $i;
  
  #        ,  
  #    SQL-   (e_arch.sql),  
  #    
  # .       
  #                  , 
  #               . ,       
  #              Bib_objs  Bib_recs,   ,  
  #              . ,     .
  #                      
  #              .    --  .
  for ( $i = scalar @{ $EXP_CFG{ TABLES_ORDER } } - 1; $i >= 0; $i-- )
  {
    $table = $EXP_CFG{ TABLES_ORDER }->[ $i ]; #      

    #    ,     
    $deleted_count_exp_imp += exec_delete( $conn, $table, 'exp_imp' );
  }
  
  #     ""  
  for ( $i = scalar @{ $EXP_CFG{ TABLES_ORDER } } - 1; $i >= 0; $i-- )
  {
    $table = $EXP_CFG{ TABLES_ORDER }->[ $i ]; #      

    #    ,   ""  
    $deleted_count_imp += exec_delete( $conn, $table, 'imp' );
  }

  #          
  if ( $deleted_count_exp_imp > 0 )
  {
    print "<p class=\"info\">";
    print( "     : " .
           "$deleted_count_exp_imp .</p>\n" );
  }
  else
  {
    print "<p class=\"info\">";
    print( "      </p>\n" );
  }

  #        ""  
  if ( $deleted_count_imp > 0 )
  {
    print "<p class=\"info\">";
    print( "     : " .
           "$deleted_count_imp .</p>\n" );
  }
  else
  {
    print "<p class=\"info\">";
    print( "      </p>\n" );
  }
  
  return ( 0 );
}

# -----------------------------------------------------------------------------
#   
# -----------------------------------------------------------------------------
sub create_main_form
{
  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_blank" );

  open_top();           #     
  create_top();         #    
  close_top();          #     
  open_bottom();        #     
  close_bottom();       #     

  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #      
  my $module_title = ( $module eq 'EXPORT' ) ? ' ' :
                                               ' ';
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => $module_title,
                    user => $user,
                    full_top => 'yes'
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#     (      public)
# -----------------------------------------------------------------------------
sub do_export_db
{
  my $command;               #      
  my @table_cmd_pairs = ();  #     ,
                             #       
  my $table;                 #   
  my $i;

  #      ,     
  #  SQL-   (e_arch.sql),    
  #  
  for ( $i = 0; $i < scalar @{ $EXP_CFG{ TABLES_ORDER } }; $i++ )
  {
    $table = $EXP_CFG{ TABLES_ORDER }->[ $i ]; #      

    #       --   
    next if $EXP_CFG{ TABLES }{ $table }{ TABLE_EXPORT } eq 'disabled';

    #  -       
    #    (      , 
    #     )
    $command = "SELECT * FROM $table";
    push( @table_cmd_pairs, [ $table, $command ] );

    # TODO.       ( )
    #           . .
    # .      !    
    #             .   ,   
    #              ,      
    #             ,     
    #               --  UPDATE  .
#    #      ,   
#    #     ,    , 
#    #      
#    delete( $EXP_CFG{ TABLES }{ $table }{ FOREIGN_KEYS } )
#      if exists( $EXP_CFG{ TABLES }{ $table }{ FOREIGN_KEYS } );
#
#    delete( $EXP_CFG{ TABLES }{ $table }{ FOREIGN_KEYS_EXCLUDE } )
#      if exists( $EXP_CFG{ TABLES }{ $table }{ FOREIGN_KEYS_EXCLUDE } );
#
#    delete( $EXP_CFG{ TABLES }{ $table }{ DEPENDENT_TABLES } )
#      if exists( $EXP_CFG{ TABLES }{ $table }{ DEPENDENT_TABLES } );
  }

  #    
  export_data( query => $query,
               create_top => \&create_top,
               table_cmd_pairs => \@table_cmd_pairs
             );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_finish_export
{
  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_blank" );

  open_top();        #     
  create_top();      #    
  close_top();       #     
  
  open_bottom();     #     

  #         "/"
  export_tables();
  
  print "<p class=\"info\">  </p>\n";

  close_bottom();    #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_finish_import
{
  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_blank" );

  open_top();        #     
  create_top();      #    
  close_top();       #     
  
  open_bottom();     #     

  #         ""   public
  # ( )
  import_tables();
  
  #         
  # ,       ,
  #     'adjust_import'  'import' ( 
  #  Bib_objs, Bib_recs  .)
  # .        
  #             " "  " "   
  #             "".
  # TODO.   create_top()    
  #       ./exp_imp/import,  " "  " "
  #        .      
  #          create_top() (   ,
  #            ,     ;
  #          ?),     ,  -
  #       , , JavaScript.
  if ( scalar stat( "./exp_imp/import" ) > 0 )  #   
  {
    if ( ! unlink( "./exp_imp/import" ) )
    {
      my $msg = "    ./exp_imp/import. : $!";
      #   
      print "<p class=\"error\">$msg</p>\n";
      print STDERR $msg . "\n";     #    
      die $msg;
    }
  }

  #     ' '  ' ';
  #      --   
  #  
  # .     (   
  #         )  ,  . 
  #           'import',    
  #        .     .
  # TODO.     !
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript">
  <!--
  var list = document.getElementsByTagName( "A" );
  var i;

  for( i = 0; i < list.length; i++ )
  {
    if ( list[ i ].innerHTML == ' ' ||
         list[ i ].innerHTML == ' '
       )
    {
      list[ i ].innerHTML = '';
    }
  }
  //-->
  </script>
END_OF_SCRIPT
  ;

  print "<p class=\"info\">  </p>\n";

  close_bottom();    #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_start_export
{
  my $conn;          #    

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_blank" );

  open_top();        #     
  create_top();      #    
  close_top();       #     
  
  open_bottom();     #     

  #   ,     
  #    

  #        
  #  
  if ( scalar stat( "./exp_imp/import" ) > 0 )  #   
  {
    if ( ! unlink( "./exp_imp/import" ) )
    {
      my $msg = "    ./exp_imp/import. : $!";
      #   
      print "<p class=\"error\">$msg</p>\n";
      print STDERR $msg . "\n";     #     
      die $msg;
    }
  }
  #   --  
  if ( ! open( EXP, "> ./exp_imp/export" ) )
  {
    my $msg = "    ./exp_imp/export. : $!";
    #   
    print "<p class=\"error\">$msg</p>\n";
    print STDERR $msg . "\n";     #     
    die $msg;
  }
  close( EXP );  

  $conn = exec_connect_db();           #   
  exec_transaction( $conn, "BEGIN" );  #     
  
  #         "/"
  # (           "")
  clear_tables( $conn );

  exec_transaction( $conn, "END" );    #  
  
  print "<p class=\"info\">    " .
        "</p>\n";

  close_bottom();    #     

  # TODO.    ,   html- 
  #        " "  " ".  
  #         ,    ,    
  #            .
  #       . TODO   do_start_import().

  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_start_import
{
  my $conn;          #    
  my $result;        #   SQL-
  my $fill_ok;       #      
  
  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_blank" );

  open_top();        #     
  create_top();      #    
  close_top();       #     
  
  open_bottom();     #     

  #        
  #  
  if ( scalar stat( "./exp_imp/export" ) > 0 )  #   
  {
    if ( ! unlink( "./exp_imp/export" ) )
    {
      my $msg = "    ./exp_imp/export. : $!";
      #   
      print "<p class=\"error\">$msg</p>\n";
      print STDERR $msg . "\n";     #     
      die $msg;
    }
  }

  $conn = exec_connect_db();           #   
  exec_transaction( $conn, "BEGIN" );  #     
  
  #         "/"  ""
  clear_tables( $conn );

  #       "/", 
  #   (SQL-)
  $fill_ok = fill_tables( $conn );

  #        
  check_before_import( $conn );

  exec_transaction( $conn, "END" );    #  

  if ( $fill_ok )       #   
  {  
    #   ,     
    #    

    #   --  
    if ( ! open( IMP, "> ./exp_imp/import" ) )
    {
      my $msg = "    ./exp_imp/import. : $!";
      #   
      print "<p class=\"error\">$msg</p>\n";
      print STDERR $msg . "\n";     #     
      die $msg;
    }
    close( IMP );  

    print "<p class=\"info\">    " .
          "</p>\n";
  }

  # TODO.   create_top()    
  #       ./exp_imp/import,  " "  " "
  #         .    ,  -
  #       , , JavaScript.
  
  close_bottom();    #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#         "/" 
#   ""
# -----------------------------------------------------------------------------
sub exec_delete
{
  #  
  my $conn = shift;             #    
  my $table = shift;            #  
  my $schema = shift;           #  

  my $result;                   #   SQL-

  #  SQL-
  #     , . .   
  #      
  my $command = "DELETE FROM $schema.$table";

  # DEBUG 
  print_debug_info( $command ) if $DEBUG;  #   

  $result = $conn->exec( $command );   #     

  #         
  if ( PGRES_COMMAND_OK ne $result->resultStatus )
  {
    #   
    print "<p class=\"error\">$CFG{ ERROR_DELETE }</p>\n";
    print STDERR $command . "\n";     #     
    die $conn->errorMessage;
  }

  #        
  # (  )
  if ( $DEBUG )
  {
    if ( $result->cmdTuples == 0 )
    {
      print_debug_info( "   $table (" .
                        $EXP_CFG{ TABLES }{ $table }{ TABLE_NAME } .
                        ")  $schema  </p>\n"
                      );
    }
    else          # ( $result->cmdTuples > 1 )
    {
      print_debug_info( "   $table (" .
                        $EXP_CFG{ TABLES }{ $table }{ TABLE_NAME } .
                        ")  $schema : " .
                        $result->cmdTuples . " ." . "</p>\n"
                      );
    }
  }
  #     
  # (     )
  return ( $result->cmdTuples );
}

# -----------------------------------------------------------------------------
#         "/"
#    (  SQL- INSERT  UPDATE)
# -----------------------------------------------------------------------------
sub exec_export
{
  #  
  my $conn = shift;        #    
  my $table = shift;       #  

  my $result;              #   SQL-
  my @row;                 #      
  my $f_key_name;          #   
  my @f_key_fields;        #     
  my @key_fields;          #   
  my %rec = ();            # -,    
                           #     
  my $fname;               #  
  my $value;               #  

  #  SQL-
  my $command = "SELECT * FROM exp_imp.$table";

  my @insert_commands = ();  #  SQL- INSERT
  my @update_commands = ();  #  SQL- UPDATE

  my $i;

  #    
  # (  --  ,    , 
  #     ,    )
  $result = exec_select( $command, "  ", $conn );
  
  #  
  if ( ! $result )
  {
    # DEBUG 
    print_debug_info( "   $table (" .
                      $EXP_CFG{ TABLES }{ $table }{ TABLE_NAME } .
                      ")  " ) if $DEBUG;
    return ( 0 );          #  0 
  }

  #      
  while ( @row = $result->fetchrow )
  {
    %rec = ();          # "" -   

    #          
    for ( $i = 0; $i < scalar @row; $i++ )
    {
      #     
      $fname = $result->fname( $i );  #      
      $value = $row[ $i ];

      $rec{ $fname } = $value;        #     -
    }

    #        
    #        ,
    #        

    #      ,    
    # undef (NULL)  0
    foreach $fname ( @{ $EXP_CFG{ TABLES }{ $table }{ ADJUSTABLE_FIELDS } } )
    {
      if ( ! ( $rec{ $fname } eq undef || $rec{ $fname } == 0 ) )
      {
        $rec{ $fname } += $EXP_CFG{ PARAMS }{ ADJUSTABLE_FIELDS_INCREASE };
      }
    }

    #    ,      ,
    # , ,      INSERT,
    #    UPDATE

    #     
    if ( ! exists $EXP_CFG{ TABLES }{ $table }{ FOREIGN_KEYS } )
    {
      make_insert_cmd_for_export( \@insert_commands, $table, \%rec );
      next;
    }

    #      $table
    # (        ,    ,
    #   UPDATE   , ,  ,   
    #    UPDATE,     , 
    #    ,       )
    foreach $f_key_name ( keys %{ $EXP_CFG{ TABLES }{ $table }
                                          { FOREIGN_KEYS } } )
    {
      #        ...
      if ( $table eq $EXP_CFG{ TABLES }{ $table }{ FOREIGN_KEYS }
                             { $f_key_name }{ REF_TABLE } )
      {
        # ...    UPDATE
        make_update_cmd_for_export( \@update_commands, $table, \%rec, 
                                    $f_key_name );
      }
    }
    #    INSERT
    make_insert_cmd_for_export( \@insert_commands, $table, \%rec );
  }

  #        SQL-
  if ( ! open( EXPORT_FILE, ">> ./exp_imp/exported_data" ) )
  {
    my $msg = "    exported_data. : $!";
    #   
    print "<p class=\"error\">$msg</p>\n";
    print STDERR $msg . "\n";     #     
    die $msg;
  } 

  #     INSERT
  foreach ( @insert_commands )
  {
    print EXPORT_FILE $_ . ";\n";
  }

  #  --   UPDATE,     
  foreach ( @update_commands )
  {
    print EXPORT_FILE $_ . ";\n";
  }

  close( EXPORT_FILE );

  #     
  # (     )
  return ( scalar @insert_commands );
}

# -----------------------------------------------------------------------------
#        "/"
#   public ( )
# -----------------------------------------------------------------------------
sub exec_import
{
  #  
  my $conn = shift;        #    
  my $table = shift;       #  

  my $result;              #   SQL-
  my @row;                 #      
  my $command;             #  SQL-
  my @update_cmds = ();    #  SQL- UPDATE
  my @insert_cmds = ();    #  SQL- INSERT
  my $imported_count;      #   

  #       ,  
  return if ( $EXP_CFG{ TABLES }{ $table }{ TABLE_IMPORT } eq 'disabled' );

  #        "" , 
  #     ,   

  #        $table
  $command = make_select_cmd( $table );
  
  #    
  # (  --  ,    , 
  #     ,    )
  $result = exec_select( $command, "  ", $conn );
  
  #  
  if ( ! $result )
  {
    print_debug_info( "    $table (" .
                      $EXP_CFG{ TABLES }{ $table }{ TABLE_NAME } .
                      ")  </p>\n"
                    ) if $DEBUG;
    return ( 0 );          #  0 
  }

  #     , ,    
  if ( $EXP_CFG{ TABLES }{ $table }{ IMPORT_MODE } eq 'check_adjust_import' )
  {
    process_check_adjust_import( $table, $result, \@update_cmds,
                                 \@insert_cmds );
  }  
  #    Bib_objs (,      )
  elsif ( $EXP_CFG{ TABLES }{ $table }{ IMPORT_MODE } eq 'adjust_import' )
  {
    process_adjust_import( $table, $result, \@update_cmds, \@insert_cmds );
  }  
  #    Orgs_act, Ser_descrs, Ser_titles (,  
  #    )
  #    ,      
  #      ,     
  #    -- 
  # .   Orgs    ,       
  #             "",    
  #           Orgs_act      "",
  #               .    
  #            .  ,  
  #         .     , ..  
  #            .    .   
  #         "", , -   
  #              (  ).   
  #               ""
  #           ,       
  #          .
  elsif ( $EXP_CFG{ TABLES }{ $table }{ IMPORT_MODE } eq 'check_import' )
  {
    process_check_import( $table, $result, \@insert_cmds );
  }  
  elsif ( $EXP_CFG{ TABLES }{ $table }{ IMPORT_MODE } eq 'import' )
  {
    process_import( $table, $result, \@insert_cmds );
  }  

  #       ( 
  #   )
  exec_update_insert( $conn, \@update_cmds );
  $imported_count = exec_update_insert( $conn, \@insert_cmds );

  return ( $imported_count );
}

# -----------------------------------------------------------------------------
#    (UPDATE)   (INSERT)  
#       ""   public (
# )
# -----------------------------------------------------------------------------
sub exec_update_insert
{
  #  
  my $conn = shift;        #    
  my $ref_cmds = shift;    #    SQL- UPDATE  INSERT

  my $cmd_type;            #  
  my $result;              #   SQL-
  my $command;             #  SQL-

  #   ,  
  return ( 0 ) if ( scalar @{ $ref_cmds } == 0 );

  #      --     ('UPDATE'  'INSERT')
  #   , ..     
  ( $cmd_type ) = $$ref_cmds[ 0 ] =~ /^(.+?)\s+/;

  foreach $command ( @{ $ref_cmds } )
  {
    # DEBUG 
    print_debug_info( $command ) if $DEBUG;  #   

    #    ( public)   ( "")
    $result = $conn->exec( $command );

    #     /   
    if ( PGRES_COMMAND_OK ne $result->resultStatus )
    {
      #   
      print "<p class=\"error\">" .
            ( ( $cmd_type eq 'INSERT' ) ? $CFG{ ERROR_INSERT } :
                                          $CFG{ ERROR_UPDATE } ) . "</p>\n";
      print STDERR $command . "\n";             #     
      die $conn->errorMessage;
    }
  }  
  #    ,        
  return ( scalar @{ $ref_cmds } );
}

# -----------------------------------------------------------------------------
#         "/"  
# -----------------------------------------------------------------------------
sub export_tables
{
  my $conn;                  #    
  my $result;                #   SQL-
  my $table;                 #      
  my $exported_count = 0;    #   
  my $i;

  #    ,   
  if ( scalar stat( "./exp_imp/exported_data" ) > 0 )
  {
    if ( ! unlink( "./exp_imp/exported_data" ) )
    {
      my $msg = "    ./exp_imp/exported_data. : $!";
      #   
      print "<p class=\"error\">$msg</p>\n";
      print STDERR $msg . "\n";     #     
      die $msg;
    }
  }

  $conn = exec_connect_db();           #   
  exec_transaction( $conn, "BEGIN" );  #     

  #      ,     
  #  SQL-   (e_arch.sql),    
  #  
  for ( $i = 0; $i < scalar @{ $EXP_CFG{ TABLES_ORDER } }; $i++ )
  {
    $table = $EXP_CFG{ TABLES_ORDER }->[ $i ]; #      

    #    ,     
    $exported_count += exec_export( $conn, $table );
  }

  exec_transaction( $conn, "END" );    #  

  #          
  if ( $exported_count > 0 )
  {
    print "<p class=\"info\">";
    print( "     exported_data: " .
           "$exported_count .</p>\n" );
  }
  else
  {
    print "<p class=\"info\">";
    print( "       </p>\n" );
  }

  return ( 0 );
}

# -----------------------------------------------------------------------------
#     "/" , 
#  SQL-
# -----------------------------------------------------------------------------
sub fill_tables
{
  # 
  my $conn = shift;          #    

  my $result;                #    
  my $inserted_count = 0;    #   
  my $command;               #  SQL-

  #    
  if ( scalar stat( "./exp_imp/exported_data" ) == 0 )
  {
    #   
    print "<p class=\"error\">    : " .
          "/exp_imp/exported_data</p>\n";
    return ( 0 );
  }

  #  ,     
  if ( ! open( IMPORT_FILE, "< ./exp_imp/exported_data" ) )
  {
    my $msg = "    exported_data. : $!";
    #   
    print "<p class=\"error\">$msg</p>\n";
    print STDERR $msg . "\n";     #     
    die $msg;
  }

  # ...    
  while ( <IMPORT_FILE> )
  {
    chomp;               #    
    next if /^$/;        #   
    next if /^\s*--/;    # - 

    s/^\s*//;            #      
    s/\s*$//;            #       
   
    #    INSERT  UPDATE
    if ( /^INSERT\s+INTO/ || /^UPDATE\s+/ )
    {
      $command = $_;   #    SQL-
    }
    #      ( , . .  
    #        , ,
    #   "")
    # .  ,   , , "",
    #                "INSERT",  
    #               .      
    #               INSERT      
    #             ""  INSERT.
    else
    {
      #   SQL-
      #   ,     
      #  
      $command .= ' ' . $_;
    }

    #        ";",  
    # 
    if ( /;$/ )
    {
      $command =~ s/;$//;    #   ";"   SQL-

      # DEBUG 
      print_debug_info( $command ) if $DEBUG;  #   

      #   /   
      $result = $conn->exec( $command );

      #     /   
      if ( PGRES_COMMAND_OK ne $result->resultStatus )
      {
        #   
        print "<p class=\"error\">";
        print /^INSERT\s+INTO/ ? $CFG{ ERROR_INSERT } : $CFG{ ERROR_UPDATE };
        print "</p>\n";
        print STDERR $command . "\n";   #     
        die $conn->errorMessage;
      }

      #     ,   
      # "/"
      $inserted_count++ if ( $command =~ /^INSERT\s+INTO/ );
    }
  }

  close( IMPORT_FILE );

  #           
  if ( $inserted_count == 0 )
  {
    print "<p class=\"error\">";
    print( "  /     </p>\n" );
    return ( 0 );
  }
  
  #          
  print "<p class=\"info\">";
  print( "     /: " .
         "$inserted_count .</p>\n" );
  
  return ( 1 );  # 1 --   
}

# -----------------------------------------------------------------------------
#         ""
#   public ( )
# -----------------------------------------------------------------------------
sub import_tables
{
  my $conn;                  #    
  my $table;                 #      
  my $imported_count = 0;    #   
  my $i;

  $conn = exec_connect_db();           #   
  exec_transaction( $conn, "BEGIN" );  #     

  #      ,     
  #  SQL-   (e_arch.sql),    
  #  
  for ( $i = 0; $i < scalar @{ $EXP_CFG{ TABLES_ORDER } }; $i++ )
  {
    $table = $EXP_CFG{ TABLES_ORDER }->[ $i ]; #      

    #    ,   ""  
    #   public ( )
    $imported_count += exec_import( $conn, $table );
  }

  exec_transaction( $conn, "END" );    #  

  #        ""  
  if ( $imported_count > 0 )
  {
    print "<p class=\"info\">";
    print( "      " .
           "   : $imported_count .</p>\n" );
  }
  else
  {
    print "<p class=\"info\">";
    print( "      </p>\n" );
  }

  return ( 0 );
}

# -----------------------------------------------------------------------------
#   INSERT      
#   "/"  
# -----------------------------------------------------------------------------
sub make_insert_cmd_for_export
{
  # 
  my $ref_insert_commands = shift;  #    SQL- INSERT
  my $table = shift;                #   
  my $ref_rec = shift;              #   -,  
                                    #    

  my $fname;                        #  
  my $value;                        #  
  my $fields;                       #    (  )
  my $values;                       #    (  )
  my $command;                      #  SQL-

  foreach $fname ( keys %{ $ref_rec } )
  {
    #     
    $value = $$ref_rec{ $fname };

    #        
    $fields .= $fname . ",";

    # TODO.    ""   .
    $value =~ s/\'/\'\'/g;

    #     (   !!!)
    #    ,   null,   
    #     
    # .       , 
    #                    
    #                .
    $values .= $value ne '' ? "'$value'," : "null," ;
  }

  $fields =~ s/,$//;         #   
  $values =~ s/,$//;         #   

  #           
  $command = "INSERT INTO exp_imp.$table ( $fields ) VALUES ( $values )";

  push( @{ $ref_insert_commands }, $command );   #    

  return( 0 );
}

# -----------------------------------------------------------------------------
#   INSERT      
#   ""    public
# -----------------------------------------------------------------------------
sub make_insert_cmd_for_import
{
  # 
  my $ref_insert_commands = shift;  #    SQL- INSERT
  my $table = shift;                #   
  my $ref_rec = shift;              #   -,  
                                    #    

  my $fname;                        #  
  my $value;                        #  
  my $fields;                       #    (  )
  my $values;                       #    (  )
  my $command;                      #  SQL-
  my $f_key_name;                   #   

  #   : ,        
  # ,      
  # (,  -),      .
  #    ,     , 
  #     , "".
  # .      ,    ,
  #               'check_adjust_import',     
  #              ,     .   
  #                  if ... 'check_adjust_import',
  #               ,    ,  
  #               .
  # TODO.          
  #         .       
  #          ,    "".

  #      $table
  foreach $f_key_name ( keys %{ $EXP_CFG{ TABLES }{ $table }
                                        { FOREIGN_KEYS } } )
  {
    #        
    if ( $table eq $EXP_CFG{ TABLES }{ $table }{ FOREIGN_KEYS }
                           { $f_key_name }{ REF_TABLE } )
    {
      # ""   ,    
      foreach $fname ( @{ $EXP_CFG{ TABLES }{ $table }{ FOREIGN_KEYS }
                                  { $f_key_name }{ F_KEY_FIELDS } } )
      {
        #     'imp_' (.  make_select_cmd())
        $$ref_rec{ 'imp_' . $fname } = undef;
      }
    }
  }

  #      INSERT
  foreach $fname ( keys %{ $ref_rec } )
  {
    next if ( $fname !~ /^imp_/ );   #     'imp_'

    #     
    $value = $$ref_rec{ $fname };

    $fname =~ s/^imp_//;
    
    #        
    $fields .= $fname . ",";

    # TODO.    ""   .
    $value =~ s/\'/\'\'/g;

    #     (   !!!)
    #    ,   null,   
    #     
    # .       , 
    #                    
    #                .
    $values .= $value ne '' ? "'$value'," : "null," ;
  }

  $fields =~ s/,$//;         #   
  $values =~ s/,$//;         #   

  #        public   
  $command = "INSERT INTO $table ( $fields ) VALUES ( $values )";

  push( @{ $ref_insert_commands }, $command );   #    

  return( 0 );
}

# -----------------------------------------------------------------------------
#   SELECT      
#   ""   public ( )
# -----------------------------------------------------------------------------
sub make_select_cmd
{
  #  
  my $table = shift;       #  

  my $fname;               #  
  my $value;               #  
  my $command;             #  SQL-

  #     , ,    
  if ( $EXP_CFG{ TABLES }{ $table }{ IMPORT_MODE } =~ /^check/ )
  {
    #       ,   
    #    $table  ""  ,   -- 
    # $table    public.     
    # CHECK_FIELDS  .  .     
    #  ,       ,   ,  
    #      ().

    $command = "SELECT ";

    #       ""     ,
    #  who_chg  when_chg (       
    #   .  /)
    foreach $fname ( @{ $EXP_CFG{ TABLES }{ $table }{ FIELDS } } )
    {
      $command .= "imp.$fname AS imp_$fname, ";
    }

    #         public   
    # 
    foreach $fname ( @{ $EXP_CFG{ TABLES }{ $table }{ KEY_FIELDS } } ) 
    {
      $command .= "pub.$fname AS $fname, ";
    }

    $command =~ s/,\s*$//;       #    ( )

    $command .= " FROM imp.$table AS imp LEFT JOIN $table AS pub ON ";

    #     CHECK_FIELDS
    foreach $fname ( @{ $EXP_CFG{ TABLES }{ $table }{ CHECK_FIELDS } } )
    {
      $command .= "imp.$fname = pub.$fname AND ";
    }

    $command =~ s/\s*AND\s*$//;  #    AND ( )
  }
  else 
  {
    #      $table  ""  
  
    $command = "SELECT ";

    foreach $fname ( @{ $EXP_CFG{ TABLES }{ $table }{ FIELDS } } )
    {
      # .     imp_ --  ,
      #                  
      #             make_insert_cmd_for_import().
      $command .= "imp.$fname AS imp_$fname, ";
    }
    $command =~ s/,\s*$//;       #    ( )

    $command .= " FROM imp.$table AS imp";
  }

  return ( $command );
}

# -----------------------------------------------------------------------------
#   UPDATE      
#   "/"  
# -----------------------------------------------------------------------------
sub make_update_cmd_for_export
{
  # 
  my $ref_update_commands = shift;  #    SQL- UPDATE
  my $table = shift;                #   
  my $ref_rec = shift;              #   -,  
                                    #    
  my $f_key_name = shift;           #   

  my @f_key_fields;                 #     
  my @ref_fields;                   #     
  my @key_fields;                   #    
  my $command;                      #  SQL-
  my $i;

  #      - ( , 
  #    -,      
  # )
  @f_key_fields = @{ $EXP_CFG{ TABLES }{ $table }{ FOREIGN_KEYS }
                             { $f_key_name }{ F_KEY_FIELDS } };
  @ref_fields = @{ $EXP_CFG{ TABLES }{ $table }{ FOREIGN_KEYS }
                           { $f_key_name }{ REF_FIELDS } };

  #       NULL (undef),   
  #       UPDATE
  # .  ,      
  #              NULL (undef),      
  #               .   " " 
  #                ,     
  #              (NULL).
  return if ( $$ref_rec{ $f_key_fields[ 0 ] } eq undef );

  #   UPDATE

  #   
  # !      /.
  $command = "UPDATE exp_imp.$table SET ";

  #     
  for ( $i = 0; $i < scalar @f_key_fields; $i++ )
  {
    #   "_ + "      
    $command .= $f_key_fields[ $i ] . " = '" .
                $$ref_rec{ $f_key_fields[ $i ] } . "', ";

    #   ""     -, 
    #      $table,    -
    # INSERT          
    #     ;
    #        UPDATE, 
    #    INSERT,     INSERT 
    #         
    $$ref_rec{ $f_key_fields[ $i ] } = undef;
  }
        
  $command =~ s/,\s*$//;  #   

  #   
  $command .= " WHERE ";

  @key_fields = @{ $EXP_CFG{ TABLES }{ $table }{ KEY_FIELDS } };

  #      
  for ( $i = 0; $i < scalar @key_fields; $i++ )
  {
    $command .= $key_fields[ $i ] . " = '" .
                $$ref_rec{ $key_fields[ $i ] } . "' AND ";
  }

  #           
  $command =~ s/\s*AND\s*$//;

  push( @{ $ref_update_commands }, $command );   #    

  return( 0 );
}

# -----------------------------------------------------------------------------
#   UPDATE      
#   ""    public
# -----------------------------------------------------------------------------
sub make_update_cmd_for_import
{
  # 
  my $ref_update_commands = shift;  #    SQL- UPDATE
  my $table = shift;                #   
  my $ref_rec = shift;              #   -,  
                                    #    
  my $fname;                        #  
  my $command;                      #  SQL-
  my $i;

  #   
  # !      .
  $command = "UPDATE imp.$table SET ";

  #     
  # .  UPDATE      
  #             'check_adjust_import'  'adjust_import'.   ,
  #                ,    .
  #                 (,   ).
  $fname = $EXP_CFG{ TABLES }{ $table }{ KEY_FIELDS }->[ 0 ];

  #   "__ + "    
  #   
  $command .= $fname . " = '" . $$ref_rec{ $fname } . "' ";

  #   
  $command .= " WHERE $fname" . " = '" . $$ref_rec{ 'imp_' . $fname } . "'";

  push( @{ $ref_update_commands }, $command );   #    

  return( 0 );
}

# -----------------------------------------------------------------------------
#  ,     imp  ,  
# 'adjust_import'
# -----------------------------------------------------------------------------
sub process_adjust_import
{
  # 
  my $table = shift;            #   
  my $result = shift;           #   SQL-
  my $ref_update_cmds = shift;  #    SQL- UPDATE
  my $ref_insert_cmds = shift;  #    SQL- INSERT

  my @row;                #      
  my %rec;                # -,     
  my $fname;              #  
  my $value;              #  
  my $new_key_value;      #    
  my $i;
  
  #      
  while ( @row = $result->fetchrow )
  {
    %rec = ();          # "" -   

    #          
    for ( $i = 0; $i < scalar @row; $i++ )
    {
      #     
      $fname = $result->fname( $i );  #      
                                      # (  'imp_')
      $value = $row[ $i ];
      $rec{ $fname } = $value;        #     -
    }

    #       $table 
    # .   'adjust_import'   Bib_objs.
    $fname = $EXP_CFG{ TABLES }{ $table }{ KEY_FIELDS }->[ 0 ];

    #        
    # (     + 1)
    #      ,     
    # ,   ,     1
    # .       ,   
    #                  , . .   
    #             INSERT       
    #               ,     .
    if ( $new_key_value )
    {
      $new_key_value++;
    }
    else
    {
      # TODO.     import_tables(), 
      #         get_next_key_value()   
      #        .  ?  ,     ?
      $new_key_value = get_next_key_value( $table, $fname );
    }

    #   UPDATE     "" 
    # (         "" )
    # .    --    
    #              ""   .
    #    -  $fname --   'imp_'.
    #           
    # make_update_cmd_for_import()      'adjust_import',
    #     'check_adjust_import'.
    $rec{ $fname } = $new_key_value;
    make_update_cmd_for_import( $ref_update_cmds, $table, \%rec );

    #    'imp_' --    imp
    #    INSERT      
    # 
    $rec{ 'imp_' . $fname } = $new_key_value;
    make_insert_cmd_for_import( $ref_insert_cmds, $table, \%rec );
  }
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  ,     imp  ,  
# 'check_adjust_import'
# -----------------------------------------------------------------------------
sub process_check_adjust_import
{
  # 
  my $table = shift;            #   
  my $result = shift;           #   SQL-
  my $ref_update_cmds = shift;  #    SQL- UPDATE
  my $ref_insert_cmds = shift;  #    SQL- INSERT

  my @row;                #      
  my %rec;                # -,     
  my $fname;              #  
  my $value;              #  
  my $new_key_value;      #    
  my $diff;               #      
  my $i;
  
  #      
  while ( @row = $result->fetchrow )
  {
    %rec = ();          # "" -   

    #          
    for ( $i = 0; $i < scalar @row; $i++ )
    {
      #     
      $fname = $result->fname( $i );  #      
      $value = $row[ $i ];

      $rec{ $fname } = $value;        #     -
    }

    #        
    # (. .       )
    # .       .  --
    #              Orgs_act.    ?
    $fname = $EXP_CFG{ TABLES }{ $table }{ KEY_FIELDS }->[ 0 ];

    # .       'imp_' (. 
    #        make_select_cmd()).
    if ( $rec{ $fname } ne undef )
    {
      #          public

      $diff = 0;
      #        KEY_FIELDS  "" 
      #      ...
      # .  ,    'check_adjust_import',
      #                 .   ,
      #             ,  .   ...
      foreach $fname ( @{ $EXP_CFG{ TABLES }{ $table }{ KEY_FIELDS } } )
      {
        if ( $rec{ 'imp_' . $fname } != $rec{ $fname } )
        { 
          $diff = 1;
          last;
        } 
      }

      if ( $diff )
      {
        # ...   UPDATE     ""
        #  (         ""
        # )
        # .    --    
        #              ""   .
        make_update_cmd_for_import( $ref_update_cmds, $table, \%rec );
      }
      else          #    
      {
        ;           #   
      }
    }
    else            #       public 
    {
      #      

      #        
      # (     + 1)
      #      ,     
      # ,   ,     1
      # .       ,   
      #                  , . .   
      #             INSERT       
      #               ,     .
      if ( $new_key_value )
      {
        $new_key_value++;
      }
      else
      {
        $new_key_value = get_next_key_value( $table, $fname );
      }

      #    UPDATE     ""
      #  (         ""
      # )
      # .    --    
      #              ""   .
      #    -   $fname --  
      #  'imp_',        undef.
      $rec{ $fname } = $new_key_value;
      make_update_cmd_for_import( $ref_update_cmds, $table, \%rec );

      #   'imp_' .  make_select_cmd()
      $rec{ 'imp_' . $fname } = $new_key_value;
      make_insert_cmd_for_import( $ref_insert_cmds, $table, \%rec );
    }
  }
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  ,     imp  ,  
# 'check_import'
# -----------------------------------------------------------------------------
sub process_check_import
{
  # 
  my $table = shift;            #   
  my $result = shift;           #   SQL-
  my $ref_insert_cmds = shift;  #    SQL- INSERT

  my @row;                #      
  my %rec;                # -,     
  my $fname;              #  
  my $value;              #  
  my $i;
  
  #      
  while ( @row = $result->fetchrow )
  {
    %rec = ();          # "" -   

    #          
    for ( $i = 0; $i < scalar @row; $i++ )
    {
      #     
      $fname = $result->fname( $i );  #      
      $value = $row[ $i ];

      $rec{ $fname } = $value;        #     -
    }

    #        
    # (. .       )
    # .   'check_import'   Orgs_act.
    $fname = $EXP_CFG{ TABLES }{ $table }{ KEY_FIELDS }->[ 0 ];

    if ( $rec{ $fname } ne undef )
    {
      #          public
      ;           #   
    }
    else          #       public 
    {
      #      
      make_insert_cmd_for_import( $ref_insert_cmds, $table, \%rec );
    }
  }
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  ,     imp  ,  
# 'import'
# -----------------------------------------------------------------------------
sub process_import
{
  # 
  my $table = shift;            #   
  my $result = shift;           #   SQL-
  my $ref_insert_cmds = shift;  #    SQL- INSERT

  my @row;                #      
  my %rec;                # -,     
  my $fname;              #  
  my $value;              #  
  my $i;
  
  #      
  while ( @row = $result->fetchrow )
  {
    %rec = ();          # "" -   

    #          
    for ( $i = 0; $i < scalar @row; $i++ )
    {
      #     
      $fname = $result->fname( $i );  #      
      $value = $row[ $i ];

      $rec{ $fname } = $value;        #     -
    }

    #      
    make_insert_cmd_for_import( $ref_insert_cmds, $table, \%rec );
  }
  return ( 0 );
}
