#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :   "   "
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'FEATURES';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Features
my @f_names =
   ( 'obj_id',           #   
                         #  
     'feature_code',     #  
     'comment'           # 
   );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              print_add_info => \&print_add_info,
              action => $script_name
            );

#    (    )
if ( $query->path_info =~ /^\/add_group$/ &&
     have_access( 'module' => $module, 'procedure' => 'ADD', 'user' => $user )
   )
{
  do_add_group();
}

#     (   )
if ( $query->param( 'submit_add_group' ) &&
     have_access( 'module' => $module, 'procedure' => 'ADD', 'user' => $user )
   )
{
  add_rec_group();
}

exit( 0 );


# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub add_rec_group
{
  my $conn;                 #    
  my $result;               #   SQL-
  my $command;              #       
  my $num_recs = 0;         #   
  my $feature_code;         #  
  
  #    . 
  my $obj_id            = $query->param( 'obj_id' );

  # ,    
  my $feature_codes_str = $query->param( 'feature_codes_str' );

  #  (         )
  my $comment           = $query->param( 'comment' );

  #      HTML-
  my $target_win        = $query->param( 'target_win' );

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => $target_win );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  print_add_info(); #     

  #      ,  
  if ( check_param_group() )
  {
    $conn = exec_connect_db();          #   
    exec_transaction( $conn, "BEGIN" ); #     

    #   -   ""
    # (       )
    $feature_codes_str =~ s/[^\d]/ /g;
    
    #  ,     ,  
    # 
    foreach $feature_code ( split( /\s+/, $feature_codes_str ) )
    {
      #   - ...
      $command = "INSERT INTO Features ( obj_id, feature_code, comment, " .
                                        "who_chg ) " .
                 "VALUES ( $obj_id, $feature_code, '$comment', '$user' )";

      # DEBUG 
      print_debug_info( $command ) if $DEBUG;  #   

      # ...      Features
      $result = $conn->exec( $command );

      #         
      if ( PGRES_COMMAND_OK ne $result->resultStatus )
      {
        #   
        print "<p class=\"error\">$CFG{ ERROR_INSERT }</p>\n";
        print STDERR $command . "\n";           #     
        die $conn->errorMessage;
      }
      else
      {
        $num_recs++;         #   
      }
    }

    exec_transaction( $conn, "END" );    #  
    
    print "<p class=\"info\">";
    print( "    : $num_recs</p>\n" );
  }

  close_bottom();      #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  if ( $query->param( 'feature_code' ) !~ /^\d+$/ )
  {
    push( @error_messages, "     " );
  }

  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }
  
  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#        
# -----------------------------------------------------------------------------
sub check_param_group
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  #        ,  4   
  if ( $query->param( 'feature_codes_str' ) !~ /\d+/ ||
       $query->param( 'feature_codes_str' ) =~ /\d{4,}/ )
  {
    push( @error_messages, "        " .
          " " );
  }

  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }
  
  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => '  ()',
                    user => $user,
                    full_top => 'no'
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_add_group
{
  #      HTML-
  my $target_win = $query->param( 'target_win' );

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => $target_win );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  #        URL-,  
  #  ,    URL    ,
  #    , ..   PATH_INFO = 'add_group' 
  #   ,     ,  
  # PATH_INFO    ,    
  print $query->start_form( -action => $script_name,
                            -target => $target_win
                          ), "\n";

  #     
  make_form_group();

  print $query->submit( -name => "submit_add_group",
                        -value => "  ",
                        -class => 'submit'
                      ), "\n";

  print $query->end_form();

  close_bottom();   #     

  print $query->end_html();

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $obj_id;             #    . 
  my $feature_code;       #  
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id       = $query->param( 'obj_id' );
  $feature_code = $query->param( 'feature_code' );
  $target_win   = $query->param( 'target_win' );

  #         
  $command = "DELETE FROM ${db_schema}features " .
             "WHERE obj_id = '$obj_id' AND " .
                   "feature_code = '$feature_code'";

  #   
  del_rec( query => $query,
           target => $target_win,
           create_top => \&create_top,
           print_add_info => \&print_add_info,
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#       
# -----------------------------------------------------------------------------
sub do_query
{
  # .        
  #              bib_recs.pl.

  my $obj_id;             #    . 
  my $bib_rec;            # . 
  my $target_win;         #      HTML-
  my( $result, $i );      #    
  my @row;                #      
  my $command;            #      
  my $href;               #   HTML-

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #  ,        
  my $alt_row = 1;

  $obj_id     = $query->param( 'obj_id' );
  $bib_rec    = $query->param( 'bib_rec' );
  $target_win = $query->param( 'target_win' );

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => $target_win );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  print_add_info(); #     

  #  ,    
  $bib_rec = CGI::escape( $bib_rec );

  #   HTML-
  $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
          "obj_id=$obj_id" .
          "&bib_rec=$bib_rec" .
          "&target_win=$target_win";

  #        
  # (      )
  # .  -   . ,   ?
  $command = "SELECT f.*, ft.feature_name, fg.feature_group_name " .
             "FROM ${db_schema}features f, ${db_schema}feature_groups fg, " .
                  "${db_schema}feature_types ft " .
             "WHERE f.obj_id = '$obj_id' AND " .
                   "f.feature_code = ft.feature_code AND " .
                   "ft.feature_group_code = fg.feature_group_code " .
             "ORDER BY f.feature_code";

  $result = exec_select( $command );   #    
  
  if ( $result )
  {
    $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                             'user' => $user );
    $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                               'user' => $user );

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th> </th>\n";
    print "<th> </th>\n";
    print "<th> </th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete );
    print "</tr>\n";

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #     ,   
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( 'feature_code' ) ]</td>\n";
      print "<td>$row[ $result->fnumber( 'feature_name' ) ]</td>\n";
      print "<td>$row[ $result->fnumber( 'feature_group_name' ) ]</td>\n";

      #        
      print "<td>" if ( $can_view || $can_delete );
      print qq{<a class="command_link" href="$script_name/view?$href} .
            "&feature_code=" . 
            $row[ $result->fnumber( 'feature_code' ) ] . "\"" .
            qq{ target="$target_win"></a>} if $can_view;
      print "\n" if $can_view;

      #     
      print qq{<a class="command_link" href="$script_name/delete?$href} .
            "&feature_code=" . 
            $row[ $result->fnumber( 'feature_code' ) ] . "\"" .
            qq{ onclick="$confirm_delete"} .
            qq{ target="$target_win"></a>} if $can_delete;
      print "</td>\n" if ( $can_view || $can_delete );

      print "</tr>\n";
    }
    print "</table>\n";
  }

  #       
  #          "/"
  if ( ! $query->param( 'exp_imp' ) &&
       have_access( 'module' => $module, 'procedure' => 'ADD', 
                    'user' => $user ) )
  {
    print "<br />\n";
    print qq{<a class="command_link" href="$script_name/add?$href"} .
          qq{ target="$target_win"> </a>};
    print "&nbsp;&nbsp;\n";
  
    #        
    print qq{<a class="command_link" href="$script_name/add_group?$href"} .
          qq{ target="$target_win">  </a>};
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $obj_id;             #    . 
  my $feature_code;       #  
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id       = $query->param( 'obj_id' );
  $feature_code = $query->param( 'feature_code' );
  $target_win   = $query->param( 'target_win' );

  #     
  $command = "SELECT f.*, ft.feature_name, fg.feature_group_name " .
             "FROM ${db_schema}features f, ${db_schema}feature_groups fg, " .
                  "${db_schema}feature_types ft " .
             "WHERE f.obj_id = '$obj_id' AND " .
                   "f.feature_code = '$feature_code' AND " .
                   "f.feature_code = ft.feature_code AND " .
                   "ft.feature_group_code = fg.feature_group_code " .
             "ORDER BY f.feature_code";

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => $target_win,
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "        : " .
                     "   .  - " .
                     $obj_id . ", " .
                     "  - $feature_code",
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "features",
                       key => "obj_id, feature_code:feature_code_begin",
                       f_names => \@f_names,
                       f_special => undef,
                       func_special => undef,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #       
    $fields{ 'obj_id' } = $query->param( 'obj_id' );

    #   

    #  
    $fields{ 'feature_code' } = $CFG{ FEATURES_FEATURE_CODE };
    
    # 
    $fields{ 'comment' }      = $CFG{ FEATURES_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  #    "  
  #  "   ,   
  #  ,     , ..   
  #   UPDATE   ,    
  #  INSERT (     ,   
  #    ,      )
  print $query->hidden( -name => 'obj_id' ), "\n";

  #     " "
  # .      'begin'  ,
  #                   ,  
  #               (.  make_cmd   E_ARCH.pm).
  #             ..       ,   
  #              (, ,   ).
  print $query->hidden( -name => 'feature_code_begin',
                        -default => $fields{ 'feature_code' }
                      ), "\n";

  #      .  
  #  ,     add_rec()  update_rec()
  print $query->hidden( -name => 'bib_rec' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print_add_info();           #     

  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th> </th>\n";

  #      JavaScript,  
  # - feature_types.pl
  create_selection_func( func_name => 'select_feature',
                         module_name => 'feature_types.pl',
                         caller_name => $module,
                         window_name => 'feature_types',
                         exp_imp => $query->param( 'exp_imp' ) );
  print "<td>";

  #   ()     
  #     (,   );
  #  JavaScript-  :   create_hot_help()
  #  HTML-,      VALUE,    
  # HTML-,      ,    
  #  NAME       " ";
  #  "  "   (  
  # create_hot_help()      
  #   )
  create_hot_help( "document.forms[ 0 ].feature_code",
                   "FEATURES_FEATURE_CODE", "REPLACE",
                   "var str; if (this.value) str = this.value;
                             else str = this.name;
                   document.forms[ 0 ].feature_name.value = str;
                   document.forms[ 0 ].feature_group_name.value = ''; " )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'feature_code',
                           -default => $fields{ 'feature_code' },
                           -size => $CFG{ FEATURES_FEATURE_CODE_SIZE },
                           -maxlength => 
                             $CFG{ FEATURES_FEATURE_CODE_MAXLENGTH }
                         ),
        "&nbsp;&nbsp;",
        qq{ <a class="command_link" href="javascript:void( 0 )"} .
        qq{ onclick="select_feature()"></a>},
        "</td>\n";
  print "</tr>\n";

  #        
  # (  )
  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>",
        $query->textfield( -name => 'feature_name',
                           -default => $fields{ 'feature_name' },
                           -size => $CFG{ FEATURES_FEATURE_NAME_SIZE },
                           -maxlength => 
                             $CFG{ FEATURES_FEATURE_NAME_MAXLENGTH },
                           -readonly => 'readonly'
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>",
        $query->textfield( -name => 'feature_group_name',
                           -default => $fields{ 'feature_group_name' },
                           -size => $CFG{ FEATURES_FEATURE_GROUP_NAME_SIZE },
                           -maxlength => 
                             $CFG{ FEATURES_FEATURE_GROUP_NAME_MAXLENGTH },
                           -readonly => 'readonly'
                         ),
        "</td>\n";
  print "</tr>\n";

  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";
  
  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment", "FEATURES_COMMENT" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ FEATURES_COMMENT_ROWS },
                          -columns => $CFG{ FEATURES_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub make_form_group
{
  #       
  my $obj_id = $query->param( 'obj_id' );

  #    "  
  #  "   ,   
  #  ,     , ..   
  #   INSERT (     ,   
  #    ,      )
  print $query->hidden( -name => 'obj_id' ), "\n";

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  #      .  
  #  ,     add_rec()  update_rec()
  print $query->hidden( -name => 'bib_rec' ), "\n";

  print_add_info();             #     

  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].feature_codes_str",
                   "FEATURES_FEATURE_CODES_STR" )
    if $CFG{ HOT_HELP_IS_ON };
  
  print $query->textfield( -name => 'feature_codes_str',
                           -default => $CFG{ FEATURES_FEATURE_CODES_STR },
                           -size => $CFG{ FEATURES_FEATURE_CODES_STR_SIZE },
                           -maxlength => 
                             $CFG{ FEATURES_FEATURE_CODES_STR_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment", "FEATURES_COMMENT_STR" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $CFG{ FEATURES_COMMENT_STR },
                          -rows => $CFG{ FEATURES_COMMENT_STR_ROWS },
                          -columns => $CFG{ FEATURES_COMMENT_STR_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
  return ( 0 );
}

# -----------------------------------------------------------------------------
#          
# -----------------------------------------------------------------------------
sub print_add_info
{
  #  .    
  print_bib_record( $query, "   " );
  
  return ( 0 );
}
