#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :   "    "
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'GEN_CHARS';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Gen_chars
my @f_names =
   ( 'obj_id',           #   
                         #  
     'gen_char',         #    
     'useful_fragments', #    , 
                         #  ( , , ...)
     'comment'           # 
   );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              print_add_info => \&print_add_info,
              action => $script_name
            );

exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  if ( $query->param( 'gen_char' ) eq '' )
  {
    push( @error_messages, "   \"  " .
          "\"" );
  }

  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }
  
  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => '  ()',
                    user => $user,
                    full_top => 'no'
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $obj_id;             #    . 
  my $target_win;         #      HTML-

  my $command;            #      

  $obj_id     = $query->param( 'obj_id' );
  $target_win = $query->param( 'target_win' );

  #         
  $command = "DELETE FROM ${db_schema}gen_chars " .
             "WHERE obj_id = '$obj_id'";

  #   
  del_rec( query => $query,
           target => $target_win,
           create_top => \&create_top,
           print_add_info => \&print_add_info,
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#        
# .       (. 
#               Gen_chars),    
#                .
# -----------------------------------------------------------------------------
sub do_query
{
  # .        
  #              bib_recs.pl.

  my $obj_id;             #    . 
  my $bib_rec;            # . 
  my $target_win;         #      HTML-
  my( $result, $i );      #    
  my @row;                #      
  my $command;            #      
  my $href;               #   HTML-

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  $obj_id     = $query->param( 'obj_id' );
  $bib_rec    = $query->param( 'bib_rec' );
  $target_win = $query->param( 'target_win' );

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => $target_win );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  print_add_info(); #     

  #  ,    
  $bib_rec = CGI::escape( $bib_rec );

  #   HTML-
  $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
          "obj_id=$obj_id" .
          "&bib_rec=$bib_rec" .
          "&target_win=$target_win";

  #         
  # (       - . . Gen_chars)
  $command = "SELECT * " .
             "FROM ${db_schema}gen_chars " .
             "WHERE obj_id = '$obj_id'";

  #    
  $result = exec_select( $command );
  
  if ( $result )
  {
    #     
    @row = $result->fetchrow;

    $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                             'user' => $user );
    $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                               'user' => $user );

    #     
    #        , .. 
    #   
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th>  </th>\n";
    print "</tr>\n";

    print "<tr>\n";
    print "<td>$row[ $result->fnumber( 'gen_char' ) ]</td>\n";
    print "</tr>\n";

    print "<tr>\n";
    print "<th>    </th>\n";
    print "</tr>\n";

    print "<tr>\n";
    #  "&nbsp;", ..     ,  
    #         
    print "<td>$row[ $result->fnumber( 'useful_fragments' ) ]&nbsp;</td>\n";
    print "</tr>\n";

    #         
    print "<tr>\n<td>" if ( $can_view || $can_delete );
    print qq{<a class="command_link" href="$script_name/view?$href"} .
          qq{ target="$target_win"></a>} if $can_view;
    print "\n" if $can_view;

    #      
    print qq{<a class="command_link" href="$script_name/delete?$href"} .
          qq{ onclick="$confirm_delete"} .
          qq{ target="$target_win"></a>} if $can_delete;
    print "</td>\n</tr>" if ( $can_view || $can_delete );

    print "</table>\n";
  }
  else     #    ,     (. PRIMARY KEY)
  {
    #          "/"
    if ( ! $query->param( 'exp_imp' ) &&
         have_access( 'module' => $module, 'procedure' => 'ADD', 
                      'user' => $user ) )
    {
      #        
      #   
      print "<br />\n";
      print qq{<a class="command_link" href="$script_name/add?$href"} .
            qq{ target="$target_win"> </a>};
    }
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $obj_id;             #    . 
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id     = $query->param( 'obj_id' );
  $target_win = $query->param( 'target_win' );

  #      
  $command = "SELECT * " .
             "FROM ${db_schema}gen_chars " .
             "WHERE obj_id = $obj_id";

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => $target_win,
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "        : " .
                     "   .  - " .
                     $obj_id,
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "gen_chars",
                       key => "obj_id",
                       f_names => \@f_names,
                       f_special => undef,
                       func_special => undef,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #       
    $fields{ 'obj_id' } = $query->param( 'obj_id' );

    #   

    #   
    $fields{ 'gen_char' }         = $CFG{ GEN_CHARS_GEN_CHAR };

    #    ,  
    $fields{ 'useful_fragments' } = $CFG{ GEN_CHARS_USEFUL_FRAGMENTS };

    # 
    $fields{ 'comment' }          = $CFG{ GEN_CHARS_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  #    "  
  #  "   ,   
  #  ,     , ..   
  #   UPDATE   ,    
  #  INSERT (     ,   
  #    ,      )
  print $query->hidden( -name => 'obj_id' ), "\n";

  #      .  
  #  ,     add_rec()  update_rec()
  print $query->hidden( -name => 'bib_rec' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print_add_info();           #     

  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].gen_char", "GEN_CHARS_GEN_CHAR" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'gen_char',
                          -default => $fields{ 'gen_char' },
                          -rows => $CFG{ GEN_CHARS_GEN_CHAR_ROWS },
                          -columns => $CFG{ GEN_CHARS_GEN_CHAR_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>       " .
            "( , , ...)</th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].useful_fragments",
                   "GEN_CHARS_USEFUL_FRAGMENTS" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'useful_fragments',
                          -default => $fields{ 'useful_fragments' },
                          -rows => $CFG{ GEN_CHARS_USEFUL_FRAGMENTS_ROWS },
                          -columns => $CFG{ GEN_CHARS_USEFUL_FRAGMENTS_COLS } 
                        ),
        "</td>\n";
  print "</tr>\n";

  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment", "GEN_CHARS_COMMENT" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ GEN_CHARS_COMMENT_ROWS },
                          -columns => $CFG{ GEN_CHARS_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
  return ( 0 );
}

# -----------------------------------------------------------------------------
#          
# -----------------------------------------------------------------------------
sub print_add_info
{
  #  .    
  print_bib_record( $query, "   " .
                    " " );
  return ( 0 );
}
