#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :    " "
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'KEYWORDS';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Keywords
my @f_names =
   ( 'keyword_code',      #   
     'keyword_name',      #   ()
     'keyword_code_orig', #   ,   
                          # (  , , ,
                          #    )
     'lang_code',         #   (1 -  )
     'comment'            # 
   );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              do_find => \&do_find,
              do_export => \&do_export,
              do_import => \&do_import,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              action => $script_name
            );

#    ,     
if ( $query->path_info =~ /^\/list_bib_recs$/ )
{
  do_list_bib_recs();
}


exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  if ( $query->param( 'keyword_code' ) eq '' )
  {
    push( @error_messages, "    " );
  }

  if ( $query->param( 'keyword_name' ) eq '' )
  {
    push( @error_messages, "    ()" );
  }

  #     
  if ( $query->param( 'keyword_code_orig' ) !~ /^\d*$/ )
  {
    push( @error_messages, "    --  " );
  }

  if ( $query->param( 'lang_code' ) eq '' )
  {
    push( @error_messages, "   " );
  }

  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }
  
  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => ' ',
                    user => $user,
                    make_letters => 'yes',
                    num_last_recs => $CFG{ KEYWORDS_NUM_LAST_RECS },
                    full_top => 'yes'
                  );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $keyword_code;          #   
  my $command;               #      

  $keyword_code = $query->param( 'keyword_code' );
  
  #         
  $command = "DELETE FROM ${db_schema}keywords " .
             "WHERE keyword_code = '$keyword_code'";

  #   
  #   
  del_rec( query => $query,
           create_top => \&create_top,
           target => "_self",
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_export
{
  my $keyword_code;          #   
  my $command;               #      
  my @table_cmd_pairs = ();  #     ,
                             #       

  $keyword_code = $query->param( 'keyword_code' );

  #  -       
  #    (      , 
  #     )
  $command = "SELECT * FROM Keywords WHERE keyword_code = $keyword_code";
  push( @table_cmd_pairs, [ 'Keywords', $command ] );

  #    
  export_data( query => $query,
               create_top => \&create_top,
               table_cmd_pairs => \@table_cmd_pairs
             );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_find
{
  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();       #     
  create_top();     #    
  close_top();      #     
  
  open_bottom();    #     
  
  print "<p class=\"info\">     </p>\n";

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_import
{
  my $keyword_code;          #   
  my $command;               #      
  my @table_cmd_pairs = ();  #     ,
                             #       

  $keyword_code = $query->param( 'keyword_code' );

  #  -       
  #    (      , 
  #     )
  $command = "SELECT * FROM exp_imp.Keywords " .
             "WHERE keyword_code = $keyword_code";
  push( @table_cmd_pairs, [ 'Keywords', $command ] );

  #    
  import_data( query => $query,
               create_top => \&create_top,
               table_cmd_pairs => \@table_cmd_pairs
             );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#    .   ,   
#  
# -----------------------------------------------------------------------------
sub do_list_bib_recs
{
  my( $result, $i );              #    
  my @row;                        #      
  my $command;                    #      
  my $keyword_code;               #   ,  
                                  # 
  my @keywords = ();              #    ,
                                  #   ""   ,
                                  #  
  my $headline;                   #   . 
  my $keywords_info;              #   ,   

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  $keyword_code = $query->param( 'keyword_code' );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  #     Keywords     :
  # --  ,  "" ;
  # --  ,     
  #    (   keyword_code_orig);
  # -- ,      
  #   (   keyword_code_orig);
  # -- ,        ,
  #     ,   
  # . .        
  #             Persons.pl.
  $command = "SELECT k1.keyword_code, k1.keyword_name " .
             "FROM ${db_schema}keywords k1 " .
             "WHERE k1.keyword_code = $keyword_code OR " .
                   "k1.keyword_code = ( SELECT k2.keyword_code_orig " .
                                       "FROM ${db_schema}keywords k2 " .
                                       "WHERE k2.keyword_code = " .
                                             "$keyword_code ) OR " .
                   "k1.keyword_code_orig = $keyword_code OR " .
                   "k1.keyword_code_orig = ( SELECT k3.keyword_code_orig " .
                                            "FROM ${db_schema}keywords k3 " .
                                            "WHERE k3.keyword_code = " .
                                                  "$keyword_code ) " .
             "ORDER BY k1.keyword_name";

  $result = exec_select( $command );   #    
  
  if ( $result )
  {
    #    .      
    while ( @row = $result->fetchrow )
    {
      $keywords_info .= $row[ $result->fnumber( 'keyword_name' ) ] . "; ";
      push( @keywords, $row[ $result->fnumber( 'keyword_code' ) ] );
    }

    $keywords_info =~ s/; $//;   #     :  
  }
  else
  {
    ;
    # TODO.  -   ?
  }
  # ------------------------------------------------------------------------

  #       
  print "<p class=\"bib_rec\">$keywords_info</p>\n";

  #   
  $headline = "<h2 class=\"module_title\">" .
              " ,    " .
              " " .
              "</h2>\n";

  #     .  ,  
  #    ,  , , 
  #     . .   ,  ;
  #  DISTINCT, . .        
  #     (,    
  #   --    )
  $command = "SELECT DISTINCT b.obj_id, b.bib_rec_num, " .
                    "CASE WHEN b.bib_rec_short IS NOT NULL " .
                         "THEN b.bib_rec_short " .
                         "ELSE b.bib_rec_full " .
                    "END AS bib_rec " .
             "FROM ${db_schema}obj_keywords ok, ${db_schema}bib_recs b " .
             "WHERE ok.obj_id = b.obj_id AND " .
                   "ok.keyword_code IN (" . join( ",", @keywords ) . ") " .
             "ORDER BY bib_rec";

  #  .   ,   
  list_bib_recs_by_query( $query, $command, $headline );

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      (),  
#    
# -----------------------------------------------------------------------------
sub do_query
{
  my( $result, $i );              #    
  my @row;                        #      
  my $command;                    #      
  my $letter;                     #    
  my $letter_lower;               #   --   

  #   ,   ,   
  #     
  my $num_last_recs;

  #  WHERE   
  my $where;

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #      / 
  my $can_export = 0;
  my $can_import = 0;

  #        
  #   ( --      
  #   )
  my $add_params = '';

  #  ,        
  my $alt_row = 1;

  my $href;    #   HTML-

  #         
  #  enable_select  caller_name (  )
  if ( $query->param( 'enable_select' ) )
  {
    $add_params = "&enable_select=1&caller_name=" .
                  $query->param( 'caller_name' );
  }

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  $letter        = $query->param( 'letter' );
  $num_last_recs = $query->param( 'num_last_recs' );

  #    ,      - 
  #      
  # .    undef,      '' 
  #               -   CGI.pm.
  if ( ( $letter eq undef || $letter eq '' ) &&
       ( $num_last_recs eq undef || $num_last_recs eq '' )
     )
  {
    close_bottom();   #     
    print $query->end_html();
    return ( 0 );
  }

  #         ,
  #   
  if ( $num_last_recs )
  {
    # .        
    #                ,   ,  
    #              .  -   ,
    #                ""   
    #             keyword_code,       .
    $where = "WHERE k1.keyword_code >= ( SELECT max( keyword_code ) " .
                                        "FROM ${db_schema}keywords " .
                                      ") - $num_last_recs + 1 ";
  }
  #       
  elsif ( $letter )
  {
    #        
    $letter = reveal_rus_letter( $letter );

    #      , 
    # ,   
    $letter_lower = change_case( $letter, 'lower' );

    #    --  ,    
    $where = "WHERE k1.keyword_name ~ '^($letter|\"$letter|" .
                                        "$letter_lower|\"$letter_lower)' ";
  }

  #       (    ,
  #     ),    $where
  # (. .          )
  #     -  
  $command = "SELECT k1.*, k2.keyword_name AS keyword_name_orig, " .
                    "l.lang_sname " .
             "FROM ( ${db_schema}keywords k1 " .
                  "LEFT JOIN ${db_schema}keywords k2 " .
                  "ON k1.keyword_code_orig = k2.keyword_code ) " .
                  "LEFT JOIN ${db_schema}langs l " .
                  "ON k1.lang_code = l.lang_code " .
             $where .
  #        ,   
  #      (,     
  #    --  )
  #      -- ,    ,  
  #  ,    ;
             "ORDER BY CASE WHEN k1.keyword_name ~ '^\"' " .
                           "THEN lower( substr( k1.keyword_name, 2 ) ) " .
                           "ELSE lower( k1.keyword_name ) " .
                      "END";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    #    ,    ,   
    if ( $num_last_recs )
    {
      print "<h3>,      (" . 
            $num_last_recs . " .)</h3>\n";
    }

    #       ,     
    # "  ",       
    # (      ,
    #     )
    if ( $query->param( 'enable_select' ) &&
         $query->param( 'caller_name') eq $module )
    {
      $can_view = 0;
      $can_delete = 0;
    }
    else
    {
      $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                               'user' => $user );
      $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                                 'user' => $user );
    }

    #     "/",     
    if ( $query->param( 'exp_imp' ) )
    {
      $can_import = import_enabled() && 
                    have_access( 'module' => $module, 'procedure' => 'IMPORT',
                                 'user' => $user );
    }
    #    public --   ,
    #   -- 
    else
    {
      $can_export = export_enabled() && 
                    have_access( 'module' => $module, 'procedure' => 'EXPORT',
                                 'user' => $user );
    }

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th>  </th>\n";
    print "<th>  ()</th>\n";
    print "<th>  &mdash;  </th>\n";
    print "<th></th>\n";
    print "<th>&nbsp;</th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete || $can_export ||
                                   $can_import );
    print "</tr>\n";

    #          
    #      ...
    if ( $query->param( 'enable_select' ) )
    {
      # ...    JavaScript    
      #     Keywords     ...
      if ( $query->param( 'caller_name' ) eq 'OBJ_KEYWORDS' )
      {
        # ...  keyword_code  keyword_name   OBJ_KEYWORDS
        create_assign_values_func( 'keyword_code', 'keyword_name' );
      }
      elsif ( $query->param( 'caller_name' ) eq 'KEYWORDS' )
      {
        # ...  keyword_code_orig  keyword_name_orig   KEYWORDS
        create_assign_values_func( 'keyword_code_orig', 'keyword_name_orig' );
      }
    }

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #    ,   (), 
      #      --  , ,   
      #  
      # (  &nbsp;    ,  
      # ,   :   
      # 'keyword_code_orig'  null,    
      # -)
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( 'keyword_code' ) ]</td>\n";

      #         
      #      ,   
      # keyword_name    

      #     "" 
      # (.    obj_groups_descrs.pl)
      #     , . . , 
      #   escapeHTML(), 
      my $keyword_name = $row[ $result->fnumber( 'keyword_name' ) ];
      $keyword_name =~ s/\'/\\\'/g;
      $keyword_name = CGI::escapeHTML( $keyword_name );

      if ( $query->param( 'enable_select' ) )
      {
        print "<td>",
              qq{ <a class="command_link" href="javascript:void( 0 )" onclick=
                  "assign_values( $row[ $result->fnumber( 'keyword_code' ) ],
                                  '$keyword_name' )">
                   $row[ $result->fnumber( 'keyword_name' ) ]</a> },
              "</td>\n";
      }
      else
      {
        print "<td>$row[ $result->fnumber( 'keyword_name' ) ]</td>\n";
      }

      #   ,   , ,
      #      "&nbsp;"
      print "<td>",
            ( $row[ $result->fnumber( 'keyword_code_orig' ) ] ne undef ) ?
              "(" . $row[ $result->fnumber( 'keyword_code_orig' ) ] . ") " .
              $row[ $result->fnumber( 'keyword_name_orig' ) ] :
            "&nbsp;",
            "</td>\n";

      print "<td>$row[ $result->fnumber( 'lang_sname' ) ]</td>\n";

      #   HTML-
      $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
              "keyword_code=" . $row[ $result->fnumber( 'keyword_code' ) ] .
              $add_params;

      #  .   ,   
      #  
      print "<td>",
            qq{ <a class="command_link"} .
            qq{ href="$script_name/list_bib_recs?$href"} .
            qq{ target="_blank">. </a> },
            "</td>\n";

      #    ()   
      print "<td>" if ( $can_view || $can_delete || $can_export ||
                        $can_import );
      print qq{ <a class="command_link" href="$script_name/view?$href"} .
            qq{ target="_self"></a> } . "\n" if $can_view;

      #     
      print qq{ <a class="command_link" href="$script_name/delete?$href"} .
            qq{ onclick="$confirm_delete" } .
            qq{ target="_self"></a> } . "\n" if $can_delete;

      #   
      print qq{ <a class="command_link" href="$script_name/export?$href"} .
            qq{ onclick="$confirm_export"} .
            qq{ target="_blank"></A> } . "\n" if $can_export;

      #   
      print qq{ <a class="command_link" href="$script_name/import?$href"} .
            qq{ onclick="$confirm_import"} .
            qq{ target="_blank"></A> } . "\n" if $can_import;

      print "</td>" if ( $can_view || $can_delete || $can_export ||
                         $can_import );
      print "</tr>\n";
    }
    print "</table>\n";
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $keyword_code;               #   
  my $command;                    #      

  $keyword_code = $query->param( 'keyword_code' );

  #      
  #     -  
  $command = "SELECT k1.*, k2.keyword_name AS keyword_name_orig " .
             "FROM ${db_schema}keywords k1 " .
                  "LEFT JOIN ${db_schema}keywords k2 " .
                  "ON k1.keyword_code_orig = k2.keyword_code " .
             "WHERE k1.keyword_code = '$keyword_code'";

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => "_self",
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "         " .
                     "  " . $keyword_code,
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
          );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "keywords",
                       key => "keyword_code",
                       f_names => \@f_names,
                       f_special => undef,
                       func_special => undef,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  #      (    
  # ,     )
  my( $ref_values, $ref_labels ) = popup_langs_list( $db_schema );

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #         ,
    #   1        
    $fields{ 'keyword_code' } = get_next_key_value( 'keywords',
                                                    'keyword_code' );
    #   

    #   ()
    $fields{ 'keyword_name' }      = $CFG{ KEYWORDS_KEYWORD_NAME };

    #   ,   
    # (  , , ,
    #    )
    $fields{ 'keyword_code_orig' } = $CFG{ KEYWORDS_KEYWORD_CODE_ORIG };

    #   (1 -  )
    $fields{ 'lang_code' }         = $CFG{ KEYWORDS_LANG_CODE };

    # 
    $fields{ 'comment' }           = $CFG{ KEYWORDS_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  #    "  "  
  #    get_next_key_value(),    
  # ,     , ..  
  #    UPDATE   
  print $query->hidden( -name => 'keyword_code',
                        -default => $fields{ 'keyword_code' }
                      ), "\n";

  #       ,     
  #           ,
  #        ,   
  #  ,     
  # . .    cities.pl.
  print $query->hidden( -name => 'enable_select' ), "\n";
  print $query->hidden( -name => 'caller_name' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>", $fields{ 'keyword_code' }, "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  ()</th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].keyword_name",
                   "KEYWORDS_KEYWORD_NAME" ) if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'keyword_name',
                           -default => $fields{ 'keyword_name' },
                           -size => $CFG{ KEYWORDS_KEYWORD_NAME_SIZE },
                           -maxlength =>
                             $CFG{ KEYWORDS_KEYWORD_NAME_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  &mdash;  </th>\n";

  #      JavaScript,  
  # - keywords.pl
  create_selection_func( func_name => 'select_orig_keyword',
                         module_name => 'keywords.pl',
                         caller_name => $module,
                         window_name => 'orig_keywords',
                         exp_imp => $query->param( 'exp_imp' ) );

  #     (  )
  print "<td>",
        $query->textfield( -name => 'keyword_code_orig',
                           -default => $fields{ 'keyword_code_orig' },
                           -size => $CFG{ KEYWORDS_KEYWORD_CODE_ORIG_SIZE },
                           -maxlength =>
                             $CFG{ KEYWORDS_KEYWORD_CODE_ORIG_MAXLENGTH }
                         ),
        "&nbsp;&nbsp;",
        $query->textfield( -name => 'keyword_name_orig',
                           -default => $fields{ 'keyword_name_orig' },
                           -size => $CFG{ KEYWORDS_KEYWORD_NAME_ORIG_SIZE },
                           -maxlength =>
                             $CFG{ KEYWORDS_KEYWORD_NAME_ORIG_MAXLENGTH },
                           -readonly => 'readonly'
                         ),
        "&nbsp;&nbsp;",
        qq{ <a class="command_link" href="javascript:void( 0 )" onclick=} .
        qq{"select_orig_keyword()">} . "</a>",
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  
  #        labels  
  # ,    popup_langs_list()   ,
  #   -   
  print "<th></th>\n";
  print "<td>",
        $query->popup_menu( -name => 'lang_code',
                            -default => $fields{ 'lang_code' },
                            -values => $ref_values,
                            -labels => { @{ $ref_labels } }
                          ),
        "</td>\n";
  print "</tr>\n";
  
  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment", "KEYWORDS_COMMENT" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ KEYWORDS_COMMENT_ROWS },
                          -columns => $CFG{ KEYWORDS_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
  return ( 0 );
}
