#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :      ,   
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

# .     (.  tables34.cfg):
#             -  ( );
#             -  ;
#             -   (   );
#             - .
#              ,    3  4  (
#              ,       ).

# .    " "  
#                ,       
#                 .   
#                  ,  () 
#               .

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;             # CGI-
my $script_name;       #    ( )

#    (    
#      )
my $module;

my $table;             #     
my $table_type;        #  :      
my @f_names = ();      #     
my $key_name;          #    
my $short_name;        #     
my $full_name;         #     
                       # .    "" 
                       #                $full_name.
my $title;             # ,   

use constant TABLE_3_FIELDS   => 0;  #    
use constant TABLE_4_FIELDS   => 1;  #    

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#        -
get_table_info();

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              do_find => \&do_find,
              do_export => \&do_export,
              do_import => \&do_import,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              action => $script_name
            );

exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  if ( $query->param( $key_name ) eq '' )
  {
    push( @error_messages, "    " );
  }

  #   ""
  if ( $table_type == TABLE_4_FIELDS && 
       $query->param( $short_name ) eq '' )
  {
    push( @error_messages, "   " );
  }

  if ( $query->param( $full_name ) eq '' )
  {
    #        ,  
    # $full_name    "",   
    # ""  (  $short_name  
    #  "" )
    push( @error_messages, ( $table_type == TABLE_4_FIELDS ) ?
                             "   " :
                             "  " );
  }

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }

  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => $title,
                    user => $user
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $command;               #      

  my $key_value = $query->param( $key_name );  #   
  
  #         
  $command = "DELETE FROM ${db_schema}$table " .
             "WHERE $key_name = '$key_value'";

  #   
  del_rec( query => $query,
           create_top => \&create_top,
           target => "_self",
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_export
{
  my $command;               #      
  my @table_cmd_pairs = ();  #     ,
                             #       

  my $key_value = $query->param( $key_name );  #   

  #  -       
  #    (      , 
  #     )
  $command = "SELECT * FROM $table " .
             "WHERE $key_name = '$key_value'";
  push( @table_cmd_pairs, [ $table, $command ] );

  #    
  export_data( query => $query,
               create_top => \&create_top,
               table_cmd_pairs => \@table_cmd_pairs
             );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_find
{
  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();       #     
  create_top();     #    
  close_top();      #     
  
  open_bottom();    #     
  
  print "<p class=\"info\">     </p>\n";

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_import
{
  my $command;               #      
  my @table_cmd_pairs = ();  #     ,
                             #       

  my $key_value = $query->param( $key_name );  #   

  #  -       
  #    (      , 
  #     )
  $command = "SELECT * FROM exp_imp.$table " .
             "WHERE $key_name = '$key_value'";
  push( @table_cmd_pairs, [ $table, $command ] );

  #    
  import_data( query => $query,
               create_top => \&create_top,
               table_cmd_pairs => \@table_cmd_pairs
             );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub do_query
{
  my( $result, $i );              #    
  my @row;                        #      
  my $command;                    #      

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #      / 
  my $can_export = 0;
  my $can_import = 0;

  #  ,        
  my $alt_row = 1;

  my $href;    #   HTML-

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  #      (   )
  $command = "SELECT * FROM ${db_schema}$table " .
             "ORDER BY $full_name";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                             'user' => $user );
    $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                               'user' => $user );

    #     "/",     
    if ( $query->param( 'exp_imp' ) )
    {
      $can_import = import_enabled() && 
                    have_access( 'module' => $module, 'procedure' => 'IMPORT',
                                 'user' => $user );
    }
    #    public --   ,
    #   -- 
    else
    {
      $can_export = export_enabled() && 
                    have_access( 'module' => $module, 'procedure' => 'EXPORT',
                                 'user' => $user );
    }

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th></th>\n";
    
    ( $table_type == TABLE_4_FIELDS ) ?
      print "<th> </th>\n" :
      print "<th></th>\n";

    #   
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete || $can_export ||
                                   $can_import );
    print "</tr>\n";

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #  (  -  )
      # id       -- lang_code
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( $key_name ) ]</td>\n";

      #   "",    
      if ( $table_type == TABLE_4_FIELDS )
      {
        print "<td>$row[ $result->fnumber( $short_name ) ]</td>\n";
      }
      #   "",   "" ,
      #     $full_name
      else
      {
        print "<td>$row[ $result->fnumber( $full_name ) ]</td>\n";
      }

      #   HTML-
      $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
              "$key_name=" . $row[ $result->fnumber( $key_name ) ];

      #     
      print "<td>" if ( $can_view || $can_delete || $can_export ||
                        $can_import );
      print qq{ <a class="command_link" href="$script_name/view?$href"} .
            qq{ target="_self"></a> } . "\n" if $can_view;

      #  
      print qq{ <a class="command_link" href="$script_name/delete?$href"} .
            qq{ onclick="$confirm_delete" } .
            qq{ target="_self"></a> } if $can_delete;

      #   
      print qq{ <a class="command_link" href="$script_name/export?$href"} .
            qq{ onclick="$confirm_export"} .
            qq{ target="_blank"></A> } . "\n" if $can_export;

      #   
      print qq{ <a class="command_link" href="$script_name/import?$href"} .
            qq{ onclick="$confirm_import"} .
            qq{ target="_blank"></A> } . "\n" if $can_import;

      print "</td>" if ( $can_view || $can_delete || $can_export ||
                         $can_import );
      print "</tr>\n";
    }
    print "</table>\n";
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $command;                    #      

  my $key_value = $query->param( $key_name );  #   

  #   
  $command = "SELECT * FROM ${db_schema}$table " .
             "WHERE $key_name = '$key_value'";

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => "_self",
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "        " .
                     "  " . $key_value,
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
          );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#        -
# -----------------------------------------------------------------------------
sub get_table_info
{
  #    (    )
  #       
  my $script;

  my $in_table = 0;
  
  #    (  .pl)   ,  
  ( undef, $script ) = $script_name =~ /^(.+\/)(.+)\..+$/;

  #      -
  if ( ! open( TABLES, "< ./cfg/tables34.cfg" ) )
  {
    #     
    print STDERR "    tables34.cfg: $!\n"; 

    #   
    die "    tables34.cfg: $!\n";
  }

  while ( <TABLES> )
  {
    chomp;                  #    
    next if $_ eq '';       #   
    next if $_ =~ /^\s*#/;  # - 

    s/^\s*//;               #    ...
    s/\s*$//;               # ...  

    if ( /^TABLE\s+(.+)$/ )
    {
      if ( lc( $1 ) eq $script )
      {
        $in_table = 1;          #  ""  
        $table = $1;            #     
        $module = uc( $table ); #   
      }
    }
    elsif ( $in_table == 1 )
    {
      if ( /^TITLE\s+(.+)$/ )
      {
        $title = $1;            # ,   
      }
      elsif ( /_code$/ )
      {
        $key_name = $_;         #          

        #      
        push( @f_names, $key_name );
      }
      elsif ( /_fname$/ )
      {
        $full_name = $_;        #     

        #      
        push( @f_names, $full_name );

        #     ""    
        #   _fname
        $table_type = TABLE_4_FIELDS;
      }
      elsif ( /_sname$/ )
      {
        $short_name = $_;       #     

        #      
        push( @f_names, $short_name );
      }
      elsif ( /_name$/ )
      {
        $full_name = $_;        #     

        #      
        push( @f_names, $full_name );

        #     ""    
        #   _name
        $table_type = TABLE_3_FIELDS;
      }
      elsif ( /^comment$/ )     #       
      {
        #      
        push( @f_names, 'comment' );

        $in_table = 0;          #     
      }
    }
    elsif ( $in_table == 0 )
    {
      next;
    }
  }

  #      -
  if ( ! close( TABLES ) )
  {
    #     
    print STDERR "    tables34.cfg: $!\n"; 

    #   
    die "    tables34.cfg: $!";
  }

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => $table,
                       key => $key_name,
                       f_names => \@f_names,
                       f_special => undef,
                       func_special => undef,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  #    -       
  #  , ...
  if ( $ref_row ne undef )  #      
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #         ,
    #   1        
    $fields{ $key_name } = get_next_key_value( $table, $key_name );
  }
  # -------------------------------------------------------------------

  #    " ..."  
  #    get_next_key_value(),    
  # ,     , ..  
  #    UPDATE   
  print $query->hidden( -name => $key_name,
                        -default => $fields{ $key_name }
                      ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";
 
  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th></th>\n";
  print "<td>", $fields{ $key_name }, "</td>\n";
  print "</tr>\n";

  print "<tr>\n";

  #       
  ( $table_type == TABLE_4_FIELDS ) ?
    print "<th> </th>\n" :
    print "<th></th>\n";

  print "<td>",
        $query->textfield( -name => $full_name,
                           -default => $fields{ $full_name },
                           -size => $CFG{ LANGS_LANG_FNAME_SIZE },
                           -maxlength => $CFG{ LANGS_LANG_FNAME_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  if ( $table_type == TABLE_4_FIELDS )
  {
    print "<tr>\n";
    print "<th> </th>\n";
    print "<td>",
          $query->textfield( -name => $short_name,
                             -default => $fields{ $short_name },
                             -size => $CFG{ LANGS_LANG_SNAME_SIZE },
                             -maxlength => $CFG{ LANGS_LANG_SNAME_MAXLENGTH }
                           ),
          "</td>\n";
    print "</tr>\n";
  }
  
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>",
        $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ LANGS_COMMENT_ROWS },
                          -columns => $CFG{ LANGS_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";

  print "</table>\n";

  # --------------------------------------------------------------------
    
  return ( 0 );
}
