#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :   "-"
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'OBJ_CONTAINERS';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Obj_containers
my @f_names =
   ( 'obj_id',           #   
                         #   ( )
     'bib_rec_num',      #  .    
                         # (    0) 
     'part_num',         #   
     'obj_id_cont',      #    
                         # ,     
                         # (-)
     'bib_rec_num_cont', #  .    
                         # (    0)
     'part_place',       #  ,    
                         #  (   8 .  )
     'comment'           # 
   );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              print_add_info => \&print_add_info,
              action => $script_name
            );

exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  #   
  if ( $query->param( 'part_num' ) !~ /^\d+$/ )
  {
    push( @error_messages, "      " .
          "" );
  }

  #   
  if ( $query->param( 'obj_id_cont' ) !~ /^\d+$/ )
  {
    push( @error_messages, "     " .
          "  . ,    " .
          "  (-)" );
  }

  #   
  if ( $query->param( 'bib_rec_num_cont' ) !~ /^\d+$/ )
  {
    push( @error_messages, "     .   " .
          "-" );
  }

  # DEBUG
  # print_params( $query );
  
  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }

  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => '  ()',
                    user => $user,
                    full_top => 'no'
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $obj_id;             #    . 
                          # ( )
  my $bib_rec_num;        #  .    
  my $part_num;           #   
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id      = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );
  $part_num    = $query->param( 'part_num' );
  $target_win  = $query->param( 'target_win' );

  #         
  # .       ,
  #               ,     .
  $command = "DELETE FROM ${db_schema}obj_containers " .
             "WHERE obj_id = '$obj_id' AND " .
                   "bib_rec_num = '$bib_rec_num' AND " .
                   "part_num = '$part_num'";

  #   
  del_rec( query => $query,
           target => $target_win,
           create_top => \&create_top,
           print_add_info => \&print_add_info,
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#    -   . 
#  
# -----------------------------------------------------------------------------
sub do_query
{
  # .        
  #              bib_recs.pl.

  my $obj_id;             #    . 
                          # ( )
  my $bib_rec_num;        #  .    
  my $bib_rec;            # . . 
  my $target_win;         #      HTML-
  my( $result, $i );      #    
  my @row;                #      
  my $command;            #      
  my $href;               #   HTML-

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #  ,        
  my $alt_row = 1;

  $obj_id      = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );
  $bib_rec     = $query->param( 'bib_rec' );
  $target_win  = $query->param( 'target_win' );

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => $target_win );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  print_add_info(); #     

  #  ,    
  $bib_rec = CGI::escape( $bib_rec );

  #   HTML-
  $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
          "obj_id=$obj_id" .
          "&bib_rec_num=$bib_rec_num" .
          "&bib_rec=$bib_rec" .
          "&target_win=$target_win";

  #     -   
  # .   PostgreSQL,  
  #                  -  ( ,
  #                     
  #             'bib_rec_full'  'bib_rec_short').
  $command = "SELECT o.*, " .
                    "CASE WHEN b.bib_rec_short IS NOT NULL " .
                         "THEN b.bib_rec_short " .
                         "ELSE b.bib_rec_full " .
                    "END AS bib_rec_cont " .
             "FROM ${db_schema}obj_containers o, ${db_schema}bib_recs b " .
             "WHERE o.obj_id = '$obj_id' AND " .
                   "o.bib_rec_num = '$bib_rec_num' AND " .
                   "o.obj_id_cont = b.obj_id AND " .
                   "o.bib_rec_num_cont = b.bib_rec_num " .
             "ORDER BY o.part_num";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                             'user' => $user );
    $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                               'user' => $user );

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th> </th>\n";
    print "<th>  - " .
          "  . </th>\n";
    print "<th>  -</th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete );
    print "</tr>\n";

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #    , . 
      # -,    .  -
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( 'part_num' ) ]</td>\n";
      print "<td class=\"center\">",
            $row[ $result->fnumber( 'obj_id_cont' ) ] . " (" .
            $row[ $result->fnumber( 'bib_rec_num_cont' ) ] . ")",
            "</td>\n";

      #    ,      
      # ,   &mdash;
      # . TODO   list_bib_recs_by_query()  E_ARCH.pm.
      my $bib_rec_cont = $row[ $result->fnumber( 'bib_rec_cont' ) ];
      $bib_rec_cont =~ s/--/&mdash;/g;

      print "<td>$bib_rec_cont</td>\n";

      #     -   
      #   
      print "<td>" if ( $can_view || $can_delete );
      print qq{<a class="command_link" href="$script_name/view?$href} .
            "&part_num=" . $row[ $result->fnumber( 'part_num' ) ] . "\"" .
            qq{ target="$target_win"></a>} if $can_view;
      print "\n" if $can_view;

      #     -   
      print qq{<a class="command_link" href="$script_name/delete?$href} .
            "&part_num=" . $row[ $result->fnumber( 'part_num' ) ] . "\"" .
            qq{ onclick="$confirm_delete"} .
            qq{ target="$target_win"></a>} if $can_delete;
      print "</td>\n" if ( $can_view || $can_delete );

      print "</tr>\n";
    }
    print "</table>\n";
  }

  #       - 
  #   
  #          "/"
  if ( ! $query->param( 'exp_imp' ) &&
       have_access( 'module' => $module, 'procedure' => 'ADD', 
                    'user' => $user ) )
  {
    print "<br />\n";
    print qq{<a class="command_link" href="$script_name/add?$href"} .
          qq{ target="$target_win"> </a>};
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $obj_id;             #    . 
                          # ( )
  my $bib_rec_num;        #  .    
  my $part_num;           #   
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id      = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );
  $part_num    = $query->param( 'part_num' );
  $target_win  = $query->param( 'target_win' );

  #     -   
  $command = "SELECT o.*, " .
                    "CASE WHEN b.bib_rec_short IS NOT NULL " .
                         "THEN b.bib_rec_short " .
                         "ELSE b.bib_rec_full " .
                    "END AS bib_rec_cont " .
             "FROM ${db_schema}obj_containers o, ${db_schema}bib_recs b " .
             "WHERE o.obj_id = '$obj_id' AND " .
                   "o.bib_rec_num = '$bib_rec_num' AND " .
                   "o.part_num = '$part_num' AND " .
                   "o.obj_id_cont = b.obj_id AND " .
                   "o.bib_rec_num_cont = b.bib_rec_num";

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => $target_win,
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "        : " .
                     "   .  - " .
                     $obj_id . ", " .
                     " .     - " .
                     $bib_rec_num . ", " .
                     "   - $part_num",
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "obj_containers",
                       key => "obj_id, bib_rec_num, " .
                              "part_num:part_num_begin",
                       f_names => \@f_names,
                       f_special => undef,
                       func_special => undef,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #        
    $fields{ 'obj_id' }      = $query->param( 'obj_id' );
    $fields{ 'bib_rec_num' } = $query->param( 'bib_rec_num' );
    
    #   
    
    #   
    if ( $CFG{ OBJ_CONTAINERS_PART_NUM } )  #    . 
    {
      $fields{ 'part_num' } = $CFG{ OBJ_CONTAINERS_PART_NUM };
    }
    else
    {
      #      part_num  
      # ,   1      
      #    .    . 
      # (   obj_id  bib_rec_num   obj_containers)
      $fields{ 'part_num' } = 
        get_next_key_value( 'obj_containers', 'part_num',
                            'obj_id = ' . $query->param( 'obj_id' ) . ' AND ' .
                            'bib_rec_num = ' . $query->param( 'bib_rec_num' )
                          );
    }

    #     , 
    #      (-)
    $fields{ 'obj_id_cont' }      = $CFG{ OBJ_CONTAINERS_OBJ_ID_CONT };
    
    #  .     (  
    #   0)
    $fields{ 'bib_rec_num_cont' } = $CFG{ OBJ_CONTAINERS_BIB_REC_NUM_CONT };
    
    #  ,     
    if ( $CFG{ OBJ_CONTAINERS_PART_NUM } )  #    . 
    {
      $fields{ 'part_place' }     = $CFG{ OBJ_CONTAINERS_PART_PLACE };
    }
    else  #      . 
    {
      #      ,    
      ( $fields{ 'part_place' } ) = 
        $query->param( 'bib_rec' ) =~ /\. ((\d+--\d+)|(\d+))/;
    }
    
    # 
    $fields{ 'comment' } = $CFG{ OBJ_CONTAINERS_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  #    "  
  #   ( )"  " . 
  #   "   ,    
  # ,     , ..   
  #   UPDATE   ,    
  #  INSERT (     ,  
  #     ,    
  #  )
  print $query->hidden( -name => 'obj_id' ), "\n";
  print $query->hidden( -name => 'bib_rec_num' ), "\n";

  #     "  "
  # .      'begin'  ,
  #                   ,  
  #               (.  make_cmd   E_ARCH.pm).
  #             ..       ,   
  #              (, ,   ).
  print $query->hidden( -name => 'part_num_begin',
                        -default => $fields{ 'part_num' }
                      ), "\n";

  #      .  
  #  ,     add_rec()  update_rec()
  print $query->hidden( -name => 'bib_rec' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print_add_info();         #     

  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>",
        $query->textfield( -name => 'part_num',
                           -default => $fields{ 'part_num' },
                           -size => $CFG{ OBJ_CONTAINERS_PART_NUM_SIZE },
                           -maxlength => 
                             $CFG{ OBJ_CONTAINERS_PART_NUM_MAXLENGTH }
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  -</th>\n";

  #      JavaScript,  
  # - bib_recs.pl
  create_selection_func( func_name => 'select_container',
                         module_name => 'bib_recs.pl',
                         caller_name => $module,
                         window_name => 'containers',
                         exp_imp => $query->param( 'exp_imp' ) );
  print "<td>",
        $query->textfield( -name => 'obj_id_cont',
                           -default => $fields{ 'obj_id_cont' },
                           -size => $CFG{ OBJ_CONTAINERS_OBJ_ID_CONT_SIZE },
                           -maxlength => 
                             $CFG{ OBJ_CONTAINERS_OBJ_ID_CONT_MAXLENGTH }
                         ),
        "&nbsp;&nbsp;",
        qq{ <a class="command_link" href="javascript:void( 0 )"} .
        qq{ onclick="select_container()"></a>},
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>    -</th>\n";
  print "<td>",
        $query->textfield( -name => 'bib_rec_num_cont',
                           -default => $fields{ 'bib_rec_num_cont' },
                           -size => 
                             $CFG{ OBJ_CONTAINERS_BIB_REC_NUM_CONT_SIZE },
                           -maxlength => 
                             $CFG{ OBJ_CONTAINERS_BIB_REC_NUM_CONT_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  #    .  -
  # (  )
  print "<tr>\n";
  print "<th>  -</th>\n";
  print "<td>",
        $query->textarea( -name => 'bib_rec_cont',
                          -default => $fields{ 'bib_rec_cont' },
                          -rows => $CFG{ OBJ_CONTAINERS_BIB_REC_CONT_ROWS },
                          -columns => 
                            $CFG{ OBJ_CONTAINERS_BIB_REC_CONT_COLS },
                          -readonly => 'readonly'
                        ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> ,      " .
            "(   8 .  )</th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].part_place",
                   "OBJ_CONTAINERS_PART_PLACE" ) if $CFG{ HOT_HELP_IS_ON };
  
  print $query->textfield( -name => 'part_place',
                           -default => $fields{ 'part_place' },
                           -size => $CFG{ OBJ_CONTAINERS_PART_PLACE_SIZE },
                           -maxlength => 
                             $CFG{ OBJ_CONTAINERS_PART_PLACE_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment",
                   "OBJ_CONTAINERS_COMMENT" ) if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ OBJ_CONTAINERS_COMMENT_ROWS },
                          -columns => $CFG{ OBJ_CONTAINERS_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
  return ( 0 );
}

# -----------------------------------------------------------------------------
#          
# -----------------------------------------------------------------------------
sub print_add_info
{
  #  .    
  print_bib_record( $query, "-" );
  
  return ( 0 );
}
