#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :   "   () 
#            "
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

# .      
#              " "   " 
#             ".   " "  
#               .    
#                    
#              ,    ,  .

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'OBJ_GROUPS';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Obj_groups
my @f_names =
   ( 'tmp_group_code',     #    
     'obj_id',             #   
                           #  
     'bib_rec_num',        #  .    
                           # (    0)
     'tmp_group_inc_date', #      
     'comment'             # 
   );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              print_add_info => \&print_add_info,
              action => $script_name
            );

exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  if ( $query->param( 'tmp_group_code' ) !~ /^\d+$/ )
  {
    push( @error_messages, "      " .
          " " );
  }

  #    
  if ( ! date_is_correct( $query->param( 'tmp_group_inc_date' ) ) )
  {
    push( @error_messages, "       " .
          "  " );
  }

  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }
  
  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => '  ()',
                    user => $user,
                    full_top => 'no'
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# .   -    do_delete_from_group()
#               obj_groups_descrs.pl.
# TODO        , 
#        .
# -----------------------------------------------------------------------------
sub do_del
{
  my $tmp_group_code;        #    
  my $obj_id;                #    . 
  my $bib_rec_num;           #  .    
  my $target_win;            #      HTML-
  my $command;               #      

  $tmp_group_code = $query->param( 'tmp_group_code' );
  $obj_id         = $query->param( 'obj_id' );
  $bib_rec_num    = $query->param( 'bib_rec_num' );
  $target_win     = $query->param( 'target_win' );
  
  #         
  $command = "DELETE FROM ${db_schema}obj_groups " .
             "WHERE tmp_group_code = '$tmp_group_code' AND " .
                   "obj_id = '$obj_id' AND " .
                   "bib_rec_num = '$bib_rec_num' ";

  #   
  del_rec( query => $query,
           target => $target_win,
           create_top => \&create_top,
           print_add_info => \&print_add_info,
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#   ,     
# -----------------------------------------------------------------------------
sub do_query
{
  # .        
  #              bib_recs.pl.

  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $bib_rec;            # . 
  my $target_win;         #      HTML-
  my( $result, $i );      #    
  my @row;                #      
  my $command;            #      
  my $href;               #   HTML-

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #  ,        
  my $alt_row = 1;

  $obj_id      = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );
  $bib_rec     = $query->param( 'bib_rec' );
  $target_win  = $query->param( 'target_win' );

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => $target_win );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  print_add_info(); #     

  #  ,    
  $bib_rec = CGI::escape( $bib_rec );

  #   HTML-
  $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
          "obj_id=$obj_id" .
          "&bib_rec_num=$bib_rec_num" .
          "&bib_rec=$bib_rec" .
          "&target_win=$target_win";

  #         
  $command = "SELECT og.*, ogd.tmp_group_name " .
             "FROM ${db_schema}obj_groups og, " .
                  "${db_schema}obj_groups_descrs ogd " .
             "WHERE og.obj_id = '$obj_id' AND " .
                   "og.bib_rec_num = '$bib_rec_num' AND " .
                   "og.tmp_group_code = ogd.tmp_group_code " .
             "ORDER BY ogd.tmp_group_name";

  $result = exec_select( $command );   #    
  
  if ( $result )
  {
    $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                             'user' => $user );
    $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                               'user' => $user );

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th>   </th>\n";
    print "<th>  </th>\n";
    print "<th>     </th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete );
    print "</tr>\n";

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #       , 
      #     
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( 'tmp_group_code' ) ]</td>\n";
      print "<td>$row[ $result->fnumber( 'tmp_group_name' ) ]</td>\n";
      print "<td class=\"center\">",
            date_for_display( $row[ $result->fnumber( 'tmp_group_inc_date' ) ]
                            ),
            "</td>\n";

      #         
      print "<td>" if ( $can_view || $can_delete );
      print qq{<a class="command_link" href="$script_name/view?$href} .
            "&tmp_group_code=" .
            $row[ $result->fnumber( 'tmp_group_code' ) ] . "\"" .
            qq{ target="$target_win"></a>} if $can_view;
      print "\n" if $can_view;

      #      
      print qq{<a class="command_link" href="$script_name/delete?$href} .
            "&tmp_group_code=" .
            $row[ $result->fnumber( 'tmp_group_code' ) ] . "\"" .
            qq{ onclick="$confirm_delete"} .
            qq{ target="$target_win"></a>} if $can_delete;
      print "</td>\n" if ( $can_view || $can_delete );

      print "</tr>\n";
    }
    print "</table>\n";
  }

  #        
  #          "/"
  if ( ! $query->param( 'exp_imp' ) &&
       have_access( 'module' => $module, 'procedure' => 'ADD', 
                    'user' => $user ) )
  {
    print "<br />\n";
    print qq{<a class="command_link" href="$script_name/add?$href"} .
          qq{ target="$target_win"> </a>};
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $tmp_group_code;     #    
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id         = $query->param( 'obj_id' );
  $bib_rec_num    = $query->param( 'bib_rec_num' );
  $tmp_group_code = $query->param( 'tmp_group_code' );
  $target_win     = $query->param( 'target_win' );

  #         
  $command = "SELECT og.*, ogd.tmp_group_name " .
             "FROM ${db_schema}obj_groups og, " .
                  "${db_schema}obj_groups_descrs ogd " .
             "WHERE og.tmp_group_code = '$tmp_group_code' AND " .
                   "og.obj_id = '$obj_id' AND " .
                   "og.bib_rec_num = '$bib_rec_num' AND " .
                   "og.tmp_group_code = ogd.tmp_group_code";

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => $target_win,
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "        : " .
                     "   .  - " .
                     $obj_id . ", " .
                     " .     - " .
                     $bib_rec_num . ", " .
                     "    - $tmp_group_code",
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "obj_groups",
                       key => "obj_id, bib_rec_num, " .
                              "tmp_group_code:tmp_group_code_begin",
                       f_names => \@f_names,
                       f_special => [ 'tmp_group_inc_date' ],
                       func_special => \&non_std_fields,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  my( $day, $mon, $year );  #    

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #        
    $fields{ 'obj_id' }      = $query->param( 'obj_id' );
    $fields{ 'bib_rec_num' } = $query->param( 'bib_rec_num' );

    #   
    ( $day, $mon, $year ) = ( localtime() )[ 3..5 ];

    $fields{ 'tmp_group_inc_date' } =
      sprintf( "%04d-%02d-%02d", $year + 1900, $mon + 1, $day );

    #   

    #     ( )
    $fields{ 'tmp_group_code' } = $CFG{ OBJ_GROUPS_TMP_GROUP_CODE };

    # 
    $fields{ 'comment' }        = $CFG{ OBJ_GROUPS_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  #    "  
  #  "  " .   
  # "   ,     ,
  #     , ..    
  #  UPDATE   ,      INSERT
  # (     ,    
  #   ,      )
  print $query->hidden( -name => 'obj_id' ), "\n";
  print $query->hidden( -name => 'bib_rec_num' ), "\n";

  #     "   "
  # .      'begin'  ,
  #                   ,  
  #               (.  make_cmd   E_ARCH.pm.
  #             ..       ,   
  #              (, ,   ).
  print $query->hidden( -name => 'tmp_group_code_begin',
                        -default => $fields{ 'tmp_group_code' }
                      ), "\n";

  #      .  
  #  ,     add_rec()  update_rec()
  print $query->hidden( -name => 'bib_rec' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print_add_info();          #     

  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th>   </th>\n";

  #      JavaScript,  
  # - obj_groups_descrs.pl
  create_selection_func( func_name => 'select_tmp_group',
                         module_name => 'obj_groups_descrs.pl',
                         caller_name => $module,
                         window_name => 'obj_groups_descrs',
                         exp_imp => $query->param( 'exp_imp' ) );
  print "<td>";

  #   ()     
  #     (,   );
  #  JavaScript-  :   create_hot_help()
  #  HTML-,      VALUE,    
  # HTML-,      ,    
  #  NAME       " 
  # "
  create_hot_help( "document.forms[ 0 ].tmp_group_code",
                   "OBJ_GROUPS_TMP_GROUP_CODE", "REPLACE",
                   "var str; if (this.value) str = this.value;
                             else str = this.name;
                    document.forms[ 0 ].tmp_group_name.value = str; " )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'tmp_group_code',
                           -default => $fields{ 'tmp_group_code' },
                           -size => $CFG{ OBJ_GROUPS_TMP_GROUP_CODE_SIZE },
                           -maxlength =>
                             $CFG{ OBJ_GROUPS_TMP_GROUP_CODE_MAXLENGTH }
                          ),
        "&nbsp;&nbsp;",
        qq{<a class="command_link" href="javascript:void( 0 )" } .
        qq{onclick="select_tmp_group()"></a>},
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>",
        $query->textarea( -name => 'tmp_group_name',
                          -default => $fields{ 'tmp_group_name' },
                          -rows => $CFG{ OBJ_GROUPS_TMP_GROUP_NAME_ROWS },
                          -columns => $CFG{ OBJ_GROUPS_TMP_GROUP_NAME_COLS }
                          -readonly => 'readonly'
                        ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>     </th>\n";
  print "<td>",
        $query->textfield( -name => 'tmp_group_inc_date',
                           -default =>
                             date_for_display( $fields{ 'tmp_group_inc_date' }
                                             ),
                           -size => $CFG{ OBJ_GROUPS_TMP_GROUP_INC_DATE_SIZE },
                           -maxlength =>
                             $CFG{ OBJ_GROUPS_TMP_GROUP_INC_DATE_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment", "OBJ_GROUPS_COMMENT" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ OBJ_GROUPS_COMMENT_ROWS },
                          -columns => $CFG{ OBJ_GROUPS_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
  return ( 0 );
}

# -----------------------------------------------------------------------------
#   ,    
#  -      
# -----------------------------------------------------------------------------
sub non_std_fields
{
  # :
  my $fname = shift;  #  
                      #   -   ( 
                      #  ).      
  my $value;
  
  #   
  # .   , ..     
  #              .     .
  if ( $fname eq 'tmp_group_inc_date' )
  {
    $value = date_for_db( $query->param( $fname ) );
  }

  return ( $value );  
}

# -----------------------------------------------------------------------------
#          
# -----------------------------------------------------------------------------
sub print_add_info
{
  #  .    
  print_bib_record( $query, "     " .
                    " " );
  return ( 0 );
}
