#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :   "   ()  
#            "
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

# .      
#              " "   " 
#             ".   " "  
#               .    
#                    
#              ,    ,  .

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'OBJ_GROUPS_DESCRS';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Obj_groups_descrs
my @f_names =
   ( 'tmp_group_code',     #    
     'tmp_group_name',     #   
     'tmp_group_descr',    #   
     'tmp_group_date',     #    
     'comment'             # 
   );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              do_find => \&do_find,
              do_export => \&do_export,
              do_import => \&do_import,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              action => $script_name
            );

#    ,     
if ( $query->path_info =~ /^\/list$/ )
{
  do_list();
}

#        
elsif ( $query->path_info =~ /^\/delete_from_group$/ &&
        have_access( 'module' => $module, 'procedure' => 'DELETE_FROM_GROUP',
                     'user' => $user )
      )
{
  do_delete_from_group();
}

#     (    )
elsif ( $query->path_info =~ /^\/add_objs_into_group$/ &&
        have_access( 'module' => $module, 'procedure' => 'ADD_INTO_GROUP',
                     'user' => $user )
      )
{
  do_add_objs_into_group();
}

#      ,   
#  (   )
if ( $query->param( 'submit_add_objs_into_group' ) &&
     have_access( 'module' => $module, 'procedure' => 'ADD_INTO_GROUP',
                  'user' => $user )
   )
{
  add_objs_into_group();
}

exit( 0 );


# -----------------------------------------------------------------------------
#       (.. , 
#   )
# -----------------------------------------------------------------------------
sub add_objs_into_group
{
  my( $conn, $result );    #    
  my $command;             #       
  my $num_recs = 0;        #   
  my $obj_id;              #    . 
  my @obj_ids = ();        #      
  my( $first, $last );     #     

  #    
  my $tmp_group_code = $query->param( 'tmp_group_code' );

  #      
  my $tmp_group_inc_date = $query->param( 'tmp_group_inc_date' );

  # ,      
  my $obj_ids_str = $query->param( 'obj_ids_str' );

  # 
  my $comment = $query->param( 'comment' );
  
  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();          #     
  create_top_2();      #       ""
                       #  
  close_top();         #     

  open_bottom();       #     

  print_add_info();    #     
  
  #       
  if ( ! check_param_objs() )
  {
    close_bottom();    #     
    print $query->end_html();
    return ( 1 );      #       
  }
  
  #    -   

  $conn = exec_connect_db();           #   
  exec_transaction( $conn, "BEGIN" );  #     

  #   -   ""
  # (       )
  # ,       ,
  # , 125-143,   "-"  ""  
  $obj_ids_str =~ s/[^\d-]/ /g;

  #       
  # (    ""    
  # )

  $obj_ids_str =~ s/^\s*//g;  #   ...
  $obj_ids_str =~ s/\s*$//g;  # ...   
  
  #  ,     ,
  #    (   )
  foreach ( split( /\s+/, $obj_ids_str ) )
  {
    if ( /^\d+$/ )           #   
    {
      push( @obj_ids, $_ );  #    
    }
    #   (  1 )
    elsif ( /^(\d+)[-]+(\d+)$/ )
    {
      #     
      $first = $1;
      $last  = $2;
      
      # TODO     check_param_objs().
      if ( $first > $last)
      {
        print "<p class=\"user_error\">";
        print "  : $first, $last";
        print "</p>\n";

        close_bottom();  #     
        print $query->end_html();
        return ( 1 );    #       
      }  
      else
      {
        for ( $obj_id = $first; $obj_id <= $last; $obj_id++ )
        {
          push( @obj_ids, $obj_id );  #     
        }
      }
    }
    #       (    )
    # .       .
    else
    {
      print "<p class=\"user_error\">";
      print "    : $_";
      print "</p>\n";

      close_bottom();  #     
      print $query->end_html();
      return ( 1 );  #       
    }
  }

  #     Obj_groups    
  #  . 
  foreach $obj_id ( @obj_ids )
  {
    #   - ...
    # .  bib_rec_num    ,  0.
    #              ,       
    #                .
    $command = "INSERT INTO Obj_groups ( tmp_group_code, obj_id, " .
                                        "tmp_group_inc_date, comment, " .
                                        "who_chg ) " .
               "VALUES ( $tmp_group_code, $obj_id, " .
                         "'" . date_for_db( $tmp_group_inc_date ) . "', " .
                         ( $comment ne '' ? "'$comment'" : "null" ) .
                         ", '$user' )";

    # DEBUG 
    print_debug_info( $command ) if $DEBUG;  #   

    # ...      Obj_groups
    $result = $conn->exec( $command );

    #         
    if ( PGRES_COMMAND_OK ne $result->resultStatus )
    {
      #   
      print "<p class=\"error\">$CFG{ ERROR_INSERT }</p>\n";
      print STDERR $command . "\n";           #     
      die $conn->errorMessage;
    }
    else
    {
      $num_recs++;         #   
    }
  }

  exec_transaction( $conn, "END" );     #  
    
  print "<p class=\"info\">";
  print "    : $num_recs .</p>\n";

  close_bottom();      #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  if ( $query->param( 'tmp_group_code' ) eq '' )
  {
    push( @error_messages, "    " );
  }

  if ( $query->param( 'tmp_group_name' ) eq '' )
  {
    push( @error_messages, "    " );
  }

  if ( $query->param( 'tmp_group_descr' ) eq '' )
  {
    push( @error_messages, "    " );
  }

  #    
  if ( ! date_is_correct( $query->param( 'tmp_group_date' ) ) )
  {
    push( @error_messages, "      " .
          " " );
  }

  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }
  
  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#       
#   
# -----------------------------------------------------------------------------
sub check_param_objs
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  #     
  if ( $query->param( 'obj_ids_str' ) eq '' )   #    
  {
    push( @error_messages, "   " );
  }
  #  -: ". , ; \ /",    
  #    "-"
  #  ,    , :
  #              " 115 ; 134-137,  147--151 168  ".
  elsif ( $query->param( 'obj_ids_str' ) !~
          /^\s*                #     
           (\d+|               #   ...
             (\d+[-]+\d+)      # ...   ( 
           )                   #   (  ))
           (\s*[\s\.,;\/\\]\s* #  
             (\d+|             #     ...
               (\d+[-]+\d+)    # ...  ...
             )
           ){0,}               #      
           \s*$/x              #     
        )
  {
    push( @error_messages, "     " .
          " " );
  }

  #    
  if ( ! date_is_correct( $query->param( 'tmp_group_inc_date' ) ) )
  {
    push( @error_messages, "       " .
          "  " );
  }

  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }
  
  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  ,     
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  # .  ,   ,  
  #              ,    .
  create_top_block( query => $query,
                    module => $module,
                    module_title => '  ' .
                                    ' ',
                    user => $user
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  ,      
# -----------------------------------------------------------------------------
sub create_top_2
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => '  ' .
                                    ' ',
                    user => $user,
                    full_top => 'no'
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_add_objs_into_group
{
  #      HTML-
  my $target_win = $query->param( 'target_win' );

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => $target_win );

  open_top();       #     
  create_top_2();   #    
  close_top();      #     

  open_bottom();    #     

  #        URL-,  
  #  ,    URL    ,
  #    , ..   PATH_INFO =
  # 'add_objs_into_group'    ,   
  #  ,   PATH_INFO    ,  
  #  
  print $query->start_form( -action => $script_name, -target => $target_win );

  #      , 
  #   
  make_form_objs();

  print $query->submit( -name => "submit_add_objs_into_group",
                        -value => "    ",
                        -class => 'submit'
                      ), "\n";

  print $query->end_form();

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#   --   
# -----------------------------------------------------------------------------
sub do_del
{
  my $tmp_group_code;        #    
  my $command;               #      

  $tmp_group_code = $query->param( 'tmp_group_code' );
  
  #         
  $command = "DELETE FROM ${db_schema}obj_groups_descrs " .
             "WHERE tmp_group_code = '$tmp_group_code'";

  #   
  del_rec( query => $query,
           create_top => \&create_top,
           target => "_self",
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#        
# .   -     do_del()
#               obj_groups.pl.
# TODO        , 
#        .
# -----------------------------------------------------------------------------
sub do_delete_from_group
{
  my $tmp_group_code;        #    
  my $obj_id;                #    . 
  my $bib_rec_num;           #  .    
  my $command;               #      

  $tmp_group_code = $query->param( 'tmp_group_code' );
  $obj_id         = $query->param( 'obj_id' );
  $bib_rec_num    = $query->param( 'bib_rec_num' );
  
  #         
  $command = "DELETE FROM ${db_schema}obj_groups " .
             "WHERE tmp_group_code = '$tmp_group_code' AND " .
                   "obj_id = '$obj_id' AND " .
                   "bib_rec_num = '$bib_rec_num' ";

  #   
  del_rec( query => $query,
           create_top => \&create_top_2,
           target => "_self",
           print_add_info => \&print_add_info,
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#   . ,     
# ( )
# -----------------------------------------------------------------------------
sub do_export
{
  my $tmp_group_code;        #      
  my $command;               #      
  my @table_cmd_pairs = ();  #     ,
                             #       

  $tmp_group_code = $query->param( 'tmp_group_code' );

  #  -       
  #    (      , 
  #     )

  #   .     
  $command = "SELECT b.* " .
             "FROM Obj_groups og, Bib_recs b " .
             "WHERE og.tmp_group_code = '$tmp_group_code' AND " .
                   "og.obj_id = b.obj_id AND " .
                   "og.bib_rec_num = b.bib_rec_num";

  push( @table_cmd_pairs, [ 'Bib_recs', $command ] );

  #    
  export_data( query => $query,
               create_top => \&create_top,
               table_cmd_pairs => \@table_cmd_pairs
             );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_find
{
  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();       #     
  create_top();     #    
  close_top();      #     
  
  open_bottom();    #     
  
  print "<p class=\"info\">     </p>\n";

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#   . ,     
# ( )
# -----------------------------------------------------------------------------
sub do_import
{
  my $tmp_group_code;        #      
  my $command;               #      
  my @table_cmd_pairs = ();  #     ,
                             #       

  $tmp_group_code = $query->param( 'tmp_group_code' );

  #  -       
  #    (      , 
  #     )

  #   .     
  $command = "SELECT b.* " .
             "FROM exp_imp.Obj_groups og, exp_imp.Bib_recs b " .
             "WHERE og.tmp_group_code = '$tmp_group_code' AND " .
                   "og.obj_id = b.obj_id AND " .
                   "og.bib_rec_num = b.bib_rec_num";

  push( @table_cmd_pairs, [ 'Bib_recs', $command ] );

  #    
  import_data( query => $query,
               create_top => \&create_top,
               table_cmd_pairs => \@table_cmd_pairs
             );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#     ,     
# -----------------------------------------------------------------------------
sub do_list
{
  my( $result, $i );              #    
  my @row;                        #      
  my $command;                    #      
  my $href;                       #   HTML-
  my $href_bib_rec;               #   HTML-  . 
  my $tmp_group_code;             #    
  my $tmp_group_name;             #   
  my $tmp_group_descr;            #   
  my $tmp_group_date;             #    
  my @avail_objs;                 #  . ,   
                                  #    . ,
                                  #   , 
                                  # ,   . 

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #      / 
  my $can_export = 0;
  my $can_import = 0;

  #  ,        
  my $alt_row = 1;

  #  HTTP-  HTML-
  http_html_headers( query => $query,
                     target => "_self" );

  $tmp_group_code  = $query->param( 'tmp_group_code' );
  $tmp_group_name  = $query->param( 'tmp_group_name' );
  $tmp_group_descr = $query->param( 'tmp_group_descr' );
  $tmp_group_date  = $query->param( 'tmp_group_date' );

  open_top();       #     
  create_top_2();   #    
  close_top();      #     

  open_bottom();    #     

  print_add_info(); #     

  #   HTML-
  $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
          "tmp_group_code=$tmp_group_code" .
          "&tmp_group_name=" . CGI::escape( $tmp_group_name ) .
          "&tmp_group_descr=" . CGI::escape( $tmp_group_descr ) .
          "&tmp_group_date=$tmp_group_date";

  #       
  # .   PostgreSQL,  
  #                  -  ( ,
  #                     
  #             'bib_rec_full'  'bib_rec_short').
  $command = "SELECT CASE WHEN b.bib_rec_short IS NOT NULL " .
                         "THEN b.bib_rec_short " .
                         "ELSE b.bib_rec_full " .
                    "END AS bib_rec, " .
                    "og.* " .
             "FROM ${db_schema}obj_groups og, ${db_schema}bib_recs b " .
             "WHERE og.tmp_group_code = '$tmp_group_code' AND " .
                   "og.obj_id = b.obj_id AND " .
                   "og.bib_rec_num = b.bib_rec_num " .
             "ORDER BY 1";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    #         'BIB_RECS',
    #      ,     
    $can_view = have_access( 'module' => 'BIB_RECS', 'procedure' => 'VIEW', 
                             'user' => $user );
    $can_delete = have_access( 'module' => $module, 
                               'procedure' => 'DELETE_FROM_GROUP',
                               'user' => $user );

    #     "/",     
    if ( $query->param( 'exp_imp' ) )
    {
      #       'BIB_RECS'
      $can_import = import_enabled() && 
                    have_access( 'module' => 'BIB_RECS',
                                 'procedure' => 'IMPORT',
                                 'user' => $user );
    }
    #    public --   
    else
    {
      $can_export = export_enabled() && 
                    have_access( 'module' => 'BIB_RECS',
                                 'procedure' => 'EXPORT',
                                 'user' => $user );
    }

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th> /</th>\n";
    print "<th>ID   . </th>\n";
    print "<th>.    </th>\n";
    print "<th>    </th>\n";
    print "<th></th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete || $can_export ||
                                   $can_import );
    print "</tr>\n";

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #   , .   . 
      #   . , .      
      #   
      $i++;                      #  
      print "<td class=\"center\">$i</td>\n";
      print "<td class=\"center\">$row[ $result->fnumber( 'obj_id' ) ]" .
            " (". $row[ $result->fnumber( 'bib_rec_num' ) ] . ")",
            "</td>\n";

      #    ,      
      # ,   &mdash;
      # . TODO   list_bib_recs_by_query()  E_ARCH.pm.
      my $bib_rec = $row[ $result->fnumber( 'bib_rec' ) ];
      $bib_rec =~ s/--/&mdash;/g;

      print "<td>$bib_rec</td>\n";

      print "<td>",
            date_for_display( $row[ $result->fnumber( 'tmp_group_inc_date' ) ]
                            ),
            "</td>\n";

      #      , 
      #    . 
      print "<td>\n";

      @avail_objs = get_available( $row[ $result->fnumber( 'obj_id' ) ] );

      #     (, . ,   
      #  )   
      foreach ( @avail_objs )
      {
        print $_ . "<br />\n";
      }
      print "</td>\n";

      #   HTML-  . 
      $href_bib_rec = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
                      "obj_id=" . $row[ $result->fnumber( 'obj_id' ) ] .
                      "&bib_rec_num=" . 
                      $row[ $result->fnumber( 'bib_rec_num' ) ];

      #   .    HTML- (  )
      print "<td>" if ( $can_view || $can_delete || $can_export ||
                        $can_import );
      print qq{<a class="command_link" } .
            qq{href="/$CFG\{ HOME_WEB_DIR \}/bib_recs.pl/view?$href_bib_rec} .
            qq{&target_win=_self"} .
            qq{ target="_blank"> . </a>} . "\n" 
        if $can_view;

      #     
      print qq{<a class="command_link" } .
            qq{href="$script_name/delete_from_group?$href} .
            "&obj_id=" . $row[ $result->fnumber( 'obj_id' ) ] .
            "&bib_rec_num=" .
            $row[ $result->fnumber( 'bib_rec_num' ) ] . "\"" .
            qq{ onclick="$confirm_delete" } .
            qq{ target="_self">   </a> } . "\n"
        if $can_delete;

      #   . 
      print qq{<a class="command_link" } .
            qq{href="/$CFG\{ HOME_WEB_DIR \}/bib_recs.pl/export?} .
            $href_bib_rec .
            qq{&target_win=_self"} .
            qq{ onclick="$confirm_export"} .
            qq{ target="_blank"> . </a>} . "\n"
        if $can_export;

      #   . 
      print qq{<a class="command_link" } .
            qq{href="/$CFG\{ HOME_WEB_DIR \}/bib_recs.pl/import?} .
            $href_bib_rec .
            qq{&target_win=_self"} .
            qq{ onclick="$confirm_import"} .
            qq{ target="_blank"> . </a>} . "\n"
        if $can_import;

      print "</td>" if ( $can_view || $can_delete || $can_export ||
                         $can_import );
      print "</tr>\n";
    }
    print "</table>\n";
  }

  #       
  #          "/"
  if ( ! $query->param( 'exp_imp' ) &&
       have_access( 'module' => $module, 'procedure' => 'ADD_INTO_GROUP', 
                    'user' => $user ) )
  {
    print "<br />\n";
    print qq{<a class="command_link" } .
          qq{href="$script_name/add_objs_into_group?$href"} .
          qq{ target="_self">    </a>};
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#     
# -----------------------------------------------------------------------------
sub do_query
{
  my( $result, $i );              #    
  my @row;                        #      
  my $command;                    #      
  my $href;                       #   HTML-

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #      / 
  my $can_export = 0;
  my $can_import = 0;

  #  ,        
  my $alt_row = 1;

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  #      
  $command = "SELECT * " .
             "FROM ${db_schema}obj_groups_descrs " .
             "ORDER BY tmp_group_name";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                             'user' => $user );
    $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                               'user' => $user );

    #     "/",     
    if ( $query->param( 'exp_imp' ) )
    {
      #       'BIB_RECS'
      $can_import = import_enabled() && 
                    have_access( 'module' => 'BIB_RECS',
                                 'procedure' => 'IMPORT',
                                 'user' => $user );
    }
    #    public --   
    else
    {
      $can_export = export_enabled() && 
                    have_access( 'module' => 'BIB_RECS',
                                 'procedure' => 'EXPORT',
                                 'user' => $user );
    }

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th> /</th>\n";
    print "<th>  </th>\n";
    print "<th> </th>\n";
    print "<th>  </th>\n";
    print "<th>&nbsp;</th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete || $can_export ||
                                   $can_import );
    print "</tr>\n";

    #          
    #      ...
    if ( $query->param( 'enable_select' ) )
    {
      # ...    JavaScript    
      #     Obj_groups_descrs     ...
      if ( $query->param( 'caller_name' ) eq 'OBJ_GROUPS' )
      {
        # ...  tmp_group_code, tmp_group_name   OBJ_GROUPS
        create_assign_values_func( 'tmp_group_code', 'tmp_group_name' );
      }
    }

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #   ,  , 
      #     
      $i++;                      #  
      print "<td class=\"center\">$i</td>\n";
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( 'tmp_group_code' ) ]</td>\n";

      #         
      #      ,  
      #  tmp_group_name    

      #    escapeHTML(),   
      #   ,     ,
      #   , ..   
      #         
      #   (, JavaScript  ""   
      #  )
      # .   CGI::escape(),   ,
      #                 --   
      #             ,      
      #              %20%F4%AD  ..

      #     , . . , 
      #   escapeHTML(), 
      my $tmp_group_name = $row[ $result->fnumber( 'tmp_group_name' ) ];
      $tmp_group_name =~ s/\'/\\\'/g;
      $tmp_group_name = CGI::escapeHTML( $tmp_group_name );

      if ( $query->param( 'enable_select' ) )
      {
        print "<td>",
              qq{<a class="command_link" href="javascript:void( 0 )" onclick=
                 "assign_values( $row[ $result->fnumber( 'tmp_group_code' ) ],
                                 '$tmp_group_name' )">
                 $row[ $result->fnumber( 'tmp_group_name' ) ]</a> },
              "</td>\n";
      }
      else
      {
        print "<td>$row[ $result->fnumber( 'tmp_group_name' ) ]</td>\n";
      }

      print "<td>",
            date_for_display( $row[ $result->fnumber( 'tmp_group_date' ) ] ),
            "</td>\n";

      #   HTML-
      $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
              "tmp_group_code=" . $row[ $result->fnumber( 'tmp_group_code' ) ];

      #    
      print "<td>",
            qq{<a class="command_link" } .
            qq{href="$script_name/list?$href} .
            "&tmp_group_name=" .
            CGI::escape( $row[ $result->fnumber( 'tmp_group_name' ) ] ) .
            "&tmp_group_descr=" .
            CGI::escape( $row[ $result->fnumber( 'tmp_group_descr' ) ] ) .
            "&tmp_group_date=" .
            $row[ $result->fnumber( 'tmp_group_date' ) ] . "\"" .
            qq{ target="_blank"></a> },
            "</td>\n";

      #       
      print "<td>" if ( $can_view || $can_delete );
      print qq{<a class="command_link" } .
            qq{href="$script_name/view?$href"} .
            qq{ target="_self"></a> } . "\n"
        if $can_view;

      #     
      print qq{<a class="command_link" } .
            qq{href="$script_name/delete?$href"} .
            qq{ onclick="$confirm_delete"} .
            qq{ target="_self"></a> } . "\n"
        if $can_delete;

      #   . ,   
      print qq{<a class="command_link" } .
            qq{href="$script_name/export?$href"} .
            qq{ onclick="$confirm_export"} .
            qq{ target="_blank">  </a>} . "\n"
        if $can_export;

      #   . ,   
      print qq{<a class="command_link" } .
            qq{href="$script_name/import?$href"} .
            qq{ onclick="$confirm_import"} .
            qq{ target="_blank">  </a>} . "\n"
        if $can_import;

      print "</td>" if ( $can_view || $can_delete || $can_export ||
                         $can_import );
      print "</tr>\n";
    }
    print "</table>\n";
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#       (  )
# -----------------------------------------------------------------------------
sub do_view
{
  my $tmp_group_code;        #    
  my $command;               #      

  $tmp_group_code = $query->param( 'tmp_group_code' );

  #      
  $command = "SELECT * " .
             "FROM ${db_schema}obj_groups_descrs " .
             "WHERE tmp_group_code = '$tmp_group_code'"; 

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => "_self",
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "         " .
                     "  " . $tmp_group_code,
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# (  )
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "obj_groups_descrs",
                       key => "tmp_group_code",
                       f_names => \@f_names,
                       f_special => [ 'tmp_group_date' ],
                       func_special => \&non_std_fields,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# (  )
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  my( $day, $mon, $year );  #    

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #         ,
    #   1        
    $fields{ 'tmp_group_code' } = get_next_key_value( 'obj_groups_descrs',
                                                      'tmp_group_code' );
    #   
    #   
    ( $day, $mon, $year ) = ( localtime() )[ 3..5 ];

    #    
    $fields{ 'tmp_group_date' } =
      sprintf( "%04d-%02d-%02d", $year + 1900, $mon + 1, $day );

    #   
    $fields{ 'tmp_group_name' }  = $CFG{ OBJ_GROUPS_DESCRS_TMP_GROUP_NAME };

    #   
    $fields{ 'tmp_group_descr' } = $CFG{ OBJ_GROUPS_DESCRS_TMP_GROUP_DESCR };

    # 
    $fields{ 'comment' }         = $CFG{ OBJ_GROUPS_DESCRS_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  #    "   " 
  #     get_next_key_value(),  
  #   ,     , .. 
  #     UPDATE   
  print $query->hidden( -name => 'tmp_group_code',
                        -default => $fields{ 'tmp_group_code' }
                      ), "\n";

  #       ,     
  #           ,
  #        ,   
  #  ,     
  # . .    cities.pl.
  print $query->hidden( -name => 'enable_select' ), "\n";
  print $query->hidden( -name => 'caller_name' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th>   </th>\n";
  print "<td>", $fields{ 'tmp_group_code' }, "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].tmp_group_name",
                   "OBJ_GROUPS_DESCRS_TMP_GROUP_NAME" ) 
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'tmp_group_name',
                          -default => $fields{ 'tmp_group_name' },
                          -rows => 
                            $CFG{ OBJ_GROUPS_DESCRS_TMP_GROUP_NAME_ROWS },
                          -columns => 
                            $CFG{ OBJ_GROUPS_DESCRS_TMP_GROUP_NAME_COLS }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].tmp_group_descr",
                   "OBJ_GROUPS_DESCRS_TMP_GROUP_DESCR" ) 
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'tmp_group_descr',
                          -default => $fields{ 'tmp_group_descr' },
                          -rows => 
                            $CFG{ OBJ_GROUPS_DESCRS_TMP_GROUP_DESCR_ROWS },
                          -columns => 
                            $CFG{ OBJ_GROUPS_DESCRS_TMP_GROUP_DESCR_COLS }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>   </th>\n";
  print "<td>",
        $query->textfield( -name => 'tmp_group_date',
                           -default =>
                              date_for_display( $fields{ 'tmp_group_date' } ),
                           -size =>
                             $CFG{ OBJ_GROUPS_DESCRS_TMP_GROUP_DATE_SIZE },
                           -maxlength =>
                             $CFG{ OBJ_GROUPS_DESCRS_TMP_GROUP_DATE_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment", "OBJ_GROUPS_DESCRS_COMMENT" ) 
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ OBJ_GROUPS_DESCRS_COMMENT_ROWS },
                          -columns => $CFG{ OBJ_GROUPS_DESCRS_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
  return ( 0 );
}

# -----------------------------------------------------------------------------
#       
# -----------------------------------------------------------------------------
sub make_form_objs
{
  my $tmp_group_inc_date;   #      
  my( $day, $mon, $year );  #    
  
  #     "   "
  #   
  my $tmp_group_code = $query->param( 'tmp_group_code' ); 

  #   
  ( $day, $mon, $year ) = ( localtime() )[ 3..5 ];

  $tmp_group_inc_date = sprintf( "%04d-%02d-%02d",
                                 $year + 1900, $mon + 1, $day );

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  #    "   "
  #   ,     ,
  #     , ..    
  #  INSERT (     ,   
  #    ,      )
  print $query->hidden( -name => 'tmp_group_code' ), "\n";

  #        
  #    ,    
  # add_objs_into_group
  print $query->hidden( -name => 'tmp_group_name' ), "\n";
  print $query->hidden( -name => 'tmp_group_descr' ), "\n";
  print $query->hidden( -name => 'tmp_group_date' ), "\n";

  print_add_info(); #     

  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th>   </th>\n";
  print "<td>", $tmp_group_code, "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  . </th>\n";
  print "<td>",
        $query->textfield( -name => 'obj_ids_str',
                           -size => $CFG{ OBJ_GROUPS_DESCRS_OBJ_IDS_STR_SIZE },
                           -maxlength =>
                             $CFG{ OBJ_GROUPS_DESCRS_OBJ_IDS_STR_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> . </th>\n";
  print "<td>", "0    ( )", "</td>\n";
  print "</TR>\n";

  print "<tr>\n";
  print "<th>     </th>\n";
  print "<td>",
        $query->textfield( -name => 'tmp_group_inc_date',
                           -default => date_for_display( $tmp_group_inc_date ),
                           -size => 
                             $CFG{ OBJ_GROUPS_DESCRS_TMP_GROUP_INC_DATE_SIZE },
                           -maxlength => $CFG{ 'OBJ_GROUPS_DESCRS_' .
                                               'TMP_GROUP_INC_DATE_MAXLENGTH' }
                         ),
        "</td>\n";
  print "</tr>\n";

  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";

  #   ()     
  #    
  # .    ""    ,
  #                 make_form().
  create_hot_help( "document.forms[ 0 ].comment", "OBJ_GROUPS_DESCRS_COMMENT" ) 
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -rows => $CFG{ OBJ_GROUPS_DESCRS_COMMENT_ROWS },
                          -columns => $CFG{ OBJ_GROUPS_DESCRS_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
  return ( 0 );
}

# -----------------------------------------------------------------------------
#   ,    
#  -      
# -----------------------------------------------------------------------------
sub non_std_fields
{
  # :
  my $fname = shift;  #  
                      #   -   ( 
                      #  ).      
  my $value;
  
  #   
  # .   , ..     
  #              .     .
  if ( $fname eq 'tmp_group_date' )
  {
    $value = date_for_db( $query->param( $fname ) );
  }

  return ( $value );  
}

# -----------------------------------------------------------------------------
#          
# -----------------------------------------------------------------------------
sub print_add_info
{
  my $script_name = $query->script_name;

  my $result;               #    
  my $command;              #      
  my @row;                  #      
  my $tmp_group_name;       #   
  my $tmp_group_descr;      #   

  #        HTML-
  if ( $CFG{ HIDE_RUS_LETTERS } )
  {
    $command = "SELECT tmp_group_name, tmp_group_descr " .
               "FROM ${db_schema}Obj_groups_descrs " .
               "WHERE tmp_group_code = " . $query->param( 'tmp_group_code' );
  
    #    
    $result = exec_select( $command );
  
    if ( $result )
    {
      #      
      @row = $result->fetchrow;
      $tmp_group_name = $row[ $result->fnumber( 'tmp_group_name' ) ];
      $tmp_group_descr = $row[ $result->fnumber( 'tmp_group_descr' ) ];

      #    ,      
      # ,   &mdash;
      # . TODO   list_bib_recs_by_query()  E_ARCH.pm.
      $tmp_group_name =~ s/--/&mdash;/g;
      $tmp_group_descr =~ s/--/&mdash;/g;
    }
  }
  else
  {
    # TODO.      s/--/&mdash;/g
    #         .   !
    $tmp_group_name = $query->param( 'tmp_group_name' );
    $tmp_group_descr = $query->param( 'tmp_group_descr' );
  }

  #     ,  , 
  #    
  print "<p class=\"bib_rec\">";
  print " : " . $query->param( 'tmp_group_code' ) . "\n";
  print "&nbsp;&nbsp;\n";
  print " : " .
        date_for_display( $query->param( 'tmp_group_date' ) ) . "<br />\n";
  print ": $tmp_group_name<br />\n";
  print ": $tmp_group_descr\n";
  print "</p>\n";

  print "<h3></h3>\n";

  #       . , 
  #  
  #       ,     
  # do_query();       
  #          
  #      . 
  print qq{<a class="command_link" } .
        qq{href="$script_name/list?} .
        ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
        "tmp_group_code=" . $query->param( 'tmp_group_code' ) .
        "&tmp_group_name=" . CGI::escape( $query->param( 'tmp_group_name' ) ) .
        "&tmp_group_descr=" .
        CGI::escape( $query->param( 'tmp_group_descr' ) ) .
        "&tmp_group_date=" . $query->param( 'tmp_group_date' ) . "\"" .
        qq{ target="_self"></a>\n};

  return ( 0 );
}
