#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :   " ,    "
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'OBJ_KEYWORDS';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Obj_keywords
my @f_names =
   ( 'obj_id',           #   
                         #  
     'keyword_code',     #   
     'comment'           # 
   );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              print_add_info => \&print_add_info,
              action => $script_name
            );

exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  if ( $query->param( 'keyword_code' ) !~ /^\d+$/ )
  {
    push( @error_messages, "      " );
  }

  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }
  
  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => '  ()',
                    user => $user,
                    full_top => 'no'
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $obj_id;             #    . 
  my $keyword_code;       #   
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id       = $query->param( 'obj_id' );
  $keyword_code = $query->param( 'keyword_code' );
  $target_win   = $query->param( 'target_win' );

  #         
  $command = "DELETE FROM ${db_schema}obj_keywords " .
             "WHERE obj_id = '$obj_id' AND " .
                   "keyword_code = '$keyword_code'";

  #   
  del_rec( query => $query,
           target => $target_win,
           create_top => \&create_top,
           print_add_info => \&print_add_info,
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#        
# -----------------------------------------------------------------------------
sub do_query
{
  # .        
  #              bib_recs.pl.

  my $obj_id;             #    . 
  my $bib_rec;            # . 
  my $target_win;         #      HTML-
  my( $result, $i );      #    
  my @row;                #      
  my $command;            #      
  my $href;               #   HTML-

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #  ,        
  my $alt_row = 1;

  $obj_id     = $query->param( 'obj_id' );
  $bib_rec    = $query->param( 'bib_rec' );
  $target_win = $query->param( 'target_win' );

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => $target_win );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  print_add_info(); #     

  #  ,    
  $bib_rec = CGI::escape( $bib_rec );

  #   HTML-
  $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
          "obj_id=$obj_id" .
          "&bib_rec=$bib_rec" .
          "&target_win=$target_win";

  #         
  # (    )
  $command = "SELECT ok.*, k.keyword_name " .
             "FROM ${db_schema}obj_keywords ok, ${db_schema}keywords k " .
             "WHERE ok.obj_id = '$obj_id' AND " .
                   "ok.keyword_code = k.keyword_code " .
             "ORDER BY k.keyword_name";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                             'user' => $user );
    $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                               'user' => $user );

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th>  </th>\n";
    print "<th> </th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete );
    print "</tr>\n";

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #       
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( 'keyword_code' ) ]</td>\n";
      print "<td>$row[ $result->fnumber( 'keyword_name' ) ]</td>\n";

      #         
      print "<td>" if ( $can_view || $can_delete );
      print qq{<a class="command_link" href="$script_name/view?$href} .
            "&keyword_code=" .
            $row[ $result->fnumber( 'keyword_code' ) ] . "\"" .
            qq{ target="$target_win"></a>} if $can_view;
      print "\n" if $can_view;

      #      
      print qq{<a class="command_link" href="$script_name/delete?$href} .
            "&keyword_code=" .
            $row[ $result->fnumber( 'keyword_code' ) ] . "\"" .
            qq{ onclick="$confirm_delete"} .
            qq{ target="$target_win"></a>} if $can_delete;
      print "</td>\n" if ( $can_view || $can_delete );

    }
    print "</table>\n";
  }

  #        
  #          "/"
  if ( ! $query->param( 'exp_imp' ) &&
       have_access( 'module' => $module, 'procedure' => 'ADD', 
                    'user' => $user ) )
  {
    print "<br />\n";
    print qq{<a class="command_link" href="$script_name/add?$href"} .
          qq{ target="$target_win"> </a>};
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $obj_id;             #    . 
  my $keyword_code;       #   
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id       = $query->param( 'obj_id' );
  $keyword_code = $query->param( 'keyword_code' );
  $target_win   = $query->param( 'target_win' );

  #      
  # (    )
  $command = "SELECT ok.*, k.keyword_name " .
             "FROM ${db_schema}obj_keywords ok, ${db_schema}keywords k " .
             "WHERE ok.obj_id = '$obj_id' AND " .
                   "ok.keyword_code = '$keyword_code' AND " .
                   "ok.keyword_code = k.keyword_code " .
             "ORDER BY k.keyword_name";

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => $target_win,
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "        : " .
                     "   .  - " .
                     $obj_id . ", " .
                     "   - $keyword_code",
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "obj_keywords",
                       key => "obj_id, keyword_code:keyword_code_begin",
                       f_names => \@f_names,
                       f_special => undef,
                       func_special => undef,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #       
    $fields{ 'obj_id' } = $query->param( 'obj_id' );

    #   

    #   
    $fields{ 'keyword_code' } = $CFG{ OBJ_KEYWORDS_KEYWORD_CODE };

    # 
    $fields{ 'comment' }      = $CFG{ OBJ_KEYWORDS_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  #    "  
  #  "   ,   
  #  ,     , ..   
  #   UPDATE   ,    
  #  INSERT (     ,   
  #    ,      )
  print $query->hidden( -name => 'obj_id' ), "\n";

  #     "  "
  # .      'begin'  ,
  #                   ,  
  #               (.  make_cmd   E_ARCH.pm).
  #             ..       ,   
  #              (, ,   ).
  print $query->hidden( -name => 'keyword_code_begin',
                        -default => $fields{ 'keyword_code' }
                      ), "\n";

  #      .  
  #  ,     add_rec()  update_rec()
  print $query->hidden( -name => 'bib_rec' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print_add_info(); #     

  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th>  </th>\n";

  #      JavaScript,  
  # - persons.pl
  create_selection_func( func_name => 'select_keyword',
                         module_name => 'keywords.pl',
                         caller_name => $module,
                         window_name => 'keywords',
                         exp_imp => $query->param( 'exp_imp' ) );
  print "<td>";

  #   ()     
  #     (,   );
  #  JavaScript-  :   create_hot_help()
  #  HTML-,      VALUE,    
  # HTML-,      ,    
  #  NAME       "  ()"
  create_hot_help( "document.forms[ 0 ].keyword_code",
                   "OBJ_KEYWORDS_KEYWORD_CODE", "REPLACE",
                   "var str; if (this.value) str = this.value;
                             else str = this.name;
                    document.forms[ 0 ].keyword_name.value = str; " )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'keyword_code',
                           -default => $fields{ 'keyword_code' },
                           -size => $CFG{ OBJ_KEYWORDS_KEYWORD_CODE_SIZE },
                           -maxlength => 
                             $CFG{ OBJ_KEYWORDS_KEYWORD_CODE_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  #     
  # (  )
  print "<tr>\n";
  print "<th>  ()</th>\n";
  print "<td>",
        $query->textfield( -name => 'keyword_name',
                           -default => $fields{ 'keyword_name' },
                           -size => $CFG{ OBJ_KEYWORDS_KEYWORD_NAME_SIZE },
                           -maxlength => 
                             $CFG{ OBJ_KEYWORDS_KEYWORD_NAME_MAXLENGTH },
                           -readonly => 'readonly'
                         ),
        "&nbsp;&nbsp;",
        qq{ <a class="command_link" href="javascript:void( 0 )"} .
        qq{ onclick="select_keyword()"></a>},
        "</td>\n";
  print "</tr>\n";

  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment", "OBJ_KEYWORDS_COMMENT" )
    if $CFG{ HOT_HELP_IS_ON };
  
  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ OBJ_KEYWORDS_COMMENT_ROWS },
                          -columns => $CFG{ OBJ_KEYWORDS_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
  return ( 0 );
}

# -----------------------------------------------------------------------------
#          
# -----------------------------------------------------------------------------
sub print_add_info
{
  #  .    
  print_bib_record( $query, " ,   " .
                    " " );
  return ( 0 );
}
