#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :   "   "
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'OBJ_SERIES';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Obj_series
my @f_names =
   ( 'obj_id',           #   
                         #   ( )
     'bib_rec_num',      #  .    
                         # (    0) 
     'series_id',        #   /
     'ser_descr_num',    #   /
                         # ( ,   bib_rec_num)
                         # (    0)
     'issue_num',        #    /
                         # (    , .. 
                         #   )
     'comment'           # 
   );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              print_add_info => \&print_add_info,
              action => $script_name
            );

exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  #   
  if ( $query->param( 'series_id' ) !~ /^\d+$/ )
  {
    push( @error_messages, "     " .
          " /" );
  }

  #   
  if ( $query->param( 'ser_descr_num' ) !~ /^\d+$/ )
  {
    push( @error_messages, "      " .
          "/" );
  }

  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }
  
  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => '  ()',
                    user => $user,
                    full_top => 'no'
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $series_id;          #   /
  my $ser_descr_num;      #   /
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id        = $query->param( 'obj_id' );
  $bib_rec_num   = $query->param( 'bib_rec_num' );
  $series_id     = $query->param( 'series_id' );
  $ser_descr_num = $query->param( 'ser_descr_num' );
  $target_win    = $query->param( 'target_win' );

  #         
  $command = "DELETE FROM ${db_schema}obj_series " .
             "WHERE obj_id = '$obj_id' AND " .
                   "bib_rec_num = '$bib_rec_num' AND " .
                   "series_id = '$series_id' AND " .
                   "ser_descr_num = '$ser_descr_num'";

  #   
  del_rec( query => $query,
           target => $target_win,
           create_top => \&create_top,
           print_add_info => \&print_add_info,
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#    ,     . 
# -----------------------------------------------------------------------------
sub do_query
{
  # .        
  #              bib_recs.pl.

  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $bib_rec;            # . 
  my $target_win;         #      HTML-
  my( $result, $i );      #    
  my @row;                #      
  my $command;            #      
  my $href;               #   HTML-

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #  ,        
  my $alt_row = 1;

  $obj_id      = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );
  $bib_rec     = $query->param( 'bib_rec' );
  $target_win  = $query->param( 'target_win' );

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => $target_win );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  print_add_info(); #     

  #  ,    
  $bib_rec = CGI::escape( $bib_rec );

  #   HTML-
  $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
          "obj_id=$obj_id" .
          "&bib_rec_num=$bib_rec_num" .
          "&bib_rec=$bib_rec" .
          "&target_win=$target_win";

  #     /   . 
  # (   /)
  $command = "SELECT os.*, sd.ser_descr " .
             "FROM ${db_schema}obj_series os, ${db_schema}ser_descrs sd " .
             "WHERE os.obj_id = '$obj_id' AND " .
                   "os.bib_rec_num = '$bib_rec_num' AND " .
                   "os.series_id = sd.series_id AND " .
                   "os.ser_descr_num = sd.ser_descr_num " .
             "ORDER BY sd.ser_descr";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                             'user' => $user );
    $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                               'user' => $user );

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th>  /</th>\n";
    print "<th>  /</th>\n";
    print "<th> /</th>\n";
    print "<th> </th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete );
    print "</tr>\n";

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #  .  /,  
      # /,  /   
      # (  &nbsp;      :
      #    'issu_num'  null,   
      #  -)
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( 'series_id' ) ]</td>\n";
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( 'ser_descr_num' ) ]</td>\n";
      print "<td>$row[ $result->fnumber( 'ser_descr' ) ]</td>\n";
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( 'issue_num' ) ]&nbsp;</td>\n";

      #     /   
      print "<td>" if ( $can_view || $can_delete );
      print qq{<a class="command_link" href="$script_name/view?$href} .
            "&series_id=" . $row[ $result->fnumber( 'series_id' ) ] .
            "&ser_descr_num=" . 
            $row[ $result->fnumber( 'ser_descr_num' ) ] . "\"" .
            qq{ target="$target_win"></a>} if $can_view;
      print "\n" if $can_view;

      #     / 
      print qq{<a class="command_link" href="$script_name/delete?$href} .
            "&series_id=" . $row[ $result->fnumber( 'series_id' ) ] .
            "&ser_descr_num=" . 
            $row[ $result->fnumber( 'ser_descr_num' ) ] . "\"" .
            qq{ onclick="$confirm_delete"} .
            qq{ target="$target_win"></a>} if $can_delete;
      print "</td>\n" if ( $can_view || $can_delete );

      print "</tr>\n";
    }
    print "</table>\n";
  }

  #       / 
  #  . 
  #          "/"
  if ( ! $query->param( 'exp_imp' ) &&
       have_access( 'module' => $module, 'procedure' => 'ADD', 
                    'user' => $user ) )
  {
    print "<br />\n";
    print qq{<a class="command_link" href="$script_name/add?$href"} .
          qq{ target="$target_win"> </a>};
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $series_id;          #   /
  my $ser_descr_num;      #   /
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id        = $query->param( 'obj_id' );
  $bib_rec_num   = $query->param( 'bib_rec_num' );
  $series_id     = $query->param( 'series_id' );
  $ser_descr_num = $query->param( 'ser_descr_num' );
  $target_win    = $query->param( 'target_win' );

  #     /   . 
  # (   /)
  $command = "SELECT os.*, sd.ser_descr " .
             "FROM ${db_schema}obj_series os, ${db_schema}ser_descrs sd " .
             "WHERE os.obj_id = '$obj_id' AND " .
                   "os.bib_rec_num = '$bib_rec_num' AND " .
                   "os.series_id = '$series_id' AND " .
                   "os.ser_descr_num = '$ser_descr_num' AND " .
                   "os.series_id = sd.series_id AND " .
                   "os.ser_descr_num = sd.ser_descr_num";

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => $target_win,
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "        : " .
                     "   .  - " .
                     $obj_id . ", " .
                     " .     - " .
                     $bib_rec_num . ", " .
                     "  / - " .
                     $series_id . ", " .
                     "  / - $ser_descr_num",
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "obj_series",
                       key => "obj_id, bib_rec_num, " .
                              "series_id:series_id_begin, " .
                              "ser_descr_num:ser_descr_num_begin",
                       f_names => \@f_names,
                       f_special => undef,
                       func_special => undef,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #        
    $fields{ 'obj_id' }      = $query->param( 'obj_id' );
    $fields{ 'bib_rec_num' } = $query->param( 'bib_rec_num' );

    # 
    $fields{ 'comment' } = $CFG{ OBJ_SERIES_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  #    "  
  #  "  " . 
  #   "   ,    
  # ,     , ..   
  #   UPDATE   ,    
  #  INSERT (     ,  
  #     ,    
  #  )
  print $query->hidden( -name => 'obj_id' ), "\n";
  print $query->hidden( -name => 'bib_rec_num' ), "\n";

  #     "  /" 
  # "  /"
  # .      'begin'  ,
  #                   ,  
  #               (.  make_cmd   E_ARCH.pm).
  #             ..       ,   
  #              (, ,   ).
  print $query->hidden( -name => 'series_id_begin',
                        -default => $fields{ 'series_id' }
                      ), "\n";
  print $query->hidden( -name => 'ser_descr_num_begin',
                        -default => $fields{ 'ser_descr_num' }
                      ), "\n";

  #      .  
  #  ,     add_rec()  update_rec()
  print $query->hidden( -name => 'bib_rec' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print_add_info();         #     

  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th>  /</th>\n";

  #      JavaScript,  
  # - ser_descrs.pl
  create_selection_func( func_name => 'select_series',
                         module_name => 'ser_descrs.pl',
                         caller_name => $module,
                         window_name => 'ser_descrs',
                         exp_imp => $query->param( 'exp_imp' ) );
  print "<td>",
        $query->textfield( -name => 'series_id',
                           -default => $fields{ 'series_id' },
                           -size => $CFG{ OBJ_SERIES_SERIES_ID_SIZE },
                           -maxlength => $CFG{ OBJ_SERIES_SERIES_ID_MAXLENGTH }
                         ),
        "&nbsp;&nbsp;",
        qq{ <a class="command_link" href="javascript:void( 0 )"} .
        qq{ onclick="select_series()"></a>},
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  /</th>\n";
  print "<td>",
        $query->textfield( -name => 'ser_descr_num',
                           -default => $fields{ 'ser_descr_num' },
                           -size => $CFG{ OBJ_SERIES_SER_DESCR_NUM_SIZE },
                           -maxlength => 
                             $CFG{ OBJ_SERIES_SER_DESCR_NUM_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  #    /
  # (  )
  print "<tr>\n";
  print "<th> /</th>\n";
  print "<td>", 
        $query->textarea( -name => 'ser_descr',
                          -default => $fields{ 'ser_descr' },
                          -rows => $CFG{ OBJ_SERIES_SER_DESCR_ROWS },
                          -columns => $CFG{ OBJ_SERIES_SER_DESCR_COLS },
                          -readonly => 'readonly'
                        ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>   /<br />" .
        "(    , . .    " .
        ")</th>\n";
  print "<td>",
        $query->textfield( -name => 'issue_num',
                           -default => $fields{ 'issue_num' },
                           -size => $CFG{ OBJ_SERIES_ISSUE_NUM_SIZE },
                           -maxlength => $CFG{ OBJ_SERIES_ISSUE_NUM_MAXLENGTH }
                          ),
        "</td>\n";
  print "</tr>\n";

  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment", "OBJ_SERIES_COMMENT" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ OBJ_SERIES_COMMENT_ROWS },
                          -columns => $CFG{ OBJ_SERIES_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
  return ( 0 );
}

# -----------------------------------------------------------------------------
#          
# -----------------------------------------------------------------------------
sub print_add_info
{
  #  .    
  print_bib_record( $query, "   " );
  
  return ( 0 );
}
