#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :   ", ,  "
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'ORGS';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Orgs
my @f_names =
   ( 'org_id',        #   
     'org_fname',     #   
     'org_sname',     #   
     'org_city_code', #   ()
     'org_addr',      #  
     'org_email',     #   
     'org_descr',     #   , . 
     'org_id_orig',   #  ,   
                      # (  ,    )
     'org_id_parent', #   
     'org_tmp_flag',  #    ()
     'lang_code',     #  ,    
                      #  (1 -  )
     'process_code',  #     
     'comment'        # 
   );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#         "  ", 
#   'caller_name'  'ORGS_PARENT'  'ORGS_ORIG'.  
#   create_top_block()  ,   
#   ,     .
#  ,     -,   
# "  "   :    
#   --  .     
#  create_selection_func()      --
#     ,     
#     ,     . 
#    .      
#    create_selection_func()   make_form().
#       'ORGS_PARENT'  'ORGS_ORIG'.
# TODO.         
#       .
if ( $query->param( 'caller_name' ) =~ /^(ORGS_ORIG|ORGS_PARENT)$/ )
{
  $module = $query->param( 'caller_name' );
}

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              do_find => \&do_find,
              do_export => \&do_export,
              do_import => \&do_import,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              action => $script_name
            );

exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  if ( $query->param( 'org_id' ) eq '' )
  {
    push( @error_messages, "    " );
  }

  if ( $query->param( 'org_fname' ) eq '' )
  {
    push( @error_messages, "    " );
  }

  if ( $query->param( 'org_sname' ) eq '' )
  {
    push( @error_messages, "    " );
  }

  if ( $query->param( 'org_city_code' ) eq '' )
  {
    push( @error_messages, "    --  " .
          "" );
  }

  #    ,   
  if ( $query->param( 'org_id_orig' ) !~ /^\d*$/ )
  {
    push( @error_messages, "  ,   " .
          "" );
  }

  #    ,   
  if ( $query->param( 'org_id_parent' ) !~ /^\d*$/ )
  {
    push( @error_messages, "   " );
  }

  if ( $query->param( 'lang_code' ) eq '' )
  {
    push( @error_messages, "   " );
  }

  if ( $query->param( 'process_code' ) eq '' )
  {
    push( @error_messages, "      " .
          "" );
  }

  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }
  
  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => ', , ' .
                                    ' ',
                    user => $user,
                    make_letters => 'yes',
                    num_last_recs => $CFG{ ORGS_NUM_LAST_RECS },
                    full_top => 'yes'
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $org_id;                #   
  my $command;               #      

  $org_id = $query->param( 'org_id' );
  
  #         
  $command = "DELETE FROM ${db_schema}orgs " .
             "WHERE org_id = '$org_id'";

  #   
  del_rec( query => $query,
           create_top => \&create_top,
           target => "_self",
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_export
{
  my $org_id;                #   
  my $command;               #      
  my @table_cmd_pairs = ();  #     ,
                             #       

  $org_id = $query->param( 'org_id' );

  #  -       
  #    (      , 
  #     )
  $command = "SELECT * FROM Orgs WHERE org_id = $org_id";
  push( @table_cmd_pairs, [ 'Orgs', $command ] );

  #    
  export_data( query => $query,
               create_top => \&create_top,
               table_cmd_pairs => \@table_cmd_pairs
             );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_find
{
  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();       #     
  create_top();     #    
  close_top();      #     
  
  open_bottom();    #     
  
  print "<p class=\"info\">     </p>\n";

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_import
{
  my $org_id;                #   
  my $command;               #      
  my @table_cmd_pairs = ();  #     ,
                             #       

  $org_id = $query->param( 'org_id' );

  #  -       
  #    (      , 
  #     )
  $command = "SELECT * FROM exp_imp.Orgs WHERE org_id = $org_id";
  push( @table_cmd_pairs, [ 'Orgs', $command ] );

  #    
  import_data( query => $query,
               create_top => \&create_top,
               table_cmd_pairs => \@table_cmd_pairs
             );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#    ,   
#   
# -----------------------------------------------------------------------------
sub do_query
{
  my( $result, $i );              #    
  my @row;                        #      
  my $command;                    #      
  my $letter;                     #    
  my $letter_lower;               #   --   

  #   ,   ,   
  #     
  my $num_last_recs;

  #  WHERE   
  my $where;
  
  #   WHERE   
  my $where_add;
  
  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #      / 
  my $can_export = 0;
  my $can_import = 0;

  #        
  #   ( --      
  #   )
  my $add_params = '';

  #  ,        
  my $alt_row = 1;

  my $href;    #   HTML-

  #         
  #  enable_select  caller_name (  )
  if ( $query->param( 'enable_select' ) )
  {
    $add_params = "&enable_select=1&caller_name=" .
                  $query->param( 'caller_name' );
  }

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  $letter        = $query->param( 'letter' );
  $num_last_recs = $query->param( 'num_last_recs' );

  #    ,      - 
  #      
  # .    undef,      '' 
  #               -   CGI.pm.
  if ( ( $letter eq undef || $letter eq '' ) &&
       ( $num_last_recs eq undef || $num_last_recs eq '' )
     )
  {
    close_bottom();   #     
    print $query->end_html();
    return ( 0 );
  }

  #         ,
  #   
  if ( $num_last_recs )
  {
    # .        
    #                ,   ,  
    #              .  -   ,
    #                ""   org_id,
    #                   .
    $where = "WHERE o1.org_id >= ( SELECT max( org_id ) " .
                                  "FROM ${db_schema}orgs ) - " .
                                  "$num_last_recs + 1 ";
  }
  #       
  elsif ( $letter )
  {
    #        
    $letter = reveal_rus_letter( $letter );

    #      , 
    # ,   
    $letter_lower = change_case( $letter, 'lower' );

    #    --  ,    
    $where = "WHERE o1.org_sname ~ '^($letter|\"$letter|" .
                                     "$letter_lower|\"$letter_lower)' ";
  }

  #          confs.pl
  #     
  $where_add = ( $query->param( 'caller_name' ) eq 'CONFS' ) ? 
               " AND o1.org_tmp_flag = 't' " :
               "";

  #     ,    $where
  # (. .        
  #      )
  #     ,    
  # ,  ,   ;
  #       ,
  #   
  $command = "SELECT o1.*, o2.org_sname AS org_sname_orig, " .
                    "o3.org_sname AS org_sname_parent, " .
                    "l.lang_sname, c.city_sname " .
             "FROM ((( ${db_schema}orgs o1 LEFT JOIN ${db_schema}orgs o2 " .
                  "ON o1.org_id_orig = o2.org_id ) " .
                  "LEFT JOIN ${db_schema}orgs o3 " .
                  "ON o1.org_id_parent = o3.org_id ) " .
                  "LEFT JOIN ${db_schema}langs l " .
                  "ON o1.lang_code = l.lang_code ) " .
                  "LEFT JOIN ${db_schema}cities c " .
                  "ON o1.org_city_code = c.city_code " .
              $where . $where_add .
  #        ,   
  #      (,     
  #    --  )
  #      -- ,    ,  
  #  ,    ;
             "ORDER BY CASE WHEN o1.org_sname ~ '^\"' " .
                           "THEN lower( substr( o1.org_sname, 2 ) ) " .
                           "ELSE lower( o1.org_sname ) " .
                      "END";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    #    ,    ,   
    if ( $num_last_recs )
    {
      print "<h3>,      (" . 
            $num_last_recs . " .)</h3>\n";
    }

    #       ,     
    # "  ",       
    # (      ,
    #     )
    if ( $query->param( 'enable_select' ) &&
         $query->param( 'caller_name') eq $module )
    {
      $can_view = 0;
      $can_delete = 0;
    }
    else
    {
      $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                               'user' => $user );
      $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                                 'user' => $user );
    }

    #     "/",     
    if ( $query->param( 'exp_imp' ) )
    {
      $can_import = import_enabled() && 
                    have_access( 'module' => $module, 'procedure' => 'IMPORT',
                                 'user' => $user );
    }
    #    public --   ,
    #   -- 
    else
    {
      $can_export = export_enabled() && 
                    have_access( 'module' => $module, 'procedure' => 'EXPORT',
                                 'user' => $user );
    }

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th> </th>\n";
    print "<th> </th>\n";
    print "<th></th>\n";
    print "<th> &mdash;   (  )</th>\n";
    print "<th>  (  )</th>\n";
    print "<th></th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete || $can_export ||
                                   $can_import );
    print "</tr>\n";

    #          
    #     ...
    if ( $query->param( 'enable_select' ) )
    {
      # ...    JavaScript    
      #     Orgs     ...
      if ( $query->param( 'caller_name' ) eq 'RESP_STAT' )
      {
        # ...  resp_org_id  org_sname   RESP_STAT
        create_assign_values_func( 'resp_org_id', 'org_sname' );
      }
      elsif ( $query->param( 'caller_name' ) eq 'PUB_PRINTER' )
      {
        # ...  pub_org_id  org_sname   PUB_PRINTER
        create_assign_values_func( 'pub_org_id', 'org_sname' );
      }
      elsif ( $query->param( 'caller_name' ) eq 'STOR_OBJS' )
      {
        # ...  owner_org_id  org_sname   STOR_OBJS
        create_assign_values_func( 'owner_org_id', 'org_sname' );
      }
      #  orgs.pl     "  ", 
      #    
      elsif ( $query->param( 'caller_name' ) eq 'ORGS_ORIG' )
      {
        # ...  org_id_orig  org_sname_orig   ORGS_ORIG
        create_assign_values_func( 'org_id_orig', 'org_sname_orig' );
      }
      elsif ( $query->param( 'caller_name' ) eq 'ORGS_PARENT' )
      {
        # ...  org_id_parent  org_sname_parent   ORGS_PARENT
        create_assign_values_func( 'org_id_parent', 'org_sname_parent' );
      }
      elsif ( $query->param( 'caller_name' ) eq 'CONFS' )
      {
        # ...  conf_code  conf_fname   CONFS
        create_assign_values_func( 'conf_code', 'conf_fname' );
      }
      elsif ( $query->param( 'caller_name' ) eq 'ORGS_ACT' )
      {
        # ...  org_id  org_fname   ORGS_ACT
        create_assign_values_func( 'org_id', 'org_fname' );
      }
    }

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #   ,  , ,  
      #    --  ,    
      #  , ,    
      # (  &nbsp;   ,   ,
      #        :  
      #  'org_id_orig'  'org_id_parent'  null,   
      #  -)
      print "<td class=\"center\">$row[ $result->fnumber( 'org_id' ) ]</td>\n";

      #         
      #     ,   
      # org_sname    

      #     "" 
      # (.    obj_groups_descrs.pl)
      #     , . . , 
      #   escapeHTML(), 
      my $org_sname = $row[ $result->fnumber( 'org_sname' ) ];
      $org_sname =~ s/\'/\\\'/g;
      $org_sname = CGI::escapeHTML( $org_sname );

      if ( $query->param( 'enable_select' ) )
      {
        print "<td>",
              qq{ <a class="command_link" href="javascript:void( 0 )" onclick=
                  "assign_values( $row[ $result->fnumber( 'org_id' ) ],
                                  '$org_sname' )">
                   $row[ $result->fnumber( 'org_sname' ) ]</a> },
              "</td>\n";
      }
      else
      {
        print "<td>$row[ $result->fnumber( 'org_sname' ) ]</td>\n";
      }

      print "<td>$row[ $result->fnumber( 'city_sname' ) ]</td>\n";

      #  ,   , ,  
      #    "&nbsp;"
      print "<td>",
            ( $row[ $result->fnumber( 'org_id_orig' ) ] ne undef ) ?
              "(" . $row[ $result->fnumber( 'org_id_orig' ) ] . ") " .
              $row[ $result->fnumber( 'org_sname_orig' ) ] :
            "&nbsp;",
            "</td>\n";

      #   , ,  
      #    "&nbsp;"
      print "<td>",
            ( $row[ $result->fnumber( 'org_id_parent' ) ] ne undef ) ?
              "(" . $row[ $result->fnumber( 'org_id_parent' ) ] . ") " .
              $row[ $result->fnumber( 'org_sname_parent' ) ] :
            "&nbsp;",
            "</td>\n";

      print "<td>$row[ $result->fnumber( 'lang_sname' ) ]</td>\n";

      #   HTML-
      $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
              "org_id=" . $row[ $result->fnumber( 'org_id' ) ] .
              $add_params;

      #      
      print "<td>" if ( $can_view || $can_delete || $can_export ||
                        $can_import );
      print qq{ <a class="command_link" href="$script_name/view?$href"} .
            qq{ target="_self"></a> } . "\n" if $can_view;

      #     
      print qq{ <a class="command_link" href="$script_name/delete?$href"} .
            qq{ onclick="$confirm_delete" } .
            qq{ target="_self"></a> } . "\n" if $can_delete;

      #   
      print qq{ <a class="command_link" href="$script_name/export?$href"} .
            qq{ onclick="$confirm_export"} .
            qq{ target="_blank"></A> } . "\n" if $can_export;

      #   
      print qq{ <a class="command_link" href="$script_name/import?$href"} .
            qq{ onclick="$confirm_import"} .
            qq{ target="_blank"></A> } . "\n" if $can_import;

      print "</td>" if ( $can_view || $can_delete || $can_export ||
                         $can_import );
      print "</tr>\n";
    }
    print "</table>\n";
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $org_id;                #   
  my $command;               #      

  $org_id = $query->param( 'org_id' );

  #     
  #       , 
  #  
  $command = "SELECT o1.*, o2.org_sname AS org_sname_orig, " .
                    "o3.org_sname AS org_sname_parent " .
             "FROM ( ${db_schema}orgs o1 LEFT JOIN ${db_schema}orgs o2 " .
                  "ON o1.org_id_orig = o2.org_id ) " .
                  "LEFT JOIN ${db_schema}orgs o3 " .
                  "ON o1.org_id_parent = o3.org_id " .
             "WHERE o1.org_id = '$org_id'";

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => "_self",
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "         " .
                     " " . $org_id,
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
          );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "orgs",
                       key => "org_id",
                       f_names => \@f_names,
                       f_special => [ 'org_tmp_flag' ],
                       func_special => \&non_std_fields,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  #      (    
  # ,     )
  my( $ref_values_langs, $ref_labels_langs ) = popup_langs_list( $db_schema );

  #      (    
  #     )
  my( $ref_values_procs, $ref_labels_procs ) =
    popup_process_types_list( $db_schema );

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #         ,
    #   1        
    $fields{ 'org_id' } = get_next_key_value( 'orgs', 'org_id' );

    #   

    #   
    $fields{ 'org_fname' }     = $CFG{ ORGS_ORG_FNAME };

    #   
    $fields{ 'org_sname' }     = $CFG{ ORGS_ORG_SNAME };

    #   ()
    $fields{ 'org_city_code' } = $CFG{ ORGS_ORG_CITY_CODE };

    #  
    $fields{ 'org_addr' }      = $CFG{ ORGS_ORG_ADDR };

    #   
    $fields{ 'org_email' }     = $CFG{ ORGS_ORG_EMAIL };

    #   , . 
    $fields{ 'org_descr' }     = $CFG{ ORGS_ORG_DESCR };

    #  ,   
    # (  ,    )
    $fields{ 'org_id_orig' }   = $CFG{ ORGS_ORG_ID_ORIG };

    #   
    $fields{ 'org_id_parent' } = $CFG{ ORGS_ORG_ID_PARENT };

    #    ()
    $fields{ 'org_tmp_flag' }  = $CFG{ ORGS_ORG_TMP_FLAG };

    #  ,      
    $fields{ 'lang_code' }     = $CFG{ ORGS_LANG_CODE };

    #     
    $fields{ 'process_code' }  = $CFG{ ORGS_PROCESS_CODE };

    # 
    $fields{ 'comment' }       = $CFG{ ORGS_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  #    "  " 
  #     get_next_key_value(),  
  #   ,     , .. 
  #     UPDATE   
  print $query->hidden( -name => 'org_id',
                        -default => $fields{ 'org_id' }
                      ), "\n";

  #       ,     
  #           ,
  #        ,   
  #  ,     
  # . .    cities.pl.
  print $query->hidden( -name => 'enable_select' ), "\n";
  print $query->hidden( -name => 'caller_name' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>", $fields{ 'org_id' }, "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].org_fname", "ORGS_ORG_FNAME" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'org_fname',
                          -default => $fields{ 'org_fname' },
                          -rows => $CFG{ ORGS_ORG_FNAME_ROWS },
                          -columns => $CFG{ ORGS_ORG_FNAME_COLS }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].org_sname", "ORGS_ORG_SNAME" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'org_sname',
                           -default => $fields{ 'org_sname' },
                           -size => $CFG{ ORGS_ORG_SNAME_SIZE },
                           -maxlength => $CFG{ ORGS_ORG_SNAME_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  #        labels  
  # ,    popup_cities_list()   ,
  #   -   
  print "<th></th>\n";

  #      JavaScript,  
  # - cities.pl
  create_selection_func( func_name => 'select_city',
                         module_name => 'cities.pl',
                         caller_name => $module,
                         window_name => 'cities',
                         exp_imp => $query->param( 'exp_imp' ) );

  #       
  # (  )
  print "<td>";

  #   ()     
  #     (,   );
  #  JavaScript-  :   create_hot_help()
  #  HTML-,      VALUE,    
  # HTML-,      ,    
  #  NAME       " ";
  #     (  create_hot_help()  
  #        )
  create_hot_help( "document.forms[ 0 ].org_city_code",
                   "ORGS_ORG_CITY_CODE", "REPLACE",
                   "var str; if (this.value) str = this.value;
                             else str = this.name;
                   document.forms[ 0 ].org_city_sname.value = str;
                   document.forms[ 0 ].org_country_sname_city.value = ''; " )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'org_city_code',
                           -default => $fields{ 'org_city_code' },
                           -size => $CFG{ ORGS_ORG_CITY_CODE_SIZE },
                           -maxlength => $CFG{ ORGS_ORG_CITY_CODE_MAXLENGTH }
                         ),
        "&nbsp;&nbsp;",
        $query->textfield( -name => 'org_city_sname',
                           -default => $fields{ 'org_city_sname' },
                           -size => $CFG{ ORGS_ORG_CITY_SNAME_SIZE },
                           -maxlength => $CFG{ ORGS_ORG_CITY_SNAME_MAXLENGTH },
                           -readonly => 'readonly'
                         ),
       "&nbsp;&nbsp;",
        $query->textfield( -name => 'org_country_sname_city',
                           -default => $fields{ 'org_country_sname_city' },
                           -size => $CFG{ ORGS_ORG_COUNTRY_SNAME_CITY_SIZE },
                           -maxlength =>
                             $CFG{ ORGS_ORG_COUNTRY_SNAME_CITY_MAXLENGTH },
                           -readonly => 'readonly'
                         ),
        "&nbsp;&nbsp;",
        qq{ <a class="command_link" href="javascript:void( 0 )" onclick=} .
        qq{"select_city()">} . "</a>",
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].org_addr", "ORGS_ORG_ADDR" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'org_addr',
                          -default => $fields{ 'org_addr' },
                          -rows => $CFG{ ORGS_ORG_ADDR_ROWS },
                          -columns => $CFG{ ORGS_ORG_ADDR_COLS }
                        ),  
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].org_email", "ORGS_ORG_EMAIL" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'org_email',
                          -default => $fields{ 'org_email' },
                          -rows => $CFG{ ORGS_ORG_EMAIL_ROWS },
                          -columns => $CFG{ ORGS_ORG_EMAIL_COLS }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  ,  </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].org_descr", "ORGS_ORG_DESCR" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'org_descr',
                          -default => $fields{ 'org_descr' },
                          -rows => $CFG{ ORGS_ORG_DESCR_ROWS },
                          -columns => $CFG{ ORGS_ORG_DESCR_COLS }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> &mdash;   (  )</th>\n";

  #      JavaScript,  
  # - orgs.pl
  #   , ..  orgs.pl   
  #   "  "    
  create_selection_func( func_name => 'select_orig_org',
                         module_name => 'orgs.pl',
                         caller_name => $module . "_ORIG",
                         window_name => 'orig_orgs',
                         exp_imp => $query->param( 'exp_imp' ) );

  #      -  
  # (  )
  # TODO. ,      " 
  #       ",    "  --  "
  #         .  CHECK   Orgs
  #              ,
  #            .  
  #               
  #          ,  ,  
  #        (confuse) .
  print "<td>",
        $query->textfield( -name => 'org_id_orig',
                           -default => $fields{ 'org_id_orig' },
                           -size => $CFG{ ORGS_ORG_ID_ORIG_SIZE },
                           -maxlength => $CFG{ ORGS_ORG_ID_ORIG_MAXLENGTH }
                         ),
        "&nbsp;&nbsp;",
        $query->textfield( -name => 'org_sname_orig',
                           -default => $fields{ 'org_sname_orig' },
                           -size => $CFG{ ORGS_ORG_SNAME_ORIG_SIZE },
                           -maxlength => $CFG{ ORGS_ORG_SNAME_ORIG_MAXLENGTH },
                           -readonly => 'readonly'
                         ),
        "&nbsp;&nbsp;",
        qq{ <a class="command_link" href="javascript:void( 0 )" onclick=} .
        qq{"select_orig_org()">} . "</a>",
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  (  )</th>\n";

  #      JavaScript,  
  # - orgs.pl
  #   , ..  orgs.pl   
  #   "  "    
  create_selection_func( func_name => 'select_parent_org',
                         module_name => 'orgs.pl',
                         caller_name => $module . "_PARENT",
                         window_name => 'parent_orgs',
                         exp_imp => $query->param( 'exp_imp' ) );

  print "<td>",
        $query->textfield( -name => 'org_id_parent',
                           -default => $fields{ 'org_id_parent' },
                           -size => $CFG{ ORGS_ORG_ID_PARENT_SIZE },
                           -maxlength => $CFG{ ORGS_ORG_ID_PARENT_MAXLENGTH }
                         ),
        "&nbsp;&nbsp;",
        $query->textfield( -name => 'org_sname_parent',
                           -default => $fields{ 'org_sname_parent' },
                           -size => $CFG{ ORGS_ORG_SNAME_PARENT_SIZE },
                           -maxlength =>
                             $CFG{ ORGS_ORG_SNAME_PARENT_MAXLENGTH },
                           -readonly => 'readonly'
                         ),
        "&nbsp;&nbsp;",
        qq{ <a class="command_link" href="javascript:void( 0 )" onclick=} .
        qq{"select_parent_org()">} . "</a>",
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>   ()</th>\n";
  print "<td>",
        $query->checkbox( -name => 'org_tmp_flag',
                          -checked => 
                             $fields{ 'org_tmp_flag' } eq 't' ? '1' : '0',
                          -value => 'yes',
                          -label => ''
                        ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  
  #        labels  
  # ,    popup_langs_list()   ,
  #   -   
  print "<th></th>\n";
  print "<td>",
        $query->popup_menu( -name => 'lang_code',
                            -default => $fields{ 'lang_code' },
                            -values => $ref_values_langs,
                            -labels => { @{ $ref_labels_langs } }
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";

  #        labels  
  # ,    popup_process_types_list() 
  #  ,   -   
  print "<th>  </th>\n";
  print "<td>",
        $query->popup_menu( -name => 'process_code',
                            -default => $fields{ 'process_code' },
                            -values => $ref_values_procs,
                            -labels => { @{ $ref_labels_procs } }
                          ),
        "</td>\n";
  print "</tr>\n";
  
  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment", "ORGS_COMMENT" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ ORGS_COMMENT_ROWS },
                          -columns => $CFG{ ORGS_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
  return ( 0 );
}

# -----------------------------------------------------------------------------
#   ,    
#  -      
# -----------------------------------------------------------------------------
sub non_std_fields
{
  # :
  my $fname = shift;  #  
                      #   -   ( 
                      #  ).      
  my $value;
  
  #    ()
  if ( $fname eq 'org_tmp_flag' )
  {
    #     bool,    
    #   
    $value = $query->param( $fname ) ? 'yes' : 'no';
  }

  return ( $value );  
}
