#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :   "  , "
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'ORGS_ACT';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Orgs_act
my @f_names =
   ( 'org_id',         #   
     'act_type_code',  #   
     'comment'         # 
   );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              do_find => \&do_find,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              action => $script_name
            );

exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  if ( $query->param( 'org_id' ) eq '' )
  {
    push( @error_messages, "    " );
  }

  if ( $query->param( 'act_type_code' ) eq '' )
  {
    push( @error_messages, "    " );
  }

  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }
  
  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => '  , ' .
                                    '',
                    user => $user,
                    make_letters => 'yes',
                    num_last_recs => $CFG{ ORGS_ACT_NUM_LAST_RECS },
                    full_top => 'yes'
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $org_id;             #   
  my $act_type_code;      #   
  my $command;            #      

  $org_id        = $query->param( 'org_id' );
  $act_type_code = $query->param( 'act_type_code' );
  
  #         
  $command = "DELETE FROM ${db_schema}orgs_act " .
             "WHERE org_id = '$org_id' AND " .
                   "act_type_code = '$act_type_code'";

  #   
  del_rec( query => $query,
           create_top => \&create_top,
           target => "_self",
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_find
{
  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();       #     
  create_top();     #    
  close_top();      #     
  
  open_bottom();    #     
  
  print "<p class=\"info\">     </p>\n";

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      , 
# -----------------------------------------------------------------------------
sub do_query
{
  my( $result, $i );              #    
  my @row;                        #      
  my $command;                    #      
  my $letter;                     #    
  my $letter_lower;               #   --   

  #   ,   ,   
  #     
  my $num_last_recs;

  #  WHERE, ORDER BY  LIMIT   
  my $condition;

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #  ,        
  my $alt_row = 1;

  my $href;    #   HTML-

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  $letter        = $query->param( 'letter' );
  $num_last_recs = $query->param( 'num_last_recs' );

  #    ,      - 
  #      
  # .    undef,      '' 
  #               -   CGI.pm.
  if ( ( $letter eq undef || $letter eq '' ) &&
       ( $num_last_recs eq undef || $num_last_recs eq '' )
     )
  {
    close_bottom();   #     
    print $query->end_html();
    return ( 0 );
  }

  #         ,
  #   
  if ( $num_last_recs )
  {
    # .        
    #                ,   ,  
    #              .  -   ,
    #                ""   org_id,
    #                   .
    # .        
    #                  ,   
    #             :
    #             -      , 
    #               $num_last_recs;
    #             -  ,    org_id, 
    #                (max - $num_last_recs + 1)  max, 
    #                ( )   
    #              ,      -
    #               ,    org_id 
    #                    ,  
    #                  .
    #  WHERE, ORDER BY  LIMIT   
    # .     ,  
    #                  
    #              LIMIT (.  SQL-  
    #             , , persons.pl).
    $condition = "WHERE oa.org_id = o.org_id AND " .
                       "oa.act_type_code = a.act_type_code " .
                 "ORDER BY oa.org_id DESC, a.act_type_sname " .
                 "LIMIT $num_last_recs";
  }
  #       
  elsif ( $letter )
  {
    #        
    $letter = reveal_rus_letter( $letter );

    #      , 
    # ,   
    $letter_lower = change_case( $letter, 'lower' );

    #  WHERE, ORDER BY  LIMIT   
    #      --  , 
    #    
    #   lower(),     
    #  (     -- ,    ,
    #    ,    )
    $condition = "WHERE oa.org_id = o.org_id AND " .
                       "oa.act_type_code = a.act_type_code AND " .
                       "o.org_sname ~ '^($letter|\"$letter|" .
                                        "$letter_lower|\"$letter_lower)' " .
                 "ORDER BY CASE WHEN o.org_sname ~ '^\"' " .
                               "THEN lower( substr( o.org_sname, 2 ) ) " .
                               "ELSE lower( o.org_sname ) " .
                          "END, " .
                          "a.act_type_sname";
  }

  #       (   
  #      )
  $command = "SELECT oa.*, o.org_sname, a.act_type_sname " .
             "FROM ${db_schema}orgs_act oa, ${db_schema}orgs o, " .
                  "${db_schema}activity_types a " .
             $condition;

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    #    ,    ,   
    if ( $num_last_recs )
    {
      print "<h3>,      (" . 
            $num_last_recs . " .)</h3>\n";
    }

    $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                             'user' => $user );
    $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                               'user' => $user );

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th> </th>\n";
    print "<th>  </th>\n";
    print "<th> </th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete );
    print "</tr>\n";

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #    ,   
      #   
      print "<td class=\"center\">$row[ $result->fnumber( 'org_id' ) ]</td>\n";
      print "<td>$row[ $result->fnumber( 'org_sname' ) ]</td>\n";
      print "<td>$row[ $result->fnumber( 'act_type_sname' ) ]</td>\n";

      #   HTML-
      $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
              "org_id=" . $row[ $result->fnumber( 'org_id' ) ] .
              "&act_type_code=" . $row[ $result->fnumber( 'act_type_code' ) ];

      #         
      print "<td>" if ( $can_view || $can_delete );
      print qq{ <a class="command_link" href="$script_name/view?$href"} .
            qq{ target="_self"></a> } . "\n" if $can_view;

      #        
      print qq{ <a class="command_link" href="$script_name/delete?$href"} .
            qq{ onclick="$confirm_delete" } .
            qq{ target="_self"></a> } . "\n"  if $can_delete;

      print "</td>\n" if ( $can_view || $can_delete );
      print "</tr>\n";
    }
    print "</table>\n";
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $org_id;             #   
  my $act_type_code;      #   
  my $command;            #      

  $org_id        = $query->param( 'org_id' );
  $act_type_code = $query->param( 'act_type_code' );

  #        
  $command = "SELECT oa.*, o.org_fname " .
             "FROM ${db_schema}orgs_act oa, ${db_schema}orgs o " .
             "WHERE oa.org_id = '$org_id' AND " .
                   "oa.org_id = o.org_id AND " .
                   "oa.act_type_code = '$act_type_code'";

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => "_self",
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "        " .
                     "  " . $org_id .
                     "     " . $act_type_code,
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "orgs_act",
                       key => "org_id:org_id_begin, " .
                              "act_type_code:act_type_code_begin",
                       f_names => \@f_names,
                       f_special => undef,
                       func_special => undef,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  #      (    
  #   )
  my( $ref_values_acts, $ref_labels_acts ) =
    popup_activity_types_list( $db_schema );

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #   

    #   
    $fields{ 'org_id' }        = $CFG{ ORGS_ACT_ORG_ID };

    #   
    $fields{ 'act_type_code' } = $CFG{ ORGS_ACT_ACT_TYPE_CODE };

    # 
    $fields{ 'comment' }       = $CFG{ ORGS_ACT_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  #     "  "
  #  "  "
  # .      'begin'  ,
  #                   ,  
  #               (.  make_cmd   E_ARCH.pm.
  #             ..       ,   
  #              (, ,   ).
  print $query->hidden( -name => 'org_id_begin',
                        -default => $fields{ 'org_id' }
                      ), "\n";
  print $query->hidden( -name => 'act_type_code_begin',
                        -default => $fields{ 'act_type_code' }
                      ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print "<table class=\"form\">\n";

  print "<tr>";
  print "<th> </th>\n";

  #      JavaScript,  
  # - orgs.pl
  create_selection_func( func_name => 'select_org',
                         module_name => 'orgs.pl',
                         caller_name => $module,
                         window_name => 'orgs',
                         exp_imp => $query->param( 'exp_imp' ) );
  print "<td>",
        $query->textfield( -name => 'org_id',
                           -default => $fields{ 'org_id' },
                           -size => $CFG{ ORGS_ACT_ORG_ID_SIZE },
                           -maxlength => $CFG{ ORGS_ACT_ORG_ID_MAXLENGTH }
                         ),
        "&nbsp;&nbsp;",
        qq{ <a class="command_link" href="javascript:void( 0 )" onclick=} .
        qq{"select_org()">} . "</a>",
        "</td>\n";
  print "</tr>\n";

  print "<tr>";
  print "<th> </th>\n";
  #      
  print "<td>",
        $query->textarea( -name => 'org_fname',
                          -default => $fields{ 'org_fname' },
                          -rows => $CFG{ ORGS_ACT_ORG_FNAME_ROWS },
                          -columns => $CFG{ ORGS_ACT_ORG_FNAME_COLS },
                          -readonly => 'readonly'
                        ),
        "</td>\n";
  print "</tr>\n";

  #        labels  
  # ,    popup_activity_types_list() 
  #  ,   -   
  print "<tr>";
  print "<th> </th>\n";
  print "<td>",
        $query->popup_menu( -name => 'act_type_code',
                            -default => $fields{ 'act_type_code' },
                            -values => $ref_values_acts,
                            -labels => { @{ $ref_labels_acts } }
                          ),
        "</td>\n";
  print "</tr>\n";
  
  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment", "ORGS_ACT_COMMENT" ) 
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ ORGS_ACT_COMMENT_ROWS },
                          -columns => $CFG{ ORGS_ACT_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
  return ( 0 );
}
