#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :   ""
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'PERSONS';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Persons
my @f_names =
   ( 'pers_id',         #   
     'pers_name',       #  , , 
                        # .    
                        #                .
     'pers_life_years', #  
     'pers_add_info',   #   (/,
                        # /, ...  , ...)
     'pers_id_orig',    #  ,   
                        # (  ,   
                        # )
     'lang_code',       #  ,    
                        # . . .  (1 -  )
     'process_code',    #     
                        # (1 - , ..   , 
                        #    . )
     'pers_addr',       # 
     'pers_email',      #  
     'comment'          # 
   );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              do_find => \&do_find,
              do_export => \&do_export,
              do_import => \&do_import,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              action => $script_name
            );

#    ,   
#      
if ( $query->path_info =~ /^\/list_bib_recs$/ )
{
  do_list_bib_recs();
}

exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  if ( $query->param( 'pers_id' ) eq '' )
  {
    push( @error_messages, "    " );
  }

  if ( $query->param( 'pers_name' ) eq '' )
  {
    push( @error_messages, "   , ,  " .
          "" );
  }

  #    ,   
  if ( $query->param( 'pers_id_orig' ) !~ /^\d*$/ )
  {
    push( @error_messages, "  ,   " .
          "" );
  }

  if ( $query->param( 'lang_code' ) eq '' )
  {
    push( @error_messages, "   " );
  }

  if ( $query->param( 'process_code' ) eq '' )
  {
    push( @error_messages, "      " );
  }

  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }
  
  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => '',
                    user => $user,
                    make_letters => 'yes',
                    num_last_recs => $CFG{ PERSONS_NUM_LAST_RECS },
                    full_top => 'yes'
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $pers_id;               #   
  my $command;               #      

  $pers_id = $query->param( 'pers_id' );
  
  #         
  $command = "DELETE FROM ${db_schema}persons " .
             "WHERE pers_id = '$pers_id'";

  #   
  del_rec( query => $query,
           create_top => \&create_top,
           target => "_self",
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_export
{
  my $pers_id;               #   
  my $command;               #      
  my @table_cmd_pairs = ();  #     ,
                             #       

  $pers_id = $query->param( 'pers_id' );

  #  -       
  #    (      , 
  #     )
  $command = "SELECT * FROM Persons WHERE pers_id = $pers_id";
  push( @table_cmd_pairs, [ 'Persons', $command ] );

  #    
  export_data( query => $query,
               create_top => \&create_top,
               table_cmd_pairs => \@table_cmd_pairs
             );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_find
{
  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();       #     
  create_top();     #    
  close_top();      #     
  
  open_bottom();    #     
  
  print "<p class=\"info\">     </p>\n";

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_import
{
  my $pers_id;               #   
  my $command;               #      
  my @table_cmd_pairs = ();  #     ,
                             #       

  $pers_id = $query->param( 'pers_id' );

  #  -       
  #    (      , 
  #     )
  $command = "SELECT * FROM exp_imp.Persons WHERE pers_id = $pers_id";
  push( @table_cmd_pairs, [ 'Persons', $command ] );

  #    
  import_data( query => $query,
               create_top => \&create_top,
               table_cmd_pairs => \@table_cmd_pairs
             );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#    .   ,   
#      
# -----------------------------------------------------------------------------
sub do_list_bib_recs
{
  my( $result, $i );              #    
  my @row;                        #      
  my $command;                    #      
  my $pers_id;                    #   ,
                                  #  
  my @persons = ();               #   ,
                                  #   ""   ,
                                  #  
  my $headline;                   #   . 
  my $personal_info;              #   ,   
  
  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  $pers_id = $query->param( 'pers_id' );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  #     Persons    :
  # --  ,  "" ;
  # --  ,     
  #    (   pers_id_orig);
  # -- ,      
  #   (   pers_id_orig);
  # -- ,        ,
  #    ,   
  # .         
  #                  -,
  #                SQL-. SQL- 
  #              .      
  #               .    
  #                   (  )
  #                ,   -  
  #                ,     ,
  #             . .     .   
  #              , . .     
  #               (ORDER BY),      
  #                 ,   
  #                     .
  $command = "SELECT p1.pers_id, p1.pers_name " .
             "FROM ${db_schema}persons p1 " .
             "WHERE p1.pers_id = $pers_id OR " .
                   "p1.pers_id = ( SELECT p2.pers_id_orig " .
                                  "FROM ${db_schema}persons p2 " .
                                  "WHERE p2.pers_id = $pers_id ) OR " .
                   "p1.pers_id_orig = $pers_id OR " .
                   "p1.pers_id_orig = ( SELECT p3.pers_id_orig " .
                                       "FROM ${db_schema}persons p3 " .
                                       "WHERE p3.pers_id = $pers_id ) " .
             "ORDER BY p1.pers_name";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    #       
    while ( @row = $result->fetchrow )
    {
      $personal_info .= $row[ $result->fnumber( 'pers_name' ) ] . "; ";
      push( @persons, $row[ $result->fnumber( 'pers_id' ) ] );
    }

    $personal_info =~ s/; $//;   #     :  
  }
  else
  {
    ;
    # TODO.  -   ?
  }
  # ------------------------------------------------------------------------

  #   ,  ""  
  #    . ,   
  # (     , . .    
  #   @persons)
  #  DISTINCT, . .      
  $command = "SELECT DISTINCT r.role_fname " .
             "FROM ${db_schema}roles r, ${db_schema}resp_stat rs " .
             "WHERE rs.resp_pers_id IN (" . join( ",", @persons ) . ") AND " .
                   "rs.role_code = r.role_code " .
             "ORDER BY 1";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    #    
    $personal_info .= "<br />\n: ";
    while ( @row = $result->fetchrow )
    {
      $personal_info .= $row[ $result->fnumber( 'role_fname' ) ] . ", ";
    }

    $personal_info =~ s/, $//;   #   :  
  }
  else
  {
    ;
    # TODO.  -   ?
  }
  # ------------------------------------------------------------------------

  #      
  print "<p class=\"bib_rec\">$personal_info</p>\n";

  #   
  $headline = "<h2 class=\"module_title\">" .
              " ,    " .
              "</h2>\n";

  #     .  ,   
  #   ,   (
  #      )
  #  DISTINCT, . .    ""  
  #      (,   
  #  )
  $command = "SELECT DISTINCT b.obj_id, b.bib_rec_num, " .
                    "CASE WHEN b.bib_rec_short IS NOT NULL " .
                         "THEN b.bib_rec_short " .
                         "ELSE b.bib_rec_full " .
                    "END AS bib_rec " .
             "FROM ${db_schema}bib_recs b, ${db_schema}resp_stat r " .
             "WHERE b.obj_id = r.obj_id AND " .
                   "r.resp_pers_id IN (" . join( ",", @persons ) . ") " .
             "ORDER BY bib_rec";

  #  .   ,   
  list_bib_recs_by_query( $query, $command, $headline );

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#    ,     
# -----------------------------------------------------------------------------
sub do_query
{
  my( $result, $i );              #    
  my @row;                        #      
  my $command;                    #      
  my $letter;                     #   
  my $letter_lower;               #   --   

  #   ,   ,   
  #     
  my $num_last_recs;

  #  WHERE   
  my $where;
  
  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #      / 
  my $can_export = 0;
  my $can_import = 0;

  #        
  #   ( --      
  #   )
  my $add_params = '';

  #  ,        
  my $alt_row = 1;

  my $href;    #   HTML-
  
  #         
  #  enable_select  caller_name (  )
  if ( $query->param( 'enable_select' ) )
  {
    $add_params = "&enable_select=1&caller_name=" .
                  $query->param( 'caller_name' );
  }

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  $letter        = $query->param( 'letter' );
  $num_last_recs = $query->param( 'num_last_recs' );

  #    ,      - 
  #      
  # .    undef,      '' 
  #               -   CGI.pm.
  if ( ( $letter eq undef || $letter eq '' ) &&
       ( $num_last_recs eq undef || $num_last_recs eq '' )
     )
  {
    close_bottom();   #     
    print $query->end_html();
    return ( 0 );
  }

  #         ,
  #   
  if ( $num_last_recs )
  {
    # .        
    #                ,   ,  
    #              .  -   ,
    #                ""   pers_id,
    #                   .
    $where = "WHERE p1.pers_id >= ( SELECT max( pers_id ) " .
                                   "FROM ${db_schema}persons ) - " .
                                   "$num_last_recs + 1 ";
  }
  #       
  elsif ( $letter )
  {
    #        
    $letter = reveal_rus_letter( $letter );

    #      , 
    # ,   
    $letter_lower = change_case( $letter, 'lower' );

    $where = "WHERE substr( p1.pers_name, 1, 1 ) IN " .
                   "( '$letter', '$letter_lower' ) ";
  }

  #     ,    $where
  # (. .          )
  # (    ,     )
  #   ...  ,   
  $command = "SELECT p1.*, p2.pers_name AS pers_name_orig, l.lang_sname " .
             "FROM ( ${db_schema}persons p1 " .
                    "LEFT JOIN ${db_schema}persons p2 " .
                    "ON p1.pers_id_orig = p2.pers_id " .
                  ") JOIN ${db_schema}langs l " .
                  "ON p1.lang_code = l.lang_code " .
             $where .
             "ORDER BY p1.pers_name";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    #    ,    ,   
    if ( $num_last_recs )
    {
      print "<h3>,      (" . 
            $num_last_recs . " .)</h3>\n";
    }

    #       ,     
    # "  ",       
    # (      ,
    #     )
    if ( $query->param( 'enable_select' ) &&
         $query->param( 'caller_name') eq $module )
    {
      $can_view = 0;
      $can_delete = 0;
    }
    else
    {
      $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                               'user' => $user );
      $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                                 'user' => $user );
    }

    #     "/",     
    if ( $query->param( 'exp_imp' ) )
    {
      $can_import = import_enabled() && 
                    have_access( 'module' => $module, 'procedure' => 'IMPORT',
                                 'user' => $user );
    }
    #    public --   ,
    #   -- 
    else
    {
      $can_export = export_enabled() && 
                    have_access( 'module' => $module, 'procedure' => 'EXPORT',
                                 'user' => $user );
    }

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th> </th>\n";
    print "<th>. . . </th>\n";
    print "<th> &mdash;   (  . . .)</th>\n";
    print "<th></th>\n";
    print "<th>&nbsp;</th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete || $can_export ||
                                   $can_import );
    print "</tr>\n";

    #          
    #     ...
    if ( $query->param( 'enable_select' ) )
    {
      # ...    JavaScript    
      #     Persons     ...
      if ( $query->param( 'caller_name' ) eq 'RESP_STAT' )
      {
        # ...  resp_pers_id  pers_name   RESP_STAT
        create_assign_values_func( 'resp_pers_id', 'pers_name' );
      }
      elsif ( $query->param( 'caller_name' ) eq 'PUB_PRINTER' )
      {
        # ...  pub_pers_id  pers_name   PUB_PRINTER
        create_assign_values_func( 'pub_pers_id', 'pers_name' );
      }
      elsif ( $query->param( 'caller_name' ) eq 'STOR_OBJS' )
      {
        # ...  owner_pers_id  pers_name   STOR_OBJS
        create_assign_values_func( 'owner_pers_id', 'pers_name' );
      }
      elsif ( $query->param( 'caller_name' ) eq 'PERSONS' )
      {
        # ...  pers_id_orig  pers_name_orig   PERSONS
        create_assign_values_func( 'pers_id_orig', 'pers_name_orig' );
      }
    }

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #   , . . .,   . . .  --  
      # , ,    . . . 
      # (  &nbsp;   ,   ,
      #   :    'pers_id_orig'  null,
      #     -)
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( 'pers_id' ) ]</td>\n";

      #         
      #     ,   
      # pers_name    

      #     "" 
      # (.    obj_groups_descrs.pl)
      #     , . . , 
      #   escapeHTML(), 
      my $pers_name = $row[ $result->fnumber( 'pers_name' ) ];
      $pers_name =~ s/\'/\\\'/g;
      $pers_name = CGI::escapeHTML( $pers_name );

      if ( $query->param( 'enable_select' ) )
      {
        print "<td>",
              qq{ <a class="command_link" href="javascript:void( 0 )" onclick=
                  "assign_values( $row[ $result->fnumber( 'pers_id' ) ],
                                  '$pers_name' )">
                   $row[ $result->fnumber( 'pers_name' ) ]</a> },
              "</td>\n";
      }
      else
      {
        print "<td>$row[ $result->fnumber( 'pers_name' ) ]</td>\n";
      }

      #  ,   , ,  
      #    "&nbsp;"
      print "<td>",
            ( $row[ $result->fnumber( 'pers_id_orig' ) ] ne undef ) ?
              "(" . $row[ $result->fnumber( 'pers_id_orig' ) ] . ") " .
              $row[ $result->fnumber( 'pers_name_orig' ) ] :
            "&nbsp;",
            "</td>\n";
      print "<td>$row[ $result->fnumber( 'lang_sname' ) ]</td>\n";

      #   HTML-
      $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
              "pers_id=" . $row[ $result->fnumber( 'pers_id' ) ] .
              $add_params;

      #  .   ,   
      #      
      print "<td>",
            qq{<a class="command_link" } .
            qq{href="$script_name/list_bib_recs?$href"} .
            qq{ target="_blank">. </a>},
            "</td>\n";

      #      
      print "<td>" if ( $can_view || $can_delete || $can_export ||
                        $can_import );
      print qq{ <a class="command_link" href="$script_name/view?$href"} .
            qq{ target="_self"></a> } . "\n" if $can_view;

      #     
      print qq{ <a class="command_link" href="$script_name/delete?$href"} .
            qq{ onclick="$confirm_delete" } .
            qq{ target="_self"></a> } if $can_delete;

      #   
      print qq{ <a class="command_link" href="$script_name/export?$href"} .
            qq{ onclick="$confirm_export"} .
            qq{ target="_blank"></A> } . "\n" if $can_export;

      #   
      print qq{ <a class="command_link" href="$script_name/import?$href"} .
            qq{ onclick="$confirm_import"} .
            qq{ target="_blank"></A> } . "\n" if $can_import;

      print "</td>" if ( $can_view || $can_delete || $can_export ||
                         $can_import );
      print "</tr>\n";
    }
    print "</table>\n";
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $pers_id;               #   
  my $command;               #      

  $pers_id = $query->param( 'pers_id' );

  #     
  #   ...  ,   
  $command = "SELECT p1.*, p2.pers_name AS pers_name_orig " .
             "FROM ${db_schema}persons p1 LEFT JOIN ${db_schema}persons p2 " .
                  "ON p1.pers_id_orig = p2.pers_id " .
             "WHERE p1.pers_id = '$pers_id'";

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => "_self",
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "         " .
                     " " . $pers_id,
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "persons",
                       key => "pers_id",
                       f_names => \@f_names,
                       f_special => undef,
                       func_special => undef,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  #      (    
  # ,     )
  my( $ref_values_langs, $ref_labels_langs ) =
    popup_langs_list( $db_schema );

  #      (    
  #     )
  my( $ref_values_procs, $ref_labels_procs ) =
    popup_process_types_list( $db_schema );

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #         ,
    #   1        
    $fields{ 'pers_id' } = get_next_key_value( 'persons', 'pers_id' );

    #   

    #  , , 
    # .        
    $fields{ 'pers_name' }       = $CFG{ PERSONS_PERS_NAME };

    #  
    $fields{ 'pers_life_years' } = $CFG{ PERSONS_PERS_LIFE_YEARS };

    #   (/, /, ...  , ...)
    $fields{ 'pers_add_info' }   = $CFG{ PERSONS_PERS_ADD_INFO };

    #  ,    (  ,
    #    )
    $fields{ 'pers_id_orig' }    = $CFG{ PERSONS_PERS_ID_ORIG };

    #  ,     . . . 
    # (1 -  )
    $fields{ 'lang_code' }       = $CFG{ PERSONS_LANG_CODE };

    #     
    # (1 - , ..   ,    
    # . )
    $fields{ 'process_code' }    = $CFG{ PERSONS_PROCESS_CODE };

    # 
    $fields{ 'pers_addr' }       = $CFG{ PERSONS_PERS_ADDR };

    #  
    $fields{ 'pers_email' }      = $CFG{ PERSONS_PERS_EMAIL };

    # 
    $fields{ 'comment' }         = $CFG{ PERSONS_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  #    "  " 
  #     get_next_key_value(),  
  #   ,     , .. 
  #     UPDATE   
  print $query->hidden( -name => 'pers_id',
                        -default => $fields{ 'pers_id' }
                      ), "\n";

  #       ,     
  #           ,
  #        ,   
  #  ,     
  # . .    cities.pl.
  print $query->hidden( -name => 'enable_select' ), "\n";
  print $query->hidden( -name => 'caller_name' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>", $fields{ 'pers_id' }, "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> , , <br />" .
            "(   )</th>\n";
  print "<td>";
  
  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].pers_name",
                   "PERSONS_PERS_NAME" ) if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'pers_name',
                           -default => $fields{ 'pers_name' },
                           -size => $CFG{ PERSONS_PERS_NAME_SIZE },
                           -maxlength => $CFG{ PERSONS_PERS_NAME_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].pers_life_years",
                   "PERSONS_PERS_LIFE_YEARS" ) if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'pers_life_years',
                           -default => $fields{ 'pers_life_years' },
                           -size => $CFG{ PERSONS_PERS_LIFE_YEARS_SIZE },
                           -maxlength =>
                             $CFG{ PERSONS_PERS_LIFE_YEARS_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> <br />" .
            "(/, /,  , ...)</th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].pers_add_info",
                   "PERSONS_PERS_ADD_INFO" ) if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'pers_add_info',
                          -default => $fields{ 'pers_add_info' },
                          -rows => $CFG{ PERSONS_PERS_ADD_INFO_ROWS },
                          -columns => $CFG{ PERSONS_PERS_ADD_INFO_COLS }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> &mdash;   (  . . .)</th>\n";

  #      JavaScript,  
  # - persons.pl
  create_selection_func( func_name => 'select_orig_person',
                         module_name => 'persons.pl',
                         caller_name => $module,
                         window_name => 'orig_persons',
                         exp_imp => $query->param( 'exp_imp' ) );

  #     (  )
  print "<td>",
        $query->textfield( -name => 'pers_id_orig',
                           -default => $fields{ 'pers_id_orig' },
                           -size => $CFG{ PERSONS_PERS_ID_ORIG_SIZE },
                           -maxlength => $CFG{ PERSONS_PERS_ID_ORIG_MAXLENGTH }
                         ),
        "&nbsp;&nbsp;",
        $query->textfield( -name => 'pers_name_orig',
                           -default => $fields{ 'pers_name_orig' },
                           -size => $CFG{ PERSONS_PERS_NAME_ORIG_SIZE },
                           -maxlength =>
                             $CFG{ PERSONS_PERS_NAME_ORIG_MAXLENGTH },
                           -readonly => 'readonly'
                         ),
        "&nbsp;&nbsp;",
        qq{ <a class="command_link" href="javascript:void( 0 )" onclick=} .
        qq{"select_orig_person()">} . "</a>",
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  
  #        labels  
  # ,    popup_langs_list()   ,
  #   -   
  print "<th></th>\n";
  print "<td>",
        $query->popup_menu( -name => 'lang_code',
                            -default => $fields{ 'lang_code' },
                            -values => $ref_values_langs,
                            -labels => { @{ $ref_labels_langs } }
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";

  #        labels  
  # ,    popup_process_types_list() 
  #  ,   -   
  print "<th>  </th>\n";
  print "<td>",
        $query->popup_menu( -name => 'process_code',
                            -default => $fields{ 'process_code' },
                            -values => $ref_values_procs,
                            -labels => { @{ $ref_labels_procs } }
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].pers_addr",
                   "PERSONS_PERS_ADDR" ) if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'pers_addr',
                          -default => $fields{ 'pers_addr' },
                          -rows => $CFG{ PERSONS_PERS_ADDR_ROWS },
                          -columns => $CFG{ PERSONS_PERS_ADDR_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].pers_email",
                   "PERSONS_PERS_EMAIL" ) if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'pers_email',
                          -default => $fields{ 'pers_email' },
                          -rows => $CFG{ PERSONS_PERS_EMAIL_ROWS },
                          -columns => $CFG{ PERSONS_PERS_EMAIL_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";

  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment",
                   "PERSONS_COMMENT" ) if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ PERSONS_COMMENT_ROWS },
                          -columns => $CFG{ PERSONS_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
  return ( 0 );
}
