#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :   " , , "
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'PUB_PRINT_DATE';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Pub_print_date
my @f_names =
   ( 'obj_id',           #   
                         #  
     'pub_date_begin',   #   
                         # .      
                         #             text, ..   
                         #             [1988], 198?, 197-, ...
     'dash_flag',        #   ,   
                         #     
     'pub_date_end',     #   
     'print_date',       #  , 
     'sine_anno_flag',   #  "  (sine anno)"
     'pub_print_date_sure_flag', #    
     'comment'           # 
   );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              print_add_info => \&print_add_info,
              action => $script_name
            );

exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  if ( $query->param( 'pub_date_begin' ) eq '' &&
       $query->param( 'pub_date_end' ) ne '' )
  {
    push( @error_messages, "   ,    " .
          " " );
  }

  #        CHECK,
  #    Pub_print_date
  if ( ! ( ( $query->param( 'sine_anno_flag' ) ne '' &&
             $query->param( 'pub_date_begin' ) eq '' &&
             $query->param( 'dash_flag' ) eq '' &&
             $query->param( 'pub_date_end' ) eq '' &&
             $query->param( 'print_date' ) eq ''
           ) ||
           ( $query->param( 'sine_anno_flag' ) eq '' &&
             ( $query->param( 'pub_date_begin' ) ne '' ||
               $query->param( 'pub_date_end' ) ne '' ||
               $query->param( 'print_date' ) ne ''
             )  
           )
         )
     )
  {
    push( @error_messages, "   " );
  }

  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }
  
  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => '  ()',
                    user => $user,
                    full_top => 'no'
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $obj_id;             #    . 
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id     = $query->param( 'obj_id' );
  $target_win = $query->param( 'target_win' );

  #         
  $command = "DELETE FROM ${db_schema}pub_print_date " .
             "WHERE obj_id = '$obj_id'";

  #   
  del_rec( query => $query,
           target => $target_win,
           create_top => \&create_top,
           print_add_info => \&print_add_info,
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#        
# .       (. 
#               Pub_print_date),    
#                .
# -----------------------------------------------------------------------------
sub do_query
{
  # .        
  #              bib_recs.pl.

  my $obj_id;             #    . 
  my $bib_rec;            # . 
  my $target_win;         #      HTML-
  my( $result, $i );      #    
  my @row;                #      
  my $command;            #      
  my $href;               #   HTML-

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #  ,        
  my $alt_row = 1;

  $obj_id     = $query->param( 'obj_id' );
  $bib_rec    = $query->param( 'bib_rec' );
  $target_win = $query->param( 'target_win' );

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => $target_win );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  print_add_info(); #     

  #  ,    
  $bib_rec = CGI::escape( $bib_rec );

  #   HTML- ( bib_rec_num  )
  $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
          "obj_id=$obj_id" .
          "&bib_rec=$bib_rec" .
          "&target_win=$target_win";

  #         
  # (       - . . Pub_print_date)
  $command = "SELECT * " .
             "FROM ${db_schema}pub_print_date " .
             "WHERE obj_id = $obj_id";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                             'user' => $user );
    $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                               'user' => $user );

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th>  </th>\n";
    print "<th>-</th>\n";
    print "<th>  </th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete );
    print "</tr>\n";

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #   
      # (  &nbsp;     :  
      #  'pub_date_begin'  'pub_date_end'  null,   
      #  -)
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( 'pub_date_begin' ) ]&nbsp;</td>\n";
      print "<td class=\"center\">",
            $row[ $result->fnumber( 'dash_flag' ) ] eq 't' ? "&mdash;" :
            "&nbsp;",
            "</td>\n";
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( 'pub_date_end' ) ]&nbsp;</td>\n";

      #         
      print "<td>" if ( $can_view || $can_delete );
      print qq{<a class="command_link" href="$script_name/view?$href"} .
            qq{ target="$target_win"></a>} if $can_view;
      print "\n" if $can_view;

      #       
      print qq{<a class="command_link" href="$script_name/delete?$href"} .
            qq{ onclick="$confirm_delete"} .
            qq{ target="$target_win"></a>} if $can_delete;
      print "</td>\n" if ( $can_view || $can_delete );

      print "</tr>\n";
    }
    print "</table>\n";
  }
  else     #    ,     (. PRIMARY KEY)
  {
    #        
    #          "/"
    if ( ! $query->param( 'exp_imp' ) &&
         have_access( 'module' => $module, 'procedure' => 'ADD', 
                      'user' => $user ) )
    {
      print "<br />\n";
      print qq{<a class="command_link" href="$script_name/add?$href"} .
            qq{ target="$target_win"> </a>};
    }
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $obj_id;             #    . 
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id     = $query->param( 'obj_id' );
  $target_win = $query->param( 'target_win' );

  #      
  $command = "SELECT * " .
             "FROM ${db_schema}pub_print_date " .
             "WHERE obj_id = $obj_id";

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => $target_win,
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "        : " .
                     "   .  - " .
                     $obj_id,
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "pub_print_date",
                       key => "obj_id",
                       f_names => \@f_names,
                       f_special => [ 'dash_flag', 'sine_anno_flag',
                                      'pub_print_date_sure_flag' ],
                       func_special => \&non_std_fields,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #       
    $fields{ 'obj_id' } = $query->param( 'obj_id' );

    #   

    #   
    $fields{ 'pub_date_begin' } = $CFG{ PUB_PRINT_DATE_PUB_DATE_BEGIN };

    #   ,   
    #     
    $fields{ 'dash_flag' }      = $CFG{ PUB_PRINT_DATE_DASH_FLAG };

    #   
    $fields{ 'pub_date_end' }   = $CFG{ PUB_PRINT_DATE_PUB_DATE_END };

    #  , 
    $fields{ 'print_date' }     = $CFG{ PUB_PRINT_DATE_PRINT_DATE };
    
    #  "  (sine anno)"
    $fields{ 'sine_anno_flag' } = $CFG{ PUB_PRINT_DATE_SINE_ANNO_FLAG };

    #    
    $fields{ 'pub_print_date_sure_flag' } =
           $CFG{ PUB_PRINT_DATE_PUB_PRINT_DATE_SURE_FLAG };

    # 
    $fields{ 'comment' } = $CFG{ PUB_PRINT_DATE_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  #    "  
  #  "   ,  
  #   ,     , .. 
  #     UPDATE   ,   
  #   INSERT (     ,
  #       ,   
  #   )
  print $query->hidden( -name => 'obj_id' ), "\n";

  #      .  
  #  ,     add_rec()  update_rec()
  print $query->hidden( -name => 'bib_rec' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print_add_info();           #     

  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].pub_date_begin",
                   "PUB_PRINT_DATE_PUB_DATE_BEGIN", "REPLACE" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'pub_date_begin',
                           -default => $fields{ 'pub_date_begin' },
                           -size => $CFG{ PUB_PRINT_DATE_PUB_DATE_BEGIN_SIZE },
                           -maxlength => 
                             $CFG{ PUB_PRINT_DATE_PUB_DATE_BEGIN_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  -<br />" .
        "(        )</th>\n";
  print "<td>",
        $query->checkbox( -name => 'dash_flag',
                          -checked => 
                             $fields{ 'dash_flag' } eq 't' ? '1' : '0',
                          -value => 'yes',
                          -label => ''
                        ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].pub_date_end",
                   "PUB_PRINT_DATE_PUB_DATE_END", "REPLACE" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'pub_date_end',
                           -default => $fields{ 'pub_date_end' },
                           -size => $CFG{ PUB_PRINT_DATE_PUB_DATE_END_SIZE },
                           -maxlength => 
                             $CFG{ PUB_PRINT_DATE_PUB_DATE_END_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> , </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].print_date",
                   "PUB_PRINT_DATE_PRINT_DATE", "REPLACE" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'print_date',
                           -default => $fields{ 'print_date' },
                           -size => $CFG{ PUB_PRINT_DATE_PRINT_DATE_SIZE },
                           -maxlength => 
                             $CFG{ PUB_PRINT_DATE_PRINT_DATE_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> \"  (sine anno)\"</th>\n";
  print "<td>",
        $query->checkbox( -name => 'sine_anno_flag',
                          -checked => 
                             $fields{ 'sine_anno_flag' } eq 't' ? '1' : '0',
                          -value => 'yes',
                          -label => ''
                        ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>   <br />" .
        "(   ,      " .
        " &mdash; [])</th>\n";
  print "<td>",
        $query->checkbox( -name => 'pub_print_date_sure_flag',
                          -checked => 
                             $fields{ 'pub_print_date_sure_flag' } eq 't' ?
                             '1' : '0',
                          -value => 'yes',
                          -label => ''
                        ),
        "</td>\n";
  print "</tr>\n";

  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment",
                   "PUB_PRINT_DATE_COMMENT" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ PUB_PRINT_DATE_COMMENT_ROWS },
                          -columns => $CFG{ PUB_PRINT_DATE_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
  return ( 0 );
}

# -----------------------------------------------------------------------------
#   ,    
#  -      
# -----------------------------------------------------------------------------
sub non_std_fields
{
  # :
  my $fname = shift;  #  
                      #   -   ( 
                      #  ).      
  my $value;

  #      - 'dash_flag',
  # 'sine_anno_flag', 'pub_print_date_sure_flag',   bool,
  #       
  $value = $query->param( $fname ) ? 'yes' : 'no';

  return ( $value );  
}

# -----------------------------------------------------------------------------
#          
# -----------------------------------------------------------------------------
sub print_add_info
{
  #  .    
  print_bib_record( $query, " , , " );
  
  return ( 0 );
}
