#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :   " , "
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'PUB_PRINT_PLACE';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Pub_print_place
my @f_names =
   ( 'obj_id',            #   
                          #  
     'bib_rec_num',       #  .    
                          # (    0)
     'group_num',         #      
     'place_num',         #      
     'city_country_flag', #  "/" (1 - ; 2 - )
     'city_code',         #   (  )
     'country_code',      #   ( ,   
                          #  )
     'pub_print_flag',    #  "/"
                          # (1 - ; 2 - )
     'sine_loco_flag',    #  "  (sine loco)"
     'place_sure_flag',   #     
     'place_add_info',    #     /
     'comment'            # 
   );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              print_add_info => \&print_add_info,
              action => $script_name
            );

exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  if ( $query->param( 'group_num' ) !~ /^\d+$/ )
  {
    push( @error_messages, "      " .
          "    " );
  }

  if ( $query->param( 'place_num' ) !~ /^\d+$/ )
  {
    push( @error_messages, "       " .
          "  " );
  }

  if ( ! ( $query->param( 'city_country_flag' ) eq '' ||
           $query->param( 'city_country_flag' ) eq '1' ||
           $query->param( 'city_country_flag' ) eq '2'
         )
     )    
  {
    push( @error_messages, "   \"/\"" );
  }

  if ( $query->param( 'city_code' ) !~ /^\d+$/ )
  {
    push( @error_messages, "      " .
          "(  )" );
  }

  if ( $query->param( 'country_code' ) !~ /^\d+$/ )
  {
    push( @error_messages, "      " .
          "( ,     )" );
  }

  if ( ! ( $query->param( 'pub_print_flag' ) eq '1' ||
           $query->param( 'pub_print_flag' ) eq '2'
         )
     )    
  {
    push( @error_messages, "   " .
          "\"/\"" );
  }

  # .      ,  
  #             CHECK  Pub_print_place.    ,
  #                 ,  .

  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }
  
  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => '  ()',
                    user => $user,
                    full_top => 'no'
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $group_num;          #      
  my $place_num;          #      
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id      = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );
  $group_num   = $query->param( 'group_num' );
  $place_num   = $query->param( 'place_num' );
  $target_win  = $query->param( 'target_win' );

  #         
  $command = "DELETE FROM ${db_schema}pub_print_place " .
             "WHERE obj_id = '$obj_id' AND " .
                   "bib_rec_num = '$bib_rec_num' AND " .
                   "group_num = '$group_num' AND " .
                   "place_num = '$place_num'";

  #   
  del_rec( query => $query,
           target => $target_win,
           create_top => \&create_top,
           print_add_info => \&print_add_info,
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#    ,   
# -----------------------------------------------------------------------------
sub do_query
{
  # .        
  #              bib_recs.pl.

  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $bib_rec;            # . 
  my $target_win;         #      HTML-
  my( $result, $i );      #    
  my @row;                #      
  my $command;            #      
  my $href;               #   HTML-
  my $place;              #  

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #  ,        
  my $alt_row = 1;

  $obj_id      = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );
  $bib_rec     = $query->param( 'bib_rec' );
  $target_win  = $query->param( 'target_win' );

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => $target_win );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  print_add_info(); #     

  #  ,    
  $bib_rec = CGI::escape( $bib_rec );

  #   HTML-
  $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
          "obj_id=$obj_id" .
          "&bib_rec_num=$bib_rec_num" .
          "&bib_rec=$bib_rec" .
          "&target_win=$target_win";

  #      ,    
  # (      ,   
  # :   -       Pub_print_place,
  #   -       Cities,   
  # Pub_print_place       )
  $command = "SELECT p.*, ct.city_sname, " .
                    "cntr1.country_sname as country_sname_pub, " .
                    "cntr2.country_sname as country_sname_city " .
             "FROM ${db_schema}pub_print_place p, ${db_schema}cities ct, " .
                  "${db_schema}countries cntr1, ${db_schema}countries cntr2 " .
             "WHERE p.obj_id = $obj_id AND " .
                   "p.bib_rec_num = $bib_rec_num AND " .
                   "p.city_code = ct.city_code AND " .
                   "ct.country_code = cntr2.country_code AND " .
                   "p.country_code = cntr1.country_code " .
             "ORDER BY p.group_num, p.place_num";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                             'user' => $user );
    $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                               'user' => $user );

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th>     </th>\n";
    print "<th>     </th>\n";
    print "<th>  ()</th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete );
    print "</tr>\n";

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #         , 
      #  
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( 'group_num' ) ]</td>\n";
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( 'place_num' ) ]</td>\n";

      #   
      if ( $row[ $result->fnumber( 'city_country_flag' ) ] eq '' )
      {
        $place = "-";
      }
      #  (   )
      elsif ( $row[ $result->fnumber( 'city_country_flag' ) ] == 1 )
      {
        #       
        $place = $row[ $result->fnumber( 'city_sname' ) ] . " (" .
                 $row[ $result->fnumber( 'country_sname_city' ) ] . ")";
      }
      # 
      else       # ( $row[ $result->fnumber( 'city_country_flag' ) ] == 2 )
      {
        $place = $row[ $result->fnumber( 'country_sname_pub' ) ];
      }
      
      #     
      if ( $row[ $result->fnumber( 'place_sure_flag' ) ] ne 't' )
      {
        $place = "[" . $place . "]";   #     
      }

      print "<td>$place</td>\n";
      
      #         
      print "<td>" if ( $can_view || $can_delete );
      print qq{<a class="command_link" href="$script_name/view?$href} .
            "&group_num=" . $row[ $result->fnumber( 'group_num' ) ] .
            "&place_num=" . $row[ $result->fnumber( 'place_num' ) ] . "\"" .
            qq{ target="$target_win"></a>} if $can_view;
      print "\n" if $can_view;

      #      
      print qq{<a class="command_link" href="$script_name/delete?$href} .
            "&group_num=" . $row[ $result->fnumber( 'group_num' ) ] .
            "&place_num=" . $row[ $result->fnumber( 'place_num' ) ] . "\"" .
            qq{ onclick="$confirm_delete"} .
            qq{ target="$target_win"></a>} if $can_delete;
      print "</td>\n" if ( $can_view || $can_delete );

      print "</tr>\n";
    }
    print "</table>\n";
  }

  #        
  #          "/"
  if ( ! $query->param( 'exp_imp' ) &&
       have_access( 'module' => $module, 'procedure' => 'ADD', 
                    'user' => $user ) )
  {
    print "<br />\n";
    print qq{<a class="command_link" href="$script_name/add?$href"} .
          qq{ target="$target_win"> </a>};
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $group_num;          #      
  my $place_num;          #      
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id      = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );
  $group_num   = $query->param( 'group_num' );
  $place_num   = $query->param( 'place_num' );
  $target_win  = $query->param( 'target_win' );

  #      
  # (      ,   
  # :   -       Pub_print_place,
  #   -       Cities,   
  # Pub_print_place       )
  $command = "SELECT p.*, ct.city_sname, " .
                    "cntr1.country_sname as country_sname_pub, " .
                    "cntr2.country_sname as country_sname_city " .
             "FROM ${db_schema}pub_print_place p, ${db_schema}cities ct, " .
                  "${db_schema}countries cntr1, ${db_schema}countries cntr2 " .
             "WHERE p.obj_id = $obj_id AND " .
                   "p.bib_rec_num = $bib_rec_num AND " .
                   "p.group_num = '$group_num' AND " .
                   "p.place_num = '$place_num' AND " .
                   "p.city_code = ct.city_code AND " .
                   "ct.country_code = cntr2.country_code AND " .
                   "p.country_code = cntr1.country_code";

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => $target_win,
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "        : " .
                     "   .  - " .
                     $obj_id . ", " .
                     " .     - " .
                     $bib_rec_num . ", " .
                     "      - $group_num, " .
                     "      - $place_num",
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "pub_print_place",
                       key => "obj_id, bib_rec_num, " .
                              "group_num:group_num_begin, " .
                              "place_num:place_num_begin",
                       f_names => \@f_names,
                       f_special => [ 'sine_loco_flag', 'place_sure_flag' ],
                       func_special => \&non_std_fields,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #        
    $fields{ 'obj_id' }      = $query->param( 'obj_id' );
    $fields{ 'bib_rec_num' } = $query->param( 'bib_rec_num' );

    #   

    #      
    $fields{ 'group_num' }         = $CFG{ PUB_PRINT_PLACE_GROUP_NUM };

    #      
    $fields{ 'place_num' }         = $CFG{ PUB_PRINT_PLACE_PLACE_NUM };

    #  "/"
    $fields{ 'city_country_flag' } = $CFG{ PUB_PRINT_PLACE_CITY_COUNTRY_FLAG };

    #   (  )
    $fields{ 'city_code' }         = $CFG{ PUB_PRINT_PLACE_CITY_CODE };

    #  
    $fields{ 'country_code' }      = $CFG{ PUB_PRINT_PLACE_COUNTRY_CODE };

    #  "/"
    $fields{ 'pub_print_flag' }    = $CFG{ PUB_PRINT_PLACE_PUB_PRINT_FLAG };

    #  "  (sine loco)"
    $fields{ 'sine_loco_flag' }    = $CFG{ PUB_PRINT_PLACE_SINE_LOCO_FLAG };

    #     
    $fields{ 'place_sure_flag' }   = $CFG{ PUB_PRINT_PLACE_PLACE_SURE_FLAG };

    #     / (, 
    #      )
    $fields{ 'place_add_info' }    = $CFG{ PUB_PRINT_PLACE_PLACE_ADD_INFO };

    # 
    $fields{ 'comment' }           = $CFG{ PUB_PRINT_PLACE_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript">
  <!--
  //          
  //      " '/'"
  function on_change_city_country_flag()
  {
    //   ""
    if ( document.forms[ 0 ].city_country_flag.selectedIndex == 1 )
    {
      document.forms[ 0 ].country_code.value = 0;     // 0 --  
      document.forms[ 0 ].country_sname_pub.value = '';      //  
      document.forms[ 0 ].country_code.disabled = true;      //  
      document.forms[ 0 ].country_sname_pub.disabled = true; //  
      document.forms[ 0 ].city_code.disabled = false;        //  
      document.forms[ 0 ].city_sname.disabled = false;       //  
      document.forms[ 0 ].country_sname_city.disabled = false; //  
      //  '  (sine loco)'
      document.forms[ 0 ].sine_loco_flag.checked = false;
      //  ,     
      document.forms[ 0 ].sine_loco_flag.disabled = true;
      //     
      document.forms[ 0 ].place_sure_flag.checked = true;
      document.forms[ 0 ].place_sure_flag.disabled = false;
    }
    //   ""
    else if ( document.forms[ 0 ].city_country_flag.selectedIndex == 2 )
    {
      document.forms[ 0 ].city_code.value = 0;        // 0 --  
      document.forms[ 0 ].city_sname.value = '';              //  
      document.forms[ 0 ].country_sname_city.value = '';      //  
      document.forms[ 0 ].city_code.disabled = true;          //  
      document.forms[ 0 ].city_sname.disabled = true;         //  
      document.forms[ 0 ].country_sname_city.disabled = true; //  
      document.forms[ 0 ].country_code.disabled = false;      //  
      document.forms[ 0 ].country_sname_pub.disabled = false; //  
      //  '  (sine loco)'
      document.forms[ 0 ].sine_loco_flag.checked = false;
      //  ,     
      document.forms[ 0 ].sine_loco_flag.disabled = true;
      //     
      document.forms[ 0 ].place_sure_flag.checked = true;
      document.forms[ 0 ].place_sure_flag.disabled = false;
    }
    else   //    
    {
      document.forms[ 0 ].city_code.value = 0;        // 0 --  
      document.forms[ 0 ].city_sname.value = '';              //  
      document.forms[ 0 ].country_sname_city.value = '';      //  
      document.forms[ 0 ].country_code.value = 0;     // 0 --  
      document.forms[ 0 ].country_sname_pub.value = '';       //  
      document.forms[ 0 ].city_code.disabled = true;          //  
      document.forms[ 0 ].city_sname.disabled = true;         //  
      document.forms[ 0 ].country_sname_city.disabled = true; //  
      document.forms[ 0 ].country_code.disabled = true;       //  
      document.forms[ 0 ].country_sname_pub.disabled = true;  //  
      //  '  (sine loco)'
      document.forms[ 0 ].sine_loco_flag.checked = true;
      //  ,     
      document.forms[ 0 ].sine_loco_flag.disabled = true;
      //     
      document.forms[ 0 ].place_sure_flag.checked = false;
      document.forms[ 0 ].place_sure_flag.disabled = true;
    }
  }
  //-->
  </script>
END_OF_SCRIPT
  ;

  #    "  
  #  "  " .   
  # "   ,     ,
  #     , ..    
  #  UPDATE   ,      INSERT
  # (     ,    
  #   ,      )
  print $query->hidden( -name => 'obj_id' ), "\n";
  print $query->hidden( -name => 'bib_rec_num' ), "\n";

  #     "     "
  #  "     "
  # .      'begin'  ,
  #                   ,  
  #               (.  make_cmd   E_ARCH.pm.
  #             ..       ,   
  #              (, ,   ).
  print $query->hidden( -name => 'group_num_begin',
                        -default => $fields{ 'group_num' }
                      ), "\n";
  print $query->hidden( -name => 'place_num_begin',
                        -default => $fields{ 'place_num' }
                      ), "\n";

  #      .  
  #  ,     add_rec()  update_rec()
  print $query->hidden( -name => 'bib_rec' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print_add_info();         #     
  
  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th>     </th>\n";
  print "<td>",
        $query->textfield( -name => 'group_num',
                           -default => $fields{ 'group_num' },
                           -size => $CFG{ PUB_PRINT_PLACE_GROUP_NUM_SIZE },
                           -maxlength => 
                             $CFG{ PUB_PRINT_PLACE_GROUP_NUM_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>     </th>\n";
  print "<td>",
        $query->textfield( -name => 'place_num',
                           -default => $fields{ 'place_num' },
                           -size => $CFG{ PUB_PRINT_PLACE_PLACE_NUM_SIZE },
                           -maxlength => 
                             $CFG{ PUB_PRINT_PLACE_PLACE_NUM_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> \"/\"</th>\n";
  print "<td>",
        $query->popup_menu( -name => 'city_country_flag',
                            -default => $fields{ 'city_country_flag' },
                            -values => [ '', '1', '2' ],
                            -labels => { '' => '-', '1' => '',
                                         '2' => '' },
                            -onChange => "on_change_city_country_flag()"
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> &mdash;   (, , )</th>\n";

  #      JavaScript,  
  # - cities.pl
  create_selection_func( func_name => 'select_city',
                         module_name => 'cities.pl',
                         caller_name => $module,
                         window_name => 'cities',
                         exp_imp => $query->param( 'exp_imp' ) );

  #       
  # (  )
  print "<td>";
  
  #   ()     
  #     (,   );
  #  JavaScript-  :   create_hot_help()
  #  HTML-,      VALUE,    
  # HTML-,      ,    
  #  NAME       " ";
  #     (  create_hot_help()  
  #        )
  create_hot_help( "document.forms[ 0 ].city_code",
                   "PUB_PRINT_PLACE_CITY_CODE", "REPLACE",
                   "var str; if (this.value) str = this.value;
                             else str = this.name;
                   document.forms[ 0 ].city_sname.value = str;
                   document.forms[ 0 ].country_sname_city.value = ''; " )
    if $CFG{ HOT_HELP_IS_ON };

  #     city_code, city_sname  country_sname_city
  my @city_code_params = ( '-name', 'city_code',
                           '-default', $fields{ 'city_code' },
                           '-size', $CFG{ PUB_PRINT_PLACE_CITY_CODE_SIZE },
                           '-maxlength', 
                             $CFG{ PUB_PRINT_PLACE_CITY_CODE_MAXLENGTH }
                         );
  my @city_sname_params = ( '-name', 'city_sname',
                            '-default', $fields{ 'city_sname' },
                            '-size', $CFG{ PUB_PRINT_PLACE_CITY_SNAME_SIZE },
                            '-maxlength', 
                              $CFG{ PUB_PRINT_PLACE_CITY_SNAME_MAXLENGTH },
                            '-readonly', 'readonly'
                          );
  my @country_sname_city_params = 
                          ( '-name', 'country_sname_city',
                            '-default', $fields{ 'country_sname_city' },
                            '-size', 
                              $CFG{ PUB_PRINT_PLACE_COUNTRY_SNAME_CITY_SIZE },
                            '-maxlength', 
                            #      
                            # -
                            $CFG{ 'PUB_PRINT_PLACE_' .
                                  'COUNTRY_SNAME_CITY_MAXLENGTH' },
                            '-readonly', 'readonly'
                          );
  #    -- "" (2),      
  if ( $fields{ 'city_country_flag' } == 2 )
  {
    push( @city_code_params, '-disabled', 'disabled' );
    push( @city_sname_params, '-disabled', 'disabled' );
    push( @country_sname_city_params, '-disabled', 'disabled' );
  }

  print $query->textfield( @city_code_params ), "&nbsp;&nbsp;",
        $query->textfield( @city_sname_params ), "&nbsp;&nbsp;",
        $query->textfield( @country_sname_city_params ), "&nbsp;&nbsp;",
        qq{ <a class="command_link" href="javascript:void( 0 )" 
            onclick=
            "if ( document.forms[ 0 ].city_code.disabled == false )
               select_city();
             else
               window.alert( ' .  ' );
            ">} . "</a>",
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> (, )<br />" .
        "(,     &mdash;  )</th>\n";

  #      JavaScript,  
  # - countries.pl
  create_selection_func( func_name => 'select_country',
                         module_name => 'countries.pl',
                         caller_name => $module,
                         window_name => 'countries',
                         exp_imp => $query->param( 'exp_imp' ) );
  #      (  )
  print "<td>";

  #   ()     
  #     (,   );
  #  JavaScript-  :   create_hot_help()
  #  HTML-,      VALUE,    
  # HTML-,      ,    
  #  NAME       " " 
  create_hot_help( "document.forms[ 0 ].country_code",
                   "PUB_PRINT_PLACE_COUNTRY_CODE", "REPLACE",
                   "var str; if (this.value) str = this.value;
                             else str = this.name;
                   document.forms[ 0 ].country_sname_pub.value = str; " )
    if $CFG{ HOT_HELP_IS_ON };

  #     country_code  country_sname_pub
  my @country_code_params = ( '-name', 'country_code',
                              '-default', $fields{ 'country_code' },
                              '-size', 
                                $CFG{ PUB_PRINT_PLACE_COUNTRY_CODE_SIZE },
                              '-maxlength', 
                                $CFG{ PUB_PRINT_PLACE_COUNTRY_CODE_MAXLENGTH }
                            );
  my @country_sname_pub_params = ( '-name', 'country_sname_pub',
                                   '-default', $fields{ 'country_sname_pub' },
                                   '-size',
                                   #    
                                   #  -
                                     $CFG{ 'PUB_PRINT_PLACE_' .
                                           'COUNTRY_SNAME_PUB_SIZE' },
                                   '-maxlength',
                                     $CFG{ 'PUB_PRINT_PLACE_' .
                                           'COUNTRY_SNAME_PUB_MAXLENGTH' },
                                   '-readonly', 'readonly'
                                 );
  #    -- "" (1),      
  if ( $fields{ 'city_country_flag' } == 1 )
  {
    push( @country_code_params, '-disabled', 'disabled' );
    push( @country_sname_pub_params, '-disabled', 'disabled' );
  }

  print $query->textfield( @country_code_params ), "&nbsp;&nbsp;",
        $query->textfield( @country_sname_pub_params ), "&nbsp;&nbsp;",
        qq{ <a class="command_link" href="javascript:void( 0 )" 
            onclick=
            "if ( document.forms[ 0 ].country_code.disabled == false )
               select_country();
             else
               window.alert( ' .  ' );
            ">} . "</a>",
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> \"/\"</th>\n";
  print "<td>",
        $query->popup_menu( -name => 'pub_print_flag',
                            -default => $fields{ 'pub_print_flag' },
                            -values => [ '1', '2' ],
                            -labels => { '1' => '',
                                         '2' => '' }
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> \"  (sine loco)\"</th>\n";
  print "<td>",
        $query->checkbox( -name => 'sine_loco_flag',
                          -checked => 
                             $fields{ 'sine_loco_flag' } eq 't' ? '1' : '0',
                          -value => 'yes',
                          -label => '',
  #          
  # JavaScript
                          -disabled => 'disabled'
                        ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>    <br />" .
        "(   ,      " .
        " &mdash; [])</th>\n";
  print "<td>",
        $query->checkbox( -name => 'place_sure_flag',
                          -checked => 
                             $fields{ 'place_sure_flag' } eq 't' ? '1' : '0',
                          -value => 'yes',
                          -label => ''
                        ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>    / <br />" .
            "(,       " .
            ")</th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].place_add_info",
                   "PUB_PRINT_PLACE_PLACE_ADD_INFO" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'place_add_info',
                          -default => $fields{ 'place_add_info' },
                          -rows => $CFG{ PUB_PRINT_PLACE_PLACE_ADD_INFO_ROWS },
                          -columns => 
                            $CFG{ PUB_PRINT_PLACE_PLACE_ADD_INFO_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";

  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment", "PUB_PRINT_PLACE_COMMENT" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ PUB_PRINT_PLACE_COMMENT_ROWS },
                          -columns => $CFG{ PUB_PRINT_PLACE_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
  return ( 0 );
}

# -----------------------------------------------------------------------------
#   ,    
#  -      
# -----------------------------------------------------------------------------
sub non_std_fields
{
  # :
  my $fname = shift;  #  
                      #   -   ( 
                      #  ).      
  my $value;

  #      - 'sine_loco_flag',
  # 'place_sure_flag',   bool,    
  #   
  $value = $query->param( $fname ) ? 'yes' : 'no';

  return ( $value );  
}

# -----------------------------------------------------------------------------
#          
# -----------------------------------------------------------------------------
sub print_add_info
{
  #  .    
  print_bib_record( $query, " , " );
  
  return ( 0 );
}
