#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :   ", , "
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'PUB_PRINTER';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Pub_printer
my @f_names =
   ( 'obj_id',              #   
                            #  
     'bib_rec_num',         #  .    
                            # (    0)
     'group_num',           #     
     'pub_num',             #  ,    
     'pers_org_flag',       #  "/"
                            # (1 - ; 2 - )
     'pub_org_id',          #  ,  ... ()
     'pub_pers_id',         #  ,  ... ()
     'pub_print_flag',      #  "/"
     'pub_func',            #   ()
     'sine_nomine_flag',    #  "  (sine nomine)"
     'pub_print_sure_flag', #    
     'pub_print_add_info',  #     /
                            # 
     'comment'              # 
   );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              print_add_info => \&print_add_info,
              action => $script_name
            );

exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  if ( $query->param( 'group_num' ) !~ /^\d+$/ )
  {
    push( @error_messages, "      " .
          "   " );
  }

  if ( $query->param( 'pub_num' ) !~ /^\d+$/ )
  {
    push( @error_messages, "     , " .
          "   " );
  }

  if ( ! ( $query->param( 'pers_org_flag' ) eq '' ||
           $query->param( 'pers_org_flag' ) eq '1' ||
           $query->param( 'pers_org_flag' ) eq '2'
         )
     )    
  {
    push( @error_messages, "   " .
          "\"/\"" );
  }

  if ( $query->param( 'pub_org_id' ) !~ /^\d+$/ )
  {
    push( @error_messages, "     , " .
          " ... ()" );
  }

  if ( $query->param( 'pub_pers_id' ) !~ /^\d+$/ )
  {
    push( @error_messages, "     , " .
          " ... ()" );
  }

  if ( ! ( $query->param( 'pub_print_flag' ) eq '1' ||
           $query->param( 'pub_print_flag' ) eq '2' ||
           $query->param( 'pub_print_flag' ) eq '3'
         )
     )    
  {
    push( @error_messages, "   " .
          "\"/\"" );
  }

  # .      ,  
  #             CHECK  Pub_printer.    ,
  #                 ,  .

  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }
  
  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => '  ()',
                    user => $user,
                    full_top => 'no'
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $group_num;          #     
  my $pub_num;            #  ,    
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id      = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );
  $group_num   = $query->param( 'group_num' );
  $pub_num     = $query->param( 'pub_num' );
  $target_win  = $query->param( 'target_win' );

  #         
  $command = "DELETE FROM ${db_schema}pub_printer " .
             "WHERE obj_id = '$obj_id' AND " .
                   "bib_rec_num = '$bib_rec_num' AND " .
                   "group_num = '$group_num' AND " .
                   "pub_num = '$pub_num'";

  #   
  del_rec( query => $query,
           target => $target_win,
           create_top => \&create_top,
           print_add_info => \&print_add_info,
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#    ,   
# -----------------------------------------------------------------------------
sub do_query
{
  # .        
  #              bib_recs.pl.

  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $bib_rec;            # . 
  my $target_win;         #      HTML-
  my( $result, $i );      #    
  my @row;                #      
  my $command;            #      
  my $href;               #   HTML-
  my $publisher;          # /

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #  ,        
  my $alt_row = 1;

  $obj_id      = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );
  $bib_rec     = $query->param( 'bib_rec' );
  $target_win  = $query->param( 'target_win' );

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => $target_win );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  print_add_info(); #     

  #  ,    
  $bib_rec = CGI::escape( $bib_rec );

  #   HTML-
  $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
          "obj_id=$obj_id" .
          "&bib_rec_num=$bib_rec_num" .
          "&bib_rec=$bib_rec" .
          "&target_win=$target_win";

  #     /   
  # (    -  
  # -)
  $command = "SELECT p.*, pers.pers_name, o.org_sname " .
             "FROM ${db_schema}pub_printer p, ${db_schema}persons pers, " .
                  "${db_schema}orgs o " .
             "WHERE p.obj_id = $obj_id AND " .
                   "p.bib_rec_num = $bib_rec_num AND " .
                   "p.pub_pers_id = pers.pers_id AND " .
                   "p.pub_org_id = o.org_id " .
             "ORDER BY p.group_num, p.pub_num";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                             'user' => $user );
    $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                               'user' => $user );

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th>    /</th>\n";
    print "<th> /   </th>\n";
    print "<th>/</th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete );
    print "</tr>\n";

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #        , 
      # 
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( 'group_num' ) ]</td>\n";
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( 'pub_num' ) ]</td>\n";

      #  /
      if ( $row[ $result->fnumber( 'pers_org_flag' ) ] eq '' )
      {
        $publisher = " ";
      }
      # 
      elsif ( $row[ $result->fnumber( 'pers_org_flag' ) ] == 2 )
      {
        #   
        $publisher = $row[ $result->fnumber( 'org_sname' ) ];
      }
      # 
      else       # ( $row[ $result->fnumber( 'pers_org_flag' ) ] == 1 )
      {
        $publisher = $row[ $result->fnumber( 'pers_name' ) ];
      }
      
      # /   
      if ( $row[ $result->fnumber( 'pub_print_sure_flag' ) ] ne 't' )
      {
        #  /  
        $publisher = "[" . $publisher . "]";
      }

      print "<td>$publisher</td>\n";

      #     /   
      print "<td>" if ( $can_view || $can_delete );
      print qq{<a class="command_link" href="$script_name/view?$href} .
            "&group_num=" . $row[ $result->fnumber( 'group_num' ) ] .
            "&pub_num=" . $row[ $result->fnumber( 'pub_num' ) ] . "\"" .
            qq{ target="$target_win"></a>} if $can_view;
      print "\n" if $can_view;

      #     /
      print qq{<a class="command_link" href="$script_name/delete?$href} .
            "&group_num=" . $row[ $result->fnumber( 'group_num' ) ] .
            "&pub_num=" . $row[ $result->fnumber( 'pub_num' ) ] . "\"" .
            qq{ onclick="$confirm_delete"} .
            qq{ target="$target_win"></a>} if $can_delete;
      print "</td>\n" if ( $can_view || $can_delete );

      print "</tr>\n";
    }
    print "</table>\n";
  }

  #       
  #          "/"
  if ( ! $query->param( 'exp_imp' ) &&
       have_access( 'module' => $module, 'procedure' => 'ADD', 
                    'user' => $user ) )
  {
    print "<br />\n";
    print qq{<a class="command_link" href="$script_name/add?$href"} .
          qq{ target="$target_win"> </a>};
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $group_num;          #     
  my $pub_num;            #  ,    
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id      = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );
  $group_num   = $query->param( 'group_num' );
  $pub_num     = $query->param( 'pub_num' );
  $target_win  = $query->param( 'target_win' );

  #     /
  # (    -  
  # -)
  $command = "SELECT p.*, pers.pers_name, o.org_sname " .
             "FROM ${db_schema}pub_printer p, ${db_schema}persons pers, " .
                  "${db_schema}orgs o " .
             "WHERE p.obj_id = $obj_id AND " .
                   "p.bib_rec_num = $bib_rec_num AND " .
                   "p.group_num = '$group_num' AND " .
                   "p.pub_num = '$pub_num' AND " .
                   "p.pub_pers_id = pers.pers_id AND " .
                   "p.pub_org_id = o.org_id";

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => $target_win,
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "        : " .
                     "   .  - " .
                     $obj_id . ", " .
                     " .     - " .
                     $bib_rec_num . ", " .
                     "     - $group_num, " .
                     "     - $pub_num",
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "pub_printer",
                       key => "obj_id, bib_rec_num, " .
                              "group_num:group_num_begin, " .
                              "pub_num:pub_num_begin",
                       f_names => \@f_names,
                       f_special => [ 'sine_nomine_flag',
                                      'pub_print_sure_flag' ],
                       func_special => \&non_std_fields,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #        
    $fields{ 'obj_id' }      = $query->param( 'obj_id' );
    $fields{ 'bib_rec_num' } = $query->param( 'bib_rec_num' );

    #   

    #     
    $fields{ 'group_num' }           = $CFG{ PUB_PRINTER_GROUP_NUM };

    #  ,    
    $fields{ 'pub_num' }             = $CFG{ PUB_PRINTER_PUB_NUM };

    #  "/"
    $fields{ 'pers_org_flag' }       = $CFG{ PUB_PRINTER_PERS_ORG_FLAG };

    #  ,  ()
    $fields{ 'pub_org_id' }          = $CFG{ PUB_PRINTER_PUB_ORG_ID };

    #  ,  ()
    $fields{ 'pub_pers_id' }         = $CFG{ PUB_PRINTER_PUB_PERS_ID };

    #  "/"
    $fields{ 'pub_print_flag' }      = $CFG{ PUB_PRINTER_PUB_PRINT_FLAG };

    #   ()
    $fields{ 'pub_func' }            = $CFG{ PUB_PRINTER_PUB_FUNC };

    #  "  (sine nomine)"
    $fields{ 'sine_nomine_flag' }    = $CFG{ PUB_PRINTER_SINE_NOMINE_FLAG };

    #    
    $fields{ 'pub_print_sure_flag' } = $CFG{ PUB_PRINTER_PUB_PRINT_SURE_FLAG };

    #     /
    $fields{ 'pub_print_add_info' }  = $CFG{ PUB_PRINTER_PUB_PRINT_ADD_INFO };

    # 
    $fields{ 'comment' }             = $CFG{ PUB_PRINTER_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript">
  <!--
  //          
  //      " '/'"
  function on_change_pers_org_flag()
  {
    //   ""
    if ( document.forms[ 0 ].pers_org_flag.selectedIndex == 1 )
    {
      document.forms[ 0 ].pub_org_id.value = 0;   // 0 --  
      document.forms[ 0 ].org_sname.value = '';         //  
      document.forms[ 0 ].pub_org_id.disabled = true;   //  
      document.forms[ 0 ].org_sname.disabled = true;    //  
      document.forms[ 0 ].pub_pers_id.disabled = false; //  
      document.forms[ 0 ].pers_name.disabled = false;   //  
      //  '  (sine nomine)'
      document.forms[ 0 ].sine_nomine_flag.checked = false;
      //  ,     
      document.forms[ 0 ].sine_nomine_flag.disabled = true;
      //    
      document.forms[ 0 ].pub_print_sure_flag.checked = true;
      document.forms[ 0 ].pub_print_sure_flag.disabled = false;
    }
    //   ""
    else if ( document.forms[ 0 ].pers_org_flag.selectedIndex == 2 )
    {
      document.forms[ 0 ].pub_pers_id.value = 0;   // 0 --  
      document.forms[ 0 ].pers_name.value = '';         //  
      document.forms[ 0 ].pub_pers_id.disabled = true;  //  
      document.forms[ 0 ].pers_name.disabled = true;    //  
      document.forms[ 0 ].pub_org_id.disabled = false;  //  
      document.forms[ 0 ].org_sname.disabled = false;   //  
      //  '  (sine nomine)'
      document.forms[ 0 ].sine_nomine_flag.checked = false;
      //  ,     
      document.forms[ 0 ].sine_nomine_flag.disabled = true;
      //    
      document.forms[ 0 ].pub_print_sure_flag.checked = true;
      document.forms[ 0 ].pub_print_sure_flag.disabled = false;
    }
    else   //   
    {
      document.forms[ 0 ].pub_pers_id.value = 0;  // 0 --  
      document.forms[ 0 ].pers_name.value = '';   //  
      document.forms[ 0 ].pub_org_id.value = 0;   // 0 --  
      document.forms[ 0 ].org_sname.value = '';   //  
      document.forms[ 0 ].pub_pers_id.disabled = true;  //  
      document.forms[ 0 ].pers_name.disabled = true;    //  
      document.forms[ 0 ].pub_org_id.disabled = true;   //  
      document.forms[ 0 ].org_sname.disabled = true;    //  
      //  '  (sine nomine)'
      document.forms[ 0 ].sine_nomine_flag.checked = true;
      //  ,     
      document.forms[ 0 ].sine_nomine_flag.disabled = true;
      //    
      document.forms[ 0 ].pub_print_sure_flag.checked = false;
      document.forms[ 0 ].pub_print_sure_flag.disabled = true;
    }
  }
  //-->
  </script>
END_OF_SCRIPT
  ;

  #    "  
  #  "  " .   
  # "   ,     ,
  #     , ..    
  #  UPDATE   ,      INSERT
  # (     ,    
  #   ,      )
  print $query->hidden( -name => 'obj_id' ), "\n";
  print $query->hidden( -name => 'bib_rec_num' ), "\n";

  #     "    "
  #  " ,    "
  # .      'begin'  ,
  #                   ,  
  #               (.  make_cmd   E_ARCH.pm.
  #             ..       ,   
  #              (, ,   ).
  print $query->hidden( -name => 'group_num_begin',
                        -default => $fields{ 'group_num' }
                      ), "\n";
  print $query->hidden( -name => 'pub_num_begin',
                        -default => $fields{ 'pub_num' }
                      ), "\n";

  #      .  
  #  ,     add_rec()  update_rec()
  print $query->hidden( -name => 'bib_rec' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print_add_info();          #     

  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th>    /</th>\n";
  print "<td>",
        $query->textfield( -name => 'group_num',
                           -default => $fields{ 'group_num' },
                           -size => $CFG{ PUB_PRINTER_GROUP_NUM_SIZE },
                           -maxlength => 
                             $CFG{ PUB_PRINTER_GROUP_NUM_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> /   </th>\n";
  print "<td>",
        $query->textfield( -name => 'pub_num',
                           -default => $fields{ 'pub_num' },
                           -size => $CFG{ PUB_PRINTER_PUB_NUM_SIZE },
                           -maxlength => $CFG{ PUB_PRINTER_PUB_NUM_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> \"/\"</th>\n";
  print "<td>",
        $query->popup_menu( -name => 'pers_org_flag',
                            -default => $fields{ 'pers_org_flag' },
                            -values => [ '', '1', '2' ],
                            -labels => { '' => '-', '1' => '',
                                         '2' => '' },
                            -onChange => "on_change_pers_org_flag()"
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> &mdash; / " .
        "(  )</th>\n";

  #      JavaScript,  
  # - orgs.pl
  create_selection_func( func_name => 'select_org',
                         module_name => 'orgs.pl',
                         caller_name => $module,
                         window_name => 'orgs',
                         exp_imp => $query->param( 'exp_imp' ) );

  #     
  # (  )
  print "<td>";

  #   ()     
  #     (,   );
  #  JavaScript-  :   create_hot_help()
  #  HTML-,      VALUE,    
  # HTML-,      ,    
  #  NAME       " "
  create_hot_help( "document.forms[ 0 ].pub_org_id",
                   "PUB_PRINTER_PUB_ORG_ID", "REPLACE",
                   "var str; if (this.value) str = this.value;
                             else str = this.name;
                   document.forms[ 0 ].org_sname.value = str; " )
    if $CFG{ HOT_HELP_IS_ON };

  #     pub_org_id  org_sname
  #    - ""    ,  
  #   0
  my @pub_org_id_params = ( '-name', 'pub_org_id',
                            '-default', $fields{ 'pers_org_flag' } == '2' ? 
                                        $fields{ 'pub_org_id' } :
                                        0,
                            '-size', $CFG{ PUB_PRINTER_PUB_ORG_ID_SIZE },
                            '-maxlength', 
                              $CFG{ PUB_PRINTER_PUB_ORG_ID_MAXLENGTH }
                          );
  my @org_sname_params = ( '-name', 'org_sname',
                           '-default', $fields{ 'org_sname' },
                           '-size', $CFG{ PUB_PRINTER_ORG_SNAME_SIZE },
                           '-maxlength', 
                             $CFG{ PUB_PRINTER_ORG_SNAME_MAXLENGTH },
                           '-readonly', 'readonly'
                         );
  #   -- "" (1)    ,  
  #    
  if ( $fields{ 'pers_org_flag' } == 1 || $fields{ 'pers_org_flag' } eq '' )
  {
    push( @pub_org_id_params, '-disabled', 'disabled' );
    push( @org_sname_params, '-disabled', 'disabled' );
  }

  print $query->textfield( @pub_org_id_params ), "&nbsp;&nbsp;",
        $query->textfield( @org_sname_params ), "&nbsp;&nbsp;",
        qq{ <a class="command_link" href="javascript:void( 0 )" 
            onclick=
            "if ( document.forms[ 0 ].pub_org_id.disabled == false )
               select_org();
             else
               window.alert( ' .  ' );
            ">} . "</a>",
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> &mdash; / (  . . .)</th>\n";

  #      JavaScript,  
  # - persons.pl
  create_selection_func( func_name => 'select_person',
                         module_name => 'persons.pl',
                         caller_name => $module,
                         window_name => 'persons',
                         exp_imp => $query->param( 'exp_imp' ) );

  #     (  )
  print "<td>";

  #   ()     
  #     (,   );
  #  JavaScript-  :   create_hot_help()
  #  HTML-,      VALUE,    
  # HTML-,      ,    
  #  NAME       " " 
  create_hot_help( "document.forms[ 0 ].pub_pers_id",
                   "PUB_PRINTER_PUB_PERS_ID", "REPLACE",
                   "var str; if (this.value) str = this.value;
                             else str = this.name;
                   document.forms[ 0 ].pers_name.value = str; " )
    if $CFG{ HOT_HELP_IS_ON };

  #     pub_pers_id  pers_name
  #    - ""    ,  
  #   0
  my @pub_pers_id_params = ( '-name', 'pub_pers_id',
                             '-default', $fields{ 'pers_org_flag' } == '1' ? 
                                         $fields{ 'pub_pers_id' } :
                                         0,
                             '-size', $CFG{ PUB_PRINTER_PUB_PERS_ID_SIZE },
                             '-maxlength', 
                               $CFG{ PUB_PRINTER_PUB_PERS_ID_MAXLENGTH }
                           );
  my @pers_name_params = ( '-name', 'pers_name',
                           '-default', $fields{ 'pers_name' },
                           '-size', $CFG{ PUB_PRINTER_PERS_NAME_SIZE },
                           '-maxlength', 
                             $CFG{ PUB_PRINTER_PERS_NAME_MAXLENGTH },
                           '-readonly', 'readonly'
                         );  
  #   -- "" (2)    ,  
  #    
  if ( $fields{ 'pers_org_flag' } == 2 || $fields{ 'pers_org_flag' } eq '' )
  {
    push( @pub_pers_id_params, '-disabled', 'disabled' );
    push( @pers_name_params, '-disabled', 'disabled' );
  }
  
  print $query->textfield( @pub_pers_id_params ), "&nbsp;&nbsp;",
        $query->textfield( @pers_name_params ), "&nbsp;&nbsp;",
        qq{ <a class="command_link" href="javascript:void( 0 )" 
            onclick=
            "if ( document.forms[ 0 ].pub_pers_id.disabled == false )
               select_person();
             else
               window.alert( ' .  ' );
            ">} . "</a>",
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> \"/\"</th>\n";
  print "<td>",
        $query->popup_menu( -name => 'pub_print_flag',
                            -default => $fields{ 'pub_print_flag' },
                            -values => [ '1', '2', '3' ],
                            -labels => { '1' => '',
                                         '2' => '',
                                         '3' => '' }
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> /</th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].pub_func", "PUB_PRINTER_PUB_FUNC" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'pub_func',
                           -default => $fields{ 'pub_func' },
                           -size => $CFG{ PUB_PRINTER_PUB_FUNC_SIZE },
                           -maxlength =>
                             $CFG{ PUB_PRINTER_PUB_FUNC_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> \"  (sine nomine)\"</th>\n";
  print "<td>",
        $query->checkbox( -name => 'sine_nomine_flag',
                          -checked => 
  #      " '/'"
  # TODO   ,     .  e_arch.cfg
  #       PUB_PRINTER_SINE_NOMINE_FLAG
                            $fields{ 'pers_org_flag' } eq '' ? '1' : '0',
                          -value => 'yes',
                          -label => '',
  #          
  # JavaScript
                          -disabled => 'disabled'
                        ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>   /<br />" .
        "( /   ,   " .
        " /   &mdash; [])" .
        "</th>\n";
  print "<td>";

  #     pub_print_sure_flag
  #      " '/'"
  my @pub_print_sure_flag_params =
     ( '-name', 'pub_print_sure_flag',
       '-checked', $fields{ 'pers_org_flag' } ne '' ?
                   ( $fields{ 'pub_print_sure_flag' } eq 't' ? '1' : '0' ) :
                   0,
       '-value', 'yes',
       '-label', ''
     );
  #     ,      
  if ( $fields{ 'pers_org_flag' } eq '' )
  {
    push( @pub_print_sure_flag_params, '-disabled', 'disabled' );
  }

  print $query->checkbox( @pub_print_sure_flag_params ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>    /<br />" .
            "(,       )" .
        "</th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].pub_print_add_info",
                   "PUB_PRINTER_PUB_PRINT_ADD_INFO" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'pub_print_add_info',
                          -default => $fields{ 'pub_print_add_info' },
                          -rows => $CFG{ PUB_PRINTER_PUB_PRINT_ADD_INFO_ROWS },
                          -columns => 
                            $CFG{ PUB_PRINTER_PUB_PRINT_ADD_INFO_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";

  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment", "PUB_PRINTER_COMMENT" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ PUB_PRINTER_COMMENT_ROWS },
                          -columns => $CFG{ PUB_PRINTER_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
  return ( 0 );
}

# -----------------------------------------------------------------------------
#   ,    
#  -      
# -----------------------------------------------------------------------------
sub non_std_fields
{
  # :
  my $fname = shift;  #  
                      #   -   ( 
                      #  ).      
  my $value;

  #      - 'sine_nomine_flag',
  # 'pub_print_sure_flag',   bool,    
  #   
  $value = $query->param( $fname ) ? 'yes' : 'no';

  return ( $value );  
}

# -----------------------------------------------------------------------------
#          
# -----------------------------------------------------------------------------
sub print_add_info
{
  #  .    
  print_bib_record( $query, ", , " );
  
  return ( 0 );
}
