#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :   "    
#            "
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'REFS_CONTENTS';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Refs_contents
my @f_names =
   ( 'obj_id',             #   
                           #  
     'bib_rec_num',        #  .    
                           # (    0)
     'ref_num',            #   ( )  
                           #      . 
     'ref_elem',           #   
                           # (,    )
     'ref_elem_descr',     #    
                           # (,  ,  
                           #  ,  
                           #   )
     'lang_code',          #  ,    
                           #   (1 -  )
     'process_code',       #     
                           #   (1 - ,
                           # ..   ,     
                           # . )
     'comment',            # 
   );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              do_find => \&do_find,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              print_add_info => \&print_add_info,
              action => $script_name
            );

exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  if ( $query->param( 'ref_elem' ) eq '' )
  {
    push( @error_messages, "    " );
  }

  # -      -   ,
  #     ,     
  #   !~ /^\d+$/
  # TODO.         .
  if ( $query->param( 'lang_code' ) eq '' )
  {
    push( @error_messages, "   " );
  }

  if ( $query->param( 'process_code' ) eq '' )
  {
    push( @error_messages, "       " .
          " " );
  }

  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }
  
  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => '  ()',
                    user => $user,
                    full_top => 'no'
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $ref_num;            #    
                          #     . 
  my $ref_elem;           #   
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id      = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );
  $ref_num     = $query->param( 'ref_num' );
  $ref_elem    = $query->param( 'ref_elem' );
  $target_win  = $query->param( 'target_win' );

  #         
  $command = "DELETE FROM ${db_schema}refs_contents " .
             "WHERE obj_id = '$obj_id' AND " .
                   "bib_rec_num = '$bib_rec_num' AND " .
                   "ref_num = '$ref_num' AND " .
                   "ref_elem = '$ref_elem'";

  #   
  del_rec( query => $query,
           target => $target_win,
           create_top => \&create_top,
           print_add_info => \&print_add_info,
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_find
{
  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();        #     
  create_top();      #    
  close_top();       #     

  print_add_info();  #     

  open_bottom();     #     
  
  print "<p class=\"info\">     </p>\n";

  close_bottom();    #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#     ()   
#   
# -----------------------------------------------------------------------------
sub do_query
{
  # .        
  #              refs_descrs.pl.

  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $ref_num;            #    
                          #     . 
  my $ref_descr;          #   
  my $bib_rec;            # . 
  my $target_win;         #      HTML-
  my( $result, $i );      #    
  my @row;                #      
  my $command;            #      
  my $href;               #   HTML-
  my $ref_elem_descr;     #    
                          # (   )
  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #  ,        
  my $alt_row = 1;

  $obj_id      = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );
  $ref_num     = $query->param( 'ref_num' );
  $ref_descr   = $query->param( 'ref_descr' );
  $bib_rec     = $query->param( 'bib_rec' );
  $target_win  = $query->param( 'target_win' );

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => $target_win );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  print_add_info(); #     

  #  ,    
  $bib_rec   = CGI::escape( $bib_rec );
  $ref_descr = CGI::escape( $ref_descr );

  #   HTML-
  $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
          "obj_id=$obj_id" .
          "&bib_rec_num=$bib_rec_num" .
          "&ref_num=$ref_num" .
          "&ref_descr=$ref_descr" .
          "&bib_rec=$bib_rec" .
          "&target_win=$target_win";

  #         
  #   
  # (    ,    )
  $command = "SELECT rc.*, l.lang_sname " .
             "FROM ${db_schema}refs_contents rc, ${db_schema}langs l " .
             "WHERE rc.obj_id = $obj_id AND " .
                   "rc.bib_rec_num = $bib_rec_num AND " .
                   "rc.ref_num = $ref_num AND " .
                   "rc.lang_code = l.lang_code " .
             "ORDER BY rc.ref_elem";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                             'user' => $user );
    $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                               'user' => $user );

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th></th>\n";
    print "<th> </th>\n";
    print "<th> </th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete );
    print "</tr>\n";

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #  ,   ( ,  
      #   . )  ,    
      print "<td>$row[ $result->fnumber( 'ref_elem' ) ]</td>\n";
      print "<td>";

      #     
      $ref_elem_descr = $row[ $result->fnumber( 'ref_elem_descr' ) ];

      #    .       
      #       ,   
      # 
      if ( ! $CFG{ REFS_CONTENTS_REF_ELEM_DESCR_DISPLAY_LEN } ||
           length( $ref_elem_descr ) <= 
             $CFG{ REFS_CONTENTS_REF_ELEM_DESCR_DISPLAY_LEN }
         )
      {
        print $ref_elem_descr;
      }
      elsif ( length( $ref_elem_descr ) >
              $CFG{ REFS_CONTENTS_REF_ELEM_DESCR_DISPLAY_LEN }
            )
      {
        print substr( $ref_elem_descr, 0, 
                      $CFG{ REFS_CONTENTS_REF_ELEM_DESCR_DISPLAY_LEN } );
        print "...";     #     
      }      
      print "</td>\n";
      print "<td>$row[ $result->fnumber( 'lang_sname' ) ]</td>\n";

      #          
      print "<td>" if ( $can_view || $can_delete );
      print qq{<a class="command_link" href="$script_name/view?$href} .
            "&ref_elem=" . 
              CGI::escape( $row[ $result->fnumber( 'ref_elem' ) ] ) . "\"" .
            qq{ target="$target_win"></a>} if $can_view;
      print "\n" if $can_view;

      #       
      print qq{<a class="command_link" href="$script_name/delete?$href} .
            "&ref_elem=" . 
              CGI::escape( $row[ $result->fnumber( 'ref_elem' ) ] ) . "\"" .
            qq{ onclick="$confirm_delete"} .
            qq{ target="$target_win"></a>} if $can_delete;
      print "</td>\n" if ( $can_view || $can_delete );

      print "</tr>\n";
    }
    print "</table>\n";
  }

  #         
  #          "/"
  if ( ! $query->param( 'exp_imp' ) &&
       have_access( 'module' => $module, 'procedure' => 'ADD', 
                    'user' => $user ) )
  {
    print "<br />\n";
    print qq{<a class="command_link" href="$script_name/add?$href"} .
          qq{ target="$target_win"> </a>};
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $ref_num;            #    
                          #     . 
  my $ref_elem;           #   
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id      = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );
  $ref_num     = $query->param( 'ref_num' );
  $ref_elem    = $query->param( 'ref_elem' );
  $target_win  = $query->param( 'target_win' );

  #          
  # (    ,    ,
  #      )
  $command = "SELECT rc.*, l.lang_sname, p.process_sname " .
             "FROM ${db_schema}refs_contents rc, ${db_schema}langs l, " .
                  "${db_schema}process_types p " .
             "WHERE rc.obj_id = $obj_id AND " .
                   "rc.bib_rec_num = $bib_rec_num AND " .
                   "rc.ref_num = $ref_num AND " .
                   "rc.ref_elem = '$ref_elem' AND " .
                   "rc.lang_code = l.lang_code AND " .
                   "rc.process_code = p.process_code";

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => $target_win,
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "        : " .
                     "   .  - " .
                     $obj_id . ", " .
                     " .     - " .
                     $bib_rec_num . ", " .
                     "    - $ref_num, " .
                     "   - $ref_elem",
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "refs_contents",
                       key => "obj_id, bib_rec_num, ref_num," .
                              "ref_elem:ref_elem_begin",
                       f_names => \@f_names,
                       f_special => undef,
                       func_special => undef,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  #      (    
  # ,      )
  my( $ref_values_langs, $ref_labels_langs ) = popup_langs_list( $db_schema );

  #      (    
  #      )
  my( $ref_values_procs, $ref_labels_procs ) =
    popup_process_types_list( $db_schema );

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #        
    $fields{ 'obj_id' }      = $query->param( 'obj_id' );
    $fields{ 'bib_rec_num' } = $query->param( 'bib_rec_num' );
    $fields{ 'ref_num' }     = $query->param( 'ref_num' );

    #   

    #   
    $fields{ 'ref_elem' }       = $CFG{ REFS_CONTENTS_REF_ELEM };

    #    
    $fields{ 'ref_elem_descr' } = $CFG{ REFS_CONTENTS_REF_ELEM_DESCR };

    #  
    $fields{ 'lang_code' }      = $CFG{ REFS_CONTENTS_LANG_CODE };

    #       
    $fields{ 'process_code' }   = $CFG{ REFS_CONTENTS_PROCESS_CODE };

    # 
    $fields{ 'comment' }        = $CFG{ REFS_CONTENTS_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  #    "  
  #  ", " .   
  # "  "   "   
  # ,     ,
  #     , ..    
  #  UPDATE   ,      INSERT
  # (     ,    
  #   ,      )
  print $query->hidden( -name => 'obj_id' ), "\n";
  print $query->hidden( -name => 'bib_rec_num' ), "\n";
  print $query->hidden( -name => 'ref_num' ), "\n";

  #     "  "
  # .      'begin'  ,
  #                   ,  
  #               (.  make_cmd   E_ARCH.pm).
  #             ..       ,   
  #              (, ,   ).
  print $query->hidden( -name => 'ref_elem_begin',
                        -default => $fields{ 'ref_elem' }
                      ), "\n";

  #      .   
  #     ,   
  #  add_rec()  update_rec()
  print $query->hidden( -name => 'bib_rec' ), "\n";
  print $query->hidden( -name => 'ref_descr' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print_add_info();           #     

  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].ref_elem",
                   "REFS_CONTENTS_REF_ELEM" ) if $CFG{ HOT_HELP_IS_ON };
  
  print $query->textarea( -name => 'ref_elem',
                          -default => $fields{ 'ref_elem' },
                          -rows => $CFG{ REFS_CONTENTS_REF_ELEM_ROWS },
                          -columns => $CFG{ REFS_CONTENTS_REF_ELEM_COLS }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>   </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].ref_elem_descr",
                   "REFS_CONTENTS_REF_ELEM_DESCR" ) if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'ref_elem_descr',
                          -default => $fields{ 'ref_elem_descr' },
                          -rows => $CFG{ REFS_CONTENTS_REF_ELEM_DESCR_ROWS },
                          -columns => 
                            $CFG{ REFS_CONTENTS_REF_ELEM_DESCR_COLS }
                         ),
        "</td>\n";
  print "</tr>\n";

  #        labels  
  # ,    popup_langs_list()   ,
  #   -   
  print "<tr>\n";
  print "<th>   </th>\n";
  print "<td>",
        $query->popup_menu( -name => 'lang_code',
                            -default => $fields{ 'lang_code' },
                            -values => $ref_values_langs,
                            -labels => { @{ $ref_labels_langs } }
                          ),
        "</td>\n";
  print "</tr>\n";

  #        labels  
  # ,    popup_process_types_list() 
  #  ,   -   
  print "<tr>\n";
  print "<th>     </th>\n";
  print "<td>",
        $query->popup_menu( -name => 'process_code',
                            -default => $fields{ 'process_code' },
                            -values => $ref_values_procs,
                            -labels => { @{ $ref_labels_procs } }
                          ),
        "</td>\n";
  print "</tr>\n";

  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";
  
  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment", "REFS_CONTENTS_COMMENT" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ REFS_CONTENTS_COMMENT_ROWS },
                          -columns => $CFG{ REFS_CONTENTS_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
  return ( 0 );
}

# -----------------------------------------------------------------------------
#          
# -----------------------------------------------------------------------------
sub print_add_info
{
  #  .    
  print_bib_record( $query, "    " .
                    " ", $module );
  return ( 0 );
}
