#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :   "     
#            "
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'REFS_DESCRS';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Refs_descrs
my @f_names =
   ( 'obj_id',             #   
                           #  
     'bib_rec_num',        #  .    
                           # (    0)
     'ref_num',            #   ( )  
                           #      . 
     'ref_type_code',      #    
     'ref_descr',          #  ()  ,
                           #    . 
                           # (   ,
                           #       )
     'ref_vol',            #      ,
                           #    
     'ref_original_flag',  #   
                           # (   ,
                           #    'no')
     'ref_complete_flag',  #    
                           #    
     'lang_code',          #  ,    
                           #   (1 -  )
     'process_code',       #     
                           #   (1 - ,
                           # ..   ,    
                           # .    
                           # )
     'comment',            # 
   );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              print_add_info => \&print_add_info,
              action => $script_name
            );

exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  #        
  # . 
  if ( $query->param( 'ref_num' ) !~ /^\d+$/ )
  {
    push( @error_messages, "      " .
          " " );
  }
  elsif ( $query->param( 'ref_num' ) <= 0 )
  {
    push( @error_messages, "    " .
          " " );
  }

  #    
  if ( $query->param( 'ref_type_code' ) !~ /^\d+$/ )
  {
    push( @error_messages, "       " .
          "" );
  }

  if ( $query->param( 'ref_descr' ) eq '' )
  {
    push( @error_messages, "   ()  " .
          "" );
  }

  # -      -   ,
  #     ,     
  #   !~ /^\d+$/
  # TODO.         .
  if ( $query->param( 'lang_code' ) eq '' )
  {
    push( @error_messages, "   " );
  }

  if ( $query->param( 'process_code' ) eq '' )
  {
    push( @error_messages, "       " .
          " " );
  }

  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }
  
  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => '  ()',
                    user => $user,
                    full_top => 'no'
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $ref_num;            #    
                          #     . 
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id      = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );
  $ref_num     = $query->param( 'ref_num' );
  $target_win  = $query->param( 'target_win' );

  #         
  $command = "DELETE FROM ${db_schema}refs_descrs " .
             "WHERE obj_id = '$obj_id' AND " .
                   "bib_rec_num = '$bib_rec_num' AND " .
                   "ref_num = '$ref_num'";

  #   
  del_rec( query => $query,
           target => $target_win,
           create_top => \&create_top,
           print_add_info => \&print_add_info,
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#        
# -----------------------------------------------------------------------------
sub do_query
{
  # .        
  #              bib_recs.pl.

  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $bib_rec;            # . 
  my $target_win;         #      HTML-
  my( $result, $i );      #    
  my @row;                #      
  my $command;            #      
  my $href;               #   HTML-

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #  ,        
  my $alt_row = 1;

  $obj_id      = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );
  $bib_rec     = $query->param( 'bib_rec' );
  $target_win  = $query->param( 'target_win' );

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => $target_win );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  print_add_info(); #     

  #  ,    
  $bib_rec = CGI::escape( $bib_rec );

  #   HTML-
  $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
          "obj_id=$obj_id" .
          "&bib_rec_num=$bib_rec_num" .
          "&bib_rec=$bib_rec" .
          "&target_win=$target_win";

  #          
  # (    ,    )
  #       
  $command = "SELECT rd.obj_id, rd.bib_rec_num, rd.ref_num, rd.ref_descr, " .
                    "rt.ref_type_sname, l.lang_sname, " .
                    "COUNT( rc.* ) AS num_elems " .
             "FROM ${db_schema}refs_descrs rd " .
                  "LEFT JOIN ${db_schema}refs_contents rc ON " .
                  "rd.obj_id = rc.obj_id AND " .
                  "rd.bib_rec_num = rc.bib_rec_num AND " .
                  "rd.ref_num = rc.ref_num, " .
                  "${db_schema}ref_types rt, ${db_schema}langs l " .
             "WHERE rd.obj_id = $obj_id AND " .
                   "rd.bib_rec_num = $bib_rec_num AND " .
                   "rd.ref_type_code = rt.ref_type_code AND " .
                   "rd.lang_code = l.lang_code " .
             "GROUP BY rd.obj_id, rd.bib_rec_num, rd.ref_num, rd.ref_descr, " .
                      "rt.ref_type_sname, l.lang_sname " .
             "ORDER BY rd.ref_num";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                             'user' => $user );
    $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                               'user' => $user );

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th> /</th>\n";
    print "<th> </th>\n";
    print "<th> </th>\n";
    print "<th> </th>\n";
    print "<th> </th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete );
    print "</tr>\n";

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #     ,  , ,
      #        ,  
      #   
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( 'ref_num' ) ]</td>\n";
      print "<td>$row[ $result->fnumber( 'ref_type_sname' ) ]</td>\n";
      print "<td>$row[ $result->fnumber( 'ref_descr' ) ]</td>\n";
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( 'num_elems' ) ]</td>\n";
      print "<td>$row[ $result->fnumber( 'lang_sname' ) ]</td>\n";

      #        ;
      #        
      print "<td>" if ( $can_view || $can_delete );
      print qq{<a class="command_link" } .
            qq{href="/$CFG\{ HOME_WEB_DIR \}/refs_contents.pl/query?$href} .
            "&ref_num=" . $row[ $result->fnumber( 'ref_num' ) ] .
            "&ref_descr=" .
            CGI::escape( $row[ $result->fnumber( 'ref_descr' ) ] ) . "\"" .
            qq{ target="_blank"></a>}, "\n",
            qq{<a class="command_link" href="$script_name/view?$href} .
            "&ref_num=" . $row[ $result->fnumber( 'ref_num' ) ] . "\"" .
            qq{ target="$target_win"></a>} if $can_view;
      print "\n" if $can_view;

      #      
      print qq{<a class="command_link" href="$script_name/delete?$href} .
            "&ref_num=" . $row[ $result->fnumber( 'ref_num' ) ] . "\"" .
            qq{ onclick="$confirm_delete"} .
            qq{ target="$target_win"></a>} if $can_delete;
      print "</td>\n" if ( $can_view || $can_delete );

      print "</tr>\n";
    }
    print "</table>\n";
  }

  #        
  #          "/"
  if ( ! $query->param( 'exp_imp' ) &&
       have_access( 'module' => $module, 'procedure' => 'ADD', 
                    'user' => $user ) )
  {
    print "<br />\n";
    print qq{<a class="command_link" href="$script_name/add?$href"} .
          qq{ target="$target_win"> </a>};
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $ref_num;            #    
                          #     . 
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id      = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );
  $ref_num     = $query->param( 'ref_num' );
  $target_win  = $query->param( 'target_win' );

  #          
  # (    ,    ,
  #      )
  $command = "SELECT rd.*, rt.ref_type_sname, l.lang_sname, p.process_sname " .
             "FROM ${db_schema}refs_descrs rd, ${db_schema}ref_types rt, " .
                  "${db_schema}langs l, ${db_schema}process_types p " .
             "WHERE rd.obj_id = $obj_id AND " .
                   "rd.bib_rec_num = $bib_rec_num AND " .
                   "rd.ref_num = $ref_num AND " .
                   "rd.ref_type_code = rt.ref_type_code AND " .
                   "rd.lang_code = l.lang_code AND " .
                   "rd.process_code = p.process_code";

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => $target_win,
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "        : " .
                     "   .  - " .
                     $obj_id . ", " .
                     " .     - " .
                     $bib_rec_num . ", " .
                     "    - $ref_num",
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "refs_descrs",
                       key => "obj_id, bib_rec_num, " .
                              "ref_num:ref_num_begin",
                       f_names => \@f_names,
                       f_special => [ 'ref_original_flag',
                                      'ref_complete_flag' ],
                       func_special => \&non_std_fields,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  #      (    
  #   )
  my( $ref_values_ref_types, $ref_labels_ref_types ) =
    popup_ref_types_list( $db_schema );

  #      (    
  # ,      )
  my( $ref_values_langs, $ref_labels_langs ) = popup_langs_list( $db_schema );

  #      (    
  #      )
  my( $ref_values_procs, $ref_labels_procs ) =
    popup_process_types_list( $db_schema );

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #        
    $fields{ 'obj_id' }      = $query->param( 'obj_id' );
    $fields{ 'bib_rec_num' } = $query->param( 'bib_rec_num' );

    #   

    #   
    if ( $CFG{ REFS_DESCRS_REF_NUM } )  #    . 
    {
      $fields{ 'ref_num' } = $CFG{ REFS_DESCRS_REF_NUM };
    }
    else
    {
      #      ref_num  
      # ,   1      
      #    .    . 
      # (   obj_id  bib_rec_num   Refs_descrs)
      $fields{ 'ref_num' } = 
        get_next_key_value( 'refs_descrs', 'ref_num',
                            'obj_id = ' . $query->param( 'obj_id' ) . ' AND ' .
                            'bib_rec_num = ' . $query->param( 'bib_rec_num' )
                          );
    }

    #    
    $fields{ 'ref_type_code' }     = $CFG{ REFS_DESCRS_REF_TYPE_CODE };

    #  ()  ,
    #    . 
    $fields{ 'ref_descr' }         = $CFG{ REFS_DESCRS_REF_DESCR };

    #      ,    
    $fields{ 'ref_vol' }           = $CFG{ REFS_DESCRS_REF_VOL };

    #   
    $fields{ 'ref_original_flag' } = $CFG{ REFS_DESCRS_REF_ORIGINAL_FLAG };

    #        
    $fields{ 'ref_complete_flag' } = $CFG{ REFS_DESCRS_REF_COMPLETE_FLAG };

    #  
    $fields{ 'lang_code' }         = $CFG{ REFS_DESCRS_LANG_CODE };

    #       
    $fields{ 'process_code' }      = $CFG{ REFS_DESCRS_PROCESS_CODE };

    # 
    $fields{ 'comment' }           = $CFG{ REFS_DESCRS_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  #    "  
  #  "  " .   
  # "   ,     ,
  #     , ..    
  #  UPDATE   ,      INSERT
  # (     ,    
  #   ,      )
  print $query->hidden( -name => 'obj_id' ), "\n";
  print $query->hidden( -name => 'bib_rec_num' ), "\n";

  #     "    ..."
  # .      'begin'  ,
  #                   ,  
  #               (.  make_cmd   E_ARCH.pm).
  #             ..       ,   
  #              (, ,   ).
  print $query->hidden( -name => 'ref_num_begin',
                        -default => $fields{ 'ref_num' }
                      ), "\n";

  #      .  
  #  ,     add_rec()  update_rec()
  print $query->hidden( -name => 'bib_rec' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print_add_info();            #     

  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th>   </th>\n";
  print "<td>",
        $query->textfield( -name => 'ref_num',
                           -default => $fields{ 'ref_num' },
                           -size => $CFG{ REFS_DESCRS_REF_NUM_SIZE },
                           -maxlength => $CFG{ REFS_DESCRS_REF_NUM_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  #        labels  
  # ,    popup_ref_types_list()   ,
  #   -   
  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>",
        $query->popup_menu( -name => 'ref_type_code',
                            -default => $fields{ 'ref_type_code' },
                            -values => $ref_values_ref_types,
                            -labels => { @{ $ref_labels_ref_types } }
                          ),
        "</td>\n";
  print "</tr>\n";


  print "<tr>\n";
  print "<th> ()  </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].ref_descr",
                   "REFS_DESCRS_REF_DESCR" ) if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'ref_descr',
                          -default => $fields{ 'ref_descr' },
                          -rows => $CFG{ REFS_DESCRS_REF_DESCR_ROWS },
                          -columns => $CFG{ REFS_DESCRS_REF_DESCR_COLS }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>     ,   " .
            " </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].ref_vol",
                   "REFS_DESCRS_REF_VOL" ) if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'ref_vol',
                           -default => $fields{ 'ref_vol' },
                           -size => $CFG{ REFS_DESCRS_REF_VOL_SIZE },
                           -maxlength => $CFG{ REFS_DESCRS_REF_VOL_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  <br />" .
            "(   ,    " .
            ")</th>\n";
  print "<td>",
        $query->checkbox( -name => 'ref_original_flag',
                          -checked => 
                             $fields{ 'ref_original_flag' } eq 't' ? '1' : '0',
                          -value => 'yes',
                          -label => ''
                        ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>    " .
            "   </th>\n";
  print "<td>",
        $query->checkbox( -name => 'ref_complete_flag',
                          -checked => 
                             $fields{ 'ref_complete_flag' } eq 't' ? '1' : '0',
                          -value => 'yes',
                          -label => ''
                        ),
        "</td>\n";
  print "</tr>\n";

  #        labels  
  # ,    popup_langs_list()   ,
  #   -   
  print "<tr>\n";
  print "<th>   </th>\n";
  print "<td>",
        $query->popup_menu( -name => 'lang_code',
                            -default => $fields{ 'lang_code' },
                            -values => $ref_values_langs,
                            -labels => { @{ $ref_labels_langs } }
                          ),
        "</td>\n";
  print "</tr>\n";

  #        labels  
  # ,    popup_process_types_list() 
  #  ,   -   
  print "<tr>\n";
  print "<th>     </th>\n";
  print "<td>",
        $query->popup_menu( -name => 'process_code',
                            -default => $fields{ 'process_code' },
                            -values => $ref_values_procs,
                            -labels => { @{ $ref_labels_procs } }
                          ),
        "</td>\n";
  print "</tr>\n";

  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";
  
  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment", "REFS_DESCRS_COMMENT" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ REFS_DESCRS_COMMENT_ROWS },
                          -columns => $CFG{ REFS_DESCRS_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
  return ( 0 );
}

# -----------------------------------------------------------------------------
#   ,    
#  -      
# -----------------------------------------------------------------------------
sub non_std_fields
{
  # :
  my $fname = shift;  #  
                      #   -   ( 
                      #  ).      
  my $value;
  
  #   
  if ( $fname eq 'ref_original_flag' )
  {
    #     bool,    
    #   
    $value = $query->param( $fname ) ? 'yes' : 'no';
  }
  #        
  elsif ( $fname eq 'ref_complete_flag' )
  {
    #     bool,    
    #   
    $value = $query->param( $fname ) ? 'yes' : 'no';
  }
  
  return ( $value );  
}

# -----------------------------------------------------------------------------
#          
# -----------------------------------------------------------------------------
sub print_add_info
{
  #  .    
  print_bib_record( $query, "    " .
                    " " );
  return ( 0 );
}
