#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :   "  "
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'RESP_STAT';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Resp_stat
my @f_names =
   ( 'obj_id',           #   
                         #  
     'bib_rec_num',      #  .    
                         # (    0)
     'resp_type',        #  
                         # (1 -   ;
                         #  2 - .  ., 
                         #        ;
                         #  3 - .  ., 
                         #       .    ;
                         #  4 - ...  ;
                         #  5 - ...  )
     'resp_num_in_type', #      
     'resp_num',         #     
                         # (    
                         #     
                         # )
     'role_code',        #  
     'pers_org_flag',    #  "/"
                         # (1 - ; 2 - )
     'resp_pers_id',     #    ()
     'resp_org_id',      #    ()
     'series_num',       #  /  
                         #  
     'series_id',        #   /
     'comment'           # 
   );

#    
my %resp_types = ( '1' => '.  .',
                   '2' => '.  .   ',
                   '3' => '.  .  . .   .',
                   '4' => '.  .  ',
                   '5' => '.  .  '
                 );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              print_add_info => \&print_add_info,
              action => $script_name
            );

exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  #   (   1  5)
  if ( $query->param( 'resp_type' ) !~ /^[12345]$/ )
  {
    push( @error_messages, "     " .
          " <br />   1  5" );
  }

  #       
  if ( $query->param( 'resp_num_in_type' ) !~ /^\d+$/ )
  {
    push( @error_messages, "       " .
          "   " );
  }

  if ( $query->param( 'resp_num' ) !~ /^\d+$/ )
  {
    push( @error_messages, "      " .
          "  " );
  }

  if ( $query->param( 'role_code' ) !~ /^\d+$/ )
  {
    push( @error_messages, "     " );
  }

  if ( $query->param( 'resp_pers_id' ) !~ /^\d+$/ )
  {
    push( @error_messages, "       " .
          "()" );
  }

  if ( $query->param( 'resp_org_id' ) !~ /^\d+$/ )
  {
    push( @error_messages, "       " .
          "()" );
  }

  if ( $query->param( 'series_num' ) ne '' && 
       $query->param( 'series_num' ) !~ /^\d+$/ )
  {
    push( @error_messages, "  /   " .
          " " );
  }

  if ( $query->param( 'series_id' ) ne '' && 
       $query->param( 'series_id' ) !~ /^\d+$/ )
  {
    push( @error_messages, "   " . 
          "/" );
  }

  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }

  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => '  ()',
                    user => $user,
                    full_top => 'no'
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $resp_type;          #  
  my $resp_num_in_type;   #      
  my $resp_num;           #     
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id           = $query->param( 'obj_id' );
  $bib_rec_num      = $query->param( 'bib_rec_num' );
  $resp_type        = $query->param( 'resp_type' );
  $resp_num_in_type = $query->param( 'resp_num_in_type' );
  $resp_num         = $query->param( 'resp_num' );
  $target_win       = $query->param( 'target_win' );

  #         
  $command = "DELETE FROM ${db_schema}resp_stat " .
             "WHERE obj_id = '$obj_id' AND " .
                   "bib_rec_num = '$bib_rec_num' AND " .
                   "resp_type = '$resp_type' AND " .
                   "resp_num_in_type = '$resp_num_in_type' AND " .
                   "resp_num = '$resp_num'";

  #   
  del_rec( query => $query,
           target => $target_win,
           create_top => \&create_top,
           print_add_info => \&print_add_info,
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#     (),    
# -----------------------------------------------------------------------------
sub do_query
{
  # .        
  #              bib_recs.pl.

  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $bib_rec;            # . 
  my $target_win;         #      HTML-
  my( $result, $i );      #    
  my @row;                #      
  my $command;            #      
  my $href;               #   HTML-

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #  ,        
  my $alt_row = 1;

  $obj_id      = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );
  $bib_rec     = $query->param( 'bib_rec' );
  $target_win  = $query->param( 'target_win' );

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => $target_win );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  print_add_info(); #     

  #  ,    
  $bib_rec = CGI::escape( $bib_rec );

  #   HTML-
  $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
          "obj_id=$obj_id" .
          "&bib_rec_num=$bib_rec_num" .
          "&bib_rec=$bib_rec" .
          "&target_win=$target_win";

  #        
  # (   .      )
  $command = "SELECT rs.*, p.pers_name, o.org_sname, r.role_sname " .
             "FROM ${db_schema}resp_stat rs, ${db_schema}persons p, " .
                  "${db_schema}orgs o, ${db_schema}roles r " .
             "WHERE rs.obj_id = $obj_id AND " .
                   "rs.bib_rec_num = $bib_rec_num AND " .
                   "rs.resp_org_id = o.org_id AND " .
                   "rs.resp_pers_id = p.pers_id AND " .
                   "rs.role_code = r.role_code " .
             "ORDER BY rs.resp_type, rs.resp_num_in_type, rs.resp_num";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                             'user' => $user );
    $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                               'user' => $user );

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th> </th>\n";
    print "<th>      /<br />" .
          "       </th>\n";
    print "<th></th>\n";
    print "<th></th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete );
    print "</tr>\n";

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #    ,   
      #    (   -    
      # ),   , . . .  
      #    
      print "<td>$resp_types{ $row[ $result->fnumber( 'resp_type' ) ] }</td>\n";
      print "<td class=\"center\">",
            $row[ $result->fnumber( 'resp_num_in_type' ) ] . "/" .
            $row[ $result->fnumber( 'resp_num' ) ],
            "</td>\n";
      print "<td>$row[ $result->fnumber( 'role_sname' ) ]</td>\n";

      #      
      # (     " "/"")
      if ( $row[ $result->fnumber( 'pers_org_flag' ) ] == 1 ) # 
      {
        print "<td>$row[ $result->fnumber( 'pers_name' ) ]</td>\n";
      }
      else         #  pers_org_flag == 2     -- 
      {
        print "<td>$row[ $result->fnumber( 'org_sname' ) ]</td>\n";
      }

      #        
      print "<td>" if ( $can_view || $can_delete );
      print qq{<a class="command_link" href="$script_name/view?$href} .
            "&resp_type=" . $row[ $result->fnumber( 'resp_type' ) ] .
            "&resp_num_in_type=" .
            $row[ $result->fnumber( 'resp_num_in_type' ) ] .
            "&resp_num=" . $row[ $result->fnumber( 'resp_num' ) ] . "\"" .
            qq{ target="$target_win"></a>} if $can_view;
      print "\n" if $can_view;

      #     
      print qq{<a class="command_link" href="$script_name/delete?$href} .
            "&resp_type=" . $row[ $result->fnumber( 'resp_type' ) ] .
            "&resp_num_in_type=" .
            $row[ $result->fnumber( 'resp_num_in_type' ) ] .
            "&resp_num=" . $row[ $result->fnumber( 'resp_num' ) ] . "\"" .
            qq{ onclick="$confirm_delete"} .
            qq{ target="$target_win"></a>} if $can_delete;
      print "</td>\n" if ( $can_view || $can_delete );

      print "</tr>\n";
    }
    print "</table>\n";
  }

  #         
  #          "/"
  if ( ! $query->param( 'exp_imp' ) &&
       have_access( 'module' => $module, 'procedure' => 'ADD', 
                    'user' => $user ) )
  {
    print "<br />\n";
    print qq{<a class="command_link" href="$script_name/add?$href"} .
          qq{ target="$target_win"> </a>};
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $resp_type;          #  
  my $resp_num_in_type;   #      
  my $resp_num;           #     
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id           = $query->param( 'obj_id' );
  $bib_rec_num      = $query->param( 'bib_rec_num' );
  $resp_type        = $query->param( 'resp_type' );
  $resp_num_in_type = $query->param( 'resp_num_in_type' );
  $resp_num         = $query->param( 'resp_num' );
  $target_win       = $query->param( 'target_win' );

  #     
  # (       )
  $command = "SELECT rs.*, p.pers_name, o.org_sname " .
             "FROM ${db_schema}resp_stat rs, ${db_schema}persons p, " .
                  "${db_schema}orgs o " .
             "WHERE rs.obj_id = $obj_id AND " .
                   "rs.bib_rec_num = $bib_rec_num AND " .
                   "rs.resp_type = '$resp_type' AND " .
                   "rs.resp_num_in_type = '$resp_num_in_type' AND " .
                   "rs.resp_num = '$resp_num' AND " .
                   "rs.resp_org_id = o.org_id AND " .
                   "rs.resp_pers_id = p.pers_id";

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => $target_win,
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "        : " .
                     "   .  - " .
                     $obj_id . ", " .
                     " .     - " .
                     $bib_rec_num . ", " .
                     "  - $resp_type, " .
                     "      - " .
                     $resp_num_in_type . ", " .
                     "     - $resp_num",
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "resp_stat",
                       key => "obj_id, bib_rec_num, " .
                              "resp_type:resp_type_begin, " .
                              "resp_num_in_type:resp_num_in_type_begin, " .
                              "resp_num:resp_num_begin",
                       f_names => \@f_names,
                       f_special => undef,
                       func_special => undef,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  #      (    
  # )
  my( $ref_values, $ref_labels ) = popup_roles_list( $db_schema );

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #        
    $fields{ 'obj_id' }      = $query->param( 'obj_id' );
    $fields{ 'bib_rec_num' } = $query->param( 'bib_rec_num' );

    #   

    #  
    $fields{ 'resp_type' }        = $CFG{ RESP_STAT_RESP_TYPE };

    #      
    $fields{ 'resp_num_in_type' } = $CFG{ RESP_STAT_RESP_NUM_IN_TYPE };

    #     
    $fields{ 'resp_num' }         = $CFG{ RESP_STAT_RESP_NUM };

    #  
    $fields{ 'role_code' }        = $CFG{ RESP_STAT_ROLE_CODE };

    #  "/"
    $fields{ 'pers_org_flag' }    = $CFG{ RESP_STAT_PERS_ORG_FLAG };

    #    ()
    $fields{ 'resp_pers_id' }     = $CFG{ RESP_STAT_RESP_PERS_ID };

    #    ()
    $fields{ 'resp_org_id' }      = $CFG{ RESP_STAT_RESP_ORG_ID };

    #  /    
    $fields{ 'series_num' }       = $CFG{ RESP_STAT_SERIES_NUM };

    #   /
    $fields{ 'series_id' }        = $CFG{ RESP_STAT_SERIES_ID };

    # 
    $fields{ 'comment' }          = $CFG{ RESP_STAT_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript">
  <!--
  //          
  //      " '/'"
  function on_change_pers_org_flag()
  {
    //   ""
    if ( document.forms[ 0 ].pers_org_flag.selectedIndex == 0 )
    {
      document.forms[ 0 ].resp_org_id.value = 0; // 0 --  
      document.forms[ 0 ].org_sname.value = '';  //  
      document.forms[ 0 ].resp_org_id.disabled = true;   //  
      document.forms[ 0 ].org_sname.disabled = true;     //  
      document.forms[ 0 ].resp_pers_id.disabled = false; //  
      document.forms[ 0 ].pers_name.disabled = false;    //  
    }
    else       //   ""
    {
      document.forms[ 0 ].resp_pers_id.value = 0; // 0 --  
      document.forms[ 0 ].pers_name.value = '';   //  
      document.forms[ 0 ].resp_pers_id.disabled = true;  //  
      document.forms[ 0 ].pers_name.disabled = true;     //  
      document.forms[ 0 ].resp_org_id.disabled = false;  //  
      document.forms[ 0 ].org_sname.disabled = false;    //  
    }
  }
  //-->
  </script>
END_OF_SCRIPT
  ;

  #    "  
  #  "  " .   
  # "   ,     ,
  #     , ..    
  #  UPDATE   ,      INSERT
  # (     ,    
  #   ,      )
  print $query->hidden( -name => 'obj_id' ), "\n";
  print $query->hidden( -name => 'bib_rec_num' ), "\n";

  #     " ", "  
  #   "  "    "
  # .      'begin'  ,
  #                   ,  
  #               (.  make_cmd   E_ARCH.pm.
  #             ..       ,   
  #              (, ,   ).
  print $query->hidden( -name => 'resp_type_begin',
                        -default => $fields{ 'resp_type' }
                      ), "\n";
  print $query->hidden( -name => 'resp_num_in_type_begin',
                        -default => $fields{ 'resp_num_in_type' }
                      ), "\n";
  print $query->hidden( -name => 'resp_num_begin',
                        -default => $fields{ 'resp_num' }
                      ), "\n";

  #      .  
  #  ,     add_rec()  update_rec()
  print $query->hidden( -name => 'bib_rec' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print_add_info(); #     

  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>",
        $query->popup_menu( -name => 'resp_type',
                            -default => $fields{ 'resp_type' },
                            -values => [ sort keys %resp_types ],
                            -labels => \%resp_types
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>     </th>\n";
  print "<td>",
        $query->textfield( -name => 'resp_num_in_type',
                           -default => $fields{ 'resp_num_in_type' },
                           -size => $CFG{ RESP_STAT_RESP_NUM_IN_TYPE_SIZE },
                           -maxlength => 
                             $CFG{ RESP_STAT_RESP_NUM_IN_TYPE_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>       </th>\n";
  print "<td>",
        $query->textfield( -name => 'resp_num',
                           -default => $fields{ 'resp_num' },
                           -size => $CFG{ RESP_STAT_RESP_NUM_SIZE },
                           -maxlength => $CFG{ RESP_STAT_RESP_NUM_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  #        labels  
  # ,    popup_roles_list() 
  #  ,   -   
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>",
        $query->popup_menu( -name => 'role_code',
                            -default => $fields{ 'role_code' },
                            -values => $ref_values,
                            -labels => { @{ $ref_labels } }
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> \"/\"</th>\n";
  print "<td>",
        $query->popup_menu( -name => 'pers_org_flag',
                            -default => $fields{ 'pers_org_flag' },
                            -values => [ 1, 2 ],
                            -labels => { 1 => '',
                                         2 => '' },
                            -onChange => "on_change_pers_org_flag()"
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  () (  . . .)</th>\n";

  #      JavaScript,  
  # - persons.pl
  create_selection_func( func_name => 'select_person',
                         module_name => 'persons.pl',
                         caller_name => $module,
                         window_name => 'persons',
                         exp_imp => $query->param( 'exp_imp' ) );
  print "<td>";
  
  #   ()     
  #     (,   );
  #  JavaScript-  :   create_hot_help()
  #  HTML-,      VALUE,    
  # HTML-,      ,    
  #  NAME       " "
  create_hot_help( "document.forms[ 0 ].resp_pers_id",
                   "RESP_STAT_RESP_PERS_ID", "REPLACE",
                   "var str; if (this.value) str = this.value;
                             else str = this.name;
                   document.forms[ 0 ].pers_name.value = str; " )
    if $CFG{ HOT_HELP_IS_ON };

  #     resp_pers_id  pers_name
  my @resp_pers_id_params = ( '-name', 'resp_pers_id', 
                              '-default', $fields{ 'resp_pers_id' },
                              '-size', $CFG{ RESP_STAT_RESP_PERS_ID_SIZE },
                              '-maxlength', 
                                $CFG{ RESP_STAT_RESP_PERS_ID_MAXLENGTH }
                            );
  my @pers_name_params = ( '-name', 'pers_name',
                           '-default', $fields{ 'pers_name' },
                           '-size', $CFG{ RESP_STAT_PERS_NAME_SIZE },
                           '-maxlength', $CFG{ RESP_STAT_PERS_NAME_MAXLENGTH },
                           '-readonly', 'readonly'
                         );  
  #    -- "" (2),      
  if ( $fields{ 'pers_org_flag' } == 2 )
  {
    push( @resp_pers_id_params, '-disabled', 'disabled' );
    push( @pers_name_params, '-disabled', 'disabled' );
  }
  
  print $query->textfield( @resp_pers_id_params ), "&nbsp;&nbsp;",
  #     (  )
        $query->textfield( @pers_name_params ), "&nbsp;&nbsp;",
        qq{ <a class="command_link" href="javascript:void( 0 )" 
            onclick=
            "if ( document.forms[ 0 ].resp_pers_id.disabled == false )
               select_person();
             else
               window.alert( ' .  ' );               
            ">} . "</a>",
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  (  )</th>\n";

  #      JavaScript,  
  # - orgs.pl
  create_selection_func( func_name => 'select_org',
                         module_name => 'orgs.pl',
                         caller_name => $module,
                         window_name => 'orgs',
                         exp_imp => $query->param( 'exp_imp' ) );
  print "<td>";
  
  #   ()     
  #     (,   )
  #    JavaScript- . 
  create_hot_help( "document.forms[ 0 ].resp_org_id",
                   "RESP_STAT_RESP_ORG_ID", "REPLACE",
                   "var str; if (this.value) str = this.value;
                             else str = this.name;
                   document.forms[ 0 ].org_sname.value = str; " )
    if $CFG{ HOT_HELP_IS_ON };

  #     resp_org_id  org_sname
  my @resp_org_id_params = ( '-name', 'resp_org_id',
                             '-default', $fields{ 'resp_org_id' },
                             '-size', $CFG{ RESP_STAT_RESP_ORG_ID_SIZE },
                             '-maxlength', 
                               $CFG{ RESP_STAT_RESP_ORG_ID_MAXLENGTH }
                           );
  my @org_sname_params = ( '-name', 'org_sname',
                           '-default', $fields{ 'org_sname' },
                           '-size', $CFG{ RESP_STAT_ORG_SNAME_SIZE },
                           '-maxlength', 
                             $CFG{ RESP_STAT_ORG_SNAME_MAXLENGTH },
                           '-readonly', 'readonly'
                         );
  #    -- "" (1),      
  if ( $fields{ 'pers_org_flag' } == 1 )
  {
    push( @resp_org_id_params, '-disabled', 'disabled' );
    push( @org_sname_params, '-disabled', 'disabled' );
  }

  print $query->textfield( @resp_org_id_params ), "&nbsp;&nbsp;",
  #     (  )
        $query->textfield( @org_sname_params ), "&nbsp;&nbsp;",
        qq{ <a class="command_link" href="javascript:void( 0 )" 
            onclick=
            "if ( document.forms[ 0 ].resp_org_id.disabled == false )
               select_org();
             else
               window.alert( ' .  ' );               
            ">} . "</a>",
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> /    </th>\n";
  print "<td>",
        $query->textfield( -name => 'series_num',
                           -default => $fields{ 'series_num' },
                           -size => $CFG{ RESP_STAT_SERIES_NUM_SIZE },
                           -maxlength => 
                             $CFG{ RESP_STAT_SERIES_NUM_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  /</th>\n";
  print "<td>",
        $query->textfield( -name => 'series_id',
                           -default => $fields{ 'series_id' },
                           -size => $CFG{ RESP_STAT_SERIES_ID_SIZE },
                           -maxlength => 
                             $CFG{ RESP_STAT_SERIES_ID_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";
  
  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment", "RESP_STAT_COMMENT" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ RESP_STAT_COMMENT_ROWS },
                          -columns => $CFG{ RESP_STAT_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
  return ( 0 );
}

# -----------------------------------------------------------------------------
#          
# -----------------------------------------------------------------------------
sub print_add_info
{
  #  .    
  print_bib_record( $query, "  " );
  
  return ( 0 );
}
