#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :    ""
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'ROLES';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Roles
my @f_names =
   ( 
     'role_code',       #  
     'role_fname',      #   
     'role_sname',      #    
     'role_code_orig',  #  ,   
                        # (  ,   
                        # )
     'lang_code',       #  ,     
                        # (1 -  )
     'process_code',    #     
                        # (1 - , ..   ,  
                        #   . )
     'comment'          # 
   );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              do_find => \&do_find,
              do_export => \&do_export,
              do_import => \&do_import,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              action => $script_name
            );

exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  if ( $query->param( 'role_code' ) eq '' )
  {
    push( @error_messages, "   " );
  }

  if ( $query->param( 'role_fname' ) eq '' )
  {
    push( @error_messages, "    " );
  }

  if ( $query->param( 'role_sname' ) eq '' )
  {
    push( @error_messages, "    " );
  }

  #    ,   
  if ( $query->param( 'role_code_orig' ) !~ /^\d*$/ )
  {
    push( @error_messages, "  ,   " );
  }

  if ( $query->param( 'lang_code' ) eq '' )
  {
    push( @error_messages, "   " );
  }

  if ( $query->param( 'process_code' ) eq '' )
  {
    push( @error_messages, "      " );
  }

  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }
  
  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => '',
                    user => $user
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $role_code;             #  
  my $command;               #      

  $role_code = $query->param( 'role_code' );
  
  #         
  $command = "DELETE FROM ${db_schema}roles " .
             "WHERE role_code = '$role_code'";

  #   
  del_rec( query => $query,
           create_top => \&create_top,
           target => "_self",
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_export
{
  my $role_code;             #  
  my $command;               #      
  my @table_cmd_pairs = ();  #     ,
                             #       

  $role_code = $query->param( 'role_code' );

  #  -       
  #    (      , 
  #     )
  $command = "SELECT * FROM Roles WHERE role_code = $role_code";
  push( @table_cmd_pairs, [ 'Roles', $command ] );

  #    
  export_data( query => $query,
               create_top => \&create_top,
               table_cmd_pairs => \@table_cmd_pairs
             );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_find
{
  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();       #     
  create_top();     #    
  close_top();      #     
  
  open_bottom();    #     
  
  print "<p class=\"info\">     </p>\n";

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_import
{
  my $role_code;             #  
  my $command;               #      
  my @table_cmd_pairs = ();  #     ,
                             #       

  $role_code = $query->param( 'role_code' );

  #  -       
  #    (      , 
  #     )
  $command = "SELECT * FROM exp_imp.Roles WHERE role_code = $role_code";
  push( @table_cmd_pairs, [ 'Roles', $command ] );

  #    
  import_data( query => $query,
               create_top => \&create_top,
               table_cmd_pairs => \@table_cmd_pairs
             );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub do_query
{
  my( $result, $i );              #    
  my @row;                        #      
  my $command;                    #      

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #      / 
  my $can_export = 0;
  my $can_import = 0;

  #        
  #   ( --      
  #   )
  my $add_params = '';

  #  ,        
  my $alt_row = 1;

  my $href;    #   HTML-

  #         
  #  enable_select  caller_name (  )
  if ( $query->param( 'enable_select' ) )
  {
    $add_params = "&enable_select=1&caller_name=" .
                  $query->param( 'caller_name' );
  }

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  #      (    , 
  #  ,   ,    
  # ,        )
  $command = "SELECT r1.*, r2.role_sname AS role_sname_orig, " .
                    "l.lang_sname, p.process_sname " .
             "FROM ( ${db_schema}roles r1 LEFT JOIN ${db_schema}roles r2 " .
                  "ON r1.role_code_orig = r2.role_code ), " .
                  "${db_schema}langs l, ${db_schema}process_types p " .
             "WHERE r1.lang_code = l.lang_code and " .
                   "r1.process_code = p.process_code " .
             "ORDER BY r1.role_sname";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    #       ,     
    # "  ",       
    # (      ,
    #     )
    if ( $query->param( 'enable_select' ) &&
         $query->param( 'caller_name') eq $module )
    {
      $can_view = 0;
      $can_delete = 0;
    }
    else
    {
      $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                               'user' => $user );
      $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                                 'user' => $user );
    }

    #     "/",     
    if ( $query->param( 'exp_imp' ) )
    {
      $can_import = import_enabled() && 
                    have_access( 'module' => $module, 'procedure' => 'IMPORT',
                                 'user' => $user );
    }
    #    public --   ,
    #   -- 
    else
    {
      $can_export = export_enabled() && 
                    have_access( 'module' => $module, 'procedure' => 'EXPORT',
                                 'user' => $user );
    }

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th> </th>\n";
    print "<th> </th>\n";
    print "<th> &mdash;   (  )</th>\n";
    print "<th></th>\n";
    print "<th> </th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete || $can_export ||
                                   $can_import );
    print "</tr>\n";

    #          
    #     ...
    if ( $query->param( 'enable_select' ) )
    {
      # ...    JavaScript    
      #     Roles     ...
      if ( $query->param( 'caller_name' ) eq 'ROLES' )
      {
        # ...  role_code_orig  role_fname_orig   ROLES
        create_assign_values_func( 'role_code_orig', 'role_fname_orig' );
      }
    }

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #   ,  ,    
      #  --  , ,     ,
      #        
      # (  &nbsp;   ,   ,
      #   :    'role_code_orig' 
      # null,     -)
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( 'role_code' ) ]</td>\n";

      #         
      #     ,   
      # role_sname    
      #         -- role_fname
      if ( $query->param( 'enable_select' ) )
      {
        print "<td>",
              qq{ <a class="command_link" href="javascript:void( 0 )" onclick=
                  "assign_values( $row[ $result->fnumber( 'role_code' ) ],
                                  '$row[ $result->fnumber( 'role_fname' ) ]'
                                )">
                   $row[ $result->fnumber( 'role_sname' ) ]</a> },
              "</td>\n";
      }
      else
      {
        print "<td>$row[ $result->fnumber( 'role_sname' ) ]</td>\n";
      }

      #  ,   , ,  
      #    "&nbsp;"
      print "<td>",
            ( $row[ $result->fnumber( 'role_code_orig' ) ] ne undef ) ?
              "(" . $row[ $result->fnumber( 'role_code_orig' ) ] . ") " .
              $row[ $result->fnumber( 'role_sname_orig' ) ] :
            "&nbsp;",
            "</td>\n";

      print "<td>$row[ $result->fnumber( 'lang_sname' ) ]</td>\n";
      print "<td>$row[ $result->fnumber( 'process_sname' ) ]</td>\n";

      #   HTML-
      $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
              "role_code=" . $row[ $result->fnumber( 'role_code' ) ] .
              $add_params;

      #      
      print "<td>" if ( $can_view || $can_delete || $can_export ||
                        $can_import );
      print qq{ <a class="command_link" href="$script_name/view?$href"} .
            qq{ target="_self"></a> } . "\n"  if $can_view;

      #    
      print qq{ <a class="command_link" href="$script_name/delete?$href"} .
            qq{ onclick="$confirm_delete" } .
            qq{ target="_self"></a> } . "\n"  if $can_delete;

      #   
      print qq{ <a class="command_link" href="$script_name/export?$href"} .
            qq{ onclick="$confirm_export"} .
            qq{ target="_blank"></A> } . "\n" if $can_export;

      #   
      print qq{ <a class="command_link" href="$script_name/import?$href"} .
            qq{ onclick="$confirm_import"} .
            qq{ target="_blank"></A> } . "\n" if $can_import;

      print "</td>" if ( $can_view || $can_delete || $can_export ||
                         $can_import );
      print "</tr>\n";
    }
    print "</table>\n";
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $role_code;               #  
  my $command;                 #      

  $role_code = $query->param( 'role_code' );

  #     
  #     ,   
  $command = "SELECT r1.*, r2.role_fname AS role_fname_orig " .
             "FROM ${db_schema}roles r1 LEFT JOIN ${db_schema}roles r2 " .
                  "ON r1.role_code_orig = r2.role_code " .
             "WHERE r1.role_code = '$role_code'"; 

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => "_self",
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "         " .
                     " " . $role_code,
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  # 
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "roles",
                       key => "role_code",
                       f_names => \@f_names,
                       f_special => undef,
                       func_special => undef,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  #      (    
  # ,     )
  my( $ref_values_langs, $ref_labels_langs ) = popup_langs_list( $db_schema );

  #      (    
  #     )
  my( $ref_values_procs, $ref_labels_procs ) =
    popup_process_types_list( $db_schema );

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #         ,
    #   1        
    $fields{ 'role_code' } = get_next_key_value( 'roles', 'role_code' );

    #   

    #   
    $fields{ 'role_fname' }     = $CFG{ ROLES_ROLE_FNAME };

    #    
    $fields{ 'role_sname' }     = $CFG{ ROLES_ROLE_SNAME };

    #  ,   
    # (  ,    )
    $fields{ 'role_code_orig' } = $CFG{ ROLES_ROLE_CODE_ORIG };

    #  ,      (1 -  )
    $fields{ 'lang_code' }      = $CFG{ ROLES_LANG_CODE };

    #     
    # (1 - , ..   ,     
    # . )
    $fields{ 'process_code' }   = $CFG{ ROLES_PROCESS_CODE };

    # 
    $fields{ 'comment' }        = $CFG{ ROLES_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  #    " "  
  #    get_next_key_value(),    
  # ,     , ..  
  #    UPDATE   
  print $query->hidden( -name => 'role_code',
                        -default => $fields{ 'role_code' }
                      ), "\n";

  #       ,     
  #           ,
  #        ,   
  #  ,     
  # . .    cities.pl.
  print $query->hidden( -name => 'enable_select' ), "\n";
  print $query->hidden( -name => 'caller_name' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>", $fields{ 'role_code' }, "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>";
  
  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].role_fname", "ROLES_ROLE_FNAME" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'role_fname',
                           -default => $fields{ 'role_fname' },
                           -size => $CFG{ ROLES_ROLE_FNAME_SIZE },
                           -maxlength => $CFG{ ROLES_ROLE_FNAME_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].role_sname", "ROLES_ROLE_SNAME" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'role_sname',
                           -default => $fields{ 'role_sname' },
                           -size => $CFG{ ROLES_ROLE_SNAME_SIZE },
                           -maxlength => $CFG{ ROLES_ROLE_SNAME_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> &mdash;   (  )</th>\n";

  #      JavaScript,  
  # - roles.pl
  create_selection_func( func_name => 'select_orig_role',
                         module_name => 'roles.pl',
                         caller_name => $module,
                         window_name => 'orig_roles',
                         exp_imp => $query->param( 'exp_imp' ) );

  #    ,   
  # (  )
  print "<td>",
        $query->textfield( -name => 'role_code_orig',
                           -default => $fields{ 'role_code_orig' },
                           -size => $CFG{ ROLES_ROLE_CODE_ORIG_SIZE },
                           -maxlength => $CFG{ ROLES_ROLE_CODE_ORIG_MAXLENGTH }
                         ),
        "&nbsp;&nbsp;",
        $query->textfield( -name => 'role_fname_orig',
                           -default => $fields{ 'role_fname_orig' },
                           -size => $CFG{ ROLES_ROLE_FNAME_ORIG_SIZE },
                           -maxlength =>
                             $CFG{ ROLES_ROLE_FNAME_ORIG_MAXLENGTH },
                           -readonly => 'readonly'
                         ),
        "&nbsp;&nbsp;",
        qq{ <a class="command_link" href="javascript:void( 0 )" onclick=} .
        qq{"select_orig_role()">} . "</a>",
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  
  #        labels  
  # ,    popup_langs_list()   ,
  #   -   
  print "<th></th>\n";
  print "<td>",
        $query->popup_menu( -name => 'lang_code',
                            -default => $fields{ 'lang_code' },
                            -values => $ref_values_langs,
                            -labels => { @{ $ref_labels_langs } }
                          ),
        "</td>\n";
  print "</tr>\n";

  #        labels  
  # ,    popup_process_types_list() 
  #  ,   -   
  print "<th>  </th>\n";
  print "<td>",
        $query->popup_menu( -name => 'process_code',
                            -default => $fields{ 'process_code' },
                            -values => $ref_values_procs,
                            -labels => { @{ $ref_labels_procs } }
                          ),
        "</td>\n";
  print "</tr>\n";
  
  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment", "ROLES_COMMENT" ) 
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ ROLES_COMMENT_ROWS },
                          -columns => $CFG{ ROLES_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
  return ( 0 );
}
