#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :    " "
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'SCI_SPECS';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Sci_specs
my @f_names =
   ( 'sci_spec_code',     #   
     'sci_spec_cipher',   #   
     'sci_spec_name',     #   
     'sci_spec_date',     #    
     'sci_spec_term',     #    
     'comment'            # 
   );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              do_find => \&do_find,
              do_export => \&do_export,
              do_import => \&do_import,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              action => $script_name
            );

exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  if ( $query->param( 'sci_spec_code' ) eq '' )
  {
    push( @error_messages, "    " );
  }

  #    ;      "05.13.01"
  if ( $query->param( 'sci_spec_cipher' ) !~ /^\d\d\.\d\d\.\d\d$/ )
  {
    push( @error_messages, "      " .
          "" );
  }

  if ( $query->param( 'sci_spec_name' ) eq '' )
  {
    push( @error_messages, "    " );
  }

  #    
  if ( ! date_is_correct( $query->param( 'sci_spec_date' ) ) )
  {
    push( @error_messages, "      " .
          " " );
  }

  #    
  if ( ! date_is_correct( $query->param( 'sci_spec_term' ) ) )
  {
    push( @error_messages, "      " .
          " " );
  }

  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }
  
  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => ' ',
                    user => $user
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $sci_spec_code;         #   
  my $command;               #      

  $sci_spec_code = $query->param( 'sci_spec_code' );
  
  #         
  $command = "DELETE FROM ${db_schema}sci_specs " .
             "WHERE sci_spec_code = '$sci_spec_code'";

  #   
  del_rec( query => $query,
           create_top => \&create_top,
           target => "_self",
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_export
{
  my $sci_spec_code;         #   
  my $command;               #      
  my @table_cmd_pairs = ();  #     ,
                             #       

  $sci_spec_code = $query->param( 'sci_spec_code' );

  #  -       
  #    (      , 
  #     )
  $command = "SELECT * FROM Sci_specs WHERE sci_spec_code = $sci_spec_code";
  push( @table_cmd_pairs, [ 'Sci_specs', $command ] );

  #    
  export_data( query => $query,
               create_top => \&create_top,
               table_cmd_pairs => \@table_cmd_pairs
             );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_find
{
  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();       #     
  create_top();     #    
  close_top();      #     
  
  open_bottom();    #     
  
  print "<p class=\"info\">     </p>\n";

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_import
{
  my $sci_spec_code;         #   
  my $command;               #      
  my @table_cmd_pairs = ();  #     ,
                             #       

  $sci_spec_code = $query->param( 'sci_spec_code' );

  #  -       
  #    (      , 
  #     )
  $command = "SELECT * FROM exp_imp.Sci_specs " .
             "WHERE sci_spec_code = $sci_spec_code";
  push( @table_cmd_pairs, [ 'Sci_specs', $command ] );

  #    
  import_data( query => $query,
               create_top => \&create_top,
               table_cmd_pairs => \@table_cmd_pairs
             );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#     
# -----------------------------------------------------------------------------
sub do_query
{
  my( $result, $i );              #    
  my @row;                        #      
  my $command;                    #      

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #      / 
  my $can_export = 0;
  my $can_import = 0;

  #        
  #   ( --      
  #   )
  my $add_params = '';

  #  ,        
  my $alt_row = 1;

  my $href;    #   HTML-

  #         
  #  enable_select  caller_name (  )
  if ( $query->param( 'enable_select' ) )
  {
    $add_params = "&enable_select=1&caller_name=" .
                  $query->param( 'caller_name' );
  }

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  #      
  $command = "SELECT * " .
             "FROM ${db_schema}sci_specs " .
             "ORDER BY sci_spec_cipher, sci_spec_date";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                             'user' => $user );
    $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                               'user' => $user );

    #     "/",     
    if ( $query->param( 'exp_imp' ) )
    {
      $can_import = import_enabled() && 
                    have_access( 'module' => $module, 'procedure' => 'IMPORT',
                                 'user' => $user );
    }
    #    public --   ,
    #   -- 
    else
    {
      $can_export = export_enabled() && 
                    have_access( 'module' => $module, 'procedure' => 'EXPORT',
                                 'user' => $user );
    }

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th>  </th>\n";
    print "<th>  </th>\n";
    print "<th></th>\n";
    print "<th> </th>\n";
    print "<th> </th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete || $can_export ||
                                   $can_import );
    print "</tr>\n";

    # .       :  
    #                  .

    #          
    #     ( ) ...
    #if ( $query->param( 'enable_select' ) )
    #{
    #  # ...    JavaScript    
    #  #     Sci_specs     ...
    #  if ( $query->param( 'caller_name' ) eq '__________' )
    #  {
    #    # ...  sci_spec_code, sci_spec_cipher  sci_spec_name
    #    #   ______________
    #    create_assign_values_func( 'sci_spec_code', 'sci_spec_cipher',
    #                               'sci_spec_name' );
    #  }
    #}

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #  , , ,     
      #  
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( 'sci_spec_code' ) ]</td>\n";

      #         
      #      ( ),  
      #  sci_spec_cipher    
      if ( $query->param( 'enable_select' ) )
      {
        print "<td class=\"center\">",
              qq{ <a class="command_link" href="javascript:void( 0 )" onclick=
                  "assign_values( 
                     $row[ $result->fnumber( 'sci_spec_code' ) ],
                     '$row[ $result->fnumber( 'sci_spec_cipher' ) ]',
                     '$row[ $result->fnumber( 'sci_spec_name' ) ]'
                   )">
                   $row[ $result->fnumber( 'city_fname' ) ]</a> },
              "</td>\n";
      }
      else
      {
        print "<td class=\"center\">" .
              "$row[ $result->fnumber( 'sci_spec_cipher' ) ]</td>\n";
      }

      print "<td>$row[ $result->fnumber( 'sci_spec_name' ) ]</td>\n";
      print "<td>" .
            date_for_display( $row[ $result->fnumber( 'sci_spec_date' ) ] ) .
            "</td>\n";
      print "<td>" .
            date_for_display( $row[ $result->fnumber( 'sci_spec_term' ) ] ) .
            "</td>\n";

      #   HTML-
      $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
              "sci_spec_code=" . $row[ $result->fnumber( 'sci_spec_code' ) ] .
              $add_params;

      #       
      print "<td>" if ( $can_view || $can_delete || $can_export ||
                        $can_import );
      print qq{ <a class="command_link" href="$script_name/view?$href"} .
            qq{ target="_self"></a> } . "\n" if $can_view;

      #     
      print qq{ <a class="command_link" href="$script_name/delete?$href"} .
            qq{ onclick="$confirm_delete" } .
            qq{ target="_self"></a> } . "\n" if $can_delete;

      #   
      print qq{ <a class="command_link" href="$script_name/export?$href"} .
            qq{ onclick="$confirm_export"} .
            qq{ target="_blank"></A> } . "\n" if $can_export;

      #   
      print qq{ <a class="command_link" href="$script_name/import?$href"} .
            qq{ onclick="$confirm_import"} .
            qq{ target="_blank"></A> } . "\n" if $can_import;

      print "</td>" if ( $can_view || $can_delete || $can_export ||
                         $can_import );
      print "</tr>\n";
    }
    print "</table>\n";
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $sci_spec_code;         #   
  my $command;               #      

  $sci_spec_code = $query->param( 'sci_spec_code' );

  #      
  $command = "SELECT * " .
             "FROM ${db_schema}sci_specs " .
             "WHERE sci_spec_code = '$sci_spec_code'"; 

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => "_self",
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "         " .
                     "  " . $sci_spec_code,
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  # 
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "sci_specs",
                       key => "sci_spec_code",
                       f_names => \@f_names,
                       f_special => [ 'sci_spec_date', 'sci_spec_term' ],
                       func_special => \&non_std_fields,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #         ,
    #   1        
    $fields{ 'sci_spec_code' } = get_next_key_value( 'sci_specs',
                                                     'sci_spec_code' );
    #   

    #   
    $fields{ 'sci_spec_cipher' } = $CFG{ SCI_SPECS_SCI_SPEC_CIPHER };

    #   
    $fields{ 'sci_spec_name' }   = $CFG{ SCI_SPECS_SCI_SPEC_NAME };

    #    
    $fields{ 'sci_spec_date' }   = $CFG{ SCI_SPECS_SCI_SPEC_DATE };

    #    
    $fields{ 'sci_spec_term' }   = $CFG{ SCI_SPECS_SCI_SPEC_TERM };

    # 
    $fields{ 'comment' }         = $CFG{ SCI_SPECS_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  #    "  " 
  #     get_next_key_value(),  
  #   ,     , .. 
  #     UPDATE   
  print $query->hidden( -name => 'sci_spec_code',
                        -default => $fields{ 'sci_spec_code' }
                      ), "\n";

  #       ,     
  #           ,
  #        ,   
  #  ,     
  # . .    cities.pl.
  print $query->hidden( -name => 'enable_select' ), "\n";
  print $query->hidden( -name => 'caller_name' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>", $fields{ 'sci_spec_code' }, "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].sci_spec_cipher",
                   "SCI_SPECS_SCI_SPEC_CIPHER" ) if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'sci_spec_cipher',
                           -default => $fields{ 'sci_spec_cipher' },
                           -size => $CFG{ SCI_SPECS_SCI_SPEC_CIPHER_SIZE },
                           -maxlength =>
                             $CFG{ SCI_SPECS_SCI_SPEC_CIPHER_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].sci_spec_name",
                   "SCI_SPECS_SCI_SPEC_NAME" ) if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'sci_spec_name',
                          -default => $fields{ 'sci_spec_name' },
                          -rows => $CFG{ SCI_SPECS_SCI_SPEC_NAME_ROWS },
                          -columns => $CFG{ SCI_SPECS_SCI_SPEC_NAME_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].sci_spec_date",
                   "SCI_SPECS_SCI_SPEC_DATE", "REPLACE" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'sci_spec_date',
                           -default =>
                              date_for_display( $fields{ 'sci_spec_date' } ),
                           -size => $CFG{ SCI_SPECS_SCI_SPEC_DATE_SIZE },
                           -maxlength =>
                             $CFG{ SCI_SPECS_SCI_SPEC_DATE_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].sci_spec_term",
                   "SCI_SPECS_SCI_SPEC_TERM", "REPLACE" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'sci_spec_term',
                           -default =>
                              date_for_display( $fields{ 'sci_spec_term' } ),
                           -size => $CFG{ SCI_SPECS_SCI_SPEC_TERM_SIZE },
                           -maxlength =>
                             $CFG{ SCI_SPECS_SCI_SPEC_TERM_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment", "SCI_SPECS_COMMENT" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ SCI_SPECS_COMMENT_ROWS },
                          -columns => $CFG{ SCI_SPECS_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
  return ( 0 );
}

# -----------------------------------------------------------------------------
#   ,    
#  -      
# -----------------------------------------------------------------------------
sub non_std_fields
{
  # :
  my $fname = shift;  #  
                      #   -   ( 
                      #  ).      
  my $value;
  
  #   
  if ( $fname eq 'sci_spec_date' || $fname eq 'sci_spec_term' )
  {
    $value = date_for_db( $query->param( $fname ) );
  }

  return ( $value );  
}
