#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :   " /"
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'SER_DESCRS';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Ser_descrs
my @f_names =
   ( 'series_id',        #   /
     'ser_descr_num',    #   /
                         # ( ,   bib_rec_num)
                         # (    0)
     'ser_descr',        #  /
     'lang_code',        #  ,   
                         #  / (1 -  )
     'process_code',     #     /
                         # (1 - , ..   , 
                         #    . )
     'reason_add_descr', #  .  ( 
                         #  )
     'comment'           # 
   );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              do_find => \&do_find,
              do_export => \&do_export,
              do_import => \&do_import,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              action => $script_name
            );

#    ,    
# (    )
if ( $query->path_info =~ /^\/list_bib_recs$/ )
{
  do_list_bib_recs();
}

exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  #     (   )
  if ( $query->param( 'series_id' ) !~ /^\d+$/ )
  {
    push( @error_messages, "      " .
          "/" );
  }

  #     (   )
  if ( $query->param( 'ser_descr_num' ) !~ /^\d+$/ )
  {
    push( @error_messages, "      " .
          "/" );
  }

  if ( $query->param( 'ser_descr' ) eq '' )
  {
    push( @error_messages, "   /" );
  }

  if ( $query->param( 'lang_code' ) eq '' )
  {
    push( @error_messages, "   " );
  }

  if ( $query->param( 'process_code' ) eq '' )
  {
    push( @error_messages, "      " .
          "/" );
  }

  # DEBUG
  # print_params( $query );
  
  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }

  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => ' /',
                    user => $user,
                    make_letters => 'yes',
                    num_last_recs => $CFG{ SER_DESCRS_NUM_LAST_RECS },
                    full_top => 'yes'
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $series_id;         #   /
  my $ser_descr_num;     #   /
  my $command;           #      

  $series_id     = $query->param( 'series_id' );
  $ser_descr_num = $query->param( 'ser_descr_num' );
  
  #         
  $command = "DELETE FROM ${db_schema}ser_descrs " .
             "WHERE series_id = '$series_id' AND " .
                   "ser_descr_num = '$ser_descr_num'";

  #   
  # TODO ,     , 
  #        ,     
  #       /    .    
  #            Series,    -  .
  #              Series
  #          (   ).
  del_rec( query => $query,
           create_top => \&create_top,
           target => "_self",
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_export
{
  # !        .
  
  my $series_id;             #   /
  my $ser_descr_num;         #   /
  my $command;               #      
  my $dep_table;             #   
  my @table_cmd_pairs = ();  #     ,
                             #       

  $series_id = $query->param( 'series_id' );
  $ser_descr_num = $query->param( 'ser_descr_num' );

  #   -   Ser_descrs  
  #    (      , 
  #     )
  $command = "SELECT * FROM Ser_descrs " .
             "WHERE series_id = $series_id AND " .
                   "ser_descr_num = $ser_descr_num";
  push( @table_cmd_pairs, [ 'Ser_descrs', $command ] );

  #    
  export_data( query => $query,
               create_top => \&create_top,
               table_cmd_pairs => \@table_cmd_pairs
             );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_find
{
  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();       #     
  create_top();     #    
  close_top();      #     
  
  open_bottom();    #     
  
  print "<p class=\"info\">     </p>\n";

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_import
{
  # !        .
  
  my $series_id;             #   /
  my $ser_descr_num;         #   /
  my $command;               #      
  my $dep_table;             #   
  my @table_cmd_pairs = ();  #     ,
                             #       

  $series_id = $query->param( 'series_id' );
  $ser_descr_num = $query->param( 'ser_descr_num' );

  #   -   Ser_descrs  
  #    (      , 
  #     )
  $command = "SELECT * FROM exp_imp.Ser_descrs " .
             "WHERE series_id = $series_id AND " .
                   "ser_descr_num = $ser_descr_num";
  push( @table_cmd_pairs, [ 'Ser_descrs', $command ] );

  #    
  import_data( query => $query,
               create_top => \&create_top,
               table_cmd_pairs => \@table_cmd_pairs
             );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#    .   ,    
# (    )
# -----------------------------------------------------------------------------
sub do_list_bib_recs
{
  my @row;                        #      
  my $command;                    #      
  my $series_id;                  #   /,
                                  #  
  my $series_issn;                # ISSN /
  my $ser_descr_num;              #   /
  my $ser_descr;                  #  /
  my $headline;                   #   . 

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  $series_id     = $query->param( 'series_id' );
  $series_issn   = $query->param( 'series_issn' );
  $ser_descr_num = $query->param( 'ser_descr_num' );
  $ser_descr     = $query->param( 'ser_descr' );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  #    /   
  # /   
  print "<p class=\"bib_rec\">";
  print " /: $series_id\n";
  print "&nbsp;&nbsp;\n";
  print "    /: $ser_descr_num</p>\n";

  #    /  ISSN ( )
  print "<p class=\"bib_rec\">$ser_descr<br />\n";
  print "ISSN: " . ( ( $series_issn ) ? $series_issn : "" ) . "</p>\n";

  #   
  $headline = "<h2 class=\"module_title\"> /</h2>\n";

  #    .  ,   
  #  / (. .  /    
  # /)
  $command = "SELECT b.obj_id, b.bib_rec_num, " .
                    "CASE WHEN b.bib_rec_short IS NOT NULL " .
                         "THEN b.bib_rec_short " .
                         "ELSE b.bib_rec_full " .
                    "END AS bib_rec " .
             "FROM ${db_schema}obj_series os, ${db_schema}bib_recs b " .
             "WHERE os.series_id = $series_id AND " .
                   "os.ser_descr_num = $ser_descr_num AND " .
                   "os.obj_id = b.obj_id AND " .
                   "os.bib_rec_num = b.bib_rec_num " .
             "ORDER BY bib_rec";

  #  .   ,   
  list_bib_recs_by_query( $query, $command, $headline );

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#     /,  
#    
# -----------------------------------------------------------------------------
sub do_query
{
  my( $result, $i );              #    
  my @row;                        #      
  my $command;                    #      
  my $letter;                     #    /
  my $letter_lower;               #   --   

  #   ,   ,   
  #     
  my $num_last_recs;

  #  WHERE   
  my $where;

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #      / 
  my $can_export = 0;
  my $can_import = 0;

  #        
  #   ( --      
  #   )
  my $add_params = '';

  #  ,        
  my $alt_row = 1;

  my $href;    #   HTML-

  #         
  #  enable_select  caller_name (  )
  if ( $query->param( 'enable_select' ) )
  {
    $add_params = "&enable_select=1&caller_name=" .
                  $query->param( 'caller_name' );
  }

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();        #     
  create_top();      #    
  close_top();       #     

  open_bottom();     #     

  $letter        = $query->param( 'letter' );
  $num_last_recs = $query->param( 'num_last_recs' );

  #    ,      - 
  #      
  # .    undef,      '' 
  #               -   CGI.pm.
  if ( ( $letter eq undef || $letter eq '' ) &&
       ( $num_last_recs eq undef || $num_last_recs eq '' )
     )
  {
    close_bottom();   #     
    print $query->end_html();
    return ( 0 );
  }

  #         ,
  #   
  if ( $num_last_recs )
  {
    # .        
    #                ,   ,  
    #              .  -   ,
    #                ""   series_id,
    #                   .
    # .       ,    
    #             ser_descr_num,     
    #             .       - 
    #                 (. .    
    #               ),    :
    #             - ,      ,  
    #              ,    series_id   
    #                ,  
    #             $num_last_recs,       ,
    #                $num_last_recs;
    #             -      ,   
    #             $num_last_recs,    series_id  
    #                ,  
    #             $num_last_recs
    $where = "WHERE d.series_id >= " .
                    "( SELECT max( series_id ) " .
                      "FROM ${db_schema}ser_descrs ) - " .
                    "$num_last_recs + 1 AND " .
                    "d.series_id = s.series_id ";
  }
  #       
  elsif ( $letter )
  {
    # !    .     .

    # . .    bib_recs.pl.
    #{
    #  use Encode qw( from_to );
    #  #    $letter    ( ,  
    #  # ),  ,   UTF-8
    #  from_to( $letter, "utf-8", "koi8-r" ) if ( length( $letter ) > 1 );
    #}

    #        
    $letter = reveal_rus_letter( $letter );

    #      , 
    # ,   
    $letter_lower = change_case( $letter, 'lower' );

    #    --  ,    
    $where = "WHERE d.ser_descr ~ '^($letter|\"$letter|" .
                                    "$letter_lower|\"$letter_lower)' AND " .
                   "d.series_id = s.series_id ";
  }

  #   ,    $where
  # (. . ,     ser_descr    
  #  ,      );
  #        (    
  #  );
  #   ISSN 
  $command = "SELECT d.*, s.series_issn " .
             "FROM ${db_schema}ser_descrs d, ${db_schema}series s " .
             $where .
  #        ,   
  #      (,     
  #    --  )
             "ORDER BY lower( substr( d.ser_descr, 1, 100 ) )";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    #    ,    ,   
    if ( $num_last_recs )
    {
    print "<h3>,      (" . 
          $num_last_recs . " .)</h3>\n";
    }

    #       ,     
    # "  ",       
    # (      ,
    #     )
    if ( $query->param( 'enable_select' ) &&
         $query->param( 'caller_name') eq $module )
    {
      $can_view = 0;
      $can_delete = 0;
    }
    else
    {
      $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                               'user' => $user );
      $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                                 'user' => $user );
    }

    #     "/",     
    if ( $query->param( 'exp_imp' ) )
    {
      $can_import = import_enabled() && 
                    have_access( 'module' => $module, 'procedure' => 'IMPORT',
                                 'user' => $user );
    }
    #    public --   ,
    #   -- 
    else
    {
      $can_export = export_enabled() && 
                    have_access( 'module' => $module, 'procedure' => 'EXPORT',
                                 'user' => $user );
    }

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th>ID</th>\n";
    print "<th>ISSN</th>\n";
    print "<th> </th>\n";
    print "<th> /</th>\n";
    print "<th>&nbsp;</th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete || $can_export ||
                                   $can_import );
    print "</tr>\n";

    #          
    #    / ...
    if ( $query->param( 'enable_select' ) )
    {
      # ...    JavaScript    
      #     Ser_descrs     ...
      if ( $query->param( 'caller_name' ) eq 'OBJ_SERIES' )
      {
        # ...  series_id, ser_descr_num  ser_descr   OBJ_SERIES
        # .      
        #                  
        #             (.  assign_values()   E_ARCH.pm).
        create_assign_values_func( 'series_id', 'ser_descr_num', 'ser_descr' );
      }
    }

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #    /, ISSN,  
      # /   /
      print "<td class=\"center\">" .
            $row[ $result->fnumber( 'series_id' ) ] . "</td>\n";
      print "<td>$row[ $result->fnumber( 'series_issn' ) ]</td>\n";
      print "<td class=\"center\">" .
            $row[ $result->fnumber( 'ser_descr_num' ) ] . "</td>\n";

      #         
      #     /,   
      # ser_descr    

      if ( $query->param( 'enable_select' ) )
      {
        #     "" 
        # (.    obj_groups_descrs.pl)
        #     , . . , 
        #   escapeHTML(), 
        my $ser_descr = $row[ $result->fnumber( 'ser_descr' ) ];
        $ser_descr =~ s/\'/\\\'/g;
        $ser_descr = CGI::escapeHTML( $ser_descr );

        print "<td>",
              qq{ <a class="command_link" href="javascript:void( 0 )" onclick=
                  "assign_values( $row[ $result->fnumber( 'series_id' ) ],
                                  $row[ $result->fnumber( 'ser_descr_num' ) ],
                                  '$ser_descr' )">
                   $row[ $result->fnumber( 'ser_descr' ) ]</a> },
              "</td>\n";
      }
      else
      {
        print "<td>$row[ $result->fnumber( 'ser_descr' ) ]</td>\n";
      }

      #   HTML-
      $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
              "series_id=" . $row[ $result->fnumber( 'series_id' ) ] .
              "&ser_descr_num=" . $row[ $result->fnumber( 'ser_descr_num' ) ] .
              $add_params;

      #  .  ,    /
      # (    )
      print "<td>",
            qq{<a class="command_link" } .
            qq{href="$script_name/list_bib_recs?$href} .
            "&series_issn=" . $row[ $result->fnumber( 'series_issn' ) ] .
            "&ser_descr=" . 
            CGI::escape( $row[ $result->fnumber( 'ser_descr' ) ] ) . "\"" .
            qq{ target="_blank"></a>},
            "</td>\n";

      #     
      print "<td>" if ( $can_view || $can_delete );
      print qq{ <a class="command_link" href="$script_name/view?$href"} .
            qq{ target="_self"></a>} . "\n" if $can_view;

      #   
      print qq{ <a class="command_link" href="$script_name/delete?$href"} .
            qq{ onclick="$confirm_delete" } .
            qq{ target="_self"></a>} . "\n" if $can_delete;

      #   
      print qq{ <a class="command_link" href="$script_name/export?$href"} .
            qq{ onclick="$confirm_export"} .
            qq{ target="_blank"></A> } . "\n" if $can_export;

      #   
      print qq{ <a class="command_link" href="$script_name/import?$href"} .
            qq{ onclick="$confirm_import"} .
            qq{ target="_blank"></A> } . "\n" if $can_import;

      print "</td>" if ( $can_view || $can_delete || $can_export ||
                         $can_import );
      print "</tr>\n";
    }
    print "</table>\n";
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $series_id;             #   /
  my $ser_descr_num;         #   /
  my $command;               #      

  $series_id     = $query->param( 'series_id' );
  $ser_descr_num = $query->param( 'ser_descr_num' );

  #    / 
  #   ISSN 
  $command = "SELECT d.*, s.series_issn " .
             "FROM ${db_schema}ser_descrs d, ${db_schema}series s " .
             "WHERE d.series_id = '$series_id' AND " .
                   "d.ser_descr_num = '$ser_descr_num' AND " . 
                   "d.series_id = s.series_id";

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => "_self",
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "        " .
                     "  / " . $series_id .
                     "    " . $ser_descr_num,
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "ser_descrs",
                       key => "series_id:series_id_begin, " .
                              "ser_descr_num:ser_descr_num_begin",
                       f_names => \@f_names,
                       f_special => undef,
                       func_special => undef,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  #      (    
  # ,    . )
  my( $ref_values_langs, $ref_labels_langs ) = popup_langs_list( $db_schema );

  #      (    
  #    . )
  my( $ref_values_procs, $ref_labels_procs ) =
    popup_process_types_list( $db_schema );

  #   HTML-      ""
  #  /
  my $href;
  
  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #   

    #   / ( ,   bib_rec_num)
    # (    0)
    $fields{ 'ser_descr_num' }    = $CFG{ SER_DESCRS_SER_DESCR_NUM };

    #  /
    $fields{ 'ser_descr' }        = $CFG{ SER_DESCRS_SER_DESCR };

    #  ,     /
    # (1 -  )
    $fields{ 'lang_code' }        = $CFG{ SER_DESCRS_LANG_CODE };

    #     /
    # (1 - , ..   ,     
    # . )
    $fields{ 'process_code' }     = $CFG{ SER_DESCRS_PROCESS_CODE };

    #  .  (   )
    $fields{ 'reason_add_descr' } = $CFG{ SER_DESCRS_REASON_ADD_DESCR };

    # 
    $fields{ 'comment' }          = $CFG{ SER_DESCRS_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  #     "  /" 
  # "  /"
  # .      'begin'  ,
  #                   ,  
  #               (.  make_cmd   E_ARCH.pm).
  #             ..       ,   
  #              (, ,   ).
  print $query->hidden( -name => 'series_id_begin',
                        -default => $fields{ 'series_id' }
                      ), "\n";
  print $query->hidden( -name => 'ser_descr_num_begin',
                        -default => $fields{ 'ser_descr_num' }
                      ), "\n";

  #       ,     
  #           ,
  #        ,   
  #  ,     
  # . .    cities.pl.
  print $query->hidden( -name => 'enable_select' ), "\n";
  print $query->hidden( -name => 'caller_name' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th>  /</th>\n";

  #      JavaScript,  
  #  series.pl   -  
  create_selection_func( func_name => 'select_series',
                         module_name => 'series.pl',
                         caller_name => $module,
                         window_name => 'series',
                         exp_imp => $query->param( 'exp_imp' ) );

  print "<td>",
        $query->textfield( -name => 'series_id',
                           -default => $fields{ 'series_id' },
                           -size => $CFG{ SER_DESCRS_SERIES_ID_SIZE },
                           -maxlength => $CFG{ SER_DESCRS_SERIES_ID_MAXLENGTH }
                         ),
        "&nbsp;&nbsp;",
        qq{ <a class="command_link" href="javascript:void( 0 )"} .
        qq{ onclick="select_series()"></a>},
        "</td>\n";
  print "</tr>\n";

  #   ISSN  (  )
  print "<tr>\n";
  print "<th>ISSN,  /</th>\n";
  print "<td>",
        $query->textfield( -name => 'series_issn',
                           -default => $fields{ 'series_issn' },
                           -size => $CFG{ SER_DESCRS_SERIES_ISSN_SIZE },
                           -maxlength => 
                             $CFG{ SER_DESCRS_SERIES_ISSN_MAXLENGTH },
                           -readonly => 'readonly'
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  /</th>\n";
  print "<td>",
        $query->textfield( -name => 'ser_descr_num',
                           -default => $fields{ 'ser_descr_num' },
                           -size => $CFG{ SER_DESCRS_SER_DESCR_NUM_SIZE },
                           -maxlength => 
                             $CFG{ SER_DESCRS_SER_DESCR_NUM_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> /</th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].ser_descr", "SER_DESCRS_SER_DESCR" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'ser_descr',
                          -default => $fields{ 'ser_descr' },
                          -rows => $CFG{ SER_DESCRS_SER_DESCR_ROWS },
                          -columns => $CFG{ SER_DESCRS_SER_DESCR_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";

  #        labels  
  # ,    popup_langs_list()   ,
  #   -   
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>",
        $query->popup_menu( -name => 'lang_code',
                            -default => $fields{ 'lang_code' },
                            -values => $ref_values_langs,
                            -labels => { @{ $ref_labels_langs } }
                          ),
        "</td>\n";
  print "</tr>\n";

  #        labels  
  # ,    popup_process_types_list() 
  #  ,   -   
  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>",
        $query->popup_menu( -name => 'process_code',
                            -default => $fields{ 'process_code' },
                            -values => $ref_values_procs,
                            -labels => { @{ $ref_labels_procs } }
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>   " .
            "(   )</th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].reason_add_descr",
                   "SER_DESCRS_REASON_ADD_DESCR" )
    if $CFG{ HOT_HELP_IS_ON };

  print  $query->textfield( -name => 'reason_add_descr',
                            -default => $fields{ 'reason_add_descr' },
                            -size => $CFG{ SER_DESCRS_REASON_ADD_DESCR_SIZE },
                            -maxlength => 
                              $CFG{ SER_DESCRS_REASON_ADD_DESCR_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment", "SER_DESCRS_COMMENT" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ SER_DESCRS_COMMENT_ROWS },
                          -columns => $CFG{ SER_DESCRS_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";

  #    -       
  #  , ,     /
  #         ,   
  # Ser_descrs
  if ( $ref_row ne undef )
  {
    #   HTML-      ""
    #  / (      
    # ,     / -    
    #  "")
    # .   /   ,  
    #              -    .
    $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
            "series_id=$fields{ 'series_id' }" .
            "&ser_descr_num=$fields{ 'ser_descr_num' }" .
            "&ser_descr=" . CGI::escape( $fields{ 'ser_descr' } ) .
            "&target_win=_self";

    #  /
    print qq{<a class="command_link"} .
          qq{ href="/$CFG\{ HOME_WEB_DIR \}/ser_titles.pl/query?$href" } .
          qq{ target="_self"> /</a><br /><br />\n};
  }

  return ( 0 );
}
