#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :   " /"
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'SER_TITLES';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Ser_titles
my @f_names =
   ( 'series_id',        #   /
     'ser_descr_num',    #   /
                         # ( ,   bib_rec_num)
                         # (    0)
     'ser_title_num',    #  
                         # (0 - ; 1, 2, ... - )
     'ser_title',        #  /
     'ser_title_info',   # ,   
     'lang_code',        #  ,    
                         # (1 -  )
     'process_code',     #    
                         # (1 - )
     'comment'           # 
   );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              print_add_info => \&print_add_info,
              action => $script_name
            );

exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  if ( $query->param( 'ser_title_num' ) !~ /^\d+$/ )
  {
    push( @error_messages, "     " );
  }

  if ( $query->param( 'ser_title' ) eq '' )
  {
    push( @error_messages, "   /" );
  }

  if ( $query->param( 'lang_code' ) eq '' )
  {
    push( @error_messages, "   " );
  }

  if ( $query->param( 'process_code' ) eq '' )
  {
    push( @error_messages, "     " );
  }

  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }
  
  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => ' /',
                    user => $user,
                    full_top => 'no'
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $series_id;          #   /
  my $ser_descr_num;      #   /
  my $ser_title_num;      #  
  my $target_win;         #      HTML-
  my $command;            #      

  $series_id     = $query->param( 'series_id' );
  $ser_descr_num = $query->param( 'ser_descr_num' );
  $ser_title_num = $query->param( 'ser_title_num' );
  $target_win    = $query->param( 'target_win' );

  #         
  $command = "DELETE FROM ${db_schema}ser_titles " .
             "WHERE series_id = '$series_id' AND " .
                   "ser_descr_num = '$ser_descr_num' AND " .
                   "ser_title_num = '$ser_title_num'";

  #   
  del_rec( query => $query,
           target => $target_win,
           create_top => \&create_top,
           print_add_info => \&print_add_info,
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#       /
# -----------------------------------------------------------------------------
sub do_query
{
  # .        
  #              ser_descrs.pl.

  my $series_id;          #   /
  my $ser_descr_num;      #   /
  my $ser_descr;          #  /
  my $target_win;         #      HTML-
  my( $result, $i );      #    
  my @row;                #      
  my $command;            #      
  my $href;               #   HTML-

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #  ,        
  my $alt_row = 1;

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => $target_win );

  $series_id     = $query->param( 'series_id' );
  $ser_descr_num = $query->param( 'ser_descr_num' );
  $ser_descr     = $query->param( 'ser_descr' );
  $target_win    = $query->param( 'target_win' );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  print_add_info(); #     

  #  ,    
  $ser_descr = CGI::escape( $ser_descr );

  #   HTML-
  $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
          "series_id=$series_id" .
          "&ser_descr_num=$ser_descr_num" .
          "&ser_descr=$ser_descr" .
          "&target_win=$target_win";

  #        /
  # (    ,    )
  $command = "SELECT t.*, l.lang_sname " .
             "FROM ${db_schema}ser_titles t, ${db_schema}langs l " .
             "WHERE t.series_id = $series_id AND " .
                   "t.ser_descr_num = $ser_descr_num AND " .
                   "t.lang_code = l.lang_code " .
             "ORDER BY t.ser_title_num";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                             'user' => $user );
    $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                               'user' => $user );

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th> </th>\n";
    print "<th></th>\n";
    print "<th> </th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete );
    print "</tr>\n";

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #   ,    
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( 'ser_title_num' ) ]</td>\n";
      print "<td>$row[ $result->fnumber( 'ser_title' ) ]</td>\n";
      print "<td>$row[ $result->fnumber( 'lang_sname' ) ]</td>\n";

      #        
      #   - . 
      print "<td>" if ( $can_view || $can_delete );
      print qq{ <a class="command_link" href="$script_name/view?$href} .
            "&ser_title_num=" . 
            $row[ $result->fnumber( 'ser_title_num' ) ] . "\"" .
            qq{ target="$target_win"></a> } if $can_view;
      print "\n" if $can_view;

      #     
      print qq{ <a class="command_link" href="$script_name/delete?$href} .
            "&ser_title_num=" . 
            $row[ $result->fnumber( 'ser_title_num' ) ] . "\"" .
            qq{ onclick="$confirm_delete" } .
            qq{ target="$target_win"></a> } if $can_delete;
      print "</td>\n" if ( $can_view || $can_delete );

      print "</tr>\n";
    }
    print "</table>\n";
  }

  #      / 
  #          "/"
  if ( ! $query->param( 'exp_imp' ) &&
       have_access( 'module' => $module, 'procedure' => 'ADD', 
                    'user' => $user ) )
  {
    print "<br />\n";
    print qq{<a class="command_link" href="$script_name/add?$href"} .
          qq{ target="$target_win"> </a>};
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $series_id;          #   /
  my $ser_descr_num;      #   /
  my $ser_title_num;      #  
  my $target_win;         #      HTML-
  my $command;            #      

  $series_id     = $query->param( 'series_id' );
  $ser_descr_num = $query->param( 'ser_descr_num' );
  $ser_title_num = $query->param( 'ser_title_num' );
  $target_win    = $query->param( 'target_win' );

  #     
  # (        
  # )
  $command = "SELECT t.*, l.lang_sname, p.process_sname " .
             "FROM ${db_schema}ser_titles t, ${db_schema}langs l, " .
                  "${db_schema}process_types p " .
             "WHERE t.series_id = $series_id AND " .
                   "t.ser_descr_num = $ser_descr_num AND " .
                   "t.ser_title_num = '$ser_title_num' AND " .
                   "t.lang_code = l.lang_code AND " .
                   "t.process_code = p.process_code";

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => $target_win,
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "        : " .
                     "  / - " .
                     $series_id . ", " .
                     "    / - " .
                     $ser_descr_num . ", " .
                     "  - $ser_title_num",
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "ser_titles",
                       key => "series_id, ser_descr_num, " .
                              "ser_title_num:ser_title_num_begin",
                       f_names => \@f_names,
                       f_special => undef,
                       func_special => undef,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  #      (    
  # ,    )
  my( $ref_values_langs, $ref_labels_langs ) = popup_langs_list( $db_schema );

  #      (    
  #    )
  my( $ref_values_procs, $ref_labels_procs ) =
    popup_process_types_list( $db_schema );

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #        
    $fields{ 'series_id' }     = $query->param( 'series_id' );
    $fields{ 'ser_descr_num' } = $query->param( 'ser_descr_num' );

    #   (0 - ; 1, 2, ... - )
    $fields{ 'ser_title_num' } = $CFG{ SER_TITLES_SER_TITLE_NUM };
    
    #  ,     (1 -  )
    $fields{ 'lang_code' }     = $CFG{ SER_TITLES_LANG_CODE };

    #     (1 -  )
    $fields{ 'process_code' }  = $CFG{ SER_TITLES_PROCESS_CODE };
  }
  # -------------------------------------------------------------------

  #    "  /"
  # "  /"   ,  
  #   ,     , .. 
  #     UPDATE   ,   
  #   INSERT (     ,
  #       ,   
  #   )
  print $query->hidden( -name => 'series_id' ), "\n";
  print $query->hidden( -name => 'ser_descr_num' ), "\n";

  #     " "
  # .      'begin'  ,
  #                   ,  
  #               (.  make_cmd   E_ARCH.pm).
  #             ..       ,   
  #              (, ,   ).
  print $query->hidden( -name => 'ser_title_num_begin',
                        -default => $fields{ 'ser_title_num' }
                      ), "\n";

  #       /
  #   ,     add_rec() 
  #  update_rec()
  print $query->hidden( -name => 'ser_descr' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print_add_info(); #     

  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>",
        $query->textfield( -name => 'ser_title_num',
                           -default => $fields{ 'ser_title_num' },
                           -size => $CFG{ SER_TITLES_SER_TITLE_NUM_SIZE },
                           -maxlength => 
                             $CFG{ SER_TITLES_SER_TITLE_NUM_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> /</th>\n";
  print "<td>",
        $query->textarea( -name => 'ser_title',
                          -default => $fields{ 'ser_title' },
                          -rows => $CFG{ SER_TITLES_SER_TITLE_ROWS },
                          -columns => $CFG{ SER_TITLES_SER_TITLE_COLS }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>,   <br />" .
            "(  \":\")</th>\n";
  print "<td>",
        $query->textarea( -name => 'ser_title_info',
                          -default => $fields{ 'ser_title_info' },
                          -rows => $CFG{ SER_TITLES_SER_TITLE_INFO_ROWS },
                          -columns => $CFG{ SER_TITLES_SER_TITLE_INFO_COLS }
                         ),
        "</td>\n";
  print "</tr>\n";

  #        labels  
  # ,    popup_langs_list()   ,
  #   -   
  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>",
        $query->popup_menu( -name => 'lang_code',
                            -default => $fields{ 'lang_code' },
                            -values => $ref_values_langs,
                            -labels => { @{ $ref_labels_langs } }
                          ),
        "</td>\n";
  print "</tr>\n";

  #        labels  
  # ,    popup_process_types_list() 
  #  ,   -   
  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>",
        $query->popup_menu( -name => 'process_code',
                            -default => $fields{ 'process_code' },
                            -values => $ref_values_procs,
                            -labels => { @{ $ref_labels_procs } }
                          ),
        "</td>\n";
  print "</tr>\n";

  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";
  
  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment", "SER_TITLES_COMMENT" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ SER_TITLES_COMMENT_ROWS },
                          -columns => $CFG{ SER_TITLES_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
  return ( 0 );
}

# -----------------------------------------------------------------------------
#          
# -----------------------------------------------------------------------------
sub print_add_info
{
  #   /   
  print_ser_descr( $query, " /" );
  
  return ( 0 );
}
