#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :   "/"
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'SERIES';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Series
my @f_names =
   ( 
     'series_id',        #   /
     'series_issn',      # ISSN,  /
     'subser_flag',      #  
     'series_id_parent', #    ()
     'comment'           # 
   );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              do_find => \&do_find,
              do_export => \&do_export,
              do_import => \&do_import,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              action => $script_name
            );

exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  #    ,   
  if ( $query->param( 'series_id_parent' ) !~ /^\d*$/ )
  {
    push( @error_messages, "   " );
  }

  if ( $query->param( 'series_id_parent' ) == $query->param( 'series_id' ) )
  {
    push( @error_messages, "     " .
          "  " );
  }
  
  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }
  
  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => '/',
                    user => $user
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $series_id;             #   /
  my $command;               #      

  $series_id = $query->param( 'series_id' );
  
  #         
  $command = "DELETE FROM ${db_schema}series " .
             "WHERE series_id = '$series_id'";

  #   
  del_rec( query => $query,
           create_top => \&create_top,
           target => "_self",
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_export
{
  # !!!       .
  #             (15.04.2012)   
  #          .       
  #          ser_descr_num   Ser_descrs.   
  #          series_id.         Series,
  #             Ser_descrs.      
  #              ,  
  #           .  / e_arch_exp.cfg.
  
  my $series_id;             #   /

  # .      .
  # my $ser_descr_num;       #   /
  
  my $command;               #      
  my @table_cmd_pairs = ();  #     ,
                             #       

  $series_id = $query->param( 'series_id' );

  #   -   Ser_descrs  
  #    (      , 
  #     )
  $command = "SELECT * FROM Ser_descrs WHERE series_id = $series_id";
  push( @table_cmd_pairs, [ 'Ser_descrs', $command ] );

  #    
  export_data( query => $query,
               create_top => \&create_top,
               table_cmd_pairs => \@table_cmd_pairs
             );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_find
{
  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  open_top();       #     
  create_top();     #    
  close_top();      #     
  
  open_bottom();    #     
  
  print "<p class=\"info\">     </p>\n";

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_import
{
  # !!!       .
  #             (15.04.2012)   
  #          .       
  #          ser_descr_num   Ser_descrs.   
  #          series_id.         Series,
  #             Ser_descrs.      
  #              ,  
  #           .  / e_arch_exp.cfg.
  
  my $series_id;             #   /

  # .      .
  # my $ser_descr_num;       #   /
  
  my $command;               #      
  my @table_cmd_pairs = ();  #     ,
                             #       

  $series_id = $query->param( 'series_id' );

  #   -   Ser_descrs  
  #    (      , 
  #     )
  $command = "SELECT * FROM exp_imp.Ser_descrs WHERE series_id = $series_id";
  push( @table_cmd_pairs, [ 'Ser_descrs', $command ] );

  #    
  import_data( query => $query,
               create_top => \&create_top,
               table_cmd_pairs => \@table_cmd_pairs
             );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#    /
# -----------------------------------------------------------------------------
sub do_query
{
  my( $result, $i );              #    
  my @row;                        #      
  my $command;                    #      

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #      / 
  my $can_export = 0;
  my $can_import = 0;

  #        
  #   ( --      
  #   )
  my $add_params = '';

  #   / (  
  # HTML-      )
  my $basic_ser_descr;

  #  ,        
  my $alt_row = 1;

  my $href;    #   HTML-
  
  #         
  #  enable_select  caller_name (  )
  if ( $query->param( 'enable_select' ) )
  {
    $add_params = "&enable_select=1&caller_name=" .
                  $query->param( 'caller_name' );
  }

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => "_self" );

  #    /
  my $faked_ser_descr = $CFG{ SERIES_FAKED_DESCR };

  $faked_ser_descr = '---   ---' unless $faked_ser_descr;

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     
  
  #     /
  #     /    
  #  ISSN   
  # .  CASE WHEN ...   ,  
  #                 ,     
  #             ,    .
  #               /   Ser_descrs  
  #               ser_descr_num  0. 
  #              d1.ser_descr_num IS NULL    WHERE,
  #                   ,   
  #                .
  #               d2.ser_descr_num IS NULL    
  #             WHERE,      ,   
  #               (,      --
  #                 ). 
  #                ( d2.ser_descr_num = 0 OR 
  #             d2.ser_descr_num IS NULL ),      ,
  #                ,     ,
  #                  ,  
  #                .    
  #             ,         
  #              (  " /"),  
  #             ""      WHERE.
  $command = "SELECT s1.*, s2.series_issn AS parent_ser_issn, " .
                    "CASE WHEN d1.ser_descr IS NOT NULL " .
                         "THEN d1.ser_descr " .
                         "ELSE '$faked_ser_descr' " .
                     "END AS basic_ser_descr, " .
                    "d2.ser_descr AS parent_ser_descr " .
             "FROM ( ( ${db_schema}series s1 " .
                      "LEFT JOIN ${db_schema}series s2 " .
                      "ON s1.series_id_parent = s2.series_id " .
                    ") LEFT JOIN ${db_schema}ser_descrs d1 " .
                    "ON s1.series_id = d1.series_id " .
                  ") LEFT JOIN ${db_schema}ser_descrs d2 " .
                  "ON s2.series_id = d2.series_id " .
             "WHERE ( d1.ser_descr_num IS NULL OR " .
                     "d1.ser_descr_num = 0 ) AND " .
                   "( d2.ser_descr_num = 0 OR d2.ser_descr_num IS NULL ) " .
             "ORDER BY basic_ser_descr";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    #       ,     
    # "  ",       
    # (      ,
    #     )
    if ( $query->param( 'enable_select' ) &&
         $query->param( 'caller_name') eq $module )
    {
      $can_view = 0;
      $can_delete = 0;
    }
    else
    {
      $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                               'user' => $user );
      $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                                 'user' => $user );
    }

    #     "/",     
    if ( $query->param( 'exp_imp' ) )
    {
      $can_import = import_enabled() && 
                    have_access( 'module' => $module, 'procedure' => 'IMPORT',
                                 'user' => $user );
    }
    #    public --   ,
    #   -- 
    else
    {
      $can_export = export_enabled() && 
                    have_access( 'module' => $module, 'procedure' => 'EXPORT',
                                 'user' => $user );
    }

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th>ID</th>\n";
    print "<th>ISSN</th>\n";
    print "<th>  /</th>\n";
    print "<th> </th>\n";
    print "<th>ID, ISSN     </th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete || $can_export ||
                                   $can_import );
    print "</tr>\n";

    #          
    #     ( ,   
    #  ) ...
    if ( $query->param( 'enable_select' ) )
    {
      # ...    JavaScript    
      #     Series (   Ser_descrs) 
      #    ...
      if ( $query->param( 'caller_name' ) eq 'SERIES' )
      {
        # ...  series_id_parent, parent_ser_issn  parent_ser_descr
        #   SERIES
        create_assign_values_func( 'series_id_parent', 'parent_ser_issn',
                                   'parent_ser_descr' );
      }
      elsif ( $query->param( 'caller_name' ) eq 'SER_DESCRS' )
      {
        # ...  series_id  series_issn   SER_DESCRS
        create_assign_values_func( 'series_id', 'series_issn' );
      }
    }

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #    /, ISSN, 
      #  /,  , , ISSN 
      #    
      # (  &nbsp;      :
      #    'series_issn'  'series_id_parent'  null,
      #     -)
      print "<td class=\"center\">" .
            $row[ $result->fnumber( 'series_id' ) ] . "</td>\n";
      print "<td>$row[ $result->fnumber( 'series_issn' ) ]&nbsp;</td>\n";

      #         
      #      ,  
      #  basic_ser_descr    
      if ( $query->param( 'enable_select' ) )
      {
        #        
        # / 
        #     , . . , 
        #   escapeHTML(), 
        # .    " "  
        #             "&#39;",      assign_values()
        #                ,   
        #                   -- 
        #             .
        # TODO.     .
        # TODO.   ,      
        #        "'" ( ),  
        #          ,   
        #       ,     
        #       .
        # $basic_ser_descr =~ s/\'/\\\'/g;
        $basic_ser_descr = 
          CGI::escapeHTML( $row[ $result->fnumber( 'basic_ser_descr' ) ] );

        print "<td>",
              qq{ <a class="command_link" href="javascript:void( 0 )" onclick=
                  "assign_values( 
                     $row[ $result->fnumber( 'series_id' ) ],
                     '$row[ $result->fnumber( 'series_issn' ) ]',
                     '$basic_ser_descr'
                   ); 
                   parent.opener.document.forms[ 0 ].subser_flag.checked =
                     true;
                  ">
                   $row[ $result->fnumber( 'basic_ser_descr' ) ]</a> },
              "</td>\n";
      }
      else
      {
        print "<td>$row[ $result->fnumber( 'basic_ser_descr' ) ]&nbsp;</td>\n";
      }
      print "<td>",
            $row[ $result->fnumber( 'subser_flag' ) ] eq 't' ? '' : '',
            "</td>\n";

      #    ,      
      #   ISSN   ,      
      print "<td>" .
            (
              ( $row[ $result->fnumber( 'series_id_parent' ) ] ) ? 
              "(" . $row[ $result->fnumber( 'series_id_parent' ) ] . ")" :
              ""
            ) . "&nbsp;\n" .
            (
              ( $row[ $result->fnumber( 'parent_ser_issn' ) ] ) ?
              "(" . $row[ $result->fnumber( 'parent_ser_issn' ) ] . ")" :
              ""
            ) . "&nbsp;\n" .
            "$row[ $result->fnumber( 'parent_ser_descr' ) ]&nbsp;\n" .
            "</td>\n";

      #   HTML-
      $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
              "series_id=" . $row[ $result->fnumber( 'series_id' ) ] .
              $add_params;

      #    /   
      print "<td>" if ( $can_view || $can_delete || $can_export ||
                        $can_import );
      print qq{ <a class="command_link" href="$script_name/view?$href"} .
            qq{ target="_self"></a> } . "\n" if $can_view;

      #    /
      print qq{ <a class="command_link" href="$script_name/delete?$href"} .
            qq{ onclick="$confirm_delete" } .
            qq{ target="_self"></a> } . "\n" if $can_delete;

      #   
      print qq{ <a class="command_link" href="$script_name/export?$href"} .
            qq{ onclick="$confirm_export"} .
            qq{ target="_blank"></A> } . "\n" if $can_export;

      #   
      print qq{ <a class="command_link" href="$script_name/import?$href"} .
            qq{ onclick="$confirm_import"} .
            qq{ target="_blank"></A> } . "\n" if $can_import;

      print "</td>" if ( $can_view || $can_delete || $can_export ||
                         $can_import );
      print "</tr>\n";
    }
    print "</table>\n";
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $series_id;             #   /
  my $command;               #      

  $series_id = $query->param( 'series_id' );

  #     /
  $command = "SELECT s1.*, s2.series_issn AS parent_ser_issn, " .
                    "d1.ser_descr AS basic_ser_descr, " .
                    "d2.ser_descr AS parent_ser_descr " .
             "FROM ( ( ${db_schema}series s1 " .
                      "LEFT JOIN ${db_schema}series s2 " .
                      "ON s1.series_id_parent = s2.series_id " .
                    ") LEFT JOIN ${db_schema}ser_descrs d1 " .
                    "ON s1.series_id = d1.series_id " .
                  ") LEFT JOIN ${db_schema}ser_descrs d2 " .
                  "ON s2.series_id = d2.series_id " .
             "WHERE ( d1.ser_descr_num IS NULL OR " .
                     "d1.ser_descr_num = 0 ) AND " .
                   "( d2.ser_descr_num = 0 OR " .
                     "d2.ser_descr_num IS NULL ) AND " .
                   "s1.series_id = '$series_id'"; 

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => "_self",
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "         " .
                     "/ " . $series_id,
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "series",
                       key => "series_id",
                       f_names => \@f_names,
                       f_special => [ 'subser_flag' ],
                       func_special => \&non_std_fields,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #         ,
    #   1        
    $fields{ 'series_id' } = get_next_key_value( 'series', 'series_id' );

    #   

    # 
    $fields{ 'comment' } = $CFG{ SERIES_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  #    "  /"
  #      get_next_key_value(),
  #     ,     ,
  # ..      UPDATE   
  print $query->hidden( -name => 'series_id',
                        -default => $fields{ 'series_id' }
                      ), "\n";

  #       ,     
  #           ,
  #        ,   
  #  ,     
  # . .    cities.pl.
  print $query->hidden( -name => 'enable_select' ), "\n";
  print $query->hidden( -name => 'caller_name' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th>  /</th>\n";
  print "<td>", $fields{ 'series_id' }, "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>ISSN,  /</th>\n";
  print "<td>",
        $query->textfield( -name => 'series_issn',
                           -default => $fields{ 'series_issn' },
                           -size => $CFG{ SERIES_ISSN_SIZE },
                           -maxlength => $CFG{ SERIES_ISSN_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  #          ,   
  #  -- 
  if ( $ref_row ne undef )
  {
    print "<tr>\n";
    print "<th>  /</th>\n";
    print "<td>",
          $query->textarea( -name => 'basic_ser_descr',
                            -default => $fields{ 'basic_ser_descr' },
                            -rows => $CFG{ SERIES_BASIC_SER_DESCR_ROWS },
                            -columns => $CFG{ SERIES_BASIC_SER_DESCR_COLS },
                            -readonly => 'readonly'
                          ),
          "</td>\n";
    print "</tr>\n";
  }

  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>",
        $query->checkbox( -name => 'subser_flag',
                          -checked => 
                             $fields{ 'subser_flag' } eq 't' ? '1' : '0',
                          -value => 'yes',
                          -label => ''
                        ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>   ()</th>\n";

  #      JavaScript,  
  #  series.pl   -  
  create_selection_func( func_name => 'select_parent_series',
                         module_name => 'series.pl',
                         caller_name => $module,
                         window_name => 'parent_series',
                         exp_imp => $query->param( 'exp_imp' ) );
  print "<td>",
        $query->textfield( -name => 'series_id_parent',
                           -default => $fields{ 'series_id_parent' },
                           -size => $CFG{ SERIES_ID_PARENT_SIZE },
                           -maxlength => $CFG{ SERIES_ID_PARENT_MAXLENGTH }
                         ),
        "&nbsp;&nbsp;",
        qq{ <a class="command_link" href="javascript:void( 0 )"} .
        qq{ onclick="select_parent_series()"></a>},
        "</td>\n";
  print "</tr>\n";

  #   ISSN     
  # (  )
  print "<tr>\n";
  print "<th>ISSN  </th>\n";
  print "<td>",
        $query->textfield( -name => 'parent_ser_issn',
                           -default => $fields{ 'parent_ser_issn' },
                           -size => $CFG{ SERIES_PARENT_SER_ISSN_SIZE },
                           -maxlength => 
                             $CFG{ SERIES_PARENT_SER_ISSN_MAXLENGTH },
                           -readonly => 'readonly'
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>   </th>\n";
  print "<td>",
        $query->textarea( -name => 'parent_ser_descr',
                          -default => $fields{ 'parent_ser_descr' },
                          -rows => $CFG{ SERIES_PARENT_SER_DESCR_ROWS },
                          -columns => $CFG{ SERIES_PARENT_SER_DESCR_COLS },
                          -readonly => 'readonly'
                        ),
        "</td>\n";
  print "</tr>\n";

  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment", "SERIES_COMMENT" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ SERIES_COMMENT_ROWS },
                          -columns => $CFG{ SERIES_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
  return ( 0 );
}

# -----------------------------------------------------------------------------
#   ,    
#  -      
# -----------------------------------------------------------------------------
sub non_std_fields
{
  # :
  my $fname = shift;  #  
                      #   -   ( 
                      #  ).      
  my $value;

  #      - 'subser_flag',
  #   bool,       
  $value = $query->param( $fname ) ? 'yes' : 'no';

  return ( $value );  
}
