#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :   "    ;
#            "
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'SPEC_MATER';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Spec_mater
my @f_names =
   ( 'obj_id',            #   
                          #  
     'bib_rec_num',       #  .    
                          # (    0)
     'spec_mat_num',      #       
                          #  .  ( 
                          #     
                          #      )
     'spec_mat_code',     #    
     'total_extent',      #     
                          # (, "378" (  ..))
     'orig_extent',       #    ,   
                          #   (, XXV ., 354 ., [10 .]) 
     'phys_add_info',     #     
     'orig_dimensions',   #  (    )
     'size_sheet',        #   ( ) (, 60x90)
     'part_sheet',        #   ( ) (, 1/16)
     'accomp_flag',       #   
     'accomp_title',      #   
     'accomp_obj_ID',     #    .
                          # ,    
                          #   
     'pack_code',         #   
     'comment'            # 
   );

$query = CGI->new();               #   CGI-

my $db_schema;                     #   ( /)

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              print_add_info => \&print_add_info,
              action => $script_name
            );

exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  if ( $query->param( 'spec_mat_num' ) !~ /^\d+$/ )
  {
    push( @error_messages, "      " .
          "   " );
  }

  if ( $query->param( 'spec_mat_code' ) !~ /^\d+$/ )
  {
    push( @error_messages, "      " .
          " " );
  }

  #     
  if ( $query->param( 'total_extent' ) !~ /^\d*$/ )
  {
    push( @error_messages, "     " );
  }

  if ( $query->param( 'orig_extent' ) eq '' )
  {
    push( @error_messages, "   (  ,    " .
          " )" );
  }

  if ( ( $query->param( 'size_sheet' ) !~ /^\d+x\d+$/ ) &&
       ( $query->param( 'size_sheet' ) !~ /^$/ )
     )
  {
    push( @error_messages, "        " .
          "  , , 60x90" );
  }

  if ( ( $query->param( 'part_sheet' ) !~ /^1\/\d+$/ ) &&
       ( $query->param( 'part_sheet' ) !~ /^$/ )
     )
  {
    push( @error_messages, "        " .
          "  , , 1/16" );
  }

  #     
  if ( $query->param( 'accomp_obj_id' ) !~ /^\d*$/ )
  {
    push( @error_messages, "    " .
          ". ,      " .
          " " );
  }

  if ( $query->param( 'pack_code' ) !~ /^\d+$/ )
  {
    push( @error_messages, "      " );
  }

  # DEBUG
  # print_params( $query );
  
  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }

  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => '  ()',
                    user => $user,
                    full_top => 'no'
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $spec_mat_num;       #     
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id       = $query->param( 'obj_id' );
  $bib_rec_num  = $query->param( 'bib_rec_num' );
  $spec_mat_num = $query->param( 'spec_mat_num' );
  $target_win   = $query->param( 'target_win' );

  #         
  $command = "DELETE FROM ${db_schema}spec_mater " .
             "WHERE obj_id = '$obj_id' AND " .
                   "bib_rec_num = '$bib_rec_num' AND " .
                   "spec_mat_num = '$spec_mat_num'";

  #   
  del_rec( query => $query,
           target => $target_win,
           create_top => \&create_top,
           print_add_info => \&print_add_info,
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#      ,   
#    
# -----------------------------------------------------------------------------
sub do_query
{
  # .        
  #              bib_recs.pl.

  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $bib_rec;            # . 
  my $target_win;         #      HTML-
  my( $result, $i );      #    
  my @row;                #      
  my $command;            #      
  my $href;               #   HTML-

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #  ,        
  my $alt_row = 1;

  $obj_id      = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );
  $bib_rec     = $query->param( 'bib_rec' );
  $target_win  = $query->param( 'target_win' );

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => $target_win );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  print_add_info(); #     

  #  ,    
  $bib_rec = CGI::escape( $bib_rec );

  #   HTML-
  $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
          "obj_id=$obj_id" .
          "&bib_rec_num=$bib_rec_num" .
          "&bib_rec=$bib_rec" .
          "&target_win=$target_win";

  #        
  # (    . . , 
  # ,    )
  $command = "SELECT m.*, mt.spec_mat_sname, mg.spec_mat_group_sname, " .
                    "p.pack_sname " .
             "FROM ${db_schema}spec_mater m, " .
                  "${db_schema}spec_mater_types mt, " .
                  "${db_schema}spec_mater_groups mg, " .
                  "${db_schema}pack_types p " .
             "WHERE m.obj_id = $obj_id AND " .
                   "m.bib_rec_num = $bib_rec_num AND " .
                   "m.spec_mat_code = mt.spec_mat_code AND " .
                   "mt.spec_mat_group_code = mg.spec_mat_group_code AND " .
                   "m.pack_code = p.pack_code " .
             "ORDER BY m.spec_mat_num";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                             'user' => $user );
    $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                               'user' => $user );

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th>    </th>\n";
    print "<th>  </th>\n";
    print "<th>   </th>\n";
    print "<th> </th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete );
    print "</tr>\n";

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #      ,  
      #    ,    
      #   
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( 'spec_mat_num' ) ]</td>\n";
      print "<td>$row[ $result->fnumber( 'spec_mat_sname' ) ]" .
            " (" . $row[ $result->fnumber( 'spec_mat_group_sname' ) ] . ")" .
            "</td>\n";
      print "<td>$row[ $result->fnumber( 'orig_extent' ) ]</td>\n";
      print "<td>$row[ $result->fnumber( 'pack_sname' ) ]</td>\n";

      #        
      print "<td>" if ( $can_view || $can_delete );
      print qq{<a class="command_link" href="$script_name/view?$href} .
            "&spec_mat_num=" . 
            $row[ $result->fnumber( 'spec_mat_num' ) ]  . "\"" .
            qq{ target="$target_win"></a>} if $can_view;
      print "\n" if $can_view;

      #     
      print qq{<a class="command_link" href="$script_name/delete?$href} .
            "&spec_mat_num=" . 
            $row[ $result->fnumber( 'spec_mat_num' ) ]  . "\"" .
            qq{ onclick="$confirm_delete"} .
            qq{ target="$target_win"></a>} if $can_delete;
      print "</td>\n" if ( $can_view || $can_delete );

      print "</tr>\n";
    }
    print "</table>\n";
  }

  #       
  #          "/"
  if ( ! $query->param( 'exp_imp' ) &&
       have_access( 'module' => $module, 'procedure' => 'ADD', 
                    'user' => $user ) )
  {
    print "<br />\n";
    print qq{<a class="command_link" href="$script_name/add?$href"} .
          qq{ target="$target_win"> </a>};
  }

  close_bottom();   #       
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $spec_mat_num;       #     
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id       = $query->param( 'obj_id' );
  $bib_rec_num  = $query->param( 'bib_rec_num' );
  $spec_mat_num = $query->param( 'spec_mat_num' );
  $target_win   = $query->param( 'target_win' );

  #     
  $command = "SELECT * " .
             "FROM ${db_schema}spec_mater " .
             "WHERE obj_id = $obj_id AND " .
                   "bib_rec_num = $bib_rec_num AND " .
                   "spec_mat_num = '$spec_mat_num'";

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => $target_win,
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "        : " .
                     "   .  - " .
                     $obj_id . ", " .
                     " .     - " .
                     $bib_rec_num . ", " .
                     "     - $spec_mat_num",
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "spec_mater",
                       key => "obj_id, bib_rec_num, " .
                              "spec_mat_num:spec_mat_num_begin",
                       f_names => \@f_names,
                       f_special => [ 'accomp_flag' ],
                       func_special => \&non_std_fields,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  #      (    
  #  . . )
  my( $ref_values_mat, $ref_labels_mat ) =
    popup_spec_mater_types_list( $db_schema );

  #      (    
  #  )
  my( $ref_values_pack, $ref_labels_pack ) =
    popup_pack_types_list( $db_schema );

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #        
    $fields{ 'obj_id' }      = $query->param( 'obj_id' );
    $fields{ 'bib_rec_num' } = $query->param( 'bib_rec_num' );

    #   

    #         .
    # 
    if ( $CFG{ SPEC_MATER_SPEC_MAT_NUM } )  #    . 
    {
      $fields{ 'spec_mat_num' } = $CFG{ SPEC_MATER_SPEC_MAT_NUM };
    }
    else
    {
      #      spec_mat_num  
      # ,   1      
      #    .    . 
      # (   obj_id  bib_rec_num   Spec_mater)
      $fields{ 'spec_mat_num' } = 
        get_next_key_value( 'spec_mater', 'spec_mat_num',
                            'obj_id = ' . $query->param( 'obj_id' ) . ' AND ' .
                            'bib_rec_num = ' . $query->param( 'bib_rec_num' )
                          );
    }

    #    
    $fields{ 'spec_mat_code' }   = $CFG{ SPEC_MATER_SPEC_MAT_CODE };

    #    ,      
    # (, XXV ., 354 ., [10 .])
    $fields{ 'orig_extent' }     = $CFG{ SPEC_MATER_ORIG_EXTENT };

    #     
    $fields{ 'phys_add_info' }   = $CFG{ SPEC_MATER_PHYS_ADD_INFO };

    #  (    )
    $fields{ 'orig_dimensions' } = $CFG{ SPEC_MATER_ORIG_DIMENSIONS };

    #   ( ) (, 60x90)
    $fields{ 'size_sheet' }      = $CFG{ SPEC_MATER_SIZE_SHEET };

    #   ( ) (, 1/16)
    $fields{ 'part_sheet' }      = $CFG{ SPEC_MATER_PART_SHEET };

    #   
    $fields{ 'accomp_flag' }     = $CFG{ SPEC_MATER_ACCOMP_FLAG };

    #   
    $fields{ 'accomp_title' }    = $CFG{ SPEC_MATER_ACCOMP_TITLE };

    #   
    $fields{ 'pack_code' }       = $CFG{ SPEC_MATER_PACK_CODE };

    # 
    $fields{ 'comment' }         = $CFG{ SPEC_MATER_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  #    "  
  #  "  " .   
  # "   ,     ,
  #     , ..    
  #  UPDATE   ,      INSERT
  # (     ,    
  #   ,      )
  print $query->hidden( -name => 'obj_id' ), "\n";
  print $query->hidden( -name => 'bib_rec_num' ), "\n";

  #     "    "
  # .      'begin'  ,
  #                   ,  
  #               (.  make_cmd   E_ARCH.pm.
  #             ..       ,   
  #              (, ,   ).
  print $query->hidden( -name => 'spec_mat_num_begin',
                        -default => $fields{ 'spec_mat_num' }
                      ), "\n";

  #      .  
  #  ,     add_rec()  update_rec()
  print $query->hidden( -name => 'bib_rec' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print_add_info();        #     

  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th>    </th>\n";
  print "<td>",
        $query->textfield( -name => 'spec_mat_num',
                           -default => $fields{ 'spec_mat_num' },
                           -size => $CFG{ SPEC_MATER_SPEC_MAT_NUM_SIZE },
                           -maxlength => 
                             $CFG{ SPEC_MATER_SPEC_MAT_NUM_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  #        labels  
  # ,    popup_spec_mater_types_list() 
  #  ,   -   
  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>",
        $query->popup_menu( -name => 'spec_mat_code',
                            -default => $fields{ 'spec_mat_code' },
                            -values => $ref_values_mat,
                            -labels => { @{ $ref_labels_mat } }
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>    <br />" .
            "(, \"378\" (  . .))</th>\n";
  print "<td>",
        $query->textfield( -name => 'total_extent',
                           -default => $fields{ 'total_extent' },
                           -size => $CFG{ SPEC_MATER_TOTAL_EXTENT_SIZE },
                           -maxlength => 
                             $CFG{ SPEC_MATER_TOTAL_EXTENT_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>   ,     <br />" .
            "(, XXV ., 354 ., [10 .])</th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].orig_extent",
                   "SPEC_MATER_ORIG_EXTENT" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'orig_extent',
                           -default => $fields{ 'orig_extent' },
                           -size => $CFG{ SPEC_MATER_ORIG_EXTENT_SIZE },
                           -maxlength => 
                             $CFG{ SPEC_MATER_ORIG_EXTENT_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>    </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].phys_add_info",
                   "SPEC_MATER_PHYS_ADD_INFO" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'phys_add_info',
                           -default => $fields{ 'phys_add_info' },
                           -size => $CFG{ SPEC_MATER_PHYS_ADD_INFO_SIZE },
                           -maxlength => 
                             $CFG{ SPEC_MATER_PHYS_ADD_INFO_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th><br />" .
        "(    )</th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].orig_dimensions",
                   "SPEC_MATER_ORIG_DIMENSIONS" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'orig_dimensions',
                           -default => $fields{ 'orig_dimensions' },
                           -size => $CFG{ SPEC_MATER_ORIG_DIMENSIONS_SIZE },
                           -maxlength => 
                             $CFG{ SPEC_MATER_ORIG_DIMENSIONS_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  ( )<br />" .
        "(, 60x90)</th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].size_sheet",
                   "SPEC_MATER_SIZE_SHEET", "REPLACE" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'size_sheet',
                           -default => $fields{ 'size_sheet' },
                           -size => $CFG{ SPEC_MATER_SIZE_SHEET_SIZE },
                           -maxlength => 
                             $CFG{ SPEC_MATER_SIZE_SHEET_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  ( )<br />" .
        "(, 1/16)</th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].part_sheet",
                   "SPEC_MATER_PART_SHEET", "REPLACE" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'part_sheet',
                           -default => $fields{ 'part_sheet' },
                           -size => $CFG{ SPEC_MATER_PART_SHEET_SIZE },
                           -maxlength => 
                             $CFG{ SPEC_MATER_PART_SHEET_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>",
        $query->checkbox( -name => 'accomp_flag',
                          -checked => 
                             $fields{ 'accomp_flag' } eq 't' ? '1' : '0',
                          -value => 'yes',
                          -label => ''
                        ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].accomp_title",
                   "SPEC_MATER_ACCOMP_TITLE" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'accomp_title',
                          -default => $fields{ 'accomp_title' },
                          -rows => $CFG{ SPEC_MATER_ACCOMP_TITLE_ROWS },
                          -columns => $CFG{ SPEC_MATER_ACCOMP_TITLE_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>   . , " .
            "     ".
            " </th>\n";
  print "<td>",
        $query->textfield( -name => 'accomp_obj_id',
                           -default => $fields{ 'accomp_obj_id' },
                           -size => $CFG{ SPEC_MATER_ACCOMP_OBJ_ID_SIZE },
                           -maxlength => 
                             $CFG{ SPEC_MATER_ACCOMP_OBJ_ID_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  #        labels  
  # ,    popup_pack_types_list() 
  #  ,   -   
  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>",
        $query->popup_menu( -name => 'pack_code',
                            -default => $fields{ 'pack_code' },
                            -values => $ref_values_pack,
                            -labels => { @{ $ref_labels_pack } }
                          ),
        "</td>\n";
  print "</tr>\n";

  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment",
                   "SPEC_MATER_COMMENT" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ SPEC_MATER_COMMENT_ROWS },
                          -columns => $CFG{ SPEC_MATER_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
    
  return ( 0 );
}

# -----------------------------------------------------------------------------
#   ,    
#  -      
# -----------------------------------------------------------------------------
sub non_std_fields
{
  # :
  my $fname = shift;  #  
                      #   -   ( 
                      #  ).      
  my $value;

  #      - 'accomp_flag',
  #   bool,       
  $value = $query->param( $fname ) ? 'yes' : 'no';

  return ( $value );  
}

# -----------------------------------------------------------------------------
#          
# -----------------------------------------------------------------------------
sub print_add_info
{
  #  .    
  print_bib_record( $query, "    ; " .
                            " " );
  return ( 0 );
}
