#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :   " ( )"
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'STOR_OBJS';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Stor_objs
my @f_names =
   ( 'obj_id',               #   
                             #  
     'stor_obj_num',         #     
                             #   . 
     'pers_org_flag',        #  "/"
                             # (1 - ; 2 - )
     'owner_pers_id',        #   ()
     'owner_org_id',         #   ()
     'phys_form_code',       #   ,  
                             #   
     'stor_obj_code',        #  ()  
                             # (,     )
     'stor_place',           #   (,   CD-ROM
                             # - (  )
     'stor_obj_add_info',    # .      
                             #    
     'stor_obj_defects',     #   
     'stor_obj_phys_cond',   #    
                             #    10- 
     'stor_obj_complete',    #   
     'acq_date',             #  
     'acq_date_precise',     #    
     'acq_date_note',        #    
     'acq_place_city',       #   (  )
     'acq_place_country',    #   ( )
                             # (,    
                             #   )
     'acq_way_code',         #   
     'stor_obj_price_curr',  #  ()    (
                             #      )
     'currency_code',        #  
     'exchange_rate',        #     
                             # (..  , 
                             #   1   )
     'stor_obj_price',       #    (   
                             #  )
     'stor_obj_price_note',  #    
     'acq_note',             # .   
     'remove_stor_obj_flag', #    
     'remove_stor_obj_note', # .     
     'comment'               # 
   );

my $db_schema;                     #   ( /)

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              print_add_info => \&print_add_info,
              action => $script_name
            );

exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  if ( $query->param( 'stor_obj_num' ) !~ /^\d+$/ )
  {
    push( @error_messages, "      " .
          "      . " );
  }

  if ( ! ( $query->param( 'pers_org_flag' ) eq '1' ||
           $query->param( 'pers_org_flag' ) eq '2'
         )
     )    
  {
    push( @error_messages, "   \"/" .
          "\"" );
  }

  if ( $query->param( 'owner_org_id' ) !~ /^\d+$/ )
  {
    push( @error_messages, "      " .
          "()" );
  }

  if ( $query->param( 'owner_pers_id' ) !~ /^\d+$/ )
  {
    push( @error_messages, "      " .
          "()" );
  }

  if ( $query->param( 'phys_form_code' ) eq '' )
  {
    push( @error_messages, "    ,   " .
          "  " );
  }

  if ( ! ( $query->param( 'stor_obj_phys_cond' ) =~ /^\d{1,2}$/ &&
           $query->param( 'stor_obj_phys_cond' ) >= 1 &&
           $query->param( 'stor_obj_phys_cond' ) <= 10
         )  
     )
  {
    push( @error_messages, "      " .
          "     10- " );
  }

  #   
  if ( $query->param( 'acq_date' ) ne '' &&
       ! date_is_correct( $query->param( 'acq_date' ) ) )
  {
    push( @error_messages, "    " );
  }

  #   
  if ( $query->param( 'acq_place_city' ) !~ /^\d*$/ )
  {
    push( @error_messages, "    " .
          "(  )" );
  }

  #   
  if ( $query->param( 'acq_place_country' ) !~ /^\d*$/ )
  {
    push( @error_messages, "    ( )" );
  }

  if ( $query->param( 'acq_way_code' ) eq '' )
  {
    push( @error_messages, "    " );
  }

  #    , ,    (   )
  if ( $query->param( 'stor_obj_price_curr' ) !~ /^(\d*|\d+\.\d{1,2})$/ )
  {
    push( @error_messages, "  ()   " .
          " (      )" );
  }

  if ( $query->param( 'currency_code' ) eq '' )
  {
    push( @error_messages, "   " );
  }

  #    , ,    (   )
  if ( $query->param( 'exchange_rate' ) !~ /^(\d*|\d+\.\d{1,5})$/ )
  {
    push( @error_messages, "     " .
          " " );
  }

  #    , ,    (   )
  if ( $query->param( 'stor_obj_price' ) !~ /^(\d*|\d+\.\d{1,2})$/ )
  {
    push( @error_messages, "  ()  " );
  }

  # .      ,  
  #             CHECK  Stor_objs.    ,
  #                 ,  .

  # DEBUG
  # print_params( $query );
  
  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }

  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => '  ()',
                    user => $user,
                    full_top => 'no'
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $obj_id;             #    . 
  my $stor_obj_num;       #     
                          #   . 
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id       = $query->param( 'obj_id' );
  $stor_obj_num = $query->param( 'stor_obj_num' );
  $target_win   = $query->param( 'target_win' );

  #         
  $command = "DELETE FROM ${db_schema}stor_objs " .
             "WHERE obj_id = '$obj_id' AND " .
                   "stor_obj_num = '$stor_obj_num'";

  #   
  del_rec( query => $query,
           target => $target_win,
           create_top => \&create_top,
           print_add_info => \&print_add_info,
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#    ( )   
# -----------------------------------------------------------------------------
sub do_query
{
  # .        
  #              bib_recs.pl.

  my $obj_id;             #    . 
  my $bib_rec;            # . 
  my $target_win;         #      HTML-
  my( $result, $i );      #    
  my @row;                #      
  my $command;            #      
  my $href;               #   HTML-
  my $owner;              #   

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #  ,        
  my $alt_row = 1;

  $obj_id     = $query->param( 'obj_id' );
  $bib_rec    = $query->param( 'bib_rec' );
  $target_win = $query->param( 'target_win' );

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => $target_win );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  print_add_info(); #     

  #  ,    
  $bib_rec = CGI::escape( $bib_rec );

  #   HTML-
  $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
          "obj_id=$obj_id" .
          "&bib_rec=$bib_rec" .
          "&target_win=$target_win";

  #         
  # (    -, 
  # -    .  )
  $command = "SELECT s.*, p.pers_name, o.org_sname, f.phys_form_sname " .
             "FROM ${db_schema}stor_objs s, ${db_schema}persons p, " .
                  "${db_schema}orgs o, ${db_schema}phys_form_types f " .
             "WHERE s.obj_id = $obj_id AND " .
                   "s.owner_pers_id = p.pers_id AND " .
                   "s.owner_org_id = o.org_id AND " .
                   "s.phys_form_code = f.phys_form_code " .
             "ORDER BY s.stor_obj_num";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                             'user' => $user );
    $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                               'user' => $user );

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th>   </th>\n";
    print "<th></th>\n";
    print "<th> </th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete );
    print "</tr>\n";

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #    ,    
      # .   
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( 'stor_obj_num' ) ]</td>\n";

      #  
      
      # 
      if ( $row[ $result->fnumber( 'pers_org_flag' ) ] == 2 )
      {
        $owner = $row[ $result->fnumber( 'org_sname' ) ];
      }
      # 
      else       # ( $row[ $result->fnumber( 'pers_org_flag' ) ] == 1 )
      {
        $owner = $row[ $result->fnumber( 'pers_name' ) ];
      }

      print "<td>$owner</td>\n";      
      print "<td>$row[ $result->fnumber( 'phys_form_sname' ) ]</td>\n";

      #         
      print "<td>" if ( $can_view || $can_delete );
      print qq{<a class="command_link" href="$script_name/view?$href} .
            "&stor_obj_num=" .
            $row[ $result->fnumber( 'stor_obj_num' ) ] . "\"" .
            qq{ target="$target_win"></a>} if $can_view;
      print "\n" if $can_view;

      #      
      print qq{<a class="command_link" href="$script_name/delete?$href} .
            "&stor_obj_num=" .
            $row[ $result->fnumber( 'stor_obj_num' ) ] . "\"" .
            qq{ onclick="$confirm_delete"} .
            qq{ target="$target_win"></a>} if $can_delete;
      print "</td>\n" if ( $can_view || $can_delete );

      print "</tr>\n";
    }
    print "</table>\n";
  }

  #        
  #          "/"
  if ( ! $query->param( 'exp_imp' ) &&
       have_access( 'module' => $module, 'procedure' => 'ADD', 
                    'user' => $user ) )
  {
    print "<br />\n";
    print qq{<a class="command_link" href="$script_name/add?$href"} .
          qq{ target="$target_win"> </a>};
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $obj_id;             #    . 
  my $stor_obj_num;       #     
                          #   . 
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id       = $query->param( 'obj_id' );
  $stor_obj_num = $query->param( 'stor_obj_num' );
  $target_win   = $query->param( 'target_win' );

  #      
  # (    -  
  # -;     ,  
  #  :   -       Stor_objs,
  #   -       Cities,   
  # Stor_objs       )
  $command = "SELECT s.*, p.pers_name, o.org_sname, ci.city_sname, " .
                    "co1.country_sname as country_sname_acq, " .
                    "co2.country_sname as country_sname_city " .
             "FROM ${db_schema}stor_objs s, ${db_schema}persons p, " .
                  "${db_schema}orgs o, ${db_schema}cities ci, " .
                  "${db_schema}countries co1, ${db_schema}countries co2 " .
             "WHERE s.obj_id = '$obj_id' AND " .
                   "s.stor_obj_num = '$stor_obj_num' AND " .
                   "s.owner_pers_id = p.pers_id AND " .
                   "s.owner_org_id = o.org_id AND " .
                   "s.acq_place_city = ci.city_code AND " .
                   "s.acq_place_country = co1.country_code AND " .
                   "ci.country_code = co2.country_code";

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => $target_win,
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "        : " .
                     "   .  - " .
                     $obj_id . ", " .
                     "    - $stor_obj_num",
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "stor_objs",
                       key => "obj_id, stor_obj_num:stor_obj_num_begin",
                       f_names => \@f_names,
                       f_special => [ 'acq_date', 'stor_obj_complete',
                                      'remove_stor_obj_flag' ],
                       func_special => \&non_std_fields,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  #      (    
  #   ,     )
  my( $ref_values_phys, $ref_labels_phys ) =
    popup_phys_form_types_list( $db_schema );

  #      (    
  #    )
  my( $ref_values_acq, $ref_labels_acq ) = popup_acq_ways_list( $db_schema );

  #      (    
  # )
  my( $ref_values_cur, $ref_labels_cur ) = popup_currencies_list( $db_schema );

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
    # "   "   , 
    #       null
    $fields{ 'acq_date_precise' } = '' 
      if $fields{ 'acq_date_precise' } eq undef;
  }
  else                      #      
  {
    #       
    $fields{ 'obj_id' } = $query->param( 'obj_id' );

    #   

    #        . 
    if ( $CFG{ STOR_OBJS_STOR_OBJ_NUM } )  #    . 
    {
      $fields{ 'stor_obj_num' } = $CFG{ STOR_OBJS_STOR_OBJ_NUM };
    }
    else
    {
      #      stor_obj_num  
      # ,   1      
      #    .  (   obj_id 
      #   stor_objs)
      $fields{ 'stor_obj_num' } = 
        get_next_key_value( 'stor_objs', 'stor_obj_num',
                            'obj_id = ' . $query->param( 'obj_id' ) );
    }

    #  "/"
    $fields{ 'pers_org_flag' }        = $CFG{ STOR_OBJS_PERS_ORG_FLAG };

    #   ()
    $fields{ 'owner_pers_id' }        = $CFG{ STOR_OBJS_OWNER_PERS_ID };

    #   ()
    $fields{ 'owner_org_id' }         = $CFG{ STOR_OBJS_OWNER_ORG_ID };

    #   ,     
    $fields{ 'phys_form_code' }       = $CFG{ STOR_OBJS_PHYS_FORM_CODE };

    #  ()   (,   
    #  )
    $fields{ 'stor_obj_code' }        = $CFG{ STOR_OBJS_STOR_OBJ_CODE };

    #  
    $fields{ 'stor_place' }           = $CFG{ STOR_OBJS_STOR_PLACE };

    # .   .       
    $fields{ 'stor_obj_add_info' }    = $CFG{ STOR_OBJS_STOR_OBJ_ADD_INFO };

    #   
    $fields{ 'stor_obj_defects' }     = $CFG{ STOR_OBJS_STOR_OBJ_DEFECTS };

    #   .     10- 
    $fields{ 'stor_obj_phys_cond' }   = $CFG{ STOR_OBJS_STOR_OBJ_PHYS_COND };

    #   
    $fields{ 'stor_obj_complete' }    = $CFG{ STOR_OBJS_STOR_OBJ_COMPLETE };

    #  
    $fields{ 'acq_date' }             = $CFG{ STOR_OBJS_ACQ_DATE };

    #    
    $fields{ 'acq_date_precise' }     = $CFG{ STOR_OBJS_ACQ_DATE_PRECISE };

    #    
    $fields{ 'acq_date_note' }        = $CFG{ STOR_OBJS_ACQ_DATE_NOTE };

    #   (  )
    $fields{ 'acq_place_city' }       = $CFG{ STOR_OBJS_ACQ_PLACE_CITY };

    #   ( )
    $fields{ 'acq_place_country' }    = $CFG{ STOR_OBJS_ACQ_PLACE_COUNTRY };

    #   
    $fields{ 'acq_way_code' }         = $CFG{ STOR_OBJS_ACQ_WAY_CODE };

    #  ()    (   
    #   )
    $fields{ 'stor_obj_price_curr' }  = $CFG{ STOR_OBJS_STOR_OBJ_PRICE_CURR };

    #  
    $fields{ 'currency_code' }        = $CFG{ STOR_OBJS_CURRENCY_CODE };

    #     
    $fields{ 'exchange_rate' }        = $CFG{ STOR_OBJS_EXCHANGE_RATE };

    #    (     )
    $fields{ 'stor_obj_price' }       = $CFG{ STOR_OBJS_STOR_OBJ_PRICE };

    #    
    $fields{ 'stor_obj_price_note' }  = $CFG{ STOR_OBJS_STOR_OBJ_PRICE_NOTE };

    # .   
    $fields{ 'acq_note' }             = $CFG{ STOR_OBJS_ACQ_NOTE };

    #    
    $fields{ 'remove_stor_obj_flag' } = $CFG{ STOR_OBJS_REMOVE_STOR_OBJ_FLAG };

    # .     
    $fields{ 'remove_stor_obj_note' } = $CFG{ STOR_OBJS_REMOVE_STOR_OBJ_NOTE };

    # 
    $fields{ 'comment' }              = $CFG{ STOR_OBJS_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript">
  <!--
  //          
  //      " '/'"
  function on_change_pers_org_flag()
  {
    //   "" (  -- 1)
    if ( document.forms[ 0 ].pers_org_flag.selectedIndex == 0 )
    {
      document.forms[ 0 ].owner_org_id.value = 0; // 0 --  
      document.forms[ 0 ].org_sname.value = '';           //  
      document.forms[ 0 ].owner_org_id.disabled = true;   //  
      document.forms[ 0 ].org_sname.disabled = true;      //  
      document.forms[ 0 ].owner_pers_id.disabled = false; //  
      document.forms[ 0 ].pers_name.disabled = false;     //  
    }
    //   "" (  -- 2)
    else if ( document.forms[ 0 ].pers_org_flag.selectedIndex == 1 )
    {
      document.forms[ 0 ].owner_pers_id.value = 0; // 0 --  
      document.forms[ 0 ].pers_name.value = '';           //  
      document.forms[ 0 ].owner_pers_id.disabled = true;  //  
      document.forms[ 0 ].pers_name.disabled = true;      //  
      document.forms[ 0 ].owner_org_id.disabled = false;  //  
      document.forms[ 0 ].org_sname.disabled = false;     //  
    }
  }
  //-->
  </script>
END_OF_SCRIPT
  ;

  #    "  
  #  "   ,   
  #  ,     , ..   
  #   UPDATE   ,    
  #  INSERT (     ,   
  #    ,      )
  print $query->hidden( -name => 'obj_id' ), "\n";

  #     "    
  #   . "
  # .      'begin'  ,
  #                   ,  
  #               (.  make_cmd   E_ARCH.pm).
  #             ..       ,   
  #              (, ,   ).
  print $query->hidden( -name => 'stor_obj_num_begin',
                        -default => $fields{ 'stor_obj_num' }
                      ), "\n";

  #      .  
  #  ,     add_rec()  update_rec()
  print $query->hidden( -name => 'bib_rec' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print_add_info();         #     

  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th>   </th>\n";
  print "<td>",
        $query->textfield( -name => 'stor_obj_num',
                           -default => $fields{ 'stor_obj_num' },
                           -size => $CFG{ STOR_OBJS_STOR_OBJ_NUM_SIZE },
                           -maxlength =>
                             $CFG{ STOR_OBJS_STOR_OBJ_NUM_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> \"/\"</th>\n";
  print "<td>",
        $query->popup_menu( -name => 'pers_org_flag',
                            -default => $fields{ 'pers_org_flag' },
                            -values => [ '1', '2' ],
                            -labels => { '1' => '',
                                         '2' => '' },
                            -onchange => "on_change_pers_org_flag()"
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> &mdash;  (  . . .)</th>\n";

  #      JavaScript,  
  # - persons.pl
  create_selection_func( func_name => 'select_person',
                         module_name => 'persons.pl',
                         caller_name => $module,
                         window_name => 'persons',
                         exp_imp => $query->param( 'exp_imp' ) );

  #     (  )
  print "<td>";

  #   ()     
  #     (,   );
  #  JavaScript-  :   create_hot_help()
  #  HTML-,      VALUE,    
  # HTML-,      ,    
  #  NAME       " " 
  create_hot_help( "document.forms[ 0 ].owner_pers_id",
                   "STOR_OBJS_OWNER_PERS_ID", "REPLACE",
                   "var str; if (this.value) str = this.value;
                             else str = this.name;
                   document.forms[ 0 ].pers_name.value = str; " )
    if $CFG{ HOT_HELP_IS_ON };

  #     owner_pers_id  pers_name
  my @owner_pers_id_params = ( '-name', 'owner_pers_id',
                               '-default', $fields{ 'owner_pers_id' },
                               '-size', $CFG{ STOR_OBJS_OWNER_PERS_ID_SIZE },
                               '-maxlength', 
                                 $CFG{ STOR_OBJS_OWNER_PERS_ID_MAXLENGTH }
                             );
  my @pers_name_params = ( '-name', 'pers_name',
                           '-default', $fields{ 'pers_name' },
                           '-size', $CFG{ STOR_OBJS_PERS_NAME_SIZE },
                           '-maxlength', $CFG{ STOR_OBJS_PERS_NAME_MAXLENGTH },
                           '-readonly', 'readonly'
                         );  
  #   -- "" (2),      
  if ( $fields{ 'pers_org_flag' } == 2 )
  {
    push( @owner_pers_id_params, '-disabled', 'disabled' );
    push( @pers_name_params, '-disabled', 'disabled' );
  }

  print $query->textfield( @owner_pers_id_params ), "&nbsp;&nbsp;",
        $query->textfield( @pers_name_params ), "&nbsp;&nbsp;",
        qq{ <a class="command_link" href="javascript:void( 0 )" 
            onclick=
            "if ( document.forms[ 0 ].owner_pers_id.disabled == false )
               select_person();
             else
               window.alert( ' .  ' );
            ">} . "</a>",
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> &mdash;  (  )</th>\n";

  #      JavaScript,  
  # - orgs.pl
  create_selection_func( func_name => 'select_org',
                         module_name => 'orgs.pl',
                         caller_name => $module,
                         window_name => 'orgs',
                         exp_imp => $query->param( 'exp_imp' ) );

  #     
  # (  )
  print "<td>";

  #   ()     
  #     (,   );
  #  JavaScript-  :   create_hot_help()
  #  HTML-,      VALUE,    
  # HTML-,      ,    
  #  NAME       " "
  create_hot_help( "document.forms[ 0 ].owner_org_id",
                   "STOR_OBJS_OWNER_ORG_ID", "REPLACE",
                   "var str; if (this.value) str = this.value;
                             else str = this.name;
                   document.forms[ 0 ].org_sname.value = str; " )
    if $CFG{ HOT_HELP_IS_ON };

  #     owner_org_id  org_sname
  my @owner_org_id_params = ( '-name', 'owner_org_id',
                              '-default', $fields{ 'owner_org_id' },
                               '-size', $CFG{ STOR_OBJS_OWNER_ORG_ID_SIZE },
                               '-maxlength', 
                                 $CFG{ STOR_OBJS_OWNER_ORG_ID_MAXLENGTH }
                            );
  my @org_sname_params = ( '-name', 'org_sname',
                           '-default', $fields{ 'org_sname' },
                           '-size', $CFG{ STOR_OBJS_OWNER_ORG_SNAME_SIZE },
                           '-maxlength', 
                             $CFG{ STOR_OBJS_OWNER_ORG_SNAME_MAXLENGTH },
                           '-readonly', 'readonly'
                         );
  #   -- "" (1),      
  if ( $fields{ 'pers_org_flag' } == 1 )
  {
    push( @owner_org_id_params, '-disabled', 'disabled' );
    push( @org_sname_params, '-disabled', 'disabled' );
  }

  print $query->textfield( @owner_org_id_params ), "&nbsp;&nbsp;",
        $query->textfield( @org_sname_params ), "&nbsp;&nbsp;",
        qq{ <a class="command_link" href="javascript:void( 0 )"
            onclick=
            "if ( document.forms[ 0 ].owner_org_id.disabled == false )
               select_org();
             else
               window.alert( ' .  ' );
            ">} . "</a>",
        "</td>\n";
  print "</tr>\n";

  #        labels  
  # ,    popup_phys_form_types_list() 
  #  ,   -   
  print "<tr>\n";
  print "<th> ,   " .
            "  </th>\n";
  print "<td>",
        $query->popup_menu( -name => 'phys_form_code',
                            -default => $fields{ 'phys_form_code' },
                            -values => $ref_values_phys,
                            -labels => { @{ $ref_labels_phys } }
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> ()  <br />" .
            "(,     )<br />" .
            "(     )</th>\n";
  print "<td>";
  
  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].stor_obj_code",
                   "STOR_OBJS_STOR_OBJ_CODE" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'stor_obj_code',
                           -default => $fields{ 'stor_obj_code' },
                           -size => $CFG{ STOR_OBJS_STOR_OBJ_CODE_SIZE },
                           -maxlength =>
                             $CFG{ STOR_OBJS_STOR_OBJ_CODE_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> <br />" .
            "( DVD-,    ;<br />" .
            "     . .)</th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].stor_place", "STOR_OBJS_STOR_PLACE" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'stor_place',
                          -default => $fields{ 'stor_place' },
                          -rows => $CFG{ STOR_OBJS_STOR_PLACE_ROWS },
                          -columns => $CFG{ STOR_OBJS_STOR_PLACE_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>       " .
            "   <br />" .
            "(,     ;  , " .
            ". .     )</th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].stor_obj_add_info",
                   "STOR_OBJS_STOR_OBJ_ADD_INFO" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'stor_obj_add_info',
                          -default => $fields{ 'stor_obj_add_info' },
                          -rows => $CFG{ STOR_OBJS_STOR_OBJ_ADD_INFO_ROWS },
                          -columns => $CFG{ STOR_OBJS_STOR_OBJ_ADD_INFO_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  <br />" .
            "( ,    , " .
            "   . .)</th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].stor_obj_defects",
                   "STOR_OBJS_STOR_OBJ_DEFECTS" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'stor_obj_defects',
                          -default => $fields{ 'stor_obj_defects' },
                          -rows => $CFG{ STOR_OBJS_STOR_OBJ_DEFECTS_ROWS },
                          -columns => $CFG{ STOR_OBJS_STOR_OBJ_DEFECTS_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>     </th>\n";
  print "<td>",
        $query->popup_menu( -name => 'stor_obj_phys_cond',
                            -default => $fields{ 'stor_obj_phys_cond' },
                            -values => [ '1', '2', '3', '4', '5',
                                         '6', '7', '8', '9', '10' ]
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  <br />" .
            "('' - , ,   ; " .
            "     \"  " .
            "\")</th>\n";
  print "<td>",
        $query->checkbox( -name => 'stor_obj_complete',
                          -checked => 
                             $fields{ 'stor_obj_complete' } eq 't' ? '1' : '0',
                          -value => 'yes',
                          -label => ''
                        ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> <br />" .
            "(      , " .
            "     ,    " .
            "  &mdash;    ,   " .
            " ,    )</th>\n";
  print "<td>";

  #   ()     
  #     (,   )
  create_hot_help( "document.forms[ 0 ].acq_date",
                   "STOR_OBJS_ACQ_DATE", "REPLACE" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'acq_date',
                           -default =>
                              date_for_display( $fields{ 'acq_date' } ),
                           -size => $CFG{ STOR_OBJS_ACQ_DATE_SIZE },
                           -maxlength => $CFG{ STOR_OBJS_ACQ_DATE_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>   </th>\n";
  print "<td>",
        $query->popup_menu( -name => 'acq_date_precise',
                            -default => $fields{ 'acq_date_precise' },
                            -values => [ 't', 'f', '' ],
                            -labels => { 't' => ' ',
                                         'f' => ' ',
                                         ''  => '  ' }
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>   </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].acq_date_note",
                   "STOR_OBJS_ACQ_DATE_NOTE" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'acq_date_note',
                           -default => $fields{ 'acq_date_note' },
                           -size => $CFG{ STOR_OBJS_ACQ_DATE_NOTE_SIZE },
                           -maxlength =>
                             $CFG{ STOR_OBJS_ACQ_DATE_NOTE_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  (    , " .
        " )</th>\n";

  #      JavaScript,  
  # - cities.pl
  create_selection_func( func_name => 'select_city',
                         module_name => 'cities.pl',
                         caller_name => $module,
                         window_name => 'cities',
                         exp_imp => $query->param( 'exp_imp' ) );

  #       
  # (  )
  print "<td>";
  
  #   ()     
  #     (,   );
  #  JavaScript-  :   create_hot_help()
  #  HTML-,      VALUE,    
  # HTML-,      ,    
  #  NAME       " ";
  #     (  create_hot_help()  
  #        );
  #  ,   "  ( )" 
  # " " (   )
  create_hot_help( "document.forms[ 0 ].acq_place_city",
                   "STOR_OBJS_ACQ_PLACE_CITY", "REPLACE",
                   "var str; if (this.value) str = this.value;
                             else str = this.name;
                   document.forms[ 0 ].city_sname.value = str;
                   document.forms[ 0 ].country_sname_city.value = '';
                   document.forms[ 0 ].acq_place_country.value = 0;
                   document.forms[ 0 ].country_sname_acq.value = ''; " )
    if $CFG{ HOT_HELP_IS_ON };
  
  print $query->textfield( -name => 'acq_place_city',
                           -default => $fields{ 'acq_place_city' },
                           -size => $CFG{ STOR_OBJS_ACQ_PLACE_CITY_SIZE },
                           -maxlength =>
                             $CFG{ STOR_OBJS_ACQ_PLACE_CITY_MAXLENGTH }
                         ),
        "&nbsp;&nbsp;",
        $query->textfield( -name => 'city_sname',
                           -default => $fields{ 'city_sname' },
                           -size => $CFG{ STOR_OBJS_CITY_SNAME_SIZE },
                           -maxlength =>
                             $CFG{ STOR_OBJS_CITY_SNAME_MAXLENGTH },
                           -readonly => 'readonly'
                         ),
        "&nbsp;&nbsp;",
        $query->textfield( -name => 'country_sname_city',
                           -default => $fields{ 'country_sname_city' },
                           -size => $CFG{ STOR_OBJS_COUNTRY_SNAME_CITY_SIZE },
                           -maxlength =>
                             $CFG{ STOR_OBJS_COUNTRY_SNAME_CITY_MAXLENGTH },
                           -readonly => 'readonly'
                         ),
        "&nbsp;&nbsp;",
        qq{ <a class="command_link" href="javascript:void( 0 )" 
             onclick="select_city();
                      document.forms[ 0 ].acq_place_country.value = 0;
                      document.forms[ 0 ].country_sname_acq.value = ''; ">
          } . "</a>",
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  (   )<br />" .
            "(,     " .
            "  )</th>\n";

  #      JavaScript,  
  # - countries.pl
  create_selection_func( func_name => 'select_country',
                         module_name => 'countries.pl',
                         caller_name => $module,
                         window_name => 'countries',
                         exp_imp => $query->param( 'exp_imp' ) );
  #      (  )
  print "<td>";
  
  #   ()     
  #     (,   );
  #  JavaScript-  :   create_hot_help()
  #  HTML-,      VALUE,    
  # HTML-,      ,    
  #  NAME       " ";
  #  ,   "  (  )",
  # " "  " " (  )
  create_hot_help( "document.forms[ 0 ].acq_place_country",
                   "STOR_OBJS_ACQ_PLACE_COUNTRY", "REPLACE",
                   "var str; if (this.value) str = this.value;
                             else str = this.name;
                   document.forms[ 0 ].country_sname_acq.value = str;
                   document.forms[ 0 ].acq_place_city.value = 0;
                   document.forms[ 0 ].city_sname.value = '';
                   document.forms[ 0 ].country_sname_city.value = ''; " )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'acq_place_country',
                           -default => $fields{ 'acq_place_country' },
                           -size => $CFG{ STOR_OBJS_ACQ_PLACE_COUNTRY_SIZE },
                           -maxlength =>
                             $CFG{ STOR_OBJS_ACQ_PLACE_COUNTRY_MAXLENGTH }
                         ),
        "&nbsp;&nbsp;",
        $query->textfield( -name => 'country_sname_acq',
                           -default => $fields{ 'country_sname_acq' },
                           -size => $CFG{ STOR_OBJS_COUNTRY_SNAME_ACQ_SIZE },
                           -maxlength =>
                             $CFG{ STOR_OBJS_COUNTRY_SNAME_ACQ_MAXLENGTH },
                           -readonly => 'readonly'
                         ),
        "&nbsp;&nbsp;",
        qq{ <a class="command_link" href="javascript:void( 0 )"
             onclick="select_country(); 
                      document.forms[ 0 ].acq_place_city.value = 0;
                      document.forms[ 0 ].city_sname.value = '';
                      document.forms[ 0 ].country_sname_city.value = '';">
          } . "</a>",
        "</td>\n";
  print "</tr>\n";

  #        labels  
  # ,    popup_acq_ways_list() 
  #  ,   -   
  print "<tr>\n";
  print "<th>   </th>\n";
  print "<td>",
        $query->popup_menu( -name => 'acq_way_code',
                            -default => $fields{ 'acq_way_code' },
                            -values => $ref_values_acq,
                            -labels => { @{ $ref_labels_acq } }
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> ()   <br />" .
            "(      )</th>\n";
  print "<td>";
  
  #   ()     
  #     (,   )
  create_hot_help( "document.forms[ 0 ].stor_obj_price_curr",
                   "STOR_OBJS_STOR_OBJ_PRICE_CURR", "REPLACE" )
    if $CFG{ HOT_HELP_IS_ON };
  
  print $query->textfield( -name => 'stor_obj_price_curr',
                           -default => $fields{ 'stor_obj_price_curr' },
                           -size => $CFG{ STOR_OBJS_STOR_OBJ_PRICE_CURR_SIZE },
                           -maxlength =>
                             $CFG{ STOR_OBJS_STOR_OBJ_PRICE_CURR_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  #        labels  
  # ,    popup_currencies_list() 
  #  ,   -   
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>",
        $query->popup_menu( -name => 'currency_code',
                            -default => $fields{ 'currency_code' },
                            -values => $ref_values_cur,
                            -labels => { @{ $ref_labels_cur } }
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>    <br />" .
            "(     )</th>\n";
  print "<td>";

  #   ()     
  #     (,   )
  create_hot_help( "document.forms[ 0 ].exchange_rate",
                   "STOR_OBJS_EXCHANGE_RATE", "REPLACE" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'exchange_rate',
                           -default => $fields{ 'exchange_rate' },
                           -size => $CFG{ STOR_OBJS_EXCHANGE_RATE_SIZE },
                           -maxlength =>
                             $CFG{ STOR_OBJS_EXCHANGE_RATE_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>  <br />" .
            "(     )</th>\n";
  print "<td>";

  #   ()     
  #     (,   )
  create_hot_help( "document.forms[ 0 ].stor_obj_price",
                   "STOR_OBJS_STOR_OBJ_PRICE", "REPLACE" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'stor_obj_price',
                           -default => $fields{ 'stor_obj_price' },
                           -size => $CFG{ STOR_OBJS_STOR_OBJ_PRICE_SIZE },
                           -maxlength =>
                             $CFG{ STOR_OBJS_STOR_OBJ_PRICE_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>   </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].stor_obj_price_note",
                   "STOR_OBJS_STOR_OBJ_PRICE_NOTE" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textfield( -name => 'stor_obj_price_note',
                           -default => $fields{ 'stor_obj_price_note' },
                           -size => $CFG{ STOR_OBJS_STOR_OBJ_PRICE_NOTE_SIZE },
                           -maxlength =>
                             $CFG{ STOR_OBJS_STOR_OBJ_PRICE_NOTE_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>   </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].acq_note", "STOR_OBJS_ACQ_NOTE" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'acq_note',
                          -default => $fields{ 'acq_note' },
                          -rows => $CFG{ STOR_OBJS_ACQ_NOTE_ROWS },
                          -columns => $CFG{ STOR_OBJS_ACQ_NOTE_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>   </th>\n";
  print "<td>",
        $query->checkbox( -name => 'remove_stor_obj_flag',
                          -checked => 
                             $fields{ 'remove_stor_obj_flag' } eq 't' ?
                                                               '1' : '0',
                          -value => 'yes',
                          -label => ''
                        ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>     </th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].remove_stor_obj_note",
                   "STOR_OBJS_REMOVE_STOR_OBJ_NOTE" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'remove_stor_obj_note',
                          -default => $fields{ 'remove_stor_obj_note' },
                          -rows => $CFG{ STOR_OBJS_REMOVE_STOR_OBJ_NOTE_ROWS },
                          -columns =>
                            $CFG{ STOR_OBJS_REMOVE_STOR_OBJ_NOTE_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";

  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";

  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment", "STOR_OBJS_COMMENT" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ STOR_OBJS_COMMENT_ROWS },
                          -columns => $CFG{ STOR_OBJS_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
  return ( 0 );
}

# -----------------------------------------------------------------------------
#   ,    
#  -      
# -----------------------------------------------------------------------------
sub non_std_fields
{
  # :
  my $fname = shift;  #  
                      #   -   ( 
                      #  ).      
  my $value;
  
  #  
  if ( $fname eq 'acq_date' )
  {
    $value = date_for_db( $query->param( $fname ) );
  }
  #        
  elsif ( $fname eq 'stor_obj_complete' || $fname eq 'remove_stor_obj_flag' )
  {
    #     bool,    
    #   
    $value = $query->param( $fname ) ? 'yes' : 'no';
  }

  return ( $value );  
}

# -----------------------------------------------------------------------------
#          
# -----------------------------------------------------------------------------
sub print_add_info
{
  #  .    
  print_bib_record( $query, " ( )" );
  
  return ( 0 );
}
