#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :  " "
# :   ""
# :     . .
# :     15.04.2012
# :   0.6
# -----------------------------------------------------------------------------

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use Pg;                          #    PostgreSQL

use E_ARCH;                      #  ,  

#     
$SIG{ __DIE__ } = \&CGI::Carp::confess;

my $query;                       # CGI-
my $script_name;                 #    ( )

#    (    
#      )
my $module = 'TITLES';

#  ,   (   REMOTE_USER)
my $user = get_user_name(); 

#     Titles
my @f_names =
   ( 'obj_id',           #   
                         #  
     'bib_rec_num',      #  .    
                         # (    0)
     'title_type_code',  #    (1 - , 2 - ,
                         # 3 - , 4 -  (  ))
     'title_num',        #   (  ,
                         #     )
     'obj_title',        # 
     'lang_code',        #    (1 -   )
     'process_code',     #    
     'private_title',    #     ()
     'obj_title_info',   # ,   
                         # (  ":")
     'comment'           # 
   );

my $db_schema;                     #   ( /)

#   
# TODO -     Title_types?!  !
my %title_types = ( '1' => '',
                    '2' => '',
                    '3' => '',
                    '4' => ' ( . .)'
                  );

$query = CGI->new();               #   CGI-

#    
select( STDERR ); 
$| = 1;
select( STDOUT );
$| = 1;

$script_name = $query->script_name;

#    /   ,   
#   ;      SQL-  
#  ,    
$db_schema = $query->param( 'exp_imp' ) ? "exp_imp." : "";

#      
common_modes( query => $query,
              module => $module,
              user => $user,
              make_form => \&make_form,
              make_command => \&make_command,
              check_param => \&check_param,
              create_top => \&create_top,
              do_query => \&do_query,
              do_view => \&do_view,
              do_add => \&do_add,
              do_del => \&do_del,
              add_rec => \&add_rec,
              update_rec => \&update_rec,
              print_add_info => \&print_add_info,
              action => $script_name
            );

exit( 0 );


# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub check_param
{
  my $no_errors = 1;        #     
  my @error_messages = ();  #        

  #    (   1  4)
  if ( $query->param( 'title_type_code' ) !~ /^[1234]$/ )
  {
    push( @error_messages, "      <br />" .
          "   1  4" );
  }

  #   (  ,   
  #  )
  if ( $query->param( 'title_num' ) !~ /^\d+$/ )
  {
    push( @error_messages, "     " );
  }

  if ( $query->param( 'obj_title' ) eq '' )
  {
    push( @error_messages, "  " );
  }

  if ( $query->param( 'lang_code' ) eq '' )
  {
    push( @error_messages, "   " );
  }

  if ( $query->param( 'process_code' ) eq '' )
  {
    push( @error_messages, "     " );
  }

  # DEBUG
  # print_params( $query );

  #    ,   
  if ( scalar @error_messages != 0 )
  {
    print_user_err_msgs( \@error_messages );
    $no_errors = 0;
  }
  
  return ( $no_errors );
}

# -----------------------------------------------------------------------------
#    ,     
# ""  
# -----------------------------------------------------------------------------
sub create_top
{
  #   
  create_top_block( query => $query,
                    module => $module,
                    module_title => '  ()',
                    user => $user,
                    full_top => 'no'
                  );
  return ( 0 );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------
sub do_del
{
  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $title_type_code;    #   
  my $title_num;          #  
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id          = $query->param( 'obj_id' );
  $bib_rec_num     = $query->param( 'bib_rec_num' );
  $title_type_code = $query->param( 'title_type_code' );
  $title_num       = $query->param( 'title_num' );
  $target_win      = $query->param( 'target_win' );

  #         
  $command = "DELETE FROM ${db_schema}titles " .
             "WHERE obj_id = '$obj_id' AND " .
                   "bib_rec_num = '$bib_rec_num' AND " .
                   "title_type_code = '$title_type_code' AND " .
                   "title_num = '$title_num'";

  #   
  del_rec( query => $query,
           target => $target_win,
           create_top => \&create_top,
           print_add_info => \&print_add_info,
           command => $command
         );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#       
# -----------------------------------------------------------------------------
sub do_query
{
  # .        
  #              bib_recs.pl.

  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $bib_rec;            # . 
  my $target_win;         #      HTML-
  my( $result, $i );      #    
  my @row;                #      
  my $command;            #      
  my $href;               #   HTML-

  #          HTML-
  #   
  my $can_view = 0;
  my $can_delete = 0;

  #  ,        
  my $alt_row = 1;

  $obj_id      = $query->param( 'obj_id' );
  $bib_rec_num = $query->param( 'bib_rec_num' );
  $bib_rec     = $query->param( 'bib_rec' );
  $target_win  = $query->param( 'target_win' );

  #  HTTP-  HTML-
  http_html_headers( query => $query, target => $target_win );

  open_top();       #     
  create_top();     #    
  close_top();      #     

  open_bottom();    #     

  print_add_info(); #     

  #  ,    
  $bib_rec = CGI::escape( $bib_rec );

  #   HTML-
  $href = ( $query->param( 'exp_imp' ) ? "exp_imp=1&" : "" ) .
          "obj_id=$obj_id" .
          "&bib_rec_num=$bib_rec_num" .
          "&bib_rec=$bib_rec" .
          "&target_win=$target_win";

  #        
  # (    ,    )
  $command = "SELECT t.*, l.lang_sname " .
             "FROM ${db_schema}titles t, ${db_schema}langs l " .
             "WHERE t.obj_id = $obj_id AND " .
                   "t.bib_rec_num = $bib_rec_num AND " .
                   "t.lang_code = l.lang_code " .
             "ORDER BY t.title_type_code, t.title_num";

  $result = exec_select( $command );    #    
  
  if ( $result )
  {
    $can_view = have_access( 'module' => $module, 'procedure' => 'VIEW', 
                             'user' => $user );
    $can_delete = have_access( 'module' => $module, 'procedure' => 'DELETE',
                               'user' => $user );

    #     
    print "<table class=\"list\">\n";
    print "<tr>\n";
    print "<th> </th>\n";
    print "<th> </th>\n";
    print "<th></th>\n";
    print "<th> </th>\n";
    print "<th>&nbsp;</th>\n" if ( $can_view || $can_delete );
    print "</tr>\n";

    #      
    while ( @row = $result->fetchrow )
    {
      #        
      if ( $CFG{ ALT_ROWS_IS_ON } )
      {
        $alt_row = ! $alt_row;
        print ( ( $alt_row ) ? "<tr class=\"alt_row\">\n" : "<tr>\n" );
      }
      else
      {
        print "<tr>\n";
      }

      #    ,  , 
      #   
      print "<td>" .
            $title_types{ $row[ $result->fnumber( 'title_type_code' ) ] } .
            "</td>\n";
      print "<td class=\"center\">" .
            "$row[ $result->fnumber( 'title_num' ) ]</td>\n";
      print "<td>$row[ $result->fnumber( 'obj_title' ) ]</td>\n";
      print "<td>$row[ $result->fnumber( 'lang_sname' ) ]</td>\n";

      #        
      print "<td>" if ( $can_view || $can_delete );
      print qq{<a class="command_link" href="$script_name/view?$href} .
            "&title_type_code=" .
            $row[ $result->fnumber( 'title_type_code' ) ] .
            "&title_num=" . $row[ $result->fnumber( 'title_num' ) ] . "\"" .
            qq{ target="$target_win"></a>} if $can_view;
      print "\n" if $can_view;

      #     
      print qq{<a class="command_link" href="$script_name/delete?$href} .
            "&title_type_code=" .
            $row[ $result->fnumber( 'title_type_code' ) ] .
            "&title_num=" . $row[ $result->fnumber( 'title_num' ) ] . "\"" .
            qq{ onclick="$confirm_delete"} .
            qq{ target="$target_win"></a>} if $can_delete;
      print "</td>\n" if ( $can_view || $can_delete );

      print "</tr>\n";
    }
    print "</table>\n";
  }

  #       
  #          "/"
  if ( ! $query->param( 'exp_imp' ) &&
       have_access( 'module' => $module, 'procedure' => 'ADD', 
                    'user' => $user ) )
  {
    print "<br />\n";
    print qq{<a class="command_link" href="$script_name/add?$href"} .
          qq{ target="$target_win"> </a>};
  }

  close_bottom();   #     
  print $query->end_html();
  return ( 0 );
}

# -----------------------------------------------------------------------------
#      
# -----------------------------------------------------------------------------
sub do_view
{
  my $obj_id;             #    . 
  my $bib_rec_num;        #  .    
  my $title_type_code;    #   
  my $title_num;          #  
  my $target_win;         #      HTML-
  my $command;            #      

  $obj_id          = $query->param( 'obj_id' );
  $bib_rec_num     = $query->param( 'bib_rec_num' );
  $title_type_code = $query->param( 'title_type_code' );
  $title_num       = $query->param( 'title_num' );
  $target_win      = $query->param( 'target_win' );

  #     
  # (        
  # )
  $command = "SELECT t.*, l.lang_sname, p.process_sname " .
             "FROM ${db_schema}titles t, ${db_schema}langs l, " .
                  "${db_schema}process_types p " .
             "WHERE t.obj_id = $obj_id AND " .
                   "t.bib_rec_num = $bib_rec_num AND " .
                   "t.title_type_code = '$title_type_code' AND " .
                   "t.title_num = '$title_num' AND " .
                   "t.lang_code = l.lang_code AND " .
                   "t.process_code = p.process_code";

  #   
  view_rec( query => $query,
            create_top => \&create_top,
            make_form => \&make_form,
            action => $script_name,
            target => $target_win,
            submit_name => "submit_update",
            submit_value => "    ",
            command => $command,
            error => "        : " .
                     "   .  - " .
                     $obj_id . ", " .
                     " .     - " .
                     $bib_rec_num . ", " .
                     "   - $title_type_code, " .
                     "  - $title_num",
            can_update => have_access( 'module' => $module, 
                                       'procedure' => 'UPDATE', 
                                       'user' => $user )
        );

  return ( 0 );
}

# -----------------------------------------------------------------------------
#  -      
# -----------------------------------------------------------------------------
sub make_command
{
  my $operation = shift; #   -   ?

  my $command;           # -

  #   
  # :   
  # -        ,  
  #    (f_special);
  # -        (func_special)
  $command = make_cmd( query => $query,
                       operation => $operation,
                       table => "titles",
                       key => "obj_id, bib_rec_num, " .
                              "title_type_code:title_type_code_begin, " .
                              "title_num:title_num_begin",
                       f_names => \@f_names,
                       f_special => [ 'private_title' ],
                       func_special => \&non_std_fields,
                       user => $user
                     );

  return ( $command );
}

# -----------------------------------------------------------------------------
#     ()   
# -----------------------------------------------------------------------------
sub make_form
{
  # 
  my $ref_row = shift;  #   ,     
  my $res = shift;      #  

  my $i;
  my %fields = ();  # -      

  #      (    
  # ,    )
  my( $ref_values_langs, $ref_labels_langs ) = popup_langs_list( $db_schema );

  #      (    
  #    )
  my( $ref_values_procs, $ref_labels_procs ) =
    popup_process_types_list( $db_schema );

  #    -       
  #  , ...
  if ( $ref_row ne undef )
  {
    # ...   -,  ...
    for $i ( 0 .. $res->nfields - 1 )
    {
      # ...     ,    
      # (      - . Pg.pm)
      $fields{ $res->fname( $i ) } = $$ref_row[ $i ];
    }
  }
  else                      #      
  {
    #        
    $fields{ 'obj_id' }      = $query->param( 'obj_id' );
    $fields{ 'bib_rec_num' } = $query->param( 'bib_rec_num' );

    #   

    #   
    $fields{ 'title_type_code' } = $CFG{ TITLES_TITLE_TYPE_CODE };

    #  
    $fields{ 'title_num' }       = $CFG{ TITLES_TITLE_NUM };

    #  
    $fields{ 'lang_code' }       = $CFG{ TITLES_LANG_CODE };

    #    . 
    $fields{ 'process_code' }    = $CFG{ TITLES_PROCESS_CODE };

    #     ()
    $fields{ 'private_title' }   = $CFG{ TITLES_PRIVATE_TITLE };
    
    #   ,   ,   . 
    ( undef, $fields{ 'obj_title' }, $fields{ 'obj_title_info' } ) =
      $query->param( 'bib_rec' ) =~
      /^(\S+,\s?\S{1,2}\.\s?\S{0,2}\.?\s+)
                                  #     ( 
                                  #    ),  
                                  # ,    ... 
                                  # (   ;  
                                  #  )
        (.+?)                     #  ("" , .. 
                                  #     )
        \s\[\S+?\]\s*:?\s*        #   , ,
                                  # [] (    , 
                                  #  ,   )
        (.*?)\/                   # ,   
                                  # ("" , ..  
                                  #     "\/")
                                  # .    Perl'
                                  #   "" -  
                                  #  " ".
      /x;      
    # 
    $fields{ 'comment' }         = $CFG{ TITLES_COMMENT };
  }
  # -------------------------------------------------------------------

  #    HTML-       
  # insert_str_into_field(),     
  #   HTML-
  print <<END_OF_SCRIPT;
  <script language="JavaScript" type="text/javascript"
          src="/$CFG{ HOME_WEB_JS_DIR }/insert_text.js"></script>
END_OF_SCRIPT
  ;

  #    "  
  #  "  " .   
  # "   ,     ,
  #     , ..    
  #  UPDATE   ,      INSERT
  # (     ,    
  #   ,      )
  print $query->hidden( -name => 'obj_id' ), "\n";
  print $query->hidden( -name => 'bib_rec_num' ), "\n";

  #     "  "  " "
  # .      'begin'  ,
  #                   ,  
  #               (.  make_cmd   E_ARCH.pm).
  #             ..       ,   
  #              (, ,   ).
  print $query->hidden( -name => 'title_type_code_begin',
                        -default => $fields{ 'title_type_code' }
                      ), "\n";
  print $query->hidden( -name => 'title_num_begin',
                        -default => $fields{ 'title_num' }
                      ), "\n";

  #      .  
  #  ,     add_rec()  update_rec()
  print $query->hidden( -name => 'bib_rec' ), "\n";

  #   exp_imp,   ,   
  #   (     : exp_imp  public)
  print $query->hidden( -name => 'exp_imp' ), "\n";

  print_add_info();         #     

  print "<table class=\"form\">\n";

  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>",
        $query->popup_menu( -name => 'title_type_code',
                            -default => $fields{ 'title_type_code' },
                            -values => [ sort keys %title_types ],
                            -labels => \%title_types
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>",
        $query->textfield( -name => 'title_num',
                           -default => $fields{ 'title_num' },
                           -size => $CFG{ TITLES_TITLE_NUM_SIZE },
                           -maxlength => $CFG{ TITLES_TITLE_NUM_MAXLENGTH }
                         ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th></th>\n";
  print "<td>",
        $query->textarea( -name => 'obj_title',
                          -default => $fields{ 'obj_title' },
                          -rows => $CFG{ TITLES_OBJ_TITLE_ROWS },
                          -columns => $CFG{ TITLES_OBJ_TITLE_COLS }
                         ),
        "</td>\n";
  print "</tr>\n";

  #        labels  
  # ,    popup_langs_list()   ,
  #   -   
  print "<tr>\n";
  print "<th> </th>\n";
  print "<td>",
        $query->popup_menu( -name => 'lang_code',
                            -default => $fields{ 'lang_code' },
                            -values => $ref_values_langs,
                            -labels => { @{ $ref_labels_langs } }
                          ),
        "</td>\n";
  print "</tr>\n";

  #        labels  
  # ,    popup_process_types_list() 
  #  ,   -   
  print "<tr>\n";
  print "<th>  </th>\n";
  print "<td>",
        $query->popup_menu( -name => 'process_code',
                            -default => $fields{ 'process_code' },
                            -values => $ref_values_procs,
                            -labels => { @{ $ref_labels_procs } }
                          ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>    ()</th>\n";
  print "<td>",
        $query->checkbox( -name => 'private_title',
                          -checked => 
                             $fields{ 'private_title' } eq 't' ? '1' : '0',
                          -value => 'yes',
                          -label => ''
                        ),
        "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<th>,   <br />" .
            "(  \":\")</th>\n";
  print "<td>";
  
  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].obj_title_info",
                   "TITLES_OBJ_TITLE_INFO" ) if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'obj_title_info',
                          -default => $fields{ 'obj_title_info' },
                          -rows => $CFG{ TITLES_OBJ_TITLE_INFO_ROWS },
                          -columns => $CFG{ TITLES_OBJ_TITLE_INFO_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";

  # --------------------------------------------------------------------
  print "<tr>\n";
  print "<th></th>\n";
  print "<td>";
  
  #   ()     
  #    
  create_hot_help( "document.forms[ 0 ].comment", "TITLES_COMMENT" )
    if $CFG{ HOT_HELP_IS_ON };

  print $query->textarea( -name => 'comment',
                          -default => $fields{ 'comment' },
                          -rows => $CFG{ TITLES_COMMENT_ROWS },
                          -columns => $CFG{ TITLES_COMMENT_COLS }
                        ),
        "</td>\n";
  print "</tr>\n";
  # --------------------------------------------------------------------

  print "</table>\n";
  return ( 0 );
}

# -----------------------------------------------------------------------------
#   ,    
#  -      
# -----------------------------------------------------------------------------
sub non_std_fields
{
  # :
  my $fname = shift;  #  
                      #   -   ( 
                      #  ).      
  my $value;
  
  #     ()
  if ( $fname eq 'private_title' )
  {
    #     bool,    
    #   
    $value = $query->param( $fname ) ? 'yes' : 'no';
  }

  return ( $value );  
}

# -----------------------------------------------------------------------------
#          
# -----------------------------------------------------------------------------
sub print_add_info
{
  #  .    
  print_bib_record( $query, "" );
  
  return ( 0 );
}
