// -----------------------------------------------------------------------------
// Система:  "Электронный архив"
// Модуль:   вставка текста в поля TEXTAREA и INPUT
// Автор:    некто white
// Дата:     20.06.2009 (дата включения мною этого программного кода 
//           в состав системы "Электронный архив")
//           9.02.2006 (дата размещения этого программного кода на
//           сайте, указанном ниже)
// Версия:   ?.?
// -----------------------------------------------------------------------------

/* ПРИМЕЧАНИЕ. Этот программный код позаимствован мною с сайта
   http://parentnode.org/javascript/working-with-the-cursor-position/
   http://pastebin.parentnode.org/78

   Данный код есть также на сайте
   http://www.htmlcenter.com/blog/insert-text-into-textareas-using-javascript/
*/

/* ПРИМЕЧАНИЕ. Сохранены комментарии автора. Мною добавлены пробелы для
               улучшения читаемости текста и несколько изменено
               форматирование.
   ПРИМЕЧАНИЕ. Вставка текста в ПЕРВОЙ позиции поля не работает, вместо
               этого вставка производится в конец текста.
*/

/* obj is the element, where we want to insert something
   text is the string, which will be inserted
*/ 

// функция переименована мною
// function insertAtCaret(obj, text) {
function insert_str_into_field( obj, text )
{
  // Go the IE way 
  if ( document.selection )
  {
    /* First of all, focus the object, we want to work with
       If we do not do so, it is possible, that the selection
       is not, where we expect it to be
    */ 
    obj.focus();

    /* Save the current value. We will need this value later
       to find out, where the text has been changed
    */ 
    var orig = obj.value.replace( /\r\n/g, "\n" );

    /* Create a TextRange based on the document.selection
       This TextRanged can be used to replace the selected
       Text with the new one
    */ 
    var range = document.selection.createRange();

    /* If the range is not part of our Object (remember the
       textarea or input field), stop processing here
    */
    if ( range.parentElement() != obj )
    {
      return false;
    }

    /* Replace the Text */ 
    range.text = text;
			
    /* Now get the new content and save it into
       a temporary variable
    */
    var actual = tmp = obj.value.replace( /\r\n/g, "\n" );

    /* Find the first occurance, where the original differs
       from the actual content. This could be the startposition
       of our text selection, but it has not to be. Think of the
       selection "ab" and replacing it with "ac". The first
       difference would be the "c", while the start position
       is the "a"
    */ 
    for ( var diff = 0; diff < orig.length; diff++ )
    {
      if ( orig.charAt( diff ) != actual.charAt( diff ) )
        break;
    }

    /* To get the real start position, we iterate through
       the string searching for the whole replacement
       text - "abc", as long as the first difference is not
       reached. If you do not understand that logic - no
       blame to you, just copy & paste it ;)
    */ 
    for ( var index = 0, start = 0; 
          tmp.match( text ) && ( tmp = tmp.replace( text, "" ) ) 
                            && index <= diff; 
          index = start + text.length )
    {
      start = actual.indexOf( text, index );
    }
  }
  else if ( obj.selectionStart )  // Go the Gecko way 
  {
    /* Find the Start and End Position */
    var start = obj.selectionStart;
    var end   = obj.selectionEnd;

    /* Remember obj is a textarea or input field */
    obj.value = obj.value.substr( 0, start ) +
                text +
                obj.value.substr( end, obj.value.length );
  }
  else
  { 
    // Fallback for any other browser 
  }

  if ( start != null )
  {
    setCaretTo( obj, start + text.length );
  }
  else 
  {
    obj.value += text;
  }
}
	
function setCaretTo( obj, pos )
{
  if ( obj.createTextRange )
  {
    /* Create a TextRange, set the internal pointer to
       a specified position and show the cursor at this position
    */ 
    var range = obj.createTextRange();
    range.move( 'character', pos );
    range.select();
  }
  else if ( obj.selectionStart )
  {
    /* Gecko is a little bit shorter on that. Simply
       focus the element and set the selection to a specified position
    */ 
    obj.focus();
    obj.setSelectionRange( pos, pos );
  }
}
